from vbelts.util import _Iterate, _ReIterate, _OutOfRangeError, _NotValidError

# Data
hipower_fcc = ({'type': 'A-26', 'fcc': '0.75'}, {'type': 'A-27', 'fcc': '0.76'}, {'type': 'A-31', 'fcc': '0.79'}, {'type': 'A-32', 'fcc': '0.8'}, {'type': 'A-33', 'fcc': '0.81'}, {'type': 'A-35', 'fcc': '0.82'}, {'type': 'A-37', 'fcc': '0.84'}, {'type': 'A-38', 'fcc': '0.85'}, {'type': 'A-41', 'fcc': '0.86'}, {'type': 'A-42', 'fcc': '0.87'}, {'type': 'A-45', 'fcc': '0.89'}, {'type': 'A-46', 'fcc': '0.9'}, {'type': 'A-47', 'fcc': '0.9'}, {'type': 'A-49', 'fcc': '0.91'}, {'type': 'A-50', 'fcc': '0.91'}, {'type': 'A-51', 'fcc': '0.91'}, {'type': 'A-53', 'fcc': '0.93'}, {'type': 'A-54', 'fcc': '0.93'}, {'type': 'A-55', 'fcc': '0.93'}, {'type': 'A-57', 'fcc': '0.95'}, {'type': 'A-60', 'fcc': '0.97'}, {'type': 'A-62', 'fcc': '0.97'}, {'type': 'A-64', 'fcc': '0.99'}, {'type': 'A-66', 'fcc': '0.99'}, {'type': 'A-68', 'fcc': '1'}, {'type': 'A-69', 'fcc': '1'}, {'type': 'A-71', 'fcc': '1.01'}, {'type': 'A-75', 'fcc': '1.03'}, {'type': 'A-80', 'fcc': '1.04'}, {'type': 'A-85', 'fcc': '1.06'}, {'type': 'A-90', 'fcc': '1.08'}, {'type': 'A-96', 'fcc': '1.09'}, {'type': 'A-105', 'fcc': '1.12'}, {'type': 'A-112', 'fcc': '1.13'}, {'type': 'A-120', 'fcc': '1.15'}, {'type': 'A-128', 'fcc': '1.17'}, {'type': 'A-136', 'fcc': '1.17'}, {'type': 'A-144', 'fcc': '1.17'}, {'type': 'A-158', 'fcc': '1.17'}, {'type': 'A-162', 'fcc': '1.17'}, {'type': 'A-173', 'fcc': '1.17'}, {'type': 'A-180', 'fcc': '1.17'}, {'type': 'B-35', 'fcc': '0.77'}, {'type': 'B-37', 'fcc': '0.78'}, {'type': 'B-38', 'fcc': '0.79'}, {'type': 'B-39', 'fcc': '0.8'}, {'type': 'B-42', 'fcc': '0.81'}, {'type': 'B-46', 'fcc': '0.83'}, {'type': 'B-48', 'fcc': '0.84'}, {'type': 'B-50', 'fcc': '0.84'}, {'type': 'B-51', 'fcc': '0.84'}, {'type': 'B-52', 'fcc': '0.86'}, {'type': 'B-53', 'fcc': '0.86'}, {'type': 'B-55', 'fcc': '0.88'}, {'type': 'B-60', 'fcc': '0.9'}, {'type': 'B-63', 'fcc': '0.9'}, {'type': 'B-64', 'fcc': '0.92'}, {'type': 'B-65', 'fcc': '0.92'}, {'type': 'B-68', 'fcc': '0.93'}, {'type': 'B-71', 'fcc': '0.94'}, {'type': 'B-73', 'fcc': '0.94'}, {'type': 'B-75', 'fcc': '0.95'}, {'type': 'B-78', 'fcc': '0.96'}, {'type': 'B-81', 'fcc': '0.96'}, {'type': 'B-85', 'fcc': '0.99'}, {'type': 'B-90', 'fcc': '1'}, {'type': 'B-93', 'fcc': '1'}, {'type': 'B-95', 'fcc': '1.01'}, {'type': 'B-97', 'fcc': '1.02'}, {'type': 'B-105', 'fcc': '1.04'}, {'type': 'B-112', 'fcc': '1.05'}, {'type': 'B-120', 'fcc': '1.07'}, {'type': 'B-124', 'fcc': '1.07'}, {'type': 'B-128', 'fcc': '1.09'}, {'type': 'B-136', 'fcc': '1.1'}, {'type': 'B-144', 'fcc': '1.12'}, {'type': 'B-158', 'fcc': '1.14'}, {'type': 'B-162', 'fcc': '1.15'}, {'type': 'B-173', 'fcc': '1.16'}, {'type': 'B-180', 'fcc': '1.17'}, {'type': 'B-195', 'fcc': '1.19'}, {'type': 'B-210', 'fcc': '1.22'}, {'type': 'B-225', 'fcc': '1.23'}, {'type': 'B-240', 'fcc': '1.24'}, {'type': 'B-270', 'fcc': '1.27'}, {'type': 'B-300', 'fcc': '1.3'}, {'type': 'B-330', 'fcc': '1.3'}, {'type': 'B-360', 'fcc': '1.3'}, {'type': 'C-51', 'fcc': '0.77'}, {'type': 'C-55', 'fcc': '0.79'}, {'type': 'C-58', 'fcc': '0.79'}, {'type': 'C-60', 'fcc': '0.81'}, {'type': 'C-63', 'fcc': '0.81'}, {'type': 'C-68', 'fcc': '0.83'}, {'type': 'C-71', 'fcc': '0.84'}, {'type': 'C-72', 'fcc': '0.84'}, {'type': 'C-73', 'fcc': '0.84'}, {'type': 'C-75', 'fcc': '0.86'}, {'type': 'C-81', 'fcc': '0.87'}, {'type': 'C-85', 'fcc': '0.88'}, {'type': 'C-90', 'fcc': '0.9'}, {'type': 'C-96', 'fcc': '0.91'}, {'type': 'C-100', 'fcc': '0.92'}, {'type': 'C-105', 'fcc': '0.93'}, {'type': 'C-112', 'fcc': '0.95'}, {'type': 'C-120', 'fcc': '0.96'}, {'type': 'C-128', 'fcc': '0.97'}, {'type': 'C-136', 'fcc': '0.99'}, {'type': 'C-144', 'fcc': '1'}, {'type': 'C-158', 'fcc': '1.02'}, {'type': 'C-162', 'fcc': '1.03'}, {'type': 'C-173', 'fcc': '1.04'}, {'type': 'C-180', 'fcc': '1.05'}, {'type': 'C-195', 'fcc': '1.07'}, {'type': 'C-210', 'fcc': '1.08'}, {'type': 'C-225', 'fcc': '1.1'}, {'type': 'C-240', 'fcc': '1.11'}, {'type': 'C-255', 'fcc': '1.13'}, {'type': 'C-270', 'fcc': '1.14'}, {'type': 'C-300', 'fcc': '1.16'}, {'type': 'C-330', 'fcc': '1.18'}, {'type': 'C-360', 'fcc': '1.2'}, {'type': 'C-390', 'fcc': '1.22'}, {'type': 'C-420', 'fcc': '1.24'}, {'type': 'D-120', 'fcc': '0.86'}, {'type': 'D-128', 'fcc': '0.88'}, {'type': 'D-136', 'fcc': '0.88'}, {'type': 'D-144', 'fcc': '0.9'}, {'type': 'D-158', 'fcc': '0.92'}, {'type': 'D-162', 'fcc': '0.92'}, {'type': 'D-173', 'fcc': '0.94'}, {'type': 'D-180', 'fcc': '0.94'}, {'type': 'D-195', 'fcc': '0.96'}, {'type': 'D-210', 'fcc': '0.98'}, {'type': 'D-225', 'fcc': '0.99'}, {'type': 'D-240', 'fcc': '1'}, {'type': 'D-250', 'fcc': '1'}, {'type': 'D-270', 'fcc': '1.02'}, {'type': 'D-300', 'fcc': '1.04'}, {'type': 'D-330', 'fcc': '1.06'}, {'type': 'D-360', 'fcc': '1.08'}, {'type': 'D-390', 'fcc': '1.1'}, {'type': 'D-420', 'fcc': '1.11'}, {'type': 'D-480', 'fcc': '1.14'})

superhc_fcc = ({'type': '3V250', 'fcc': '0.83'}, {'type': '3V265', 'fcc': '0.84'}, {'type': '3V280', 'fcc': '0.85'}, {'type': '3V300', 'fcc': '0.86'}, {'type': '3V315', 'fcc': '0.87'}, {'type': '3V335', 'fcc': '0.88'}, {'type': '3V355', 'fcc': '0.89'}, {'type': '3V375', 'fcc': '0.9'}, {'type': '3V400', 'fcc': '0.92'}, {'type': '3V425', 'fcc': '0.93'}, {'type': '3V450', 'fcc': '0.94'}, {'type': '3V475', 'fcc': '0.95'}, {'type': '3V500', 'fcc': '0.96'}, {'type': '3V530', 'fcc': '0.97'}, {'type': '3V560', 'fcc': '0.98'}, {'type': '3V600', 'fcc': '0.99'}, {'type': '3V630', 'fcc': '1'}, {'type': '3V670', 'fcc': '1.01'}, {'type': '3V710', 'fcc': '1.02'}, {'type': '3V750', 'fcc': '1.03'}, {'type': '3V800', 'fcc': '1.04'}, {'type': '3V850', 'fcc': '1.06'}, {'type': '3V900', 'fcc': '1.07'}, {'type': '3V950', 'fcc': '1.08'}, {'type': '3V1000', 'fcc': '1.09'}, {'type': '3V1060', 'fcc': '1.1'}, {'type': '3V1120', 'fcc': '1.11'}, {'type': '3V1180', 'fcc': '1.12'}, {'type': '3V1250', 'fcc': '1.13'}, {'type': '3V1320', 'fcc': '1.14'}, {'type': '3V1400', 'fcc': '1.15'}, {'type': '5V500', 'fcc': '0.85'}, {'type': '5V530', 'fcc': '0.86'}, {'type': '5V560', 'fcc': '0.87'}, {'type': '5V600', 'fcc': '0.88'}, {'type': '5V630', 'fcc': '0.89'}, {'type': '5V670', 'fcc': '0.9'}, {'type': '5V710', 'fcc': '0.91'}, {'type': '5V750', 'fcc': '0.92'}, {'type': '5V800', 'fcc': '0.93'}, {'type': '5V850', 'fcc': '0.94'}, {'type': '5V900', 'fcc': '0.95'}, {'type': '5V950', 'fcc': '0.96'}, {'type': '5V1000', 'fcc': '0.96'}, {'type': '5V1060', 'fcc': '0.97'}, {'type': '5V1120', 'fcc': '0.98'}, {'type': '5V1180', 'fcc': '0.99'}, {'type': '5V1250', 'fcc': '1'}, {'type': '5V1320', 'fcc': '1.01'}, {'type': '5V1400', 'fcc': '1.02'}, {'type': '5V1500', 'fcc': '1.03'}, {'type': '5V1600', 'fcc': '1.04'}, {'type': '5V1700', 'fcc': '1.05'}, {'type': '5V1800', 'fcc': '1.06'}, {'type': '5V1900', 'fcc': '1.07'}, {'type': '5V2000', 'fcc': '1.08'}, {'type': '5V2120', 'fcc': '1.09'}, {'type': '5V2240', 'fcc': '1.09'}, {'type': '5V2360', 'fcc': '1.1'}, {'type': '5V2500', 'fcc': '1.11'}, {'type': '5V2650', 'fcc': '1.12'}, {'type': '5V2800', 'fcc': '1.13'}, {'type': '5V3000', 'fcc': '1.14'}, {'type': '5V3150', 'fcc': '1.15'}, {'type': '5V3350', 'fcc': '1.16'}, {'type': '5V3550', 'fcc': '1.17'}, {'type': '8V1000', 'fcc': '0.87'}, {'type': '8V1060', 'fcc': '0.88'}, {'type': '8V1120', 'fcc': '0.88'}, {'type': '8V1180', 'fcc': '0.89'}, {'type': '8V1250', 'fcc': '0.9'}, {'type': '8V1320', 'fcc': '0.91'}, {'type': '8V1400', 'fcc': '0.92'}, {'type': '8V1500', 'fcc': '0.93'}, {'type': '8V1600', 'fcc': '0.94'}, {'type': '8V1700', 'fcc': '0.94'}, {'type': '8V1800', 'fcc': '0.95'}, {'type': '8V1900', 'fcc': '0.96'}, {'type': '8V2000', 'fcc': '0.97'}, {'type': '8V2120', 'fcc': '0.98'}, {'type': '8V2240', 'fcc': '0.98'}, {'type': '8V2360', 'fcc': '0.99'}, {'type': '8V2500', 'fcc': '1'}, {'type': '8V2650', 'fcc': '1.01'}, {'type': '8V2800', 'fcc': '1.02'}, {'type': '8V3000', 'fcc': '1.03'}, {'type': '8V3150', 'fcc': '1.03'}, {'type': '8V3350', 'fcc': '1.04'}, {'type': '8V3550', 'fcc': '1.05'}, {'type': '8V3750', 'fcc': '1.06'}, {'type': '8V4000', 'fcc': '1.07'}, {'type': '8V4250', 'fcc': '1.08'}, {'type': '8V4500', 'fcc': '1.09'}, {'type': '8V4750', 'fcc': '1.09'}, {'type': '8V5000', 'fcc': '1.10'}, {'type': '8V5600', 'fcc': '1.12'})

fcac_contact_arc = ({'factor': '0', 'contact_arc': '180', 'fcac': '1'}, {'factor': '0.1', 'contact_arc': '174', 'fcac': '0.99'}, {'factor': '0.2', 'contact_arc': '169', 'fcac': '0.97'}, {'factor': '0.3', 'contact_arc': '163', 'fcac': '0.96'}, {'factor': '0.4', 'contact_arc': '157', 'fcac': '0.94'}, {'factor': '0.5', 'contact_arc': '151', 'fcac': '0.93'}, {'factor': '0.6', 'contact_arc': '145', 'fcac': '0.91'}, {'factor': '0.7', 'contact_arc': '139', 'fcac': '0.89'}, {'factor': '0.8', 'contact_arc': '133', 'fcac': '0.87'}, {'factor': '0.9', 'contact_arc': '127', 'fcac': '0.85'}, {'factor': '1', 'contact_arc': '120', 'fcac': '0.82'}, {'factor': '1.1', 'contact_arc': '113', 'fcac': '0.8'}, {'factor': '1.2', 'contact_arc': '106', 'fcac': '0.77'}, {'factor': '1.3', 'contact_arc': '99', 'fcac': '0.73'}, {'factor': '1.4', 'contact_arc': '91', 'fcac': '0.7'}, {'factor': '1.5', 'contact_arc': '83', 'fcac': '0.65'})

HiPower_a_pa = ({'gr_low': '1', 'gr_high': '1.02', 'rpm': '200', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '400', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '600', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '800', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '950', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1000', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1160', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1200', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1400', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1425', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1600', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1750', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1800', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '2000', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '2000', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '2400', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '2600', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '2800', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '2850', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '3000', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '3200', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '3400', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '3450', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '3600', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '3800', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '4000', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '4200', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '4400', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '4600', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '4800', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '5000', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '5200', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '5400', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '5600', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '5800', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '6000', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '6200', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '6400', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '6500', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '6800', 'power_a': '0'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '200', 'power_a': '0'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '400', 'power_a': '0.01'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '600', 'power_a': '0.01'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '800', 'power_a': '0.02'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '950', 'power_a': '0.02'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '1000', 'power_a': '0.02'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '1160', 'power_a': '0.02'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '1200', 'power_a': '0.02'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '1400', 'power_a': '0.03'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '1425', 'power_a': '0.03'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '1600', 'power_a': '0.03'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '1750', 'power_a': '0.04'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '1800', 'power_a': '0.04'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '2000', 'power_a': '0.04'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '2000', 'power_a': '0.05'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '2400', 'power_a': '0.05'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '2600', 'power_a': '0.05'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '2800', 'power_a': '0.06'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '2850', 'power_a': '0.05'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '3000', 'power_a': '0.06'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '3200', 'power_a': '0.07'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '3400', 'power_a': '0.07'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '3450', 'power_a': '0.07'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '3600', 'power_a': '0.07'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '3800', 'power_a': '0.08'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '4000', 'power_a': '0.08'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '4200', 'power_a': '0.09'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '4400', 'power_a': '0.09'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '4600', 'power_a': '0.1'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '4800', 'power_a': '0.1'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '5000', 'power_a': '0.1'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '5200', 'power_a': '0.11'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '5400', 'power_a': '0.11'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '5600', 'power_a': '0.12'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '5800', 'power_a': '0.12'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '6000', 'power_a': '0.12'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '6200', 'power_a': '0.13'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '6400', 'power_a': '0.13'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '6500', 'power_a': '0.14'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '6800', 'power_a': '0.14'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '200', 'power_a': '0.01'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '400', 'power_a': '0.02'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '600', 'power_a': '0.02'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '800', 'power_a': '0.03'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '950', 'power_a': '0.04'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '1000', 'power_a': '0.04'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '1160', 'power_a': '0.05'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '1200', 'power_a': '0.05'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '1400', 'power_a': '0.06'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '1425', 'power_a': '0.06'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '1600', 'power_a': '0.07'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '1750', 'power_a': '0.07'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '1800', 'power_a': '0.07'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '2000', 'power_a': '0.08'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '2000', 'power_a': '0.09'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '2400', 'power_a': '0.1'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '2600', 'power_a': '0.11'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '2800', 'power_a': '0.12'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '2850', 'power_a': '0.12'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '3000', 'power_a': '0.12'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '3200', 'power_a': '0.13'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '3400', 'power_a': '0.14'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '3450', 'power_a': '0.14'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '3600', 'power_a': '0.15'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '3800', 'power_a': '0.16'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '4000', 'power_a': '0.17'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '4200', 'power_a': '0.17'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '4400', 'power_a': '0.18'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '4600', 'power_a': '0.19'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '4800', 'power_a': '0.2'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '5000', 'power_a': '0.21'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '5200', 'power_a': '0.21'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '5400', 'power_a': '0.22'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '5600', 'power_a': '0.23'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '5800', 'power_a': '0.24'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '6000', 'power_a': '0.25'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '6200', 'power_a': '0.26'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '6400', 'power_a': '0.26'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '6500', 'power_a': '0.27'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '6800', 'power_a': '0.28'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '200', 'power_a': '0.01'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '400', 'power_a': '0.02'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '600', 'power_a': '0.04'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '800', 'power_a': '0.05'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '950', 'power_a': '0.06'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '1000', 'power_a': '0.06'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '1160', 'power_a': '0.07'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '1200', 'power_a': '0.07'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '1400', 'power_a': '0.09'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '1425', 'power_a': '0.09'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '1600', 'power_a': '0.1'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '1750', 'power_a': '0.11'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '1800', 'power_a': '0.11'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '2000', 'power_a': '0.12'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '2000', 'power_a': '0.14'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '2400', 'power_a': '0.15'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '2600', 'power_a': '0.16'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '2800', 'power_a': '0.17'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '2850', 'power_a': '0.18'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '3000', 'power_a': '0.19'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '3200', 'power_a': '0.2'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '3400', 'power_a': '0.21'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '3450', 'power_a': '0.21'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '3600', 'power_a': '0.22'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '3800', 'power_a': '0.24'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '4000', 'power_a': '0.25'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '4200', 'power_a': '0.26'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '4400', 'power_a': '0.27'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '4600', 'power_a': '0.29'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '4800', 'power_a': '0.3'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '5000', 'power_a': '0.31'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '5200', 'power_a': '0.32'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '5400', 'power_a': '0.33'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '5600', 'power_a': '0.35'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '5800', 'power_a': '0.36'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '6000', 'power_a': '0.37'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '6200', 'power_a': '0.38'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '6400', 'power_a': '0.4'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '6500', 'power_a': '0.41'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '6800', 'power_a': '0.42'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '200', 'power_a': '0.02'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '400', 'power_a': '0.03'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '600', 'power_a': '0.05'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '800', 'power_a': '0.07'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '950', 'power_a': '0.08'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '1000', 'power_a': '0.08'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '1160', 'power_a': '0.1'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '1200', 'power_a': '0.1'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '1400', 'power_a': '0.12'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '1425', 'power_a': '0.12'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '1600', 'power_a': '0.13'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '1750', 'power_a': '0.14'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '1800', 'power_a': '0.15'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '2000', 'power_a': '0.17'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '2000', 'power_a': '0.18'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '2400', 'power_a': '0.2'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '2600', 'power_a': '0.21'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '2800', 'power_a': '0.23'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '2850', 'power_a': '0.24'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '3000', 'power_a': '0.25'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '3200', 'power_a': '0.26'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '3400', 'power_a': '0.28'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '3450', 'power_a': '0.29'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '3600', 'power_a': '0.3'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '3800', 'power_a': '0.31'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '4000', 'power_a': '0.33'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '4200', 'power_a': '0.35'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '4400', 'power_a': '0.36'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '4600', 'power_a': '0.38'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '4800', 'power_a': '0.4'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '5000', 'power_a': '0.41'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '5200', 'power_a': '0.43'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '5400', 'power_a': '0.45'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '5600', 'power_a': '0.46'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '5800', 'power_a': '0.48'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '6000', 'power_a': '0.5'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '6200', 'power_a': '0.51'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '6400', 'power_a': '0.53'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '6500', 'power_a': '0.55'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '6800', 'power_a': '0.56'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '200', 'power_a': '0.02'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '400', 'power_a': '0.04'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '600', 'power_a': '0.06'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '800', 'power_a': '0.08'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '950', 'power_a': '0.1'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '1000', 'power_a': '0.1'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '1160', 'power_a': '0.12'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '1200', 'power_a': '0.12'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '1400', 'power_a': '0.14'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '1425', 'power_a': '0.15'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '1600', 'power_a': '0.17'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '1750', 'power_a': '0.18'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '1800', 'power_a': '0.19'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '2000', 'power_a': '0.21'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '2000', 'power_a': '0.23'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '2400', 'power_a': '0.25'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '2600', 'power_a': '0.27'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '2800', 'power_a': '0.29'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '2850', 'power_a': '0.29'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '3000', 'power_a': '0.31'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '3200', 'power_a': '0.33'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '3400', 'power_a': '0.35'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '3450', 'power_a': '0.36'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '3600', 'power_a': '0.37'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '3800', 'power_a': '0.39'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '4000', 'power_a': '0.41'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '4200', 'power_a': '0.43'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '4400', 'power_a': '0.45'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '4600', 'power_a': '0.48'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '4800', 'power_a': '0.5'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '5000', 'power_a': '0.52'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '5200', 'power_a': '0.54'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '5400', 'power_a': '0.56'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '5600', 'power_a': '0.58'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '5800', 'power_a': '0.6'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '6000', 'power_a': '0.62'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '6200', 'power_a': '0.64'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '6400', 'power_a': '0.66'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '6500', 'power_a': '0.68'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '6800', 'power_a': '0.7'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '200', 'power_a': '0.02'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '400', 'power_a': '0.05'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '600', 'power_a': '0.07'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '800', 'power_a': '0.1'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '950', 'power_a': '0.12'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '1000', 'power_a': '0.12'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '1160', 'power_a': '0.14'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '1200', 'power_a': '0.15'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '1400', 'power_a': '0.17'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '1425', 'power_a': '0.18'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '1600', 'power_a': '0.2'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '1750', 'power_a': '0.22'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '1800', 'power_a': '0.22'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '2000', 'power_a': '0.25'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '2000', 'power_a': '0.27'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '2400', 'power_a': '0.3'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '2600', 'power_a': '0.32'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '2800', 'power_a': '0.35'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '2850', 'power_a': '0.35'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '3000', 'power_a': '0.37'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '3200', 'power_a': '0.4'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '3400', 'power_a': '0.42'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '3450', 'power_a': '0.43'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '3600', 'power_a': '0.45'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '3800', 'power_a': '0.47'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '4000', 'power_a': '0.5'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '4200', 'power_a': '0.52'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '4400', 'power_a': '0.55'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '4600', 'power_a': '0.57'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '4800', 'power_a': '0.6'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '5000', 'power_a': '0.62'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '5200', 'power_a': '0.65'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '5400', 'power_a': '0.67'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '5600', 'power_a': '0.69'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '5800', 'power_a': '0.72'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '6000', 'power_a': '0.74'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '6200', 'power_a': '0.77'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '6400', 'power_a': '0.79'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '6500', 'power_a': '0.82'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '6800', 'power_a': '0.84'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '200', 'power_a': '0.03'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '400', 'power_a': '0.06'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '600', 'power_a': '0.09'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '800', 'power_a': '0.12'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '950', 'power_a': '0.14'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '1000', 'power_a': '0.14'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '1160', 'power_a': '0.17'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '1200', 'power_a': '0.17'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '1400', 'power_a': '0.2'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '1425', 'power_a': '0.21'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '1600', 'power_a': '0.23'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '1750', 'power_a': '0.25'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '1800', 'power_a': '0.26'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '2000', 'power_a': '0.29'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '2000', 'power_a': '0.32'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '2400', 'power_a': '0.35'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '2600', 'power_a': '0.38'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '2800', 'power_a': '0.41'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '2850', 'power_a': '0.41'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '3000', 'power_a': '0.43'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '3200', 'power_a': '0.46'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '3400', 'power_a': '0.49'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '3450', 'power_a': '0.5'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '3600', 'power_a': '0.52'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '3800', 'power_a': '0.55'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '4000', 'power_a': '0.58'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '4200', 'power_a': '0.61'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '4400', 'power_a': '0.64'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '4600', 'power_a': '0.67'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '4800', 'power_a': '0.69'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '5000', 'power_a': '0.72'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '5200', 'power_a': '0.75'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '5400', 'power_a': '0.78'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '5600', 'power_a': '0.81'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '5800', 'power_a': '0.84'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '6000', 'power_a': '0.87'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '6200', 'power_a': '0.9'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '6400', 'power_a': '0.93'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '6500', 'power_a': '0.96'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '6800', 'power_a': '0.98'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '200', 'power_a': '0.03'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '400', 'power_a': '0.07'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '600', 'power_a': '0.1'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '800', 'power_a': '0.13'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '950', 'power_a': '0.16'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '1000', 'power_a': '0.17'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '1160', 'power_a': '0.19'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '1200', 'power_a': '0.2'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '1400', 'power_a': '0.23'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '1425', 'power_a': '0.24'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '1600', 'power_a': '0.26'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '1750', 'power_a': '0.29'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '1800', 'power_a': '0.3'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '2000', 'power_a': '0.33'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '2000', 'power_a': '0.36'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '2400', 'power_a': '0.4'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '2600', 'power_a': '0.43'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '2800', 'power_a': '0.46'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '2850', 'power_a': '0.47'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '3000', 'power_a': '0.5'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '3200', 'power_a': '0.53'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '3400', 'power_a': '0.56'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '3450', 'power_a': '0.57'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '3600', 'power_a': '0.6'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '3800', 'power_a': '0.63'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '4000', 'power_a': '0.66'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '4200', 'power_a': '0.69'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '4400', 'power_a': '0.73'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '4600', 'power_a': '0.76'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '4800', 'power_a': '0.79'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '5000', 'power_a': '0.83'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '5200', 'power_a': '0.86'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '5400', 'power_a': '0.89'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '5600', 'power_a': '0.93'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '5800', 'power_a': '0.96'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '6000', 'power_a': '0.99'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '6200', 'power_a': '1.03'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '6400', 'power_a': '1.06'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '6500', 'power_a': '1.09'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '6800', 'power_a': '1.13'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '200', 'power_a': '0.04'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '400', 'power_a': '0.07'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '600', 'power_a': '0.11'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '800', 'power_a': '0.15'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '950', 'power_a': '0.18'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '1000', 'power_a': '0.19'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '1160', 'power_a': '0.22'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '1200', 'power_a': '0.22'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '1400', 'power_a': '0.26'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '1425', 'power_a': '0.27'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '1600', 'power_a': '0.3'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '1750', 'power_a': '0.33'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '1800', 'power_a': '0.34'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '2000', 'power_a': '0.37'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '2000', 'power_a': '0.41'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '2400', 'power_a': '0.45'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '2600', 'power_a': '0.48'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '2800', 'power_a': '0.52'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '2850', 'power_a': '0.53'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '3000', 'power_a': '0.56'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '3200', 'power_a': '0.6'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '3400', 'power_a': '0.63'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '3450', 'power_a': '0.64'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '3600', 'power_a': '0.67'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '3800', 'power_a': '0.71'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '4000', 'power_a': '0.74'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '4200', 'power_a': '0.78'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '4400', 'power_a': '0.82'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '4600', 'power_a': '0.86'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '4800', 'power_a': '0.89'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '5000', 'power_a': '0.93'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '5200', 'power_a': '0.97'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '5400', 'power_a': '1.01'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '5600', 'power_a': '1.04'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '5800', 'power_a': '1.08'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '6000', 'power_a': '1.12'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '6200', 'power_a': '1.15'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '6400', 'power_a': '1.19'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '6500', 'power_a': '1.23'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '6800', 'power_a': '1.27'})

HiPower_a_pb = ({'diameter': '65', 'rpm': '200', 'power_b': '0.19'}, {'diameter': '65', 'rpm': '400', 'power_b': '0.32'}, {'diameter': '65', 'rpm': '600', 'power_b': '0.42'}, {'diameter': '65', 'rpm': '800', 'power_b': '0.5'}, {'diameter': '65', 'rpm': '950', 'power_b': '0.55'}, {'diameter': '65', 'rpm': '1000', 'power_b': '0.57'}, {'diameter': '65', 'rpm': '1160', 'power_b': '0.61'}, {'diameter': '65', 'rpm': '1200', 'power_b': '0.62'}, {'diameter': '65', 'rpm': '1400', 'power_b': '0.67'}, {'diameter': '65', 'rpm': '1425', 'power_b': '0.67'}, {'diameter': '65', 'rpm': '1600', 'power_b': '0.71'}, {'diameter': '65', 'rpm': '1750', 'power_b': '0.73'}, {'diameter': '65', 'rpm': '1800', 'power_b': '0.74'}, {'diameter': '65', 'rpm': '2000', 'power_b': '0.76'}, {'diameter': '65', 'rpm': '2200', 'power_b': '0.77'}, {'diameter': '65', 'rpm': '2400', 'power_b': '0.71'}, {'diameter': '65', 'rpm': '2400', 'power_b': '0.78'}, {'diameter': '65', 'rpm': '2600', 'power_b': '0.78'}, {'diameter': '65', 'rpm': '2800', 'power_b': '0.77'}, {'diameter': '65', 'rpm': '2850', 'power_b': '0.77'}, {'diameter': '65', 'rpm': '3000', 'power_b': '0.76'}, {'diameter': '65', 'rpm': '3200', 'power_b': '0.74'}, {'diameter': '65', 'rpm': '3450', 'power_b': '0.7'}, {'diameter': '65', 'rpm': '3600', 'power_b': '0.68'}, {'diameter': '65', 'rpm': '3800', 'power_b': '0.63'}, {'diameter': '65', 'rpm': '4000', 'power_b': '0.58'}, {'diameter': '65', 'rpm': '4200', 'power_b': '0.53'}, {'diameter': '65', 'rpm': '4400', 'power_b': '0.47'}, {'diameter': '65', 'rpm': '4600', 'power_b': '0.39'}, {'diameter': '65', 'rpm': '4800', 'power_b': '0.32'}, {'diameter': '65', 'rpm': '5000', 'power_b': '0.23'}, {'diameter': '65', 'rpm': '5200', 'power_b': '0.14'}, {'diameter': '65', 'rpm': '5400', 'power_b': '0.03'}, {'diameter': '70', 'rpm': '200', 'power_b': '0.24'}, {'diameter': '70', 'rpm': '400', 'power_b': '0.41'}, {'diameter': '70', 'rpm': '600', 'power_b': '0.54'}, {'diameter': '70', 'rpm': '800', 'power_b': '0.66'}, {'diameter': '70', 'rpm': '950', 'power_b': '0.74'}, {'diameter': '70', 'rpm': '1000', 'power_b': '0.76'}, {'diameter': '70', 'rpm': '1160', 'power_b': '0.84'}, {'diameter': '70', 'rpm': '1200', 'power_b': '0.85'}, {'diameter': '70', 'rpm': '1400', 'power_b': '0.93'}, {'diameter': '70', 'rpm': '1425', 'power_b': '0.94'}, {'diameter': '70', 'rpm': '1600', 'power_b': '1'}, {'diameter': '70', 'rpm': '1750', 'power_b': '1.05'}, {'diameter': '70', 'rpm': '1800', 'power_b': '1.06'}, {'diameter': '70', 'rpm': '2000', 'power_b': '1.12'}, {'diameter': '70', 'rpm': '2200', 'power_b': '1.16'}, {'diameter': '70', 'rpm': '2400', 'power_b': '1.2'}, {'diameter': '70', 'rpm': '2400', 'power_b': '1.25'}, {'diameter': '70', 'rpm': '2600', 'power_b': '1.22'}, {'diameter': '70', 'rpm': '2800', 'power_b': '1.24'}, {'diameter': '70', 'rpm': '2850', 'power_b': '1.25'}, {'diameter': '70', 'rpm': '3000', 'power_b': '1.25'}, {'diameter': '70', 'rpm': '3200', 'power_b': '1.26'}, {'diameter': '70', 'rpm': '3450', 'power_b': '1.25'}, {'diameter': '70', 'rpm': '3600', 'power_b': '1.24'}, {'diameter': '70', 'rpm': '3800', 'power_b': '1.22'}, {'diameter': '70', 'rpm': '4000', 'power_b': '1.19'}, {'diameter': '70', 'rpm': '4200', 'power_b': '1.15'}, {'diameter': '70', 'rpm': '4400', 'power_b': '1.1'}, {'diameter': '70', 'rpm': '4600', 'power_b': '1.05'}, {'diameter': '70', 'rpm': '4800', 'power_b': '0.98'}, {'diameter': '70', 'rpm': '5000', 'power_b': '0.91'}, {'diameter': '70', 'rpm': '5200', 'power_b': '0.82'}, {'diameter': '70', 'rpm': '5400', 'power_b': '0.73'}, {'diameter': '70', 'rpm': '5600', 'power_b': '0.63'}, {'diameter': '70', 'rpm': '5800', 'power_b': '0.51'}, {'diameter': '70', 'rpm': '6000', 'power_b': '0.39'}, {'diameter': '70', 'rpm': '6200', 'power_b': '0.25'}, {'diameter': '70', 'rpm': '6400', 'power_b': '0.11'}, {'diameter': '75', 'rpm': '200', 'power_b': '0.29'}, {'diameter': '75', 'rpm': '400', 'power_b': '0.49'}, {'diameter': '75', 'rpm': '600', 'power_b': '0.67'}, {'diameter': '75', 'rpm': '800', 'power_b': '0.82'}, {'diameter': '75', 'rpm': '950', 'power_b': '0.92'}, {'diameter': '75', 'rpm': '1000', 'power_b': '0.96'}, {'diameter': '75', 'rpm': '1160', 'power_b': '1.06'}, {'diameter': '75', 'rpm': '1200', 'power_b': '1.08'}, {'diameter': '75', 'rpm': '1400', 'power_b': '1.19'}, {'diameter': '75', 'rpm': '1425', 'power_b': '1.21'}, {'diameter': '75', 'rpm': '1600', 'power_b': '1.3'}, {'diameter': '75', 'rpm': '1750', 'power_b': '1.37'}, {'diameter': '75', 'rpm': '1800', 'power_b': '1.39'}, {'diameter': '75', 'rpm': '2000', 'power_b': '1.47'}, {'diameter': '75', 'rpm': '2200', 'power_b': '1.54'}, {'diameter': '75', 'rpm': '2400', 'power_b': '1.61'}, {'diameter': '75', 'rpm': '2600', 'power_b': '1.66'}, {'diameter': '75', 'rpm': '2800', 'power_b': '1.7'}, {'diameter': '75', 'rpm': '2850', 'power_b': '1.71'}, {'diameter': '75', 'rpm': '3000', 'power_b': '1.74'}, {'diameter': '75', 'rpm': '3200', 'power_b': '1.77'}, {'diameter': '75', 'rpm': '3400', 'power_b': '1.78'}, {'diameter': '75', 'rpm': '3450', 'power_b': '1.79'}, {'diameter': '75', 'rpm': '3600', 'power_b': '1.79'}, {'diameter': '75', 'rpm': '3800', 'power_b': '1.79'}, {'diameter': '75', 'rpm': '4000', 'power_b': '1.77'}, {'diameter': '75', 'rpm': '4200', 'power_b': '1.75'}, {'diameter': '75', 'rpm': '4400', 'power_b': '1.72'}, {'diameter': '75', 'rpm': '4600', 'power_b': '1.67'}, {'diameter': '75', 'rpm': '4800', 'power_b': '1.62'}, {'diameter': '75', 'rpm': '5000', 'power_b': '1.55'}, {'diameter': '75', 'rpm': '5200', 'power_b': '1.48'}, {'diameter': '75', 'rpm': '5400', 'power_b': '1.39'}, {'diameter': '75', 'rpm': '5600', 'power_b': '1.29'}, {'diameter': '75', 'rpm': '5800', 'power_b': '1.17'}, {'diameter': '75', 'rpm': '6000', 'power_b': '1.05'}, {'diameter': '75', 'rpm': '6200', 'power_b': '0.91'}, {'diameter': '75', 'rpm': '6400', 'power_b': '0.76'}, {'diameter': '75', 'rpm': '6600', 'power_b': '0.59'}, {'diameter': '75', 'rpm': '6800', 'power_b': '0.41'}, {'diameter': '80', 'rpm': '200', 'power_b': '0.33'}, {'diameter': '80', 'rpm': '400', 'power_b': '0.58'}, {'diameter': '80', 'rpm': '600', 'power_b': '0.79'}, {'diameter': '80', 'rpm': '800', 'power_b': '0.98'}, {'diameter': '80', 'rpm': '950', 'power_b': '1.11'}, {'diameter': '80', 'rpm': '1000', 'power_b': '1.15'}, {'diameter': '80', 'rpm': '1160', 'power_b': '1.28'}, {'diameter': '80', 'rpm': '1200', 'power_b': '1.31'}, {'diameter': '80', 'rpm': '1400', 'power_b': '1.45'}, {'diameter': '80', 'rpm': '1425', 'power_b': '1.47'}, {'diameter': '80', 'rpm': '1600', 'power_b': '1.59'}, {'diameter': '80', 'rpm': '1750', 'power_b': '1.68'}, {'diameter': '80', 'rpm': '1800', 'power_b': '1.71'}, {'diameter': '80', 'rpm': '2000', 'power_b': '1.82'}, {'diameter': '80', 'rpm': '2200', 'power_b': '1.92'}, {'diameter': '80', 'rpm': '2400', 'power_b': '2.01'}, {'diameter': '80', 'rpm': '2600', 'power_b': '2.09'}, {'diameter': '80', 'rpm': '2800', 'power_b': '2.16'}, {'diameter': '80', 'rpm': '2850', 'power_b': '2.17'}, {'diameter': '80', 'rpm': '3000', 'power_b': '2.22'}, {'diameter': '80', 'rpm': '3200', 'power_b': '2.26'}, {'diameter': '80', 'rpm': '3400', 'power_b': '2.3'}, {'diameter': '80', 'rpm': '3450', 'power_b': '2.31'}, {'diameter': '80', 'rpm': '3600', 'power_b': '2.33'}, {'diameter': '80', 'rpm': '3800', 'power_b': '2.34'}, {'diameter': '80', 'rpm': '4000', 'power_b': '2.34'}, {'diameter': '80', 'rpm': '4200', 'power_b': '2.33'}, {'diameter': '80', 'rpm': '4400', 'power_b': '2.31'}, {'diameter': '80', 'rpm': '4600', 'power_b': '2.28'}, {'diameter': '80', 'rpm': '4800', 'power_b': '2.23'}, {'diameter': '80', 'rpm': '5000', 'power_b': '2.17'}, {'diameter': '80', 'rpm': '5200', 'power_b': '2.1'}, {'diameter': '80', 'rpm': '5400', 'power_b': '2.01'}, {'diameter': '80', 'rpm': '5600', 'power_b': '1.91'}, {'diameter': '80', 'rpm': '5800', 'power_b': '1.79'}, {'diameter': '80', 'rpm': '6000', 'power_b': '1.66'}, {'diameter': '80', 'rpm': '6200', 'power_b': '1.51'}, {'diameter': '80', 'rpm': '6400', 'power_b': '1.65'}, {'diameter': '80', 'rpm': '6600', 'power_b': '1.17'}, {'diameter': '80', 'rpm': '6800', 'power_b': '0.98'}, {'diameter': '85', 'rpm': '200', 'power_b': '0.38'}, {'diameter': '85', 'rpm': '400', 'power_b': '0.66'}, {'diameter': '85', 'rpm': '600', 'power_b': '0.91'}, {'diameter': '85', 'rpm': '800', 'power_b': '1.14'}, {'diameter': '85', 'rpm': '950', 'power_b': '1.29'}, {'diameter': '85', 'rpm': '1000', 'power_b': '1.34'}, {'diameter': '85', 'rpm': '1160', 'power_b': '1.5'}, {'diameter': '85', 'rpm': '1200', 'power_b': '1.53'}, {'diameter': '85', 'rpm': '1400', 'power_b': '1.71'}, {'diameter': '85', 'rpm': '1425', 'power_b': '1.73'}, {'diameter': '85', 'rpm': '1600', 'power_b': '1.87'}, {'diameter': '85', 'rpm': '1750', 'power_b': '1.99'}, {'diameter': '85', 'rpm': '1800', 'power_b': '2.03'}, {'diameter': '85', 'rpm': '2000', 'power_b': '2.16'}, {'diameter': '85', 'rpm': '2200', 'power_b': '2.29'}, {'diameter': '85', 'rpm': '2400', 'power_b': '2.41'}, {'diameter': '85', 'rpm': '2600', 'power_b': '2.51'}, {'diameter': '85', 'rpm': '2800', 'power_b': '2.6'}, {'diameter': '85', 'rpm': '2850', 'power_b': '2.62'}, {'diameter': '85', 'rpm': '3000', 'power_b': '2.68'}, {'diameter': '85', 'rpm': '3200', 'power_b': '2.75'}, {'diameter': '85', 'rpm': '3400', 'power_b': '2.81'}, {'diameter': '85', 'rpm': '3450', 'power_b': '2.82'}, {'diameter': '85', 'rpm': '3600', 'power_b': '2.85'}, {'diameter': '85', 'rpm': '3800', 'power_b': '2.88'}, {'diameter': '85', 'rpm': '4000', 'power_b': '2.89'}, {'diameter': '85', 'rpm': '4200', 'power_b': '2.89'}, {'diameter': '85', 'rpm': '4400', 'power_b': '2.88'}, {'diameter': '85', 'rpm': '4600', 'power_b': '2.85'}, {'diameter': '85', 'rpm': '4800', 'power_b': '2.81'}, {'diameter': '85', 'rpm': '5000', 'power_b': '2.75'}, {'diameter': '85', 'rpm': '5200', 'power_b': '2.68'}, {'diameter': '85', 'rpm': '5400', 'power_b': '2.59'}, {'diameter': '85', 'rpm': '5600', 'power_b': '2.48'}, {'diameter': '85', 'rpm': '5800', 'power_b': '2.36'}, {'diameter': '85', 'rpm': '6000', 'power_b': '2.22'}, {'diameter': '85', 'rpm': '6200', 'power_b': '2.06'}, {'diameter': '85', 'rpm': '6400', 'power_b': '1.88'}, {'diameter': '85', 'rpm': '6600', 'power_b': '1.68'}, {'diameter': '85', 'rpm': '6800', 'power_b': '1.46'}, {'diameter': '90', 'rpm': '200', 'power_b': '0.42'}, {'diameter': '90', 'rpm': '400', 'power_b': '0.74'}, {'diameter': '90', 'rpm': '600', 'power_b': '1.03'}, {'diameter': '90', 'rpm': '800', 'power_b': '1.29'}, {'diameter': '90', 'rpm': '950', 'power_b': '1.47'}, {'diameter': '90', 'rpm': '1000', 'power_b': '1.53'}, {'diameter': '90', 'rpm': '1160', 'power_b': '1.71'}, {'diameter': '90', 'rpm': '1200', 'power_b': '1.76'}, {'diameter': '90', 'rpm': '1400', 'power_b': '1.96'}, {'diameter': '90', 'rpm': '1425', 'power_b': '1.99'}, {'diameter': '90', 'rpm': '1600', 'power_b': '2.16'}, {'diameter': '90', 'rpm': '1750', 'power_b': '2.3'}, {'diameter': '90', 'rpm': '1800', 'power_b': '2.34'}, {'diameter': '90', 'rpm': '2000', 'power_b': '2.51'}, {'diameter': '90', 'rpm': '2200', 'power_b': '2.66'}, {'diameter': '90', 'rpm': '2400', 'power_b': '2.8'}, {'diameter': '90', 'rpm': '2600', 'power_b': '2.93'}, {'diameter': '90', 'rpm': '2800', 'power_b': '3.04'}, {'diameter': '90', 'rpm': '2850', 'power_b': '2.07'}, {'diameter': '90', 'rpm': '3000', 'power_b': '3.14'}, {'diameter': '90', 'rpm': '3200', 'power_b': '3.23'}, {'diameter': '90', 'rpm': '3400', 'power_b': '3.3'}, {'diameter': '90', 'rpm': '3450', 'power_b': '3.31'}, {'diameter': '90', 'rpm': '3600', 'power_b': '3.35'}, {'diameter': '90', 'rpm': '3800', 'power_b': '3.4'}, {'diameter': '90', 'rpm': '4000', 'power_b': '3.42'}, {'diameter': '90', 'rpm': '4200', 'power_b': '3.43'}, {'diameter': '90', 'rpm': '4400', 'power_b': '3.43'}, {'diameter': '90', 'rpm': '4600', 'power_b': '3.4'}, {'diameter': '90', 'rpm': '4800', 'power_b': '3.36'}, {'diameter': '90', 'rpm': '5000', 'power_b': '3.3'}, {'diameter': '90', 'rpm': '5200', 'power_b': '3.22'}, {'diameter': '90', 'rpm': '5400', 'power_b': '3.13'}, {'diameter': '90', 'rpm': '5600', 'power_b': '3.01'}, {'diameter': '90', 'rpm': '5800', 'power_b': '2.87'}, {'diameter': '90', 'rpm': '6000', 'power_b': '2.72'}, {'diameter': '90', 'rpm': '6200', 'power_b': '2.54'}, {'diameter': '90', 'rpm': '6400', 'power_b': '2.34'}, {'diameter': '95', 'rpm': '200', 'power_b': '0.47'}, {'diameter': '95', 'rpm': '400', 'power_b': '0.83'}, {'diameter': '95', 'rpm': '600', 'power_b': '1.15'}, {'diameter': '95', 'rpm': '800', 'power_b': '1.45'}, {'diameter': '95', 'rpm': '950', 'power_b': '1.65'}, {'diameter': '95', 'rpm': '1000', 'power_b': '1.72'}, {'diameter': '95', 'rpm': '1160', 'power_b': '1.93'}, {'diameter': '95', 'rpm': '1200', 'power_b': '1.98'}, {'diameter': '95', 'rpm': '1400', 'power_b': '2.22'}, {'diameter': '95', 'rpm': '1425', 'power_b': '2.25'}, {'diameter': '95', 'rpm': '1600', 'power_b': '2.44'}, {'diameter': '95', 'rpm': '1750', 'power_b': '2.6'}, {'diameter': '95', 'rpm': '1800', 'power_b': '2.65'}, {'diameter': '95', 'rpm': '2000', 'power_b': '2.84'}, {'diameter': '95', 'rpm': '2200', 'power_b': '3.02'}, {'diameter': '95', 'rpm': '2400', 'power_b': '3.19'}, {'diameter': '95', 'rpm': '2600', 'power_b': '3.34'}, {'diameter': '95', 'rpm': '2800', 'power_b': '3.47'}, {'diameter': '95', 'rpm': '2850', 'power_b': '3.5'}, {'diameter': '95', 'rpm': '3000', 'power_b': '3.57'}, {'diameter': '95', 'rpm': '3200', 'power_b': '3.69'}, {'diameter': '95', 'rpm': '3400', 'power_b': '3.78'}, {'diameter': '95', 'rpm': '3450', 'power_b': '3.8'}, {'diameter': '95', 'rpm': '3600', 'power_b': '3.85'}, {'diameter': '95', 'rpm': '3800', 'power_b': '3.9'}, {'diameter': '95', 'rpm': '4000', 'power_b': '3.93'}, {'diameter': '95', 'rpm': '4200', 'power_b': '3.95'}, {'diameter': '95', 'rpm': '4400', 'power_b': '3.94'}, {'diameter': '95', 'rpm': '4600', 'power_b': '3.92'}, {'diameter': '95', 'rpm': '4800', 'power_b': '3.88'}, {'diameter': '95', 'rpm': '5000', 'power_b': '3.81'}, {'diameter': '95', 'rpm': '5200', 'power_b': '3.73'}, {'diameter': '95', 'rpm': '5400', 'power_b': '3.62'}, {'diameter': '95', 'rpm': '5600', 'power_b': '3.49'}, {'diameter': '95', 'rpm': '5800', 'power_b': '3.34'}, {'diameter': '95', 'rpm': '6000', 'power_b': '3.16'}, {'diameter': '95', 'rpm': '6200', 'power_b': '2.96'}, {'diameter': '100', 'rpm': '200', 'power_b': '0.51'}, {'diameter': '100', 'rpm': '400', 'power_b': '0.91'}, {'diameter': '100', 'rpm': '600', 'power_b': '1.27'}, {'diameter': '100', 'rpm': '800', 'power_b': '1.6'}, {'diameter': '100', 'rpm': '950', 'power_b': '1.83'}, {'diameter': '100', 'rpm': '1000', 'power_b': '1.91'}, {'diameter': '100', 'rpm': '1160', 'power_b': '2.14'}, {'diameter': '100', 'rpm': '1200', 'power_b': '2.2'}, {'diameter': '100', 'rpm': '1400', 'power_b': '2.47'}, {'diameter': '100', 'rpm': '1425', 'power_b': '2.5'}, {'diameter': '100', 'rpm': '1600', 'power_b': '2.72'}, {'diameter': '100', 'rpm': '1750', 'power_b': '2.9'}, {'diameter': '100', 'rpm': '1800', 'power_b': '2.96'}, {'diameter': '100', 'rpm': '2000', 'power_b': '3.18'}, {'diameter': '100', 'rpm': '2200', 'power_b': '3.38'}, {'diameter': '100', 'rpm': '2400', 'power_b': '3.57'}, {'diameter': '100', 'rpm': '2600', 'power_b': '3.74'}, {'diameter': '100', 'rpm': '2800', 'power_b': '3.89'}, {'diameter': '100', 'rpm': '2850', 'power_b': '3.93'}, {'diameter': '100', 'rpm': '3000', 'power_b': '4.03'}, {'diameter': '100', 'rpm': '3200', 'power_b': '4.14'}, {'diameter': '100', 'rpm': '3400', 'power_b': '4.24'}, {'diameter': '100', 'rpm': '3450', 'power_b': '4.26'}, {'diameter': '100', 'rpm': '3600', 'power_b': '4.32'}, {'diameter': '100', 'rpm': '3800', 'power_b': '4.38'}, {'diameter': '100', 'rpm': '4000', 'power_b': '4.42'}, {'diameter': '100', 'rpm': '4200', 'power_b': '4.44'}, {'diameter': '100', 'rpm': '4400', 'power_b': '4.44'}, {'diameter': '100', 'rpm': '4600', 'power_b': '4.41'}, {'diameter': '100', 'rpm': '4800', 'power_b': '4.36'}, {'diameter': '100', 'rpm': '5000', 'power_b': '4.29'}, {'diameter': '100', 'rpm': '5200', 'power_b': '4.19'}, {'diameter': '100', 'rpm': '5400', 'power_b': '4.07'}, {'diameter': '100', 'rpm': '5600', 'power_b': '3.92'}, {'diameter': '100', 'rpm': '5800', 'power_b': '3.74'}, {'diameter': '105', 'rpm': '200', 'power_b': '0.55'}, {'diameter': '105', 'rpm': '400', 'power_b': '0.99'}, {'diameter': '105', 'rpm': '600', 'power_b': '1.39'}, {'diameter': '105', 'rpm': '800', 'power_b': '1.75'}, {'diameter': '105', 'rpm': '950', 'power_b': '2.01'}, {'diameter': '105', 'rpm': '1000', 'power_b': '2.1'}, {'diameter': '105', 'rpm': '1160', 'power_b': '2.35'}, {'diameter': '105', 'rpm': '1200', 'power_b': '2.42'}, {'diameter': '105', 'rpm': '1400', 'power_b': '2.72'}, {'diameter': '105', 'rpm': '1425', 'power_b': '2.75'}, {'diameter': '105', 'rpm': '1600', 'power_b': '3'}, {'diameter': '105', 'rpm': '1750', 'power_b': '3.2'}, {'diameter': '105', 'rpm': '1800', 'power_b': '3.26'}, {'diameter': '105', 'rpm': '2000', 'power_b': '3.51'}, {'diameter': '105', 'rpm': '2200', 'power_b': '3.73'}, {'diameter': '105', 'rpm': '2400', 'power_b': '3.94'}, {'diameter': '105', 'rpm': '2600', 'power_b': '4.13'}, {'diameter': '105', 'rpm': '2800', 'power_b': '4.3'}, {'diameter': '105', 'rpm': '2850', 'power_b': '4.34'}, {'diameter': '105', 'rpm': '3000', 'power_b': '4.45'}, {'diameter': '105', 'rpm': '3200', 'power_b': '4.59'}, {'diameter': '105', 'rpm': '3400', 'power_b': '4.69'}, {'diameter': '105', 'rpm': '3450', 'power_b': '4.72'}, {'diameter': '105', 'rpm': '3600', 'power_b': '4.78'}, {'diameter': '105', 'rpm': '3800', 'power_b': '4.85'}, {'diameter': '105', 'rpm': '4000', 'power_b': '4.89'}, {'diameter': '105', 'rpm': '4200', 'power_b': '4.91'}, {'diameter': '105', 'rpm': '4400', 'power_b': '4.9'}, {'diameter': '105', 'rpm': '4600', 'power_b': '4.87'}, {'diameter': '105', 'rpm': '4800', 'power_b': '4.81'}, {'diameter': '105', 'rpm': '5000', 'power_b': '4.73'}, {'diameter': '105', 'rpm': '5200', 'power_b': '4.61'}, {'diameter': '105', 'rpm': '5400', 'power_b': '4.47'}, {'diameter': '105', 'rpm': '5600', 'power_b': '4.3'}, {'diameter': '110', 'rpm': '200', 'power_b': '0.6'}, {'diameter': '110', 'rpm': '400', 'power_b': '1.08'}, {'diameter': '110', 'rpm': '600', 'power_b': '1.51'}, {'diameter': '110', 'rpm': '800', 'power_b': '1.91'}, {'diameter': '110', 'rpm': '950', 'power_b': '2.19'}, {'diameter': '110', 'rpm': '1000', 'power_b': '2.28'}, {'diameter': '110', 'rpm': '1160', 'power_b': '2.56'}, {'diameter': '110', 'rpm': '1200', 'power_b': '2.63'}, {'diameter': '110', 'rpm': '1400', 'power_b': '2.96'}, {'diameter': '110', 'rpm': '1425', 'power_b': '3'}, {'diameter': '110', 'rpm': '1600', 'power_b': '3.27'}, {'diameter': '110', 'rpm': '1750', 'power_b': '3.49'}, {'diameter': '110', 'rpm': '1800', 'power_b': '3.56'}, {'diameter': '110', 'rpm': '2000', 'power_b': '3.83'}, {'diameter': '110', 'rpm': '2200', 'power_b': '4.08'}, {'diameter': '110', 'rpm': '2400', 'power_b': '4.31'}, {'diameter': '110', 'rpm': '2600', 'power_b': '4.52'}, {'diameter': '110', 'rpm': '2800', 'power_b': '4.71'}, {'diameter': '110', 'rpm': '2850', 'power_b': '4.75'}, {'diameter': '110', 'rpm': '3000', 'power_b': '4.87'}, {'diameter': '110', 'rpm': '3200', 'power_b': '5.01'}, {'diameter': '110', 'rpm': '3400', 'power_b': '5.13'}, {'diameter': '110', 'rpm': '3450', 'power_b': '5.16'}, {'diameter': '110', 'rpm': '3600', 'power_b': '5.23'}, {'diameter': '110', 'rpm': '3800', 'power_b': '5.3'}, {'diameter': '110', 'rpm': '4000', 'power_b': '5.34'}, {'diameter': '110', 'rpm': '4200', 'power_b': '5.35'}, {'diameter': '110', 'rpm': '4400', 'power_b': '5.34'}, {'diameter': '110', 'rpm': '4600', 'power_b': '5.3'}, {'diameter': '110', 'rpm': '4800', 'power_b': '5.23'}, {'diameter': '110', 'rpm': '5000', 'power_b': '5.12'}, {'diameter': '110', 'rpm': '5200', 'power_b': '4.99'}, {'diameter': '110', 'rpm': '5400', 'power_b': '4.82'}, {'diameter': '115', 'rpm': '200', 'power_b': '0.64'}, {'diameter': '115', 'rpm': '400', 'power_b': '1.16'}, {'diameter': '115', 'rpm': '600', 'power_b': '1.63'}, {'diameter': '115', 'rpm': '800', 'power_b': '2.06'}, {'diameter': '115', 'rpm': '950', 'power_b': '2.37'}, {'diameter': '115', 'rpm': '1000', 'power_b': '2.46'}, {'diameter': '115', 'rpm': '1160', 'power_b': '2.77'}, {'diameter': '115', 'rpm': '1200', 'power_b': '2.85'}, {'diameter': '115', 'rpm': '1400', 'power_b': '3.21'}, {'diameter': '115', 'rpm': '1425', 'power_b': '3.25'}, {'diameter': '115', 'rpm': '1600', 'power_b': '3.54'}, {'diameter': '115', 'rpm': '1750', 'power_b': '3.78'}, {'diameter': '115', 'rpm': '1800', 'power_b': '3.86'}, {'diameter': '115', 'rpm': '2000', 'power_b': '4.15'}, {'diameter': '115', 'rpm': '2200', 'power_b': '4.42'}, {'diameter': '115', 'rpm': '2400', 'power_b': '4.67'}, {'diameter': '115', 'rpm': '2600', 'power_b': '4.9'}, {'diameter': '115', 'rpm': '2800', 'power_b': '5.1'}, {'diameter': '115', 'rpm': '2850', 'power_b': '5.15'}, {'diameter': '115', 'rpm': '3000', 'power_b': '5.28'}, {'diameter': '115', 'rpm': '3200', 'power_b': '5.43'}, {'diameter': '115', 'rpm': '3400', 'power_b': '5.56'}, {'diameter': '115', 'rpm': '3450', 'power_b': '5.58'}, {'diameter': '115', 'rpm': '3600', 'power_b': '5.65'}, {'diameter': '115', 'rpm': '3800', 'power_b': '5.72'}, {'diameter': '115', 'rpm': '4000', 'power_b': '5.76'}, {'diameter': '115', 'rpm': '4200', 'power_b': '5.77'}, {'diameter': '115', 'rpm': '4400', 'power_b': '5.75'}, {'diameter': '115', 'rpm': '4600', 'power_b': '5.69'}, {'diameter': '115', 'rpm': '4800', 'power_b': '5.6'}, {'diameter': '115', 'rpm': '5000', 'power_b': '5.48'}, {'diameter': '120', 'rpm': '200', 'power_b': '0.68'}, {'diameter': '120', 'rpm': '400', 'power_b': '1.24'}, {'diameter': '120', 'rpm': '600', 'power_b': '1.74'}, {'diameter': '120', 'rpm': '800', 'power_b': '2.21'}, {'diameter': '120', 'rpm': '950', 'power_b': '2.54'}, {'diameter': '120', 'rpm': '1000', 'power_b': '2.65'}, {'diameter': '120', 'rpm': '1160', 'power_b': '2.98'}, {'diameter': '120', 'rpm': '1200', 'power_b': '3.06'}, {'diameter': '120', 'rpm': '1400', 'power_b': '3.45'}, {'diameter': '120', 'rpm': '1425', 'power_b': '3.49'}, {'diameter': '120', 'rpm': '1600', 'power_b': '3.81'}, {'diameter': '120', 'rpm': '1750', 'power_b': '4.07'}, {'diameter': '120', 'rpm': '1800', 'power_b': '4.15'}, {'diameter': '120', 'rpm': '2000', 'power_b': '4.47'}, {'diameter': '120', 'rpm': '2200', 'power_b': '4.76'}, {'diameter': '120', 'rpm': '2400', 'power_b': '5.03'}, {'diameter': '120', 'rpm': '2600', 'power_b': '5.27'}, {'diameter': '120', 'rpm': '2800', 'power_b': '5.49'}, {'diameter': '120', 'rpm': '2850', 'power_b': '5.54'}, {'diameter': '120', 'rpm': '3000', 'power_b': '5.67'}, {'diameter': '120', 'rpm': '3200', 'power_b': '5.83'}, {'diameter': '120', 'rpm': '3400', 'power_b': '5.96'}, {'diameter': '120', 'rpm': '3450', 'power_b': '5.99'}, {'diameter': '120', 'rpm': '3600', 'power_b': '6.06'}, {'diameter': '120', 'rpm': '3800', 'power_b': '6.13'}, {'diameter': '120', 'rpm': '4000', 'power_b': '6.16'}, {'diameter': '120', 'rpm': '4200', 'power_b': '6.16'}, {'diameter': '120', 'rpm': '4400', 'power_b': '6.13'}, {'diameter': '120', 'rpm': '4600', 'power_b': '6.05'}, {'diameter': '120', 'rpm': '4800', 'power_b': '5.94'}, {'diameter': '125', 'rpm': '200', 'power_b': '0.73'}, {'diameter': '125', 'rpm': '400', 'power_b': '1.32'}, {'diameter': '125', 'rpm': '600', 'power_b': '1.86'}, {'diameter': '125', 'rpm': '800', 'power_b': '2.36'}, {'diameter': '125', 'rpm': '950', 'power_b': '2.71'}, {'diameter': '125', 'rpm': '1000', 'power_b': '283'}, {'diameter': '125', 'rpm': '1160', 'power_b': '3.19'}, {'diameter': '125', 'rpm': '1200', 'power_b': '3.27'}, {'diameter': '125', 'rpm': '1400', 'power_b': '3.69'}, {'diameter': '125', 'rpm': '1425', 'power_b': '3.74'}, {'diameter': '125', 'rpm': '1600', 'power_b': '4.08'}, {'diameter': '125', 'rpm': '1750', 'power_b': '4.35'}, {'diameter': '125', 'rpm': '1800', 'power_b': '4.44'}, {'diameter': '125', 'rpm': '2000', 'power_b': '4.78'}, {'diameter': '125', 'rpm': '2200', 'power_b': '5.09'}, {'diameter': '125', 'rpm': '2400', 'power_b': '5.38'}, {'diameter': '125', 'rpm': '2600', 'power_b': '5.63'}, {'diameter': '125', 'rpm': '2800', 'power_b': '5.86'}, {'diameter': '125', 'rpm': '2850', 'power_b': '5.91'}, {'diameter': '125', 'rpm': '3000', 'power_b': '6.06'}, {'diameter': '125', 'rpm': '3200', 'power_b': '6.22'}, {'diameter': '125', 'rpm': '3400', 'power_b': '6.36'}, {'diameter': '125', 'rpm': '3450', 'power_b': '6.38'}, {'diameter': '125', 'rpm': '3600', 'power_b': '6.45'}, {'diameter': '125', 'rpm': '3800', 'power_b': '6.52'}, {'diameter': '125', 'rpm': '4000', 'power_b': '6.54'}, {'diameter': '125', 'rpm': '4200', 'power_b': '6.53'}, {'diameter': '125', 'rpm': '4400', 'power_b': '6.47'}, {'diameter': '125', 'rpm': '4600', 'power_b': '6.38'}, {'diameter': '140', 'rpm': '200', 'power_b': '0.86'}, {'diameter': '140', 'rpm': '400', 'power_b': '1.56'}, {'diameter': '140', 'rpm': '600', 'power_b': '2.2'}, {'diameter': '140', 'rpm': '800', 'power_b': '2.8'}, {'diameter': '140', 'rpm': '950', 'power_b': '3.23'}, {'diameter': '140', 'rpm': '1000', 'power_b': '3.37'}, {'diameter': '140', 'rpm': '1160', 'power_b': '3.79'}, {'diameter': '140', 'rpm': '1200', 'power_b': '3.9'}, {'diameter': '140', 'rpm': '1400', 'power_b': '4.39'}, {'diameter': '140', 'rpm': '1425', 'power_b': '4.45'}, {'diameter': '140', 'rpm': '1600', 'power_b': '4.86'}, {'diameter': '140', 'rpm': '1750', 'power_b': '5.19'}, {'diameter': '140', 'rpm': '1800', 'power_b': '5.29'}, {'diameter': '140', 'rpm': '2000', 'power_b': '5.69'}, {'diameter': '140', 'rpm': '2200', 'power_b': '6.06'}, {'diameter': '140', 'rpm': '2400', 'power_b': '6.39'}, {'diameter': '140', 'rpm': '2600', 'power_b': '6.68'}, {'diameter': '140', 'rpm': '2800', 'power_b': '6.93'}, {'diameter': '140', 'rpm': '2850', 'power_b': '6.99'}, {'diameter': '140', 'rpm': '3000', 'power_b': '7.14'}, {'diameter': '140', 'rpm': '3200', 'power_b': '7.31'}, {'diameter': '140', 'rpm': '3400', 'power_b': '7.44'}, {'diameter': '140', 'rpm': '3450', 'power_b': '7.46'}, {'diameter': '140', 'rpm': '3600', 'power_b': '7.51'}, {'diameter': '140', 'rpm': '3800', 'power_b': '7.54'}, {'diameter': '140', 'rpm': '4000', 'power_b': '7.52'}, {'diameter': '140', 'rpm': '4200', 'power_b': '7.45'}, {'diameter': '150', 'rpm': '200', 'power_b': '0.94'}, {'diameter': '150', 'rpm': '400', 'power_b': '1.72'}, {'diameter': '150', 'rpm': '600', 'power_b': '2.43'}, {'diameter': '150', 'rpm': '800', 'power_b': '3.1'}, {'diameter': '150', 'rpm': '950', 'power_b': '3.57'}, {'diameter': '150', 'rpm': '1000', 'power_b': '3.72'}, {'diameter': '150', 'rpm': '1160', 'power_b': '4.19'}, {'diameter': '150', 'rpm': '1200', 'power_b': '4.31'}, {'diameter': '150', 'rpm': '1400', 'power_b': '4.86'}, {'diameter': '150', 'rpm': '1425', 'power_b': '4.92'}, {'diameter': '150', 'rpm': '1600', 'power_b': '5.37'}, {'diameter': '150', 'rpm': '1750', 'power_b': '5.73'}, {'diameter': '150', 'rpm': '1800', 'power_b': '5.84'}, {'diameter': '150', 'rpm': '2000', 'power_b': '6.28'}, {'diameter': '150', 'rpm': '2200', 'power_b': '6.67'}, {'diameter': '150', 'rpm': '2400', 'power_b': '7.03'}, {'diameter': '150', 'rpm': '2600', 'power_b': '7.33'}, {'diameter': '150', 'rpm': '2800', 'power_b': '7.59'}, {'diameter': '150', 'rpm': '2850', 'power_b': '7.65'}, {'diameter': '150', 'rpm': '3000', 'power_b': '7.81'}, {'diameter': '150', 'rpm': '3200', 'power_b': '7.97'}, {'diameter': '150', 'rpm': '3400', 'power_b': '8.07'}, {'diameter': '150', 'rpm': '3450', 'power_b': '8.09'}, {'diameter': '150', 'rpm': '3600', 'power_b': '8.12'}, {'diameter': '150', 'rpm': '3800', 'power_b': '8.11'}, {'diameter': '150', 'rpm': '4000', 'power_b': '8.04'}, {'diameter': '165', 'rpm': '200', 'power_b': '1.07'}, {'diameter': '165', 'rpm': '400', 'power_b': '1.96'}, {'diameter': '165', 'rpm': '600', 'power_b': '2.77'}, {'diameter': '165', 'rpm': '800', 'power_b': '3.53'}, {'diameter': '165', 'rpm': '950', 'power_b': '4.07'}, {'diameter': '165', 'rpm': '1000', 'power_b': '4.24'}, {'diameter': '165', 'rpm': '1160', 'power_b': '4.78'}, {'diameter': '165', 'rpm': '1200', 'power_b': '4.91'}, {'diameter': '165', 'rpm': '1400', 'power_b': '5.53'}, {'diameter': '165', 'rpm': '1425', 'power_b': '5.61'}, {'diameter': '165', 'rpm': '1600', 'power_b': '6.11'}, {'diameter': '165', 'rpm': '1750', 'power_b': '6.51'}, {'diameter': '165', 'rpm': '1800', 'power_b': '6.64'}, {'diameter': '165', 'rpm': '2000', 'power_b': '7.12'}, {'diameter': '165', 'rpm': '2200', 'power_b': '7.55'}, {'diameter': '165', 'rpm': '2400', 'power_b': '7.93'}, {'diameter': '165', 'rpm': '2600', 'power_b': '8.25'}, {'diameter': '165', 'rpm': '2800', 'power_b': '8.51'}, {'diameter': '165', 'rpm': '2850', 'power_b': '8.56'}, {'diameter': '165', 'rpm': '3000', 'power_b': '8.7'}, {'diameter': '165', 'rpm': '3200', 'power_b': '8.83'}, {'diameter': '165', 'rpm': '3400', 'power_b': '8.89'}, {'diameter': '165', 'rpm': '3450', 'power_b': '8.89'}, {'diameter': '165', 'rpm': '3600', 'power_b': '8.87'}, {'diameter': '180', 'rpm': '200', 'power_b': '1.19'}, {'diameter': '180', 'rpm': '400', 'power_b': '2.19'}, {'diameter': '180', 'rpm': '600', 'power_b': '3.11'}, {'diameter': '180', 'rpm': '800', 'power_b': '3.96'}, {'diameter': '180', 'rpm': '950', 'power_b': '4.56'}, {'diameter': '180', 'rpm': '1000', 'power_b': '4.76'}, {'diameter': '180', 'rpm': '1160', 'power_b': '5.36'}, {'diameter': '180', 'rpm': '1200', 'power_b': '5.5'}, {'diameter': '180', 'rpm': '1400', 'power_b': '6.19'}, {'diameter': '180', 'rpm': '1425', 'power_b': '6.28'}, {'diameter': '180', 'rpm': '1600', 'power_b': '6.83'}, {'diameter': '180', 'rpm': '1750', 'power_b': '7.27'}, {'diameter': '180', 'rpm': '1800', 'power_b': '7.41'}, {'diameter': '180', 'rpm': '2000', 'power_b': '7.93'}, {'diameter': '180', 'rpm': '2200', 'power_b': '8.38'}, {'diameter': '180', 'rpm': '2400', 'power_b': '8.77'}, {'diameter': '180', 'rpm': '2600', 'power_b': '9.08'}, {'diameter': '180', 'rpm': '2800', 'power_b': '9.32'}, {'diameter': '180', 'rpm': '2850', 'power_b': '9.36'}, {'diameter': '180', 'rpm': '3000', 'power_b': '9.47'}, {'diameter': '180', 'rpm': '3200', 'power_b': '9.55'}, {'diameter': '190', 'rpm': '200', 'power_b': '1.28'}, {'diameter': '190', 'rpm': '400', 'power_b': '2.35'}, {'diameter': '190', 'rpm': '600', 'power_b': '3.33'}, {'diameter': '190', 'rpm': '800', 'power_b': '4.24'}, {'diameter': '190', 'rpm': '950', 'power_b': '4.89'}, {'diameter': '190', 'rpm': '1000', 'power_b': '5.1'}, {'diameter': '190', 'rpm': '1160', 'power_b': '5.74'}, {'diameter': '190', 'rpm': '1200', 'power_b': '5.89'}, {'diameter': '190', 'rpm': '1400', 'power_b': '6.62'}, {'diameter': '190', 'rpm': '1425', 'power_b': '6.71'}, {'diameter': '190', 'rpm': '1600', 'power_b': '7.29'}, {'diameter': '190', 'rpm': '1750', 'power_b': '7.76'}, {'diameter': '190', 'rpm': '1800', 'power_b': '7.9'}, {'diameter': '190', 'rpm': '2000', 'power_b': '8.44'}, {'diameter': '190', 'rpm': '2200', 'power_b': '8.9'}, {'diameter': '190', 'rpm': '2400', 'power_b': '9.28'}, {'diameter': '190', 'rpm': '2600', 'power_b': '9.58'}, {'diameter': '190', 'rpm': '2800', 'power_b': '9.8'}, {'diameter': '190', 'rpm': '2850', 'power_b': '9.83'}, {'diameter': '190', 'rpm': '3000', 'power_b': '9.92'}, {'diameter': '190', 'rpm': '3200', 'power_b': '9.94'})

HiPower_b_pa = ({'gr_low': '1', 'gr_high': '1.02', 'rpm': '200', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '400', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '600', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '725', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '800', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '870', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '950', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1000', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1160', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1200', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1400', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1425', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1600', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1750', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1800', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '2000', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '2200', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '2400', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '2600', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '2800', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '2850', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '3000', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '3200', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '3400', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '3450', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '3600', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '3800', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '4000', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '4200', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '4400', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '4600', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '4800', 'power_a': '0'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '200', 'power_a': '0.01'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '400', 'power_a': '0.02'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '600', 'power_a': '0.03'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '725', 'power_a': '0.04'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '800', 'power_a': '0.04'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '870', 'power_a': '0.04'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '950', 'power_a': '0.05'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '1000', 'power_a': '0.05'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '1160', 'power_a': '0.06'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '1200', 'power_a': '0.06'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '1400', 'power_a': '0.07'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '1425', 'power_a': '0.07'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '1600', 'power_a': '0.08'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '1750', 'power_a': '0.09'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '1800', 'power_a': '0.09'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '2000', 'power_a': '0.1'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '2200', 'power_a': '0.11'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '2400', 'power_a': '0.12'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '2600', 'power_a': '0.13'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '2800', 'power_a': '0.14'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '2850', 'power_a': '0.14'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '3000', 'power_a': '0.15'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '3200', 'power_a': '0.16'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '3400', 'power_a': '0.17'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '3450', 'power_a': '0.17'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '3600', 'power_a': '0.18'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '3800', 'power_a': '0.19'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '4000', 'power_a': '0.2'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '4200', 'power_a': '0.21'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '4400', 'power_a': '0.22'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '4600', 'power_a': '0.23'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '4800', 'power_a': '0.24'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '200', 'power_a': '0.02'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '400', 'power_a': '0.04'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '600', 'power_a': '0.06'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '725', 'power_a': '0.07'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '800', 'power_a': '0.08'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '870', 'power_a': '0.09'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '950', 'power_a': '0.09'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '1000', 'power_a': '0.1'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '1160', 'power_a': '0.11'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '1200', 'power_a': '0.12'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '1400', 'power_a': '0.14'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '1425', 'power_a': '0.14'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '1600', 'power_a': '0.16'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '1750', 'power_a': '0.17'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '1800', 'power_a': '0.18'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '2000', 'power_a': '0.2'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '2200', 'power_a': '0.22'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '2400', 'power_a': '0.24'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '2600', 'power_a': '0.26'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '2800', 'power_a': '0.28'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '2850', 'power_a': '0.28'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '3000', 'power_a': '0.3'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '3200', 'power_a': '0.32'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '3400', 'power_a': '0.34'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '3450', 'power_a': '0.34'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '3600', 'power_a': '0.36'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '3800', 'power_a': '0.37'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '4000', 'power_a': '0.39'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '4200', 'power_a': '0.41'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '4400', 'power_a': '0.43'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '4600', 'power_a': '0.45'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '4800', 'power_a': '0.47'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '200', 'power_a': '0.03'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '400', 'power_a': '0.06'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '600', 'power_a': '0.09'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '725', 'power_a': '0.11'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '800', 'power_a': '0.12'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '870', 'power_a': '0.13'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '950', 'power_a': '0.14'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '1000', 'power_a': '0.15'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '1160', 'power_a': '0.17'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '1200', 'power_a': '0.18'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '1400', 'power_a': '0.21'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '1425', 'power_a': '0.21'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '1600', 'power_a': '0.24'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '1750', 'power_a': '0.26'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '1800', 'power_a': '0.27'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '2000', 'power_a': '0.3'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '2200', 'power_a': '0.33'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '2400', 'power_a': '0.35'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '2600', 'power_a': '0.38'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '2800', 'power_a': '0.41'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '2850', 'power_a': '0.42'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '3000', 'power_a': '0.44'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '3200', 'power_a': '0.47'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '3400', 'power_a': '0.5'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '3450', 'power_a': '0.51'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '3600', 'power_a': '0.53'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '3800', 'power_a': '0.56'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '4000', 'power_a': '0.59'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '4200', 'power_a': '0.62'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '4400', 'power_a': '0.65'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '4600', 'power_a': '0.68'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '4800', 'power_a': '0.71'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '200', 'power_a': '0.04'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '400', 'power_a': '0.08'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '600', 'power_a': '0.12'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '725', 'power_a': '0.14'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '800', 'power_a': '0.16'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '870', 'power_a': '0.17'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '950', 'power_a': '0.19'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '1000', 'power_a': '0.2'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '1160', 'power_a': '0.23'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '1200', 'power_a': '0.24'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '1400', 'power_a': '0.28'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '1425', 'power_a': '0.28'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '1600', 'power_a': '0.32'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '1750', 'power_a': '0.35'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '1800', 'power_a': '0.35'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '2000', 'power_a': '0.39'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '2200', 'power_a': '0.43'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '2400', 'power_a': '0.47'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '2600', 'power_a': '0.51'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '2800', 'power_a': '0.55'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '2850', 'power_a': '0.56'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '3000', 'power_a': '0.59'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '3200', 'power_a': '0.63'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '3400', 'power_a': '0.67'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '3450', 'power_a': '0.68'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '3600', 'power_a': '0.71'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '3800', 'power_a': '0.75'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '4000', 'power_a': '0.79'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '4200', 'power_a': '0.83'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '4400', 'power_a': '0.87'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '4600', 'power_a': '0.91'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '4800', 'power_a': '0.95'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '200', 'power_a': '0.05'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '400', 'power_a': '0.1'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '600', 'power_a': '0.15'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '725', 'power_a': '0.18'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '800', 'power_a': '0.2'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '870', 'power_a': '0.21'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '950', 'power_a': '0.23'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '1000', 'power_a': '0.25'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '1160', 'power_a': '0.29'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '1200', 'power_a': '0.3'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '1400', 'power_a': '0.35'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '1425', 'power_a': '0.35'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '1600', 'power_a': '0.39'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '1750', 'power_a': '0.43'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '1800', 'power_a': '0.44'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '2000', 'power_a': '0.49'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '2200', 'power_a': '0.54'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '2400', 'power_a': '0.59'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '2600', 'power_a': '0.64'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '2800', 'power_a': '0.69'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '2850', 'power_a': '0.7'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '3000', 'power_a': '0.74'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '3000', 'power_a': '0.79'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '3400', 'power_a': '0.84'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '3450', 'power_a': '0.85'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '3600', 'power_a': '0.89'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '3800', 'power_a': '0.94'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '4000', 'power_a': '0.99'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '4200', 'power_a': '1.04'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '4400', 'power_a': '1.08'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '4600', 'power_a': '1.13'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '4800', 'power_a': '1.18'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '200', 'power_a': '0.06'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '400', 'power_a': '0.12'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '600', 'power_a': '0.18'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '725', 'power_a': '0.21'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '800', 'power_a': '0.24'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '870', 'power_a': '0.26'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '950', 'power_a': '0.28'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '1000', 'power_a': '0.3'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '1160', 'power_a': '0.34'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '1200', 'power_a': '0.36'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '1400', 'power_a': '0.41'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '1425', 'power_a': '0.42'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '1600', 'power_a': '0.47'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '1750', 'power_a': '0.52'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '1800', 'power_a': '0.53'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '2000', 'power_a': '0.59'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '2200', 'power_a': '0.65'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '2400', 'power_a': '0.71'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '2600', 'power_a': '0.77'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '2800', 'power_a': '0.83'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '2850', 'power_a': '0.84'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '3000', 'power_a': '0.89'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '3200', 'power_a': '0.95'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '3400', 'power_a': '1.01'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '3450', 'power_a': '1.02'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '3600', 'power_a': '1.07'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '3800', 'power_a': '1.12'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '4000', 'power_a': '1.18'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '4200', 'power_a': '1.24'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '4400', 'power_a': '1.3'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '4600', 'power_a': '1.36'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '4800', 'power_a': '1.42'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '200', 'power_a': '0.07'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '400', 'power_a': '0.14'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '600', 'power_a': '0.21'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '725', 'power_a': '0.25'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '800', 'power_a': '0.29'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '870', 'power_a': '0.3'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '950', 'power_a': '0.33'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '1000', 'power_a': '0.35'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '1160', 'power_a': '0.4'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '1200', 'power_a': '0.41'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '1400', 'power_a': '0.48'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '1425', 'power_a': '0.49'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '1600', 'power_a': '0.55'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '1750', 'power_a': '0.6'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '1800', 'power_a': '0.62'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '2000', 'power_a': '0.69'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '2200', 'power_a': '0.76'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '2400', 'power_a': '0.83'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '2600', 'power_a': '0.9'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '2800', 'power_a': '0.97'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '2850', 'power_a': '0.98'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '3000', 'power_a': '1.04'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '3000', 'power_a': '1.11'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '3400', 'power_a': '1.17'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '3450', 'power_a': '1.19'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '3600', 'power_a': '1.24'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '3800', 'power_a': '1.31'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '4000', 'power_a': '1.38'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '4200', 'power_a': '1.45'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '4400', 'power_a': '1.42'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '4600', 'power_a': '1.59'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '4800', 'power_a': '1.66'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '200', 'power_a': '0.08'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '400', 'power_a': '0.16'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '600', 'power_a': '0.24'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '725', 'power_a': '0.29'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '800', 'power_a': '0.32'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '870', 'power_a': '0.34'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '950', 'power_a': '0.38'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '1000', 'power_a': '0.39'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '1160', 'power_a': '0.46'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '1200', 'power_a': '0.47'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '1400', 'power_a': '0.55'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '1425', 'power_a': '0.56'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '1600', 'power_a': '0.63'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '1750', 'power_a': '0.69'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '1800', 'power_a': '0.71'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '2000', 'power_a': '0.79'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '2200', 'power_a': '0.87'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '2400', 'power_a': '0.95'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '2600', 'power_a': '1.03'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '2800', 'power_a': '1.11'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '2850', 'power_a': '1.13'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '3000', 'power_a': '1.18'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '3200', 'power_a': '1.26'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '3400', 'power_a': '1.34'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '3450', 'power_a': '1.36'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '3600', 'power_a': '1.42'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '3800', 'power_a': '1.5'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '4000', 'power_a': '1.58'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '4200', 'power_a': '1.66'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '4400', 'power_a': '1.74'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '4600', 'power_a': '1.82'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '4800', 'power_a': '1.89'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '200', 'power_a': '0.09'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '400', 'power_a': '0.18'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '600', 'power_a': '0.27'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '725', 'power_a': '0.32'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '800', 'power_a': '0.36'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '870', 'power_a': '0.39'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '950', 'power_a': '0.42'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '1000', 'power_a': '0.44'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '1160', 'power_a': '0.52'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '1200', 'power_a': '0.53'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '1400', 'power_a': '0.62'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '1425', 'power_a': '0.63'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '1600', 'power_a': '0.71'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '1750', 'power_a': '0.78'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '1800', 'power_a': '0.8'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '2000', 'power_a': '0.89'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '2200', 'power_a': '0.98'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '2400', 'power_a': '1.07'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '2600', 'power_a': '1.15'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '2800', 'power_a': '1.24'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '2850', 'power_a': '1.27'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '3000', 'power_a': '1.33'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '3200', 'power_a': '1.42'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '3400', 'power_a': '1.51'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '3450', 'power_a': '1.53'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '3600', 'power_a': '1.6'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '3800', 'power_a': '1.69'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '4000', 'power_a': '1.78'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '4200', 'power_a': '1.87'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '4400', 'power_a': '1.95'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '4600', 'power_a': '2.04'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '4800', 'power_a': '2.13'})

HiPower_b_pb = ({'diameter': '120', 'rpm': '200', 'power_b': '0.82'}, {'diameter': '120', 'rpm': '400', 'power_b': '1.43'}, {'diameter': '120', 'rpm': '600', 'power_b': '1.95'}, {'diameter': '120', 'rpm': '725', 'power_b': '2.25'}, {'diameter': '120', 'rpm': '800', 'power_b': '2.42'}, {'diameter': '120', 'rpm': '870', 'power_b': '2.57'}, {'diameter': '120', 'rpm': '950', 'power_b': '2.74'}, {'diameter': '120', 'rpm': '1000', 'power_b': '2.84'}, {'diameter': '120', 'rpm': '1160', 'power_b': '3.14'}, {'diameter': '120', 'rpm': '1200', 'power_b': '3.21'}, {'diameter': '120', 'rpm': '1400', 'power_b': '3.55'}, {'diameter': '120', 'rpm': '1425', 'power_b': '3.59'}, {'diameter': '120', 'rpm': '1600', 'power_b': '3.84'}, {'diameter': '120', 'rpm': '1750', 'power_b': '4.04'}, {'diameter': '120', 'rpm': '1800', 'power_b': '4.1'}, {'diameter': '120', 'rpm': '2000', 'power_b': '4.32'}, {'diameter': '120', 'rpm': '2200', 'power_b': '4.5'}, {'diameter': '120', 'rpm': '2400', 'power_b': '4.64'}, {'diameter': '120', 'rpm': '2600', 'power_b': '4.74'}, {'diameter': '120', 'rpm': '2800', 'power_b': '4.79'}, {'diameter': '120', 'rpm': '2850', 'power_b': '4.79'}, {'diameter': '120', 'rpm': '3000', 'power_b': '4.8'}, {'diameter': '120', 'rpm': '3200', 'power_b': '4.76'}, {'diameter': '120', 'rpm': '3400', 'power_b': '4.67'}, {'diameter': '120', 'rpm': '3450', 'power_b': '4.64'}, {'diameter': '120', 'rpm': '3600', 'power_b': '4.53'}, {'diameter': '120', 'rpm': '3800', 'power_b': '4.34'}, {'diameter': '120', 'rpm': '4000', 'power_b': '4.09'}, {'diameter': '120', 'rpm': '4200', 'power_b': '3.79'}, {'diameter': '120', 'rpm': '4400', 'power_b': '3.43'}, {'diameter': '120', 'rpm': '4600', 'power_b': '3.01'}, {'diameter': '120', 'rpm': '4800', 'power_b': '2.52'}, {'diameter': '125', 'rpm': '200', 'power_b': '0.89'}, {'diameter': '125', 'rpm': '400', 'power_b': '1.56'}, {'diameter': '125', 'rpm': '600', 'power_b': '2.15'}, {'diameter': '125', 'rpm': '725', 'power_b': '2.48'}, {'diameter': '125', 'rpm': '800', 'power_b': '2.67'}, {'diameter': '125', 'rpm': '870', 'power_b': '2.84'}, {'diameter': '125', 'rpm': '950', 'power_b': '3.03'}, {'diameter': '125', 'rpm': '1000', 'power_b': '3.14'}, {'diameter': '125', 'rpm': '1160', 'power_b': '3.49'}, {'diameter': '125', 'rpm': '1200', 'power_b': '3.57'}, {'diameter': '125', 'rpm': '1400', 'power_b': '3.95'}, {'diameter': '125', 'rpm': '1425', 'power_b': '4'}, {'diameter': '125', 'rpm': '1600', 'power_b': '4.9'}, {'diameter': '125', 'rpm': '1750', 'power_b': '4.52'}, {'diameter': '125', 'rpm': '1800', 'power_b': '4.59'}, {'diameter': '125', 'rpm': '2000', 'power_b': '4.85'}, {'diameter': '125', 'rpm': '2200', 'power_b': '5.06'}, {'diameter': '125', 'rpm': '2400', 'power_b': '5.23'}, {'diameter': '125', 'rpm': '2600', 'power_b': '5.35'}, {'diameter': '125', 'rpm': '2800', 'power_b': '5.43'}, {'diameter': '125', 'rpm': '2850', 'power_b': '5.44'}, {'diameter': '125', 'rpm': '3000', 'power_b': '5.45'}, {'diameter': '125', 'rpm': '3200', 'power_b': '5.42'}, {'diameter': '125', 'rpm': '3400', 'power_b': '5.34'}, {'diameter': '125', 'rpm': '3450', 'power_b': '5.31'}, {'diameter': '125', 'rpm': '3600', 'power_b': '5.2'}, {'diameter': '125', 'rpm': '3800', 'power_b': '5'}, {'diameter': '125', 'rpm': '4000', 'power_b': '4.74'}, {'diameter': '125', 'rpm': '4200', 'power_b': '4.42'}, {'diameter': '125', 'rpm': '4400', 'power_b': '4.03'}, {'diameter': '125', 'rpm': '4600', 'power_b': '3.57'}, {'diameter': '130', 'rpm': '200', 'power_b': '0.96'}, {'diameter': '130', 'rpm': '400', 'power_b': '1.7'}, {'diameter': '130', 'rpm': '600', 'power_b': '2.34'}, {'diameter': '130', 'rpm': '725', 'power_b': '2.71'}, {'diameter': '130', 'rpm': '800', 'power_b': '2.92'}, {'diameter': '130', 'rpm': '870', 'power_b': '3.11'}, {'diameter': '130', 'rpm': '950', 'power_b': '3.32'}, {'diameter': '130', 'rpm': '1000', 'power_b': '3.45'}, {'diameter': '130', 'rpm': '1160', 'power_b': '3.83'}, {'diameter': '130', 'rpm': '1200', 'power_b': '3.92'}, {'diameter': '130', 'rpm': '1400', 'power_b': '4.35'}, {'diameter': '130', 'rpm': '1425', 'power_b': '4.4'}, {'diameter': '130', 'rpm': '1600', 'power_b': '4.74'}, {'diameter': '130', 'rpm': '1750', 'power_b': '5'}, {'diameter': '130', 'rpm': '1800', 'power_b': '5.08'}, {'diameter': '130', 'rpm': '2000', 'power_b': '5.37'}, {'diameter': '130', 'rpm': '2200', 'power_b': '5.61'}, {'diameter': '130', 'rpm': '2400', 'power_b': '5.81'}, {'diameter': '130', 'rpm': '2600', 'power_b': '5.95'}, {'diameter': '130', 'rpm': '2800', 'power_b': '6.05'}, {'diameter': '130', 'rpm': '2850', 'power_b': '6.06'}, {'diameter': '130', 'rpm': '3000', 'power_b': '6.08'}, {'diameter': '130', 'rpm': '3200', 'power_b': '6.06'}, {'diameter': '130', 'rpm': '3400', 'power_b': '5.98'}, {'diameter': '130', 'rpm': '3450', 'power_b': '5.95'}, {'diameter': '130', 'rpm': '3600', 'power_b': '5.83'}, {'diameter': '130', 'rpm': '3800', 'power_b': '5.63'}, {'diameter': '130', 'rpm': '4000', 'power_b': '5.35'}, {'diameter': '130', 'rpm': '4200', 'power_b': '5'}, {'diameter': '130', 'rpm': '4400', 'power_b': '4.58'}, {'diameter': '135', 'rpm': '200', 'power_b': '1.04'}, {'diameter': '135', 'rpm': '400', 'power_b': '1.83'}, {'diameter': '135', 'rpm': '600', 'power_b': '2.54'}, {'diameter': '135', 'rpm': '725', 'power_b': '2.94'}, {'diameter': '135', 'rpm': '800', 'power_b': '3.17'}, {'diameter': '135', 'rpm': '870', 'power_b': '3.38'}, {'diameter': '135', 'rpm': '950', 'power_b': '3.61'}, {'diameter': '135', 'rpm': '1000', 'power_b': '3.75'}, {'diameter': '135', 'rpm': '1160', 'power_b': '4.17'}, {'diameter': '135', 'rpm': '1200', 'power_b': '4.27'}, {'diameter': '135', 'rpm': '1400', 'power_b': '4.75'}, {'diameter': '135', 'rpm': '1425', 'power_b': '4.81'}, {'diameter': '135', 'rpm': '1600', 'power_b': '5.18'}, {'diameter': '135', 'rpm': '1750', 'power_b': '5.46'}, {'diameter': '135', 'rpm': '1800', 'power_b': '5.55'}, {'diameter': '135', 'rpm': '2000', 'power_b': '5.88'}, {'diameter': '135', 'rpm': '2200', 'power_b': '6.16'}, {'diameter': '135', 'rpm': '2400', 'power_b': '6.38'}, {'diameter': '135', 'rpm': '2600', 'power_b': '6.54'}, {'diameter': '135', 'rpm': '2800', 'power_b': '6.65'}, {'diameter': '135', 'rpm': '2850', 'power_b': '6.67'}, {'diameter': '135', 'rpm': '3000', 'power_b': '6.7'}, {'diameter': '135', 'rpm': '3200', 'power_b': '6.68'}, {'diameter': '135', 'rpm': '3400', 'power_b': '6.59'}, {'diameter': '135', 'rpm': '3450', 'power_b': '6.56'}, {'diameter': '135', 'rpm': '3600', 'power_b': '6.44'}, {'diameter': '135', 'rpm': '3800', 'power_b': '6.21'}, {'diameter': '135', 'rpm': '4000', 'power_b': '5.91'}, {'diameter': '135', 'rpm': '4200', 'power_b': '5.53'}, {'diameter': '140', 'rpm': '200', 'power_b': '1.11'}, {'diameter': '140', 'rpm': '400', 'power_b': '1.97'}, {'diameter': '140', 'rpm': '600', 'power_b': '2.73'}, {'diameter': '140', 'rpm': '725', 'power_b': '3.17'}, {'diameter': '140', 'rpm': '800', 'power_b': '3.42'}, {'diameter': '140', 'rpm': '870', 'power_b': '3.65'}, {'diameter': '140', 'rpm': '950', 'power_b': '3.9'}, {'diameter': '140', 'rpm': '1000', 'power_b': '4.05'}, {'diameter': '140', 'rpm': '1160', 'power_b': '4.51'}, {'diameter': '140', 'rpm': '1200', 'power_b': '4.62'}, {'diameter': '140', 'rpm': '1400', 'power_b': '5.14'}, {'diameter': '140', 'rpm': '1425', 'power_b': '5.21'}, {'diameter': '140', 'rpm': '1600', 'power_b': '5.61'}, {'diameter': '140', 'rpm': '1750', 'power_b': '5.93'}, {'diameter': '140', 'rpm': '1800', 'power_b': '6.03'}, {'diameter': '140', 'rpm': '2000', 'power_b': '6.39'}, {'diameter': '140', 'rpm': '2200', 'power_b': '6.69'}, {'diameter': '140', 'rpm': '2400', 'power_b': '6.94'}, {'diameter': '140', 'rpm': '2600', 'power_b': '7.12'}, {'diameter': '140', 'rpm': '2800', 'power_b': '7.24'}, {'diameter': '140', 'rpm': '2850', 'power_b': '7.26'}, {'diameter': '140', 'rpm': '3000', 'power_b': '7.29'}, {'diameter': '140', 'rpm': '3200', 'power_b': '7.27'}, {'diameter': '140', 'rpm': '3400', 'power_b': '7.18'}, {'diameter': '140', 'rpm': '3450', 'power_b': '7.15'}, {'diameter': '140', 'rpm': '3600', 'power_b': '7.01'}, {'diameter': '140', 'rpm': '3800', 'power_b': '6.77'}, {'diameter': '140', 'rpm': '4000', 'power_b': '6.43'}, {'diameter': '140', 'rpm': '4200', 'power_b': '6.02'}, {'diameter': '145', 'rpm': '200', 'power_b': '1.18'}, {'diameter': '145', 'rpm': '400', 'power_b': '2.1'}, {'diameter': '145', 'rpm': '600', 'power_b': '2.92'}, {'diameter': '145', 'rpm': '725', 'power_b': '3.39'}, {'diameter': '145', 'rpm': '800', 'power_b': '3.67'}, {'diameter': '145', 'rpm': '870', 'power_b': '3.91'}, {'diameter': '145', 'rpm': '950', 'power_b': '4.18'}, {'diameter': '145', 'rpm': '1000', 'power_b': '4.35'}, {'diameter': '145', 'rpm': '1160', 'power_b': '4.85'}, {'diameter': '145', 'rpm': '1200', 'power_b': '4.97'}, {'diameter': '145', 'rpm': '1400', 'power_b': '5.53'}, {'diameter': '145', 'rpm': '1425', 'power_b': '5.6'}, {'diameter': '145', 'rpm': '1600', 'power_b': '6.04'}, {'diameter': '145', 'rpm': '1750', 'power_b': '6.39'}, {'diameter': '145', 'rpm': '1800', 'power_b': '6.5'}, {'diameter': '145', 'rpm': '2000', 'power_b': '6.89'}, {'diameter': '145', 'rpm': '2200', 'power_b': '7.22'}, {'diameter': '145', 'rpm': '2400', 'power_b': '7.48'}, {'diameter': '145', 'rpm': '2600', 'power_b': '7.68'}, {'diameter': '145', 'rpm': '2800', 'power_b': '7.81'}, {'diameter': '145', 'rpm': '2850', 'power_b': '7.83'}, {'diameter': '145', 'rpm': '3000', 'power_b': '7.87'}, {'diameter': '145', 'rpm': '3200', 'power_b': '7.85'}, {'diameter': '145', 'rpm': '3400', 'power_b': '7.74'}, {'diameter': '145', 'rpm': '3450', 'power_b': '7.7'}, {'diameter': '145', 'rpm': '3600', 'power_b': '7.56'}, {'diameter': '145', 'rpm': '3800', 'power_b': '7.28'}, {'diameter': '145', 'rpm': '4000', 'power_b': '6.91'}, {'diameter': '150', 'rpm': '200', 'power_b': '1.25'}, {'diameter': '150', 'rpm': '400', 'power_b': '2.24'}, {'diameter': '150', 'rpm': '600', 'power_b': '3.11'}, {'diameter': '150', 'rpm': '725', 'power_b': '3.62'}, {'diameter': '150', 'rpm': '800', 'power_b': '3.91'}, {'diameter': '150', 'rpm': '870', 'power_b': '4.17'}, {'diameter': '150', 'rpm': '950', 'power_b': '4.47'}, {'diameter': '150', 'rpm': '1000', 'power_b': '4.64'}, {'diameter': '150', 'rpm': '1160', 'power_b': '5.18'}, {'diameter': '150', 'rpm': '1200', 'power_b': '5.31'}, {'diameter': '150', 'rpm': '1400', 'power_b': '5.92'}, {'diameter': '150', 'rpm': '1425', 'power_b': '5.99'}, {'diameter': '150', 'rpm': '1600', 'power_b': '6.47'}, {'diameter': '150', 'rpm': '1750', 'power_b': '6.84'}, {'diameter': '150', 'rpm': '1800', 'power_b': '6.96'}, {'diameter': '150', 'rpm': '2000', 'power_b': '7.38'}, {'diameter': '150', 'rpm': '2200', 'power_b': '7.73'}, {'diameter': '150', 'rpm': '2400', 'power_b': '8.02'}, {'diameter': '150', 'rpm': '2600', 'power_b': '8.23'}, {'diameter': '150', 'rpm': '2800', 'power_b': '8.37'}, {'diameter': '150', 'rpm': '2850', 'power_b': '8.39'}, {'diameter': '150', 'rpm': '3000', 'power_b': '8.42'}, {'diameter': '150', 'rpm': '3200', 'power_b': '8.79'}, {'diameter': '150', 'rpm': '3400', 'power_b': '8.27'}, {'diameter': '150', 'rpm': '3450', 'power_b': '8.23'}, {'diameter': '150', 'rpm': '3600', 'power_b': '8.06'}, {'diameter': '150', 'rpm': '3800', 'power_b': '7.75'}, {'diameter': '155', 'rpm': '200', 'power_b': '1.32'}, {'diameter': '155', 'rpm': '400', 'power_b': '2.37'}, {'diameter': '155', 'rpm': '600', 'power_b': '3.3'}, {'diameter': '155', 'rpm': '725', 'power_b': '3.85'}, {'diameter': '155', 'rpm': '800', 'power_b': '4.16'}, {'diameter': '155', 'rpm': '870', 'power_b': '4.44'}, {'diameter': '155', 'rpm': '950', 'power_b': '4.75'}, {'diameter': '155', 'rpm': '1000', 'power_b': '4.94'}, {'diameter': '155', 'rpm': '1160', 'power_b': '5.52'}, {'diameter': '155', 'rpm': '1200', 'power_b': '5.65'}, {'diameter': '155', 'rpm': '1400', 'power_b': '6.31'}, {'diameter': '155', 'rpm': '1425', 'power_b': '6.38'}, {'diameter': '155', 'rpm': '1600', 'power_b': '6.89'}, {'diameter': '155', 'rpm': '1750', 'power_b': '7.29'}, {'diameter': '155', 'rpm': '1800', 'power_b': '7.41'}, {'diameter': '155', 'rpm': '2000', 'power_b': '7.86'}, {'diameter': '155', 'rpm': '2200', 'power_b': '8.24'}, {'diameter': '155', 'rpm': '2400', 'power_b': '8.54'}, {'diameter': '155', 'rpm': '2600', 'power_b': '8.77'}, {'diameter': '155', 'rpm': '2800', 'power_b': '8.9'}, {'diameter': '155', 'rpm': '2850', 'power_b': '8.93'}, {'diameter': '155', 'rpm': '3000', 'power_b': '8.95'}, {'diameter': '155', 'rpm': '3200', 'power_b': '8.91'}, {'diameter': '155', 'rpm': '3400', 'power_b': '8.77'}, {'diameter': '155', 'rpm': '3450', 'power_b': '8.72'}, {'diameter': '155', 'rpm': '3600', 'power_b': '8.53'}, {'diameter': '155', 'rpm': '3800', 'power_b': '8.19'}, {'diameter': '160', 'rpm': '200', 'power_b': '1.39'}, {'diameter': '160', 'rpm': '400', 'power_b': '2.5'}, {'diameter': '160', 'rpm': '600', 'power_b': '3.49'}, {'diameter': '160', 'rpm': '725', 'power_b': '4.07'}, {'diameter': '160', 'rpm': '800', 'power_b': '4.4'}, {'diameter': '160', 'rpm': '870', 'power_b': '4.7'}, {'diameter': '160', 'rpm': '950', 'power_b': '5.03'}, {'diameter': '160', 'rpm': '1000', 'power_b': '5.23'}, {'diameter': '160', 'rpm': '1160', 'power_b': '5.85'}, {'diameter': '160', 'rpm': '1200', 'power_b': '5.99'}, {'diameter': '160', 'rpm': '1400', 'power_b': '6.69'}, {'diameter': '160', 'rpm': '1425', 'power_b': '6.77'}, {'diameter': '160', 'rpm': '1600', 'power_b': '7.31'}, {'diameter': '160', 'rpm': '1750', 'power_b': '7.73'}, {'diameter': '160', 'rpm': '1800', 'power_b': '7.86'}, {'diameter': '160', 'rpm': '2000', 'power_b': '8.34'}, {'diameter': '160', 'rpm': '2200', 'power_b': '8.74'}, {'diameter': '160', 'rpm': '2400', 'power_b': '9.06'}, {'diameter': '160', 'rpm': '2600', 'power_b': '9.29'}, {'diameter': '160', 'rpm': '2800', 'power_b': '9.42'}, {'diameter': '160', 'rpm': '2850', 'power_b': '9.44'}, {'diameter': '160', 'rpm': '3000', 'power_b': '9.47'}, {'diameter': '160', 'rpm': '3200', 'power_b': '9.41'}, {'diameter': '160', 'rpm': '3400', 'power_b': '9.24'}, {'diameter': '160', 'rpm': '3450', 'power_b': '9.19'}, {'diameter': '160', 'rpm': '3600', 'power_b': '8.97'}, {'diameter': '170', 'rpm': '200', 'power_b': '1.53'}, {'diameter': '170', 'rpm': '400', 'power_b': '2.77'}, {'diameter': '170', 'rpm': '600', 'power_b': '3.87'}, {'diameter': '170', 'rpm': '725', 'power_b': '4.51'}, {'diameter': '170', 'rpm': '800', 'power_b': '4.88'}, {'diameter': '170', 'rpm': '870', 'power_b': '5.22'}, {'diameter': '170', 'rpm': '950', 'power_b': '5.59'}, {'diameter': '170', 'rpm': '1000', 'power_b': '5.81'}, {'diameter': '170', 'rpm': '1160', 'power_b': '6.5'}, {'diameter': '170', 'rpm': '1200', 'power_b': '6.66'}, {'diameter': '170', 'rpm': '1400', 'power_b': '7.44'}, {'diameter': '170', 'rpm': '1425', 'power_b': '7.53'}, {'diameter': '170', 'rpm': '1600', 'power_b': '8.13'}, {'diameter': '170', 'rpm': '1750', 'power_b': '8.6'}, {'diameter': '170', 'rpm': '1800', 'power_b': '8.75'}, {'diameter': '170', 'rpm': '2000', 'power_b': '9.27'}, {'diameter': '170', 'rpm': '2200', 'power_b': '9.7'}, {'diameter': '170', 'rpm': '2400', 'power_b': '10'}, {'diameter': '170', 'rpm': '2600', 'power_b': '10.3'}, {'diameter': '170', 'rpm': '2800', 'power_b': '10.4'}, {'diameter': '170', 'rpm': '2850', 'power_b': '10.4'}, {'diameter': '170', 'rpm': '3000', 'power_b': '10.4'}, {'diameter': '170', 'rpm': '3200', 'power_b': '10.3'}, {'diameter': '170', 'rpm': '3400', 'power_b': '10.1'}, {'diameter': '170', 'rpm': '3450', 'power_b': '10'}, {'diameter': '175', 'rpm': '200', 'power_b': '1.6'}, {'diameter': '175', 'rpm': '400', 'power_b': '2.9'}, {'diameter': '175', 'rpm': '600', 'power_b': '4.06'}, {'diameter': '175', 'rpm': '725', 'power_b': '4.73'}, {'diameter': '175', 'rpm': '800', 'power_b': '5.12'}, {'diameter': '175', 'rpm': '870', 'power_b': '5.47'}, {'diameter': '175', 'rpm': '950', 'power_b': '5.86'}, {'diameter': '175', 'rpm': '1000', 'power_b': '6.1'}, {'diameter': '175', 'rpm': '1160', 'power_b': '6.82'}, {'diameter': '175', 'rpm': '1200', 'power_b': '7'}, {'diameter': '175', 'rpm': '1400', 'power_b': '7.81'}, {'diameter': '175', 'rpm': '1425', 'power_b': '7.91'}, {'diameter': '175', 'rpm': '1600', 'power_b': '8.54'}, {'diameter': '175', 'rpm': '1750', 'power_b': '9.03'}, {'diameter': '175', 'rpm': '1800', 'power_b': '9.18'}, {'diameter': '175', 'rpm': '2000', 'power_b': '9.72'}, {'diameter': '175', 'rpm': '2200', 'power_b': '10.2'}, {'diameter': '175', 'rpm': '2400', 'power_b': '10.5'}, {'diameter': '175', 'rpm': '2600', 'power_b': '10.8'}, {'diameter': '175', 'rpm': '2800', 'power_b': '10.9'}, {'diameter': '175', 'rpm': '2850', 'power_b': '10.9'}, {'diameter': '175', 'rpm': '3000', 'power_b': '10.9'}, {'diameter': '175', 'rpm': '3200', 'power_b': '10.7'}, {'diameter': '175', 'rpm': '3400', 'power_b': '10.5'}, {'diameter': '180', 'rpm': '200', 'power_b': '1.67'}, {'diameter': '180', 'rpm': '400', 'power_b': '3.03'}, {'diameter': '180', 'rpm': '600', 'power_b': '4.25'}, {'diameter': '180', 'rpm': '725', 'power_b': '4.95'}, {'diameter': '180', 'rpm': '800', 'power_b': '5.36'}, {'diameter': '180', 'rpm': '870', 'power_b': '5.73'}, {'diameter': '180', 'rpm': '950', 'power_b': '6.14'}, {'diameter': '180', 'rpm': '1000', 'power_b': '6.39'}, {'diameter': '180', 'rpm': '1160', 'power_b': '7.15'}, {'diameter': '180', 'rpm': '1200', 'power_b': '7.33'}, {'diameter': '180', 'rpm': '1400', 'power_b': '8.18'}, {'diameter': '180', 'rpm': '1425', 'power_b': '8.28'}, {'diameter': '180', 'rpm': '1600', 'power_b': '8.94'}, {'diameter': '180', 'rpm': '1750', 'power_b': '9.45'}, {'diameter': '180', 'rpm': '1800', 'power_b': '9.6'}, {'diameter': '180', 'rpm': '2000', 'power_b': '10.2'}, {'diameter': '180', 'rpm': '2200', 'power_b': '10.6'}, {'diameter': '180', 'rpm': '2400', 'power_b': '11'}, {'diameter': '180', 'rpm': '2600', 'power_b': '11.2'}, {'diameter': '180', 'rpm': '2800', 'power_b': '11.3'}, {'diameter': '180', 'rpm': '2850', 'power_b': '11.3'}, {'diameter': '180', 'rpm': '3000', 'power_b': '11.3'}, {'diameter': '180', 'rpm': '3200', 'power_b': '11.1'}, {'diameter': '190', 'rpm': '200', 'power_b': '1.81'}, {'diameter': '190', 'rpm': '400', 'power_b': '3.29'}, {'diameter': '190', 'rpm': '600', 'power_b': '4.62'}, {'diameter': '190', 'rpm': '725', 'power_b': '5.39'}, {'diameter': '190', 'rpm': '800', 'power_b': '5.84'}, {'diameter': '190', 'rpm': '870', 'power_b': '6.24'}, {'diameter': '190', 'rpm': '950', 'power_b': '6.68'}, {'diameter': '190', 'rpm': '1000', 'power_b': '6.96'}, {'diameter': '190', 'rpm': '1160', 'power_b': '7.78'}, {'diameter': '190', 'rpm': '1200', 'power_b': '7.98'}, {'diameter': '190', 'rpm': '1400', 'power_b': '8.9'}, {'diameter': '190', 'rpm': '1425', 'power_b': '9.01'}, {'diameter': '190', 'rpm': '1600', 'power_b': '9.72'}, {'diameter': '190', 'rpm': '1750', 'power_b': '10.3'}, {'diameter': '190', 'rpm': '1800', 'power_b': '10.4'}, {'diameter': '190', 'rpm': '2000', 'power_b': '11'}, {'diameter': '190', 'rpm': '2200', 'power_b': '11.5'}, {'diameter': '190', 'rpm': '2400', 'power_b': '11.9'}, {'diameter': '190', 'rpm': '2600', 'power_b': '12.1'}, {'diameter': '190', 'rpm': '2800', 'power_b': '12.1'}, {'diameter': '190', 'rpm': '2850', 'power_b': '12.1'}, {'diameter': '190', 'rpm': '3000', 'power_b': '12.1'}, {'diameter': '200', 'rpm': '200', 'power_b': '1.92'}, {'diameter': '200', 'rpm': '400', 'power_b': '3.55'}, {'diameter': '200', 'rpm': '600', 'power_b': '4.99'}, {'diameter': '200', 'rpm': '725', 'power_b': '5.82'}, {'diameter': '200', 'rpm': '800', 'power_b': '6.31'}, {'diameter': '200', 'rpm': '870', 'power_b': '6.74'}, {'diameter': '200', 'rpm': '950', 'power_b': '7.22'}, {'diameter': '200', 'rpm': '1000', 'power_b': '7.52'}, {'diameter': '200', 'rpm': '1160', 'power_b': '8.41'}, {'diameter': '200', 'rpm': '1200', 'power_b': '8.62'}, {'diameter': '200', 'rpm': '1400', 'power_b': '9.61'}, {'diameter': '200', 'rpm': '1425', 'power_b': '9.73'}, {'diameter': '200', 'rpm': '1600', 'power_b': '10.5'}, {'diameter': '200', 'rpm': '1750', 'power_b': '11.1'}, {'diameter': '200', 'rpm': '1800', 'power_b': '11.2'}, {'diameter': '200', 'rpm': '2000', 'power_b': '11.9'}, {'diameter': '200', 'rpm': '2200', 'power_b': '12.4'}, {'diameter': '200', 'rpm': '2400', 'power_b': '12.7'}, {'diameter': '200', 'rpm': '2600', 'power_b': '12.9'}, {'diameter': '200', 'rpm': '2800', 'power_b': '12.9'}, {'diameter': '200', 'rpm': '2850', 'power_b': '12.9'}, {'diameter': '200', 'rpm': '3000', 'power_b': '12.7'}, {'diameter': '210', 'rpm': '200', 'power_b': '2'}, {'diameter': '210', 'rpm': '400', 'power_b': '3.8'}, {'diameter': '210', 'rpm': '600', 'power_b': '5.35'}, {'diameter': '210', 'rpm': '725', 'power_b': '6.25'}, {'diameter': '210', 'rpm': '800', 'power_b': '6.77'}, {'diameter': '210', 'rpm': '870', 'power_b': '7.24'}, {'diameter': '210', 'rpm': '950', 'power_b': '7.76'}, {'diameter': '210', 'rpm': '1000', 'power_b': '8.07'}, {'diameter': '210', 'rpm': '1160', 'power_b': '9.03'}, {'diameter': '210', 'rpm': '1200', 'power_b': '9.25'}, {'diameter': '210', 'rpm': '1400', 'power_b': '10.3'}, {'diameter': '210', 'rpm': '1425', 'power_b': '10.4'}, {'diameter': '210', 'rpm': '1600', 'power_b': '11.2'}, {'diameter': '210', 'rpm': '1750', 'power_b': '11.8'}, {'diameter': '210', 'rpm': '1800', 'power_b': '12'}, {'diameter': '210', 'rpm': '2000', 'power_b': '12.7'}, {'diameter': '210', 'rpm': '2200', 'power_b': '13.1'}, {'diameter': '210', 'rpm': '2400', 'power_b': '13.5'}, {'diameter': '210', 'rpm': '2600', 'power_b': '13.6'}, {'diameter': '210', 'rpm': '2800', 'power_b': '13.5'}, {'diameter': '210', 'rpm': '2850', 'power_b': '13.5'}, {'diameter': '220', 'rpm': '200', 'power_b': '2.23'}, {'diameter': '220', 'rpm': '400', 'power_b': '4.06'}, {'diameter': '220', 'rpm': '600', 'power_b': '5.72'}, {'diameter': '220', 'rpm': '725', 'power_b': '6.68'}, {'diameter': '220', 'rpm': '800', 'power_b': '7.23'}, {'diameter': '220', 'rpm': '870', 'power_b': '7.73'}, {'diameter': '220', 'rpm': '950', 'power_b': '8.28'}, {'diameter': '220', 'rpm': '1000', 'power_b': '8.62'}, {'diameter': '220', 'rpm': '1160', 'power_b': '9.63'}, {'diameter': '220', 'rpm': '1200', 'power_b': '9.87'}, {'diameter': '220', 'rpm': '1400', 'power_b': '11'}, {'diameter': '220', 'rpm': '1425', 'power_b': '11.1'}, {'diameter': '220', 'rpm': '1600', 'power_b': '12'}, {'diameter': '220', 'rpm': '1750', 'power_b': '12.6'}, {'diameter': '220', 'rpm': '1800', 'power_b': '12.8'}, {'diameter': '220', 'rpm': '2000', 'power_b': '13.4'}, {'diameter': '220', 'rpm': '2200', 'power_b': '13.9'}, {'diameter': '220', 'rpm': '2400', 'power_b': '14.2'}, {'diameter': '220', 'rpm': '2600', 'power_b': '14.2'}, {'diameter': '230', 'rpm': '200', 'power_b': '2.37'}, {'diameter': '230', 'rpm': '400', 'power_b': '4.32'}, {'diameter': '230', 'rpm': '600', 'power_b': '6.08'}, {'diameter': '230', 'rpm': '725', 'power_b': '7.1'}, {'diameter': '230', 'rpm': '800', 'power_b': '7.69'}, {'diameter': '230', 'rpm': '870', 'power_b': '8.22'}, {'diameter': '230', 'rpm': '950', 'power_b': '8.81'}, {'diameter': '230', 'rpm': '1000', 'power_b': '9.16'}, {'diameter': '230', 'rpm': '1160', 'power_b': '10.2'}, {'diameter': '230', 'rpm': '1200', 'power_b': '10.5'}, {'diameter': '230', 'rpm': '1400', 'power_b': '11.7'}, {'diameter': '230', 'rpm': '1425', 'power_b': '11.8'}, {'diameter': '230', 'rpm': '1600', 'power_b': '12.7'}, {'diameter': '230', 'rpm': '1750', 'power_b': '13.3'}, {'diameter': '230', 'rpm': '1800', 'power_b': '13.5'}, {'diameter': '230', 'rpm': '2000', 'power_b': '14.2'}, {'diameter': '230', 'rpm': '2200', 'power_b': '14.6'}, {'diameter': '230', 'rpm': '2400', 'power_b': '14.8'}, {'diameter': '230', 'rpm': '2600', 'power_b': '14.8'}, {'diameter': '240', 'rpm': '200', 'power_b': '2.5'}, {'diameter': '240', 'rpm': '400', 'power_b': '4.57'}, {'diameter': '240', 'rpm': '600', 'power_b': '6.44'}, {'diameter': '240', 'rpm': '725', 'power_b': '7.52'}, {'diameter': '240', 'rpm': '800', 'power_b': '8.14'}, {'diameter': '240', 'rpm': '870', 'power_b': '8.7'}, {'diameter': '240', 'rpm': '950', 'power_b': '9.32'}, {'diameter': '240', 'rpm': '1000', 'power_b': '9.69'}, {'diameter': '240', 'rpm': '1160', 'power_b': '10.8'}, {'diameter': '240', 'rpm': '1200', 'power_b': '11.1'}, {'diameter': '240', 'rpm': '1400', 'power_b': '12.3'}, {'diameter': '240', 'rpm': '1425', 'power_b': '12.5'}, {'diameter': '240', 'rpm': '1600', 'power_b': '13.4'}, {'diameter': '240', 'rpm': '1750', 'power_b': '14'}, {'diameter': '240', 'rpm': '1800', 'power_b': '14.2'}, {'diameter': '240', 'rpm': '2000', 'power_b': '14.8'}, {'diameter': '240', 'rpm': '2200', 'power_b': '15.2'}, {'diameter': '240', 'rpm': '2400', 'power_b': '15.4'})

HiPower_c_pa = ({'gr_low': '1', 'gr_high': '1.02', 'rpm': '100', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '200', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '300', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '400', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '500', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '575', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '600', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '690', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '700', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '725', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '800', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '870', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '900', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '950', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1000', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1100', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1160', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1200', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1300', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1400', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1425', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1500', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1600', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1700', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1750', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1800', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1900', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '2000', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '2100', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '2200', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '2300', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '2400', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '2500', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '2600', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '2700', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '2800', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '2900', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '3000', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '3100', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '3200', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '3300', 'power_a': '0'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '100', 'power_a': '0.01'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '200', 'power_a': '0.02'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '300', 'power_a': '0.04'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '400', 'power_a': '0.05'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '500', 'power_a': '0.06'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '575', 'power_a': '0.07'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '600', 'power_a': '0.07'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '690', 'power_a': '0.09'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '700', 'power_a': '0.09'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '725', 'power_a': '0.09'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '800', 'power_a': '0.1'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '870', 'power_a': '0.11'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '900', 'power_a': '0.11'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '950', 'power_a': '0.12'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '1000', 'power_a': '0.12'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '1100', 'power_a': '0.14'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '1160', 'power_a': '0.14'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '1200', 'power_a': '0.15'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '1300', 'power_a': '0.16'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '1400', 'power_a': '0.17'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '1425', 'power_a': '0.18'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '1500', 'power_a': '0.19'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '1600', 'power_a': '0.2'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '1700', 'power_a': '0.21'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '1750', 'power_a': '0.22'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '1800', 'power_a': '0.22'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '1900', 'power_a': '0.24'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '2000', 'power_a': '0.25'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '2100', 'power_a': '0.26'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '2200', 'power_a': '0.27'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '2300', 'power_a': '0.29'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '2400', 'power_a': '0.3'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '2500', 'power_a': '0.31'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '2600', 'power_a': '0.32'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '2700', 'power_a': '0.34'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '2800', 'power_a': '0.35'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '2900', 'power_a': '0.36'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '3000', 'power_a': '0.37'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '3100', 'power_a': '0.39'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '3200', 'power_a': '0.4'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '3300', 'power_a': '0.41'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '100', 'power_a': '0.02'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '200', 'power_a': '0.05'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '300', 'power_a': '0.07'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '400', 'power_a': '0.1'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '500', 'power_a': '0.12'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '575', 'power_a': '0.14'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '600', 'power_a': '0.15'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '690', 'power_a': '0.17'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '700', 'power_a': '0.17'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '725', 'power_a': '0.18'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '800', 'power_a': '0.2'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '870', 'power_a': '0.22'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '900', 'power_a': '0.22'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '950', 'power_a': '0.24'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '1000', 'power_a': '0.25'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '1100', 'power_a': '0.27'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '1160', 'power_a': '0.29'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '1200', 'power_a': '0.3'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '1300', 'power_a': '0.32'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '1400', 'power_a': '0.35'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '1425', 'power_a': '0.35'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '1500', 'power_a': '0.37'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '1600', 'power_a': '0.4'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '1700', 'power_a': '0.42'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '1750', 'power_a': '0.43'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '1800', 'power_a': '0.45'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '1900', 'power_a': '0.47'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '2000', 'power_a': '0.5'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '2100', 'power_a': '0.52'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '2200', 'power_a': '0.55'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '2300', 'power_a': '0.57'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '2400', 'power_a': '0.6'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '2500', 'power_a': '0.62'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '2600', 'power_a': '0.64'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '2700', 'power_a': '0.67'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '2800', 'power_a': '0.69'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '2900', 'power_a': '0.72'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '3000', 'power_a': '0.74'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '3100', 'power_a': '0.77'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '3200', 'power_a': '0.79'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '3300', 'power_a': '0.82'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '100', 'power_a': '0.04'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '200', 'power_a': '0.07'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '300', 'power_a': '0.11'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '400', 'power_a': '0.15'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '500', 'power_a': '0.19'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '575', 'power_a': '0.21'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '600', 'power_a': '0.22'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '690', 'power_a': '0.26'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '700', 'power_a': '0.26'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '725', 'power_a': '0.27'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '800', 'power_a': '0.3'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '870', 'power_a': '0.32'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '900', 'power_a': '0.33'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '950', 'power_a': '0.35'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '1000', 'power_a': '0.37'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '1100', 'power_a': '0.41'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '1160', 'power_a': '0.43'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '1200', 'power_a': '0.45'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '1300', 'power_a': '0.48'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '1400', 'power_a': '0.52'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '1425', 'power_a': '0.53'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '1500', 'power_a': '0.56'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '1600', 'power_a': '0.6'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '1700', 'power_a': '0.63'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '1750', 'power_a': '0.65'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '1800', 'power_a': '0.67'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '1900', 'power_a': '0.71'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '2000', 'power_a': '0.74'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '2100', 'power_a': '0.78'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '2200', 'power_a': '0.82'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '2300', 'power_a': '0.86'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '2400', 'power_a': '0.89'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '2500', 'power_a': '0.93'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '2600', 'power_a': '0.97'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '2700', 'power_a': '1'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '2800', 'power_a': '1.04'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '2900', 'power_a': '1.08'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '3000', 'power_a': '1.12'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '3100', 'power_a': '1.15'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '3200', 'power_a': '1.19'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '3300', 'power_a': '1.23'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '100', 'power_a': '0.05'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '200', 'power_a': '0.1'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '300', 'power_a': '0.15'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '400', 'power_a': '0.2'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '500', 'power_a': '0.25'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '575', 'power_a': '0.29'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '600', 'power_a': '0.3'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '690', 'power_a': '0.34'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '700', 'power_a': '0.35'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '725', 'power_a': '0.36'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '800', 'power_a': '0.4'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '870', 'power_a': '0.43'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '900', 'power_a': '0.45'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '950', 'power_a': '0.47'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '1000', 'power_a': '0.5'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '1100', 'power_a': '0.55'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '1160', 'power_a': '0.58'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '1200', 'power_a': '0.6'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '1300', 'power_a': '0.64'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '1400', 'power_a': '0.69'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '1425', 'power_a': '0.71'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '1500', 'power_a': '0.74'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '1600', 'power_a': '0.79'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '1700', 'power_a': '0.84'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '1750', 'power_a': '0.87'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '1800', 'power_a': '0.89'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '1900', 'power_a': '0.97'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '2000', 'power_a': '0.99'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '2100', 'power_a': '1.04'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '2200', 'power_a': '1.09'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '2300', 'power_a': '1.14'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '2400', 'power_a': '1.19'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '2500', 'power_a': '1.24'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '2600', 'power_a': '1.29'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '2700', 'power_a': '1.34'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '2800', 'power_a': '1.39'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '2900', 'power_a': '1.44'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '3000', 'power_a': '1.49'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '3100', 'power_a': '1.54'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '3200', 'power_a': '1.59'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '3300', 'power_a': '1.64'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '100', 'power_a': '0.06'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '200', 'power_a': '0.12'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '300', 'power_a': '0.19'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '400', 'power_a': '0.25'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '500', 'power_a': '0.31'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '575', 'power_a': '0.36'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '600', 'power_a': '0.37'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '690', 'power_a': '0.43'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '700', 'power_a': '0.43'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '725', 'power_a': '0.45'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '800', 'power_a': '0.5'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '870', 'power_a': '0.54'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '900', 'power_a': '0.56'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '950', 'power_a': '0.59'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '1000', 'power_a': '0.62'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '1100', 'power_a': '0.68'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '1160', 'power_a': '0.72'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '1200', 'power_a': '0.74'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '1300', 'power_a': '81'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '1400', 'power_a': '0.87'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '1425', 'power_a': '0.88'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '1500', 'power_a': '93'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '1600', 'power_a': '0.99'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '1700', 'power_a': '1.05'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '1750', 'power_a': '1.09'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '1800', 'power_a': '1.12'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '1900', 'power_a': '1.18'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '2000', 'power_a': '1.24'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '2100', 'power_a': '1.3'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '2200', 'power_a': '1.36'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '2300', 'power_a': '1.43'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '2400', 'power_a': '1.49'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '2500', 'power_a': '1.55'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '2600', 'power_a': '1.61'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '2700', 'power_a': '1.67'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '2800', 'power_a': '1.74'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '2900', 'power_a': '1.8'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '3000', 'power_a': '1.86'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '3100', 'power_a': '1.92'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '3200', 'power_a': '1.98'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '3300', 'power_a': '2.05'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '100', 'power_a': '0.07'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '200', 'power_a': '0.15'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '300', 'power_a': '0.22'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '400', 'power_a': '0.3'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '500', 'power_a': '0.37'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '575', 'power_a': '0.43'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '600', 'power_a': '0.45'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '690', 'power_a': '0.51'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '700', 'power_a': '0.52'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '725', 'power_a': '0.54'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '800', 'power_a': '0.6'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '870', 'power_a': '65'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '900', 'power_a': '0.67'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '950', 'power_a': '0.71'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '1000', 'power_a': '0.74'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '1100', 'power_a': '0.82'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '1160', 'power_a': '0.86'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '1200', 'power_a': '0.89'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '1300', 'power_a': '0.97'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '1400', 'power_a': '1.04'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '1425', 'power_a': '1.06'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '1500', 'power_a': '1.12'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '1600', 'power_a': '1.19'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '1700', 'power_a': '1.27'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '1750', 'power_a': '1.3'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '1800', 'power_a': '1.34'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '1900', 'power_a': '1.41'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '2000', 'power_a': '1.49'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '2100', 'power_a': '1.56'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '2200', 'power_a': '1.64'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '2300', 'power_a': '1.71'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '2400', 'power_a': '1.79'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '2500', 'power_a': '1.86'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '2600', 'power_a': '1.94'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '2700', 'power_a': '2.01'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '2800', 'power_a': '2.08'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '2900', 'power_a': '2.16'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '3000', 'power_a': '2.23'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '3100', 'power_a': '2.31'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '3200', 'power_a': '2.38'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '3300', 'power_a': '2.46'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '100', 'power_a': '0.09'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '200', 'power_a': '0.17'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '300', 'power_a': '0.26'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '400', 'power_a': '0.35'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '500', 'power_a': '0.43'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '575', 'power_a': '0.5'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '600', 'power_a': '0.52'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '690', 'power_a': '0.6'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '700', 'power_a': '0.61'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '725', 'power_a': '0.63'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '800', 'power_a': '0.69'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '870', 'power_a': '76'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '900', 'power_a': '0.78'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '950', 'power_a': '0.83'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '1000', 'power_a': '0.87'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '1100', 'power_a': '0.96'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '1160', 'power_a': '1.01'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '1200', 'power_a': '1.04'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '1300', 'power_a': '1.13'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '1400', 'power_a': '1.22'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '1425', 'power_a': '1.24'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '1500', 'power_a': '1.3'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '1600', 'power_a': '1.39'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '1700', 'power_a': '1.48'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '1750', 'power_a': '1.52'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '1800', 'power_a': '1.56'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '1900', 'power_a': '1.65'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '2000', 'power_a': '1.74'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '2100', 'power_a': '1.82'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '2200', 'power_a': '1.91'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '2300', 'power_a': '2'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '2400', 'power_a': '2.08'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '2500', 'power_a': '2.17'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '2600', 'power_a': '2.26'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '2700', 'power_a': '2.35'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '2800', 'power_a': '2.43'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '2900', 'power_a': '2.52'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '3000', 'power_a': '2.61'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '3100', 'power_a': '2.69'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '3200', 'power_a': '2.78'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '3300', 'power_a': '2.87'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '100', 'power_a': '0.1'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '200', 'power_a': '0.2'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '300', 'power_a': '0.3'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '400', 'power_a': '0.4'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '500', 'power_a': '0.5'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '575', 'power_a': '0.57'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '600', 'power_a': '0.6'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '690', 'power_a': '0.69'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '700', 'power_a': '0.7'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '725', 'power_a': '0.72'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '800', 'power_a': '0.79'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '870', 'power_a': '0.86'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '900', 'power_a': '0.89'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '950', 'power_a': '0.94'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '1000', 'power_a': '0.99'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '1100', 'power_a': '1.09'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '1160', 'power_a': '1.15'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '1200', 'power_a': '1.19'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '1300', 'power_a': '1.24'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '1400', 'power_a': '1.39'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '1425', 'power_a': '1.41'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '1500', 'power_a': '1.49'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '1600', 'power_a': '1.59'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '1700', 'power_a': '1.67'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '1750', 'power_a': '1.74'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '1800', 'power_a': '1.79'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '1900', 'power_a': '1.87'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '2000', 'power_a': '1.99'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '2100', 'power_a': '2.09'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '2200', 'power_a': '2.18'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '2300', 'power_a': '2.28'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '2400', 'power_a': '2.38'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '2500', 'power_a': '2.48'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '2600', 'power_a': '2.58'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '2700', 'power_a': '2.68'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '2800', 'power_a': '2.78'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '2900', 'power_a': '2.88'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '3000', 'power_a': '2.98'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '3100', 'power_a': '3.08'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '3200', 'power_a': '3.18'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '3300', 'power_a': '3.28'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '100', 'power_a': '0.11'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '200', 'power_a': '0.22'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '300', 'power_a': '0.34'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '400', 'power_a': '0.45'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '500', 'power_a': '0.56'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '575', 'power_a': '0.64'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '600', 'power_a': '0.67'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '690', 'power_a': '0.77'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '700', 'power_a': '0.78'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '725', 'power_a': '0.81'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '800', 'power_a': '0.89'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '870', 'power_a': '0.97'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '900', 'power_a': '1.01'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '950', 'power_a': '1.06'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '1000', 'power_a': '1.12'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '1100', 'power_a': '1.23'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '1160', 'power_a': '1.37'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '1200', 'power_a': '1.34'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '1300', 'power_a': '1.45'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '1400', 'power_a': '1.56'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '1425', 'power_a': '1.59'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '1500', 'power_a': '1.68'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '1600', 'power_a': '1.79'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '1700', 'power_a': '1.9'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '1750', 'power_a': '1.95'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '1800', 'power_a': '2.01'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '1900', 'power_a': '2.12'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '2000', 'power_a': '2.23'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '2100', 'power_a': '2.35'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '2200', 'power_a': '2.46'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '2300', 'power_a': '2.57'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '2400', 'power_a': '2.68'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '2500', 'power_a': '2.79'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '2600', 'power_a': '2.9'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '2700', 'power_a': '3.02'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '2800', 'power_a': '3.13'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '2900', 'power_a': '3.24'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '3000', 'power_a': '3.35'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '3100', 'power_a': '3.46'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '3200', 'power_a': '3.57'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '3300', 'power_a': '3.69'})

HiPower_c_pb = ({'diameter': '180', 'rpm': '100', 'power_b': '1.18'}, {'diameter': '180', 'rpm': '200', 'power_b': '2.1'}, {'diameter': '180', 'rpm': '300', 'power_b': '2.92'}, {'diameter': '180', 'rpm': '400', 'power_b': '3.66'}, {'diameter': '180', 'rpm': '500', 'power_b': '4.35'}, {'diameter': '180', 'rpm': '575', 'power_b': '4.83'}, {'diameter': '180', 'rpm': '600', 'power_b': '4.99'}, {'diameter': '180', 'rpm': '690', 'power_b': '5.53'}, {'diameter': '180', 'rpm': '700', 'power_b': '5.59'}, {'diameter': '180', 'rpm': '725', 'power_b': '5.73'}, {'diameter': '180', 'rpm': '800', 'power_b': '6.15'}, {'diameter': '180', 'rpm': '870', 'power_b': '6.52'}, {'diameter': '180', 'rpm': '900', 'power_b': '6.67'}, {'diameter': '180', 'rpm': '950', 'power_b': '6.92'}, {'diameter': '180', 'rpm': '1000', 'power_b': '7.16'}, {'diameter': '180', 'rpm': '1100', 'power_b': '7.61'}, {'diameter': '180', 'rpm': '1160', 'power_b': '7.86'}, {'diameter': '180', 'rpm': '1200', 'power_b': '8.02'}, {'diameter': '180', 'rpm': '1300', 'power_b': '8.39'}, {'diameter': '180', 'rpm': '1400', 'power_b': '8.73'}, {'diameter': '180', 'rpm': '1425', 'power_b': '8.81'}, {'diameter': '180', 'rpm': '1500', 'power_b': '9.03'}, {'diameter': '180', 'rpm': '1600', 'power_b': '9.29'}, {'diameter': '180', 'rpm': '1700', 'power_b': '9.51'}, {'diameter': '180', 'rpm': '1750', 'power_b': '9.6'}, {'diameter': '180', 'rpm': '1800', 'power_b': '9.69'}, {'diameter': '180', 'rpm': '1900', 'power_b': '9.82'}, {'diameter': '180', 'rpm': '2000', 'power_b': '9.92'}, {'diameter': '180', 'rpm': '2100', 'power_b': '9.97'}, {'diameter': '180', 'rpm': '2200', 'power_b': '9.97'}, {'diameter': '180', 'rpm': '2300', 'power_b': '9.92'}, {'diameter': '180', 'rpm': '2400', 'power_b': '9.83'}, {'diameter': '180', 'rpm': '2500', 'power_b': '9.68'}, {'diameter': '180', 'rpm': '2600', 'power_b': '9.49'}, {'diameter': '180', 'rpm': '2700', 'power_b': '9.24'}, {'diameter': '180', 'rpm': '2800', 'power_b': '8.94'}, {'diameter': '180', 'rpm': '2900', 'power_b': '8.58'}, {'diameter': '180', 'rpm': '3000', 'power_b': '8.16'}, {'diameter': '180', 'rpm': '3100', 'power_b': '7.68'}, {'diameter': '180', 'rpm': '3200', 'power_b': '7.14'}, {'diameter': '180', 'rpm': '3300', 'power_b': '6.55'}, {'diameter': '190', 'rpm': '100', 'power_b': '1.31'}, {'diameter': '190', 'rpm': '200', 'power_b': '2.35'}, {'diameter': '190', 'rpm': '300', 'power_b': '3.27'}, {'diameter': '190', 'rpm': '400', 'power_b': '4.12'}, {'diameter': '190', 'rpm': '500', 'power_b': '4.91'}, {'diameter': '190', 'rpm': '575', 'power_b': '5.47'}, {'diameter': '190', 'rpm': '600', 'power_b': '5.65'}, {'diameter': '190', 'rpm': '690', 'power_b': '6.27'}, {'diameter': '190', 'rpm': '700', 'power_b': '6.34'}, {'diameter': '190', 'rpm': '725', 'power_b': '6.51'}, {'diameter': '190', 'rpm': '800', 'power_b': '6.99'}, {'diameter': '190', 'rpm': '870', 'power_b': '7.42'}, {'diameter': '190', 'rpm': '900', 'power_b': '7.6'}, {'diameter': '190', 'rpm': '950', 'power_b': '7.88'}, {'diameter': '190', 'rpm': '1000', 'power_b': '8.16'}, {'diameter': '190', 'rpm': '1100', 'power_b': '8.69'}, {'diameter': '190', 'rpm': '1160', 'power_b': '8.98'}, {'diameter': '190', 'rpm': '1200', 'power_b': '9.17'}, {'diameter': '190', 'rpm': '1300', 'power_b': '9.62'}, {'diameter': '190', 'rpm': '1400', 'power_b': '10'}, {'diameter': '190', 'rpm': '1425', 'power_b': '10.1'}, {'diameter': '190', 'rpm': '1500', 'power_b': '10.4'}, {'diameter': '190', 'rpm': '1600', 'power_b': '10.7'}, {'diameter': '190', 'rpm': '1700', 'power_b': '11'}, {'diameter': '190', 'rpm': '1750', 'power_b': '11.1'}, {'diameter': '190', 'rpm': '1800', 'power_b': '11.2'}, {'diameter': '190', 'rpm': '1900', 'power_b': '11.3'}, {'diameter': '190', 'rpm': '2000', 'power_b': '11.5'}, {'diameter': '190', 'rpm': '2100', 'power_b': '11.5'}, {'diameter': '190', 'rpm': '2200', 'power_b': '11.6'}, {'diameter': '190', 'rpm': '2300', 'power_b': '11.5'}, {'diameter': '190', 'rpm': '2400', 'power_b': '11.4'}, {'diameter': '190', 'rpm': '2500', 'power_b': '11.3'}, {'diameter': '190', 'rpm': '2600', 'power_b': '11.1'}, {'diameter': '190', 'rpm': '2700', 'power_b': '10.8'}, {'diameter': '190', 'rpm': '2800', 'power_b': '10.5'}, {'diameter': '190', 'rpm': '2900', 'power_b': '10.1'}, {'diameter': '190', 'rpm': '3000', 'power_b': '9.58'}, {'diameter': '190', 'rpm': '3100', 'power_b': '9.05'}, {'diameter': '200', 'rpm': '100', 'power_b': '1.44'}, {'diameter': '200', 'rpm': '200', 'power_b': '2.59'}, {'diameter': '200', 'rpm': '300', 'power_b': '3.62'}, {'diameter': '200', 'rpm': '400', 'power_b': '4.57'}, {'diameter': '200', 'rpm': '500', 'power_b': '5.46'}, {'diameter': '200', 'rpm': '575', 'power_b': '6.09'}, {'diameter': '200', 'rpm': '600', 'power_b': '6.3'}, {'diameter': '200', 'rpm': '690', 'power_b': '7'}, {'diameter': '200', 'rpm': '700', 'power_b': '7.08'}, {'diameter': '200', 'rpm': '725', 'power_b': '7.27'}, {'diameter': '200', 'rpm': '800', 'power_b': '7.82'}, {'diameter': '200', 'rpm': '870', 'power_b': '8.31'}, {'diameter': '200', 'rpm': '900', 'power_b': '8.51'}, {'diameter': '200', 'rpm': '950', 'power_b': '8.84'}, {'diameter': '200', 'rpm': '1000', 'power_b': '9.16'}, {'diameter': '200', 'rpm': '1100', 'power_b': '9.76'}, {'diameter': '200', 'rpm': '1160', 'power_b': '10.1'}, {'diameter': '200', 'rpm': '1200', 'power_b': '10.3'}, {'diameter': '200', 'rpm': '1300', 'power_b': '10.8'}, {'diameter': '200', 'rpm': '1400', 'power_b': '11.3'}, {'diameter': '200', 'rpm': '1425', 'power_b': '11.4'}, {'diameter': '200', 'rpm': '1500', 'power_b': '11.7'}, {'diameter': '200', 'rpm': '1600', 'power_b': '12.1'}, {'diameter': '200', 'rpm': '1700', 'power_b': '12.4'}, {'diameter': '200', 'rpm': '1750', 'power_b': '12.5'}, {'diameter': '200', 'rpm': '1800', 'power_b': '12.6'}, {'diameter': '200', 'rpm': '1900', 'power_b': '12.8'}, {'diameter': '200', 'rpm': '2000', 'power_b': '13'}, {'diameter': '200', 'rpm': '2100', 'power_b': '13.1'}, {'diameter': '200', 'rpm': '2200', 'power_b': '13.1'}, {'diameter': '200', 'rpm': '2300', 'power_b': '13'}, {'diameter': '200', 'rpm': '2400', 'power_b': '12.9'}, {'diameter': '200', 'rpm': '2500', 'power_b': '12.8'}, {'diameter': '200', 'rpm': '2600', 'power_b': '12.5'}, {'diameter': '200', 'rpm': '2700', 'power_b': '12.2'}, {'diameter': '200', 'rpm': '2800', 'power_b': '11.8'}, {'diameter': '200', 'rpm': '2900', 'power_b': '11.4'}, {'diameter': '210', 'rpm': '100', 'power_b': '1.57'}, {'diameter': '210', 'rpm': '200', 'power_b': '2.83'}, {'diameter': '210', 'rpm': '300', 'power_b': '3.97'}, {'diameter': '210', 'rpm': '400', 'power_b': '5.03'}, {'diameter': '210', 'rpm': '500', 'power_b': '6.01'}, {'diameter': '210', 'rpm': '575', 'power_b': '6.72'}, {'diameter': '210', 'rpm': '600', 'power_b': '6.94'}, {'diameter': '210', 'rpm': '690', 'power_b': '7.73'}, {'diameter': '210', 'rpm': '700', 'power_b': '7.82'}, {'diameter': '210', 'rpm': '725', 'power_b': '8.09'}, {'diameter': '210', 'rpm': '800', 'power_b': '8.64'}, {'diameter': '210', 'rpm': '870', 'power_b': '9.19'}, {'diameter': '210', 'rpm': '900', 'power_b': '9.41'}, {'diameter': '210', 'rpm': '950', 'power_b': '9.78'}, {'diameter': '210', 'rpm': '1000', 'power_b': '10.1'}, {'diameter': '210', 'rpm': '1100', 'power_b': '10.8'}, {'diameter': '210', 'rpm': '1160', 'power_b': '11.2'}, {'diameter': '210', 'rpm': '1200', 'power_b': '11.4'}, {'diameter': '210', 'rpm': '1300', 'power_b': '12'}, {'diameter': '210', 'rpm': '1400', 'power_b': '12.5'}, {'diameter': '210', 'rpm': '1425', 'power_b': '12.6'}, {'diameter': '210', 'rpm': '1500', 'power_b': '13'}, {'diameter': '210', 'rpm': '1600', 'power_b': '13.4'}, {'diameter': '210', 'rpm': '1700', 'power_b': '13.7'}, {'diameter': '210', 'rpm': '1750', 'power_b': '13.9'}, {'diameter': '210', 'rpm': '1800', 'power_b': '14'}, {'diameter': '210', 'rpm': '1900', 'power_b': '14.2'}, {'diameter': '210', 'rpm': '2000', 'power_b': '14.4'}, {'diameter': '210', 'rpm': '2100', 'power_b': '14.5'}, {'diameter': '210', 'rpm': '2200', 'power_b': '14.5'}, {'diameter': '210', 'rpm': '2300', 'power_b': '14.5'}, {'diameter': '210', 'rpm': '2400', 'power_b': '14.3'}, {'diameter': '210', 'rpm': '2500', 'power_b': '14.1'}, {'diameter': '210', 'rpm': '2600', 'power_b': '13.9'}, {'diameter': '210', 'rpm': '2700', 'power_b': '13.5'}, {'diameter': '210', 'rpm': '2800', 'power_b': '13.1'}, {'diameter': '220', 'rpm': '100', 'power_b': '1.7'}, {'diameter': '220', 'rpm': '200', 'power_b': '3.07'}, {'diameter': '220', 'rpm': '300', 'power_b': '4.32'}, {'diameter': '220', 'rpm': '400', 'power_b': '5.48'}, {'diameter': '220', 'rpm': '500', 'power_b': '6.56'}, {'diameter': '220', 'rpm': '575', 'power_b': '7.33'}, {'diameter': '220', 'rpm': '600', 'power_b': '7.58'}, {'diameter': '220', 'rpm': '690', 'power_b': '8.45'}, {'diameter': '220', 'rpm': '700', 'power_b': '8.55'}, {'diameter': '220', 'rpm': '725', 'power_b': '8.78'}, {'diameter': '220', 'rpm': '800', 'power_b': '9.46'}, {'diameter': '220', 'rpm': '870', 'power_b': '10.1'}, {'diameter': '220', 'rpm': '900', 'power_b': '10.3'}, {'diameter': '220', 'rpm': '950', 'power_b': '10.7'}, {'diameter': '220', 'rpm': '1000', 'power_b': '11.1'}, {'diameter': '220', 'rpm': '1100', 'power_b': '11.9'}, {'diameter': '220', 'rpm': '1160', 'power_b': '12.3'}, {'diameter': '220', 'rpm': '1200', 'power_b': '12.5'}, {'diameter': '220', 'rpm': '1300', 'power_b': '13.2'}, {'diameter': '220', 'rpm': '1400', 'power_b': '13.7'}, {'diameter': '220', 'rpm': '1425', 'power_b': '13.9'}, {'diameter': '220', 'rpm': '1500', 'power_b': '14.2'}, {'diameter': '220', 'rpm': '1600', 'power_b': '14.7'}, {'diameter': '220', 'rpm': '1700', 'power_b': '15.1'}, {'diameter': '220', 'rpm': '1750', 'power_b': '15.2'}, {'diameter': '220', 'rpm': '1800', 'power_b': '15.4'}, {'diameter': '220', 'rpm': '1900', 'power_b': '15.6'}, {'diameter': '220', 'rpm': '2000', 'power_b': '15.8'}, {'diameter': '220', 'rpm': '2100', 'power_b': '15.9'}, {'diameter': '220', 'rpm': '2200', 'power_b': '15.8'}, {'diameter': '220', 'rpm': '2300', 'power_b': '15.8'}, {'diameter': '220', 'rpm': '2400', 'power_b': '15.7'}, {'diameter': '220', 'rpm': '2500', 'power_b': '15.4'}, {'diameter': '220', 'rpm': '2600', 'power_b': '15.1'}, {'diameter': '220', 'rpm': '2700', 'power_b': '14.7'}, {'diameter': '230', 'rpm': '100', 'power_b': '1.83'}, {'diameter': '230', 'rpm': '200', 'power_b': '3.31'}, {'diameter': '230', 'rpm': '300', 'power_b': '4.67'}, {'diameter': '230', 'rpm': '400', 'power_b': '5.92'}, {'diameter': '230', 'rpm': '500', 'power_b': '7.11'}, {'diameter': '230', 'rpm': '575', 'power_b': '7.95'}, {'diameter': '230', 'rpm': '600', 'power_b': '8.22'}, {'diameter': '230', 'rpm': '690', 'power_b': '9.17'}, {'diameter': '230', 'rpm': '700', 'power_b': '9.27'}, {'diameter': '230', 'rpm': '725', 'power_b': '9.53'}, {'diameter': '230', 'rpm': '800', 'power_b': '10.3'}, {'diameter': '230', 'rpm': '870', 'power_b': '10.9'}, {'diameter': '230', 'rpm': '900', 'power_b': '11.2'}, {'diameter': '230', 'rpm': '950', 'power_b': '11.6'}, {'diameter': '230', 'rpm': '1000', 'power_b': '12.1'}, {'diameter': '230', 'rpm': '1100', 'power_b': '12.9'}, {'diameter': '230', 'rpm': '1160', 'power_b': '13.3'}, {'diameter': '230', 'rpm': '1200', 'power_b': '13.6'}, {'diameter': '230', 'rpm': '1300', 'power_b': '14.3'}, {'diameter': '230', 'rpm': '1400', 'power_b': '14.9'}, {'diameter': '230', 'rpm': '1425', 'power_b': '15.1'}, {'diameter': '230', 'rpm': '1500', 'power_b': '15.5'}, {'diameter': '230', 'rpm': '1600', 'power_b': '16'}, {'diameter': '230', 'rpm': '1700', 'power_b': '16.4'}, {'diameter': '230', 'rpm': '1750', 'power_b': '16.5'}, {'diameter': '230', 'rpm': '1800', 'power_b': '16.7'}, {'diameter': '230', 'rpm': '1900', 'power_b': '16.9'}, {'diameter': '230', 'rpm': '2000', 'power_b': '17.1'}, {'diameter': '230', 'rpm': '2100', 'power_b': '17.2'}, {'diameter': '230', 'rpm': '2200', 'power_b': '17.2'}, {'diameter': '230', 'rpm': '2300', 'power_b': '17.1'}, {'diameter': '230', 'rpm': '2400', 'power_b': '16.9'}, {'diameter': '230', 'rpm': '2500', 'power_b': '16.6'}, {'diameter': '230', 'rpm': '2600', 'power_b': '16.2'}, {'diameter': '240', 'rpm': '100', 'power_b': '1.95'}, {'diameter': '240', 'rpm': '200', 'power_b': '3.55'}, {'diameter': '240', 'rpm': '300', 'power_b': '5.01'}, {'diameter': '240', 'rpm': '400', 'power_b': '6.37'}, {'diameter': '240', 'rpm': '500', 'power_b': '7.65'}, {'diameter': '240', 'rpm': '575', 'power_b': '8.56'}, {'diameter': '240', 'rpm': '600', 'power_b': '8.85'}, {'diameter': '240', 'rpm': '690', 'power_b': '9.88'}, {'diameter': '240', 'rpm': '700', 'power_b': '9.99'}, {'diameter': '240', 'rpm': '725', 'power_b': '10.3'}, {'diameter': '240', 'rpm': '800', 'power_b': '11.1'}, {'diameter': '240', 'rpm': '870', 'power_b': '11.8'}, {'diameter': '240', 'rpm': '900', 'power_b': '12.1'}, {'diameter': '240', 'rpm': '950', 'power_b': '12.6'}, {'diameter': '240', 'rpm': '1000', 'power_b': '13'}, {'diameter': '240', 'rpm': '1100', 'power_b': '13.9'}, {'diameter': '240', 'rpm': '1160', 'power_b': '14.4'}, {'diameter': '240', 'rpm': '1200', 'power_b': '14.7'}, {'diameter': '240', 'rpm': '1300', 'power_b': '15.4'}, {'diameter': '240', 'rpm': '1400', 'power_b': '16.1'}, {'diameter': '240', 'rpm': '1425', 'power_b': '16.2'}, {'diameter': '240', 'rpm': '1500', 'power_b': '16.7'}, {'diameter': '240', 'rpm': '1600', 'power_b': '17.2'}, {'diameter': '240', 'rpm': '1700', 'power_b': '17.6'}, {'diameter': '240', 'rpm': '1750', 'power_b': '17.8'}, {'diameter': '240', 'rpm': '1800', 'power_b': '17.9'}, {'diameter': '240', 'rpm': '1900', 'power_b': '18.2'}, {'diameter': '240', 'rpm': '2000', 'power_b': '18.3'}, {'diameter': '240', 'rpm': '2100', 'power_b': '18.4'}, {'diameter': '240', 'rpm': '2200', 'power_b': '18.4'}, {'diameter': '240', 'rpm': '2300', 'power_b': '18.2'}, {'diameter': '240', 'rpm': '2400', 'power_b': '18'}, {'diameter': '240', 'rpm': '2500', 'power_b': '17.6'}, {'diameter': '250', 'rpm': '100', 'power_b': '2.08'}, {'diameter': '250', 'rpm': '200', 'power_b': '3.79'}, {'diameter': '250', 'rpm': '300', 'power_b': '5.35'}, {'diameter': '250', 'rpm': '400', 'power_b': '6.81'}, {'diameter': '250', 'rpm': '500', 'power_b': '8.19'}, {'diameter': '250', 'rpm': '575', 'power_b': '9.17'}, {'diameter': '250', 'rpm': '600', 'power_b': '9.48'}, {'diameter': '250', 'rpm': '690', 'power_b': '10.6'}, {'diameter': '250', 'rpm': '700', 'power_b': '10.7'}, {'diameter': '250', 'rpm': '725', 'power_b': '11'}, {'diameter': '250', 'rpm': '800', 'power_b': '11.9'}, {'diameter': '250', 'rpm': '870', 'power_b': '12.6'}, {'diameter': '250', 'rpm': '900', 'power_b': '12.9'}, {'diameter': '250', 'rpm': '950', 'power_b': '13.5'}, {'diameter': '250', 'rpm': '1000', 'power_b': '14'}, {'diameter': '250', 'rpm': '1100', 'power_b': '14.9'}, {'diameter': '250', 'rpm': '1160', 'power_b': '15.4'}, {'diameter': '250', 'rpm': '1200', 'power_b': '15.7'}, {'diameter': '250', 'rpm': '1300', 'power_b': '16.5'}, {'diameter': '250', 'rpm': '1400', 'power_b': '17.2'}, {'diameter': '250', 'rpm': '1425', 'power_b': '17.4'}, {'diameter': '250', 'rpm': '1500', 'power_b': '17.8'}, {'diameter': '250', 'rpm': '1600', 'power_b': '18.4'}, {'diameter': '250', 'rpm': '1700', 'power_b': '18.8'}, {'diameter': '250', 'rpm': '1750', 'power_b': '19'}, {'diameter': '250', 'rpm': '1800', 'power_b': '19.1'}, {'diameter': '250', 'rpm': '1900', 'power_b': '19.4'}, {'diameter': '250', 'rpm': '2000', 'power_b': '19.5'}, {'diameter': '250', 'rpm': '2100', 'power_b': '19.5'}, {'diameter': '250', 'rpm': '2200', 'power_b': '19.5'}, {'diameter': '250', 'rpm': '2300', 'power_b': '19.3'}, {'diameter': '250', 'rpm': '2400', 'power_b': '18.9'}, {'diameter': '260', 'rpm': '100', 'power_b': '2.21'}, {'diameter': '260', 'rpm': '200', 'power_b': '4.03'}, {'diameter': '260', 'rpm': '300', 'power_b': '5.7'}, {'diameter': '260', 'rpm': '400', 'power_b': '7.25'}, {'diameter': '260', 'rpm': '500', 'power_b': '8.72'}, {'diameter': '260', 'rpm': '575', 'power_b': '9.77'}, {'diameter': '260', 'rpm': '600', 'power_b': '10.1'}, {'diameter': '260', 'rpm': '690', 'power_b': '11.3'}, {'diameter': '260', 'rpm': '700', 'power_b': '11.4'}, {'diameter': '260', 'rpm': '725', 'power_b': '11.7'}, {'diameter': '260', 'rpm': '800', 'power_b': '12.6'}, {'diameter': '260', 'rpm': '870', 'power_b': '13.5'}, {'diameter': '260', 'rpm': '900', 'power_b': '13.8'}, {'diameter': '260', 'rpm': '950', 'power_b': '14.3'}, {'diameter': '260', 'rpm': '1000', 'power_b': '14.9'}, {'diameter': '260', 'rpm': '1100', 'power_b': '15.9'}, {'diameter': '260', 'rpm': '1160', 'power_b': '16.4'}, {'diameter': '260', 'rpm': '1200', 'power_b': '16.8'}, {'diameter': '260', 'rpm': '1300', 'power_b': '17.6'}, {'diameter': '260', 'rpm': '1400', 'power_b': '18.3'}, {'diameter': '260', 'rpm': '1425', 'power_b': '18.5'}, {'diameter': '260', 'rpm': '1500', 'power_b': '19'}, {'diameter': '260', 'rpm': '1600', 'power_b': '19.5'}, {'diameter': '260', 'rpm': '1700', 'power_b': '20'}, {'diameter': '260', 'rpm': '1750', 'power_b': '20.1'}, {'diameter': '260', 'rpm': '1800', 'power_b': '20.3'}, {'diameter': '260', 'rpm': '1900', 'power_b': '20.5'}, {'diameter': '260', 'rpm': '2000', 'power_b': '20.6'}, {'diameter': '260', 'rpm': '2100', 'power_b': '20.6'}, {'diameter': '260', 'rpm': '2200', 'power_b': '20.5'}, {'diameter': '260', 'rpm': '2300', 'power_b': '20.2'}, {'diameter': '270', 'rpm': '100', 'power_b': '2.33'}, {'diameter': '270', 'rpm': '200', 'power_b': '4.27'}, {'diameter': '270', 'rpm': '300', 'power_b': '6.04'}, {'diameter': '270', 'rpm': '400', 'power_b': '7.69'}, {'diameter': '270', 'rpm': '500', 'power_b': '9.25'}, {'diameter': '270', 'rpm': '575', 'power_b': '10.4'}, {'diameter': '270', 'rpm': '600', 'power_b': '10.7'}, {'diameter': '270', 'rpm': '690', 'power_b': '12'}, {'diameter': '270', 'rpm': '700', 'power_b': '12.1'}, {'diameter': '270', 'rpm': '725', 'power_b': '12.5'}, {'diameter': '270', 'rpm': '800', 'power_b': '13.4'}, {'diameter': '270', 'rpm': '870', 'power_b': '14.3'}, {'diameter': '270', 'rpm': '900', 'power_b': '14.6'}, {'diameter': '270', 'rpm': '950', 'power_b': '15.2'}, {'diameter': '270', 'rpm': '1000', 'power_b': '15.8'}, {'diameter': '270', 'rpm': '1100', 'power_b': '16.8'}, {'diameter': '270', 'rpm': '1160', 'power_b': '17.4'}, {'diameter': '270', 'rpm': '1200', 'power_b': '17.8'}, {'diameter': '270', 'rpm': '1300', 'power_b': '18.7'}, {'diameter': '270', 'rpm': '1400', 'power_b': '19.4'}, {'diameter': '270', 'rpm': '1425', 'power_b': '19.6'}, {'diameter': '270', 'rpm': '1500', 'power_b': '20.1'}, {'diameter': '270', 'rpm': '1600', 'power_b': '20.6'}, {'diameter': '270', 'rpm': '1700', 'power_b': '21.1'}, {'diameter': '270', 'rpm': '1750', 'power_b': '21.3'}, {'diameter': '270', 'rpm': '1800', 'power_b': '21.4'}, {'diameter': '270', 'rpm': '1900', 'power_b': '21.6'}, {'diameter': '270', 'rpm': '2000', 'power_b': '21.7'}, {'diameter': '270', 'rpm': '2100', 'power_b': '21.6'}, {'diameter': '270', 'rpm': '2200', 'power_b': '21.4'}, {'diameter': '280', 'rpm': '100', 'power_b': '2.46'}, {'diameter': '280', 'rpm': '200', 'power_b': '4.5'}, {'diameter': '280', 'rpm': '300', 'power_b': '6.38'}, {'diameter': '280', 'rpm': '400', 'power_b': '8.13'}, {'diameter': '280', 'rpm': '500', 'power_b': '9.78'}, {'diameter': '280', 'rpm': '575', 'power_b': '11'}, {'diameter': '280', 'rpm': '600', 'power_b': '11.3'}, {'diameter': '280', 'rpm': '690', 'power_b': '12.7'}, {'diameter': '280', 'rpm': '700', 'power_b': '12.8'}, {'diameter': '280', 'rpm': '725', 'power_b': '13.2'}, {'diameter': '280', 'rpm': '800', 'power_b': '14.2'}, {'diameter': '280', 'rpm': '870', 'power_b': '15.1'}, {'diameter': '280', 'rpm': '900', 'power_b': '15.5'}, {'diameter': '280', 'rpm': '950', 'power_b': '16.1'}, {'diameter': '280', 'rpm': '1000', 'power_b': '16.7'}, {'diameter': '280', 'rpm': '1100', 'power_b': '17.8'}, {'diameter': '280', 'rpm': '1160', 'power_b': '18.4'}, {'diameter': '280', 'rpm': '1200', 'power_b': '18.8'}, {'diameter': '280', 'rpm': '1300', 'power_b': '19.7'}, {'diameter': '280', 'rpm': '1400', 'power_b': '20.5'}, {'diameter': '280', 'rpm': '1425', 'power_b': '20.7'}, {'diameter': '280', 'rpm': '1500', 'power_b': '21.2'}, {'diameter': '280', 'rpm': '1600', 'power_b': '21.7'}, {'diameter': '280', 'rpm': '1700', 'power_b': '22.1'}, {'diameter': '280', 'rpm': '1750', 'power_b': '22.3'}, {'diameter': '280', 'rpm': '1800', 'power_b': '22.4'}, {'diameter': '280', 'rpm': '1900', 'power_b': '22.6'}, {'diameter': '280', 'rpm': '2000', 'power_b': '22.6'}, {'diameter': '280', 'rpm': '2100', 'power_b': '22.5'}, {'diameter': '300', 'rpm': '100', 'power_b': '2.71'}, {'diameter': '300', 'rpm': '200', 'power_b': '4.97'}, {'diameter': '300', 'rpm': '300', 'power_b': '7.05'}, {'diameter': '300', 'rpm': '400', 'power_b': '9'}, {'diameter': '300', 'rpm': '500', 'power_b': '10.8'}, {'diameter': '300', 'rpm': '575', 'power_b': '12.1'}, {'diameter': '300', 'rpm': '600', 'power_b': '12.6'}, {'diameter': '300', 'rpm': '690', 'power_b': '14'}, {'diameter': '300', 'rpm': '700', 'power_b': '14.2'}, {'diameter': '300', 'rpm': '725', 'power_b': '14.6'}, {'diameter': '300', 'rpm': '800', 'power_b': '15.7'}, {'diameter': '300', 'rpm': '870', 'power_b': '16.7'}, {'diameter': '300', 'rpm': '900', 'power_b': '17.1'}, {'diameter': '300', 'rpm': '950', 'power_b': '17.8'}, {'diameter': '300', 'rpm': '1000', 'power_b': '18.5'}, {'diameter': '300', 'rpm': '1100', 'power_b': '19.6'}, {'diameter': '300', 'rpm': '1160', 'power_b': '20.3'}, {'diameter': '300', 'rpm': '1200', 'power_b': '20.7'}, {'diameter': '300', 'rpm': '1300', 'power_b': '21.7'}, {'diameter': '300', 'rpm': '1400', 'power_b': '22.5'}, {'diameter': '300', 'rpm': '1425', 'power_b': '22.7'}, {'diameter': '300', 'rpm': '1500', 'power_b': '23.2'}, {'diameter': '300', 'rpm': '1600', 'power_b': '23.7'}, {'diameter': '300', 'rpm': '1700', 'power_b': '24.1'}, {'diameter': '300', 'rpm': '1750', 'power_b': '24.3'}, {'diameter': '300', 'rpm': '1800', 'power_b': '24.4'}, {'diameter': '300', 'rpm': '1900', 'power_b': '24.4'}, {'diameter': '300', 'rpm': '2000', 'power_b': '24.4'}, {'diameter': '320', 'rpm': '100', 'power_b': '2.96'}, {'diameter': '320', 'rpm': '200', 'power_b': '5.44'}, {'diameter': '320', 'rpm': '300', 'power_b': '7.72'}, {'diameter': '320', 'rpm': '400', 'power_b': '9.86'}, {'diameter': '320', 'rpm': '500', 'power_b': '11.9'}, {'diameter': '320', 'rpm': '575', 'power_b': '13.3'}, {'diameter': '320', 'rpm': '600', 'power_b': '13.8'}, {'diameter': '320', 'rpm': '690', 'power_b': '15.4'}, {'diameter': '320', 'rpm': '700', 'power_b': '15.5'}, {'diameter': '320', 'rpm': '725', 'power_b': '16'}, {'diameter': '320', 'rpm': '800', 'power_b': '17.2'}, {'diameter': '320', 'rpm': '870', 'power_b': '18.3'}, {'diameter': '320', 'rpm': '900', 'power_b': '18.7'}, {'diameter': '320', 'rpm': '950', 'power_b': '19.5'}, {'diameter': '320', 'rpm': '1000', 'power_b': '20.2'}, {'diameter': '320', 'rpm': '1100', 'power_b': '21.4'}, {'diameter': '320', 'rpm': '1160', 'power_b': '22.1'}, {'diameter': '320', 'rpm': '1200', 'power_b': '22.6'}, {'diameter': '320', 'rpm': '1300', 'power_b': '23.6'}, {'diameter': '320', 'rpm': '1400', 'power_b': '24.4'}, {'diameter': '320', 'rpm': '1425', 'power_b': '24.6'}, {'diameter': '320', 'rpm': '1500', 'power_b': '25.1'}, {'diameter': '320', 'rpm': '1600', 'power_b': '25.6'}, {'diameter': '320', 'rpm': '1700', 'power_b': '25.9'}, {'diameter': '320', 'rpm': '1750', 'power_b': '26'}, {'diameter': '320', 'rpm': '1800', 'power_b': '26.1'}, {'diameter': '320', 'rpm': '1900', 'power_b': '26'}, {'diameter': '340', 'rpm': '100', 'power_b': '3.21'}, {'diameter': '340', 'rpm': '200', 'power_b': '5.9'}, {'diameter': '340', 'rpm': '300', 'power_b': '8.39'}, {'diameter': '340', 'rpm': '400', 'power_b': '10.7'}, {'diameter': '340', 'rpm': '500', 'power_b': '12.9'}, {'diameter': '340', 'rpm': '575', 'power_b': '14.5'}, {'diameter': '340', 'rpm': '600', 'power_b': '15'}, {'diameter': '340', 'rpm': '690', 'power_b': '16.7'}, {'diameter': '340', 'rpm': '700', 'power_b': '16.9'}, {'diameter': '340', 'rpm': '725', 'power_b': '17.3'}, {'diameter': '340', 'rpm': '800', 'power_b': '18.7'}, {'diameter': '340', 'rpm': '870', 'power_b': '19.8'}, {'diameter': '340', 'rpm': '900', 'power_b': '20.9'}, {'diameter': '340', 'rpm': '950', 'power_b': '21.1'}, {'diameter': '340', 'rpm': '1000', 'power_b': '21.8'}, {'diameter': '340', 'rpm': '1100', 'power_b': '23.2'}, {'diameter': '340', 'rpm': '1160', 'power_b': '23.9'}, {'diameter': '340', 'rpm': '1200', 'power_b': '24.4'}, {'diameter': '340', 'rpm': '1300', 'power_b': '25.4'}, {'diameter': '340', 'rpm': '1400', 'power_b': '26.2'}, {'diameter': '340', 'rpm': '1425', 'power_b': '26.4'}, {'diameter': '340', 'rpm': '1500', 'power_b': '26.8'}, {'diameter': '340', 'rpm': '1600', 'power_b': '27.3'}, {'diameter': '340', 'rpm': '1700', 'power_b': '27.5'}, {'diameter': '340', 'rpm': '1750', 'power_b': '27.5'}, {'diameter': '360', 'rpm': '100', 'power_b': '3.46'}, {'diameter': '360', 'rpm': '200', 'power_b': '6.36'}, {'diameter': '360', 'rpm': '300', 'power_b': '9.05'}, {'diameter': '360', 'rpm': '400', 'power_b': '11.6'}, {'diameter': '360', 'rpm': '500', 'power_b': '13.9'}, {'diameter': '360', 'rpm': '575', 'power_b': '15.6'}, {'diameter': '360', 'rpm': '600', 'power_b': '16.1'}, {'diameter': '360', 'rpm': '690', 'power_b': '18'}, {'diameter': '360', 'rpm': '700', 'power_b': '18.2'}, {'diameter': '360', 'rpm': '725', 'power_b': '18.7'}, {'diameter': '360', 'rpm': '800', 'power_b': '20.1'}, {'diameter': '360', 'rpm': '870', 'power_b': '21.3'}, {'diameter': '360', 'rpm': '900', 'power_b': '21.9'}, {'diameter': '360', 'rpm': '950', 'power_b': '22.7'}, {'diameter': '360', 'rpm': '1000', 'power_b': '23.4'}, {'diameter': '360', 'rpm': '1100', 'power_b': '24.8'}, {'diameter': '360', 'rpm': '1160', 'power_b': '25.6'}, {'diameter': '360', 'rpm': '1200', 'power_b': '26'}, {'diameter': '360', 'rpm': '1300', 'power_b': '27.1'}, {'diameter': '360', 'rpm': '1400', 'power_b': '27.9'}, {'diameter': '360', 'rpm': '1425', 'power_b': '28'}, {'diameter': '360', 'rpm': '1500', 'power_b': '28.4'}, {'diameter': '360', 'rpm': '1600', 'power_b': '28.8'}, {'diameter': '360', 'rpm': '1700', 'power_b': '28.9'}, {'diameter': '380', 'rpm': '100', 'power_b': '3.7'}, {'diameter': '380', 'rpm': '200', 'power_b': '6.82'}, {'diameter': '380', 'rpm': '300', 'power_b': '9.7'}, {'diameter': '380', 'rpm': '400', 'power_b': '12.4'}, {'diameter': '380', 'rpm': '500', 'power_b': '14.9'}, {'diameter': '380', 'rpm': '575', 'power_b': '16.7'}, {'diameter': '380', 'rpm': '600', 'power_b': '17.3'}, {'diameter': '380', 'rpm': '690', 'power_b': '19.3'}, {'diameter': '380', 'rpm': '700', 'power_b': '19.5'}, {'diameter': '380', 'rpm': '725', 'power_b': '20'}, {'diameter': '380', 'rpm': '800', 'power_b': '21.9'}, {'diameter': '380', 'rpm': '870', 'power_b': '22.8'}, {'diameter': '380', 'rpm': '900', 'power_b': '23.3'}, {'diameter': '380', 'rpm': '950', 'power_b': '24.2'}, {'diameter': '380', 'rpm': '1000', 'power_b': '25'}, {'diameter': '380', 'rpm': '1100', 'power_b': '26.4'}, {'diameter': '380', 'rpm': '1160', 'power_b': '27.2'}, {'diameter': '380', 'rpm': '1200', 'power_b': '27.6'}, {'diameter': '380', 'rpm': '1300', 'power_b': '28.6'}, {'diameter': '380', 'rpm': '1400', 'power_b': '29.4'}, {'diameter': '380', 'rpm': '1425', 'power_b': '29.5'}, {'diameter': '380', 'rpm': '1500', 'power_b': '29.9'}, {'diameter': '380', 'rpm': '1600', 'power_b': '30.1'}, {'diameter': '400', 'rpm': '100', 'power_b': '3.94'}, {'diameter': '400', 'rpm': '200', 'power_b': '7.28'}, {'diameter': '400', 'rpm': '300', 'power_b': '10.4'}, {'diameter': '400', 'rpm': '400', 'power_b': '13.2'}, {'diameter': '400', 'rpm': '500', 'power_b': '15.9'}, {'diameter': '400', 'rpm': '575', 'power_b': '17.8'}, {'diameter': '400', 'rpm': '600', 'power_b': '18.4'}, {'diameter': '400', 'rpm': '690', 'power_b': '20.5'}, {'diameter': '400', 'rpm': '700', 'power_b': '20.4'}, {'diameter': '400', 'rpm': '725', 'power_b': '21.3'}, {'diameter': '400', 'rpm': '800', 'power_b': '22.9'}, {'diameter': '400', 'rpm': '870', 'power_b': '24.2'}, {'diameter': '400', 'rpm': '900', 'power_b': '24.8'}, {'diameter': '400', 'rpm': '950', 'power_b': '25.7'}, {'diameter': '400', 'rpm': '1000', 'power_b': '26.5'}, {'diameter': '400', 'rpm': '1100', 'power_b': '27.9'}, {'diameter': '400', 'rpm': '1160', 'power_b': '28.7'}, {'diameter': '400', 'rpm': '1200', 'power_b': '29.1'}, {'diameter': '400', 'rpm': '1300', 'power_b': '30.1'}, {'diameter': '400', 'rpm': '1400', 'power_b': '30.7'}, {'diameter': '400', 'rpm': '1425', 'power_b': '30.9'}, {'diameter': '400', 'rpm': '1500', 'power_b': '31.1'})

HiPower_d_pa = ({'gr_low': '1', 'gr_high': '1.02', 'rpm': '50', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '100', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '150', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '200', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '250', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '300', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '350', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '400', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '435', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '450', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '485', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '500', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '550', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '575', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '600', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '650', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '690', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '700', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '725', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '750', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '800', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '850', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '870', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '900', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '950', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '950', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1000', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1050', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1100', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1150', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1160', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1200', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1250', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1300', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1350', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1400', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1450', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1500', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1550', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1600', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1650', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1700', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1750', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1800', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1850', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1900', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1950', 'power_a': '0'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '50', 'power_a': '0.02'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '100', 'power_a': '0.04'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '150', 'power_a': '0.06'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '200', 'power_a': '0.08'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '250', 'power_a': '0.1'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '300', 'power_a': '0.12'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '350', 'power_a': '0.14'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '400', 'power_a': '0.16'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '435', 'power_a': '0.17'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '450', 'power_a': '0.18'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '485', 'power_a': '0.19'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '500', 'power_a': '0.2'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '550', 'power_a': '0.21'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '575', 'power_a': '0.22'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '600', 'power_a': '0.23'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '650', 'power_a': '0.25'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '690', 'power_a': '0.27'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '700', 'power_a': '0.27'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '725', 'power_a': '0.28'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '750', 'power_a': '0.29'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '800', 'power_a': '0.31'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '850', 'power_a': '0.33'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '870', 'power_a': '0.34'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '900', 'power_a': '0.35'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '950', 'power_a': '0.37'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '950', 'power_a': '0.37'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '1000', 'power_a': '0.39'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '1050', 'power_a': '0.41'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '1100', 'power_a': '0.43'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '1150', 'power_a': '0.45'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '1160', 'power_a': '0.45'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '1200', 'power_a': '0.47'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '1250', 'power_a': '0.49'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '1300', 'power_a': '0.51'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '1350', 'power_a': '0.53'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '1400', 'power_a': '0.55'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '1450', 'power_a': '0.57'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '1500', 'power_a': '0.59'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '1550', 'power_a': '0.6'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '1600', 'power_a': '0.62'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '1650', 'power_a': '0.64'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '1700', 'power_a': '0.66'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '1750', 'power_a': '0.68'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '1800', 'power_a': '0.7'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '1850', 'power_a': '0.72'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '1900', 'power_a': '0.74'}, {'gr_low': '1.02', 'gr_high': '1.04', 'rpm': '1950', 'power_a': '0.76'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '50', 'power_a': '0.04'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '100', 'power_a': '0.08'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '150', 'power_a': '0.12'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '200', 'power_a': '0.16'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '250', 'power_a': '0.19'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '300', 'power_a': '0.23'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '350', 'power_a': '0.27'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '400', 'power_a': '0.31'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '435', 'power_a': '0.34'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '450', 'power_a': '0.35'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '485', 'power_a': '0.38'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '500', 'power_a': '0.39'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '550', 'power_a': '0.43'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '575', 'power_a': '0.45'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '600', 'power_a': '0.47'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '650', 'power_a': '0.51'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '690', 'power_a': '0.54'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '700', 'power_a': '0.54'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '725', 'power_a': '0.56'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '750', 'power_a': '0.58'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '800', 'power_a': '0.62'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '850', 'power_a': '0.66'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '870', 'power_a': '0.68'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '900', 'power_a': '0.7'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '950', 'power_a': '0.74'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '950', 'power_a': '0.74'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '1000', 'power_a': '0.78'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '1050', 'power_a': '0.82'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '1100', 'power_a': '0.86'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '1150', 'power_a': '0.89'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '1160', 'power_a': '0.9'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '1200', 'power_a': '0.93'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '1250', 'power_a': '0.97'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '1300', 'power_a': '1.01'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '1350', 'power_a': '1.05'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '1400', 'power_a': '1.09'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '1450', 'power_a': '1.13'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '1500', 'power_a': '1.17'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '1550', 'power_a': '1.2'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '1600', 'power_a': '1.24'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '1650', 'power_a': '1.28'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '1700', 'power_a': '1.32'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '1750', 'power_a': '1.36'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '1800', 'power_a': '1.4'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '1850', 'power_a': '1.44'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '1900', 'power_a': '1.48'}, {'gr_low': '1.04', 'gr_high': '1.06', 'rpm': '1950', 'power_a': '1.52'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '50', 'power_a': '0.06'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '100', 'power_a': '0.12'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '150', 'power_a': '0.17'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '200', 'power_a': '0.23'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '250', 'power_a': '0.29'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '300', 'power_a': '0.35'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '350', 'power_a': '0.41'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '400', 'power_a': '0.47'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '435', 'power_a': '0.51'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '450', 'power_a': '0.52'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '485', 'power_a': '0.57'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '500', 'power_a': '0.58'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '550', 'power_a': '0.64'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '575', 'power_a': '0.67'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '600', 'power_a': '0.7'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '650', 'power_a': '0.76'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '690', 'power_a': '0.8'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '700', 'power_a': '0.82'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '725', 'power_a': '0.84'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '750', 'power_a': '0.87'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '800', 'power_a': '0.93'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '850', 'power_a': '0.99'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '870', 'power_a': '1.01'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '900', 'power_a': '1.05'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '950', 'power_a': '1.11'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '950', 'power_a': '1.11'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '1000', 'power_a': '1.17'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '1050', 'power_a': '1.22'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '1100', 'power_a': '1.28'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '1150', 'power_a': '1.34'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '1160', 'power_a': '1.35'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '1200', 'power_a': '1.4'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '1250', 'power_a': '1.46'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '1300', 'power_a': '1.51'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '1350', 'power_a': '1.57'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '1400', 'power_a': '1.63'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '1450', 'power_a': '1.69'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '1500', 'power_a': '1.75'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '1550', 'power_a': '1.81'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '1600', 'power_a': '1.86'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '1650', 'power_a': '1.92'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '1700', 'power_a': '1.98'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '1750', 'power_a': '2.04'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '1800', 'power_a': '2.4'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '1850', 'power_a': '2.16'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '1900', 'power_a': '2.21'}, {'gr_low': '1.06', 'gr_high': '1.09', 'rpm': '1950', 'power_a': '2.27'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '50', 'power_a': '0.08'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '100', 'power_a': '0.16'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '150', 'power_a': '0.23'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '200', 'power_a': '0.31'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '250', 'power_a': '0.39'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '300', 'power_a': '0.47'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '350', 'power_a': '0.54'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '400', 'power_a': '0.62'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '435', 'power_a': '0.68'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '450', 'power_a': '0.7'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '485', 'power_a': '0.75'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '500', 'power_a': '0.78'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '550', 'power_a': '0.85'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '575', 'power_a': '0.89'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '600', 'power_a': '0.93'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '650', 'power_a': '1.01'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '690', 'power_a': '1.07'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '700', 'power_a': '1.09'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '725', 'power_a': '1.13'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '750', 'power_a': '1.17'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '800', 'power_a': '1.24'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '850', 'power_a': '1.32'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '870', 'power_a': '1.35'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '900', 'power_a': '1.4'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '950', 'power_a': '1.48'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '950', 'power_a': '1.48'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '1000', 'power_a': '1.55'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '1050', 'power_a': '1.63'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '1100', 'power_a': '1.71'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '1150', 'power_a': '1.79'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '1160', 'power_a': '1.8'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '1200', 'power_a': '1.86'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '1250', 'power_a': '1.94'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '1300', 'power_a': '2.01'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '1350', 'power_a': '2.1'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '1400', 'power_a': '2.18'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '1450', 'power_a': '2.25'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '1500', 'power_a': '2.33'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '1550', 'power_a': '2.41'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '1600', 'power_a': '2.49'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '1650', 'power_a': '2.56'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '1700', 'power_a': '2.64'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '1750', 'power_a': '2.72'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '1800', 'power_a': '2.8'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '1850', 'power_a': '2.88'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '1900', 'power_a': '2.95'}, {'gr_low': '1.09', 'gr_high': '1.13', 'rpm': '1950', 'power_a': '3.03'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '50', 'power_a': '0.1'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '100', 'power_a': '0.19'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '150', 'power_a': '0.29'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '200', 'power_a': '0.39'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '250', 'power_a': '0.49'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '300', 'power_a': '0.58'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '350', 'power_a': '0.68'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '400', 'power_a': '0.78'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '435', 'power_a': '0.85'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '450', 'power_a': '0.87'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '485', 'power_a': '0.94'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '500', 'power_a': '0.97'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '550', 'power_a': '1.07'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '575', 'power_a': '1.12'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '600', 'power_a': '1.17'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '650', 'power_a': '1.26'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '690', 'power_a': '1.34'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '700', 'power_a': '1.36'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '725', 'power_a': '1.41'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '750', 'power_a': '1.46'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '800', 'power_a': '1.55'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '850', 'power_a': '1.65'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '870', 'power_a': '1.69'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '900', 'power_a': '1.75'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '950', 'power_a': '1.85'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '950', 'power_a': '1.85'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '1000', 'power_a': '1.94'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '1050', 'power_a': '2.04'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '1100', 'power_a': '2.14'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '1150', 'power_a': '2.23'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '1160', 'power_a': '2.25'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '1200', 'power_a': '2.33'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '1250', 'power_a': '2.43'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '1300', 'power_a': '2.53'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '1350', 'power_a': '2.62'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '1400', 'power_a': '2.72'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '1450', 'power_a': '2.82'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '1500', 'power_a': '2.91'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '1550', 'power_a': '3.01'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '1600', 'power_a': '3.11'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '1650', 'power_a': '3.21'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '1700', 'power_a': '3.3'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '1750', 'power_a': '3.4'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '1800', 'power_a': '3.5'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '1850', 'power_a': '3.59'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '1900', 'power_a': '3.69'}, {'gr_low': '1.13', 'gr_high': '1.17', 'rpm': '1950', 'power_a': '3.79'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '50', 'power_a': '0.12'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '100', 'power_a': '0.23'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '150', 'power_a': '0.35'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '200', 'power_a': '0.47'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '250', 'power_a': '0.58'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '300', 'power_a': '0.7'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '350', 'power_a': '0.82'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '400', 'power_a': '0.93'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '435', 'power_a': '1.01'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '450', 'power_a': '1.05'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '485', 'power_a': '1.13'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '500', 'power_a': '1.17'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '550', 'power_a': '1.28'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '575', 'power_a': '1.34'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '600', 'power_a': '1.4'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '650', 'power_a': '1.52'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '690', 'power_a': '1.61'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '700', 'power_a': '1.63'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '725', 'power_a': '1.69'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '750', 'power_a': '1.75'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '800', 'power_a': '1.87'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '850', 'power_a': '1.98'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '870', 'power_a': '2.03'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '900', 'power_a': '2.1'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '950', 'power_a': '2.22'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '950', 'power_a': '2.22'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '1000', 'power_a': '2.33'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '1050', 'power_a': '2.45'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '1100', 'power_a': '2.57'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '1150', 'power_a': '2.68'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '1160', 'power_a': '2.71'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '1200', 'power_a': '2.8'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '1250', 'power_a': '2.92'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '1300', 'power_a': '3.03'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '1350', 'power_a': '3.15'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '1400', 'power_a': '3.27'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '1450', 'power_a': '3.38'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '1500', 'power_a': '3.5'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '1550', 'power_a': '3.62'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '1600', 'power_a': '3.73'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '1650', 'power_a': '3.85'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '1700', 'power_a': '3.97'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '1750', 'power_a': '4.08'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '1800', 'power_a': '4.2'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '1850', 'power_a': '4.32'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '1900', 'power_a': '4.43'}, {'gr_low': '1.17', 'gr_high': '1.23', 'rpm': '1950', 'power_a': '4.55'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '50', 'power_a': '0.14'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '100', 'power_a': '0.27'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '150', 'power_a': '0.41'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '200', 'power_a': '0.54'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '250', 'power_a': '0.68'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '300', 'power_a': '0.82'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '350', 'power_a': '0.95'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '400', 'power_a': '1.09'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '435', 'power_a': '1.18'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '450', 'power_a': '1.22'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '485', 'power_a': '1.32'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '500', 'power_a': '1.36'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '550', 'power_a': '1.5'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '575', 'power_a': '1.57'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '600', 'power_a': '1.63'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '650', 'power_a': '1.77'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '690', 'power_a': '1.88'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '700', 'power_a': '1.91'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '725', 'power_a': '1.97'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '750', 'power_a': '2.04'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '800', 'power_a': '2.18'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '850', 'power_a': '2.31'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '870', 'power_a': '2.37'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '900', 'power_a': '2.45'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '950', 'power_a': '2.59'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '950', 'power_a': '2.59'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '1000', 'power_a': '2.72'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '1050', 'power_a': '2.86'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '1100', 'power_a': '2.99'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '1150', 'power_a': '3.13'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '1160', 'power_a': '3.16'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '1200', 'power_a': '3.27'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '1250', 'power_a': '3.4'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '1300', 'power_a': '3.54'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '1350', 'power_a': '3.67'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '1400', 'power_a': '3.81'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '1450', 'power_a': '3.95'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '1500', 'power_a': '4.08'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '1550', 'power_a': '4.22'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '1600', 'power_a': '4.36'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '1650', 'power_a': '4.49'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '1700', 'power_a': '4.63'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '1750', 'power_a': '4.76'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '1800', 'power_a': '4.9'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '1850', 'power_a': '5.04'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '1900', 'power_a': '5.17'}, {'gr_low': '1.23', 'gr_high': '1.31', 'rpm': '1950', 'power_a': '5.31'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '50', 'power_a': '0.16'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '100', 'power_a': '0.31'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '150', 'power_a': '0.47'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '200', 'power_a': '0.62'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '250', 'power_a': '0.78'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '300', 'power_a': '0.93'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '350', 'power_a': '1.09'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '400', 'power_a': '1.24'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '435', 'power_a': '1.35'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '450', 'power_a': '1.4'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '485', 'power_a': '1.51'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '500', 'power_a': '1.56'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '550', 'power_a': '1.71'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '575', 'power_a': '1.79'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '600', 'power_a': '1.87'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '650', 'power_a': '2.02'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '690', 'power_a': '2.15'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '700', 'power_a': '2.18'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '725', 'power_a': '2.26'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '750', 'power_a': '2.33'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '800', 'power_a': '2.49'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '850', 'power_a': '2.64'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '870', 'power_a': '2.71'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '900', 'power_a': '2.8'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '950', 'power_a': '2.96'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '950', 'power_a': '2.96'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '1000', 'power_a': '3.11'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '1050', 'power_a': '3.27'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '1100', 'power_a': '3.42'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '1150', 'power_a': '3.58'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '1160', 'power_a': '3.61'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '1200', 'power_a': '3.73'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '1250', 'power_a': '3.89'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '1300', 'power_a': '4.04'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '1350', 'power_a': '4.2'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '1400', 'power_a': '4.36'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '1450', 'power_a': '4.51'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '1500', 'power_a': '4.67'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '1550', 'power_a': '4.82'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '1600', 'power_a': '4.98'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '1650', 'power_a': '5.13'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '1700', 'power_a': '5.29'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '1750', 'power_a': '5.44'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '1800', 'power_a': '5.6'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '1850', 'power_a': '5.76'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '1900', 'power_a': '5.91'}, {'gr_low': '1.31', 'gr_high': '1.49', 'rpm': '1950', 'power_a': '6.07'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '50', 'power_a': '0.17'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '100', 'power_a': '0.35'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '150', 'power_a': '0.52'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '200', 'power_a': '0.7'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '250', 'power_a': '0.87'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '300', 'power_a': '1.05'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '350', 'power_a': '1.22'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '400', 'power_a': '1.4'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '435', 'power_a': '1.52'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '450', 'power_a': '1.57'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '485', 'power_a': '1.7'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '500', 'power_a': '1.75'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '550', 'power_a': '1.92'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '575', 'power_a': '2.01'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '600', 'power_a': '2.1'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '650', 'power_a': '2.27'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '690', 'power_a': '2.41'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '700', 'power_a': '2.45'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '725', 'power_a': '2.54'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '750', 'power_a': '2.62'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '800', 'power_a': '2.8'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '850', 'power_a': '2.97'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '870', 'power_a': '3.04'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '900', 'power_a': '3.15'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '950', 'power_a': '3.32'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '950', 'power_a': '3.32'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '1000', 'power_a': '3.5'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '1050', 'power_a': '3.67'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '1100', 'power_a': '3.85'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '1150', 'power_a': '4.02'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '1160', 'power_a': '4.06'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '1200', 'power_a': '4.2'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '1250', 'power_a': '4.37'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '1300', 'power_a': '4.55'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '1350', 'power_a': '4.72'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '1400', 'power_a': '4.9'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '1450', 'power_a': '5.07'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '1500', 'power_a': '5.25'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '1550', 'power_a': '5.42'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '1600', 'power_a': '5.6'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '1650', 'power_a': '5.77'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '1700', 'power_a': '5.95'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '1750', 'power_a': '6.12'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '1800', 'power_a': '6.3'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '1850', 'power_a': '6.47'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '1900', 'power_a': '6.65'}, {'gr_low': '1.49', 'gr_high': '10', 'rpm': '1950', 'power_a': '6.82'})

HiPower_d_pb = ({'diameter': '300', 'rpm': '50', 'power_b': '2.11'}, {'diameter': '300', 'rpm': '100', 'power_b': '3.81'}, {'diameter': '300', 'rpm': '150', 'power_b': '5.34'}, {'diameter': '300', 'rpm': '200', 'power_b': '6.76'}, {'diameter': '300', 'rpm': '250', 'power_b': '0.81'}, {'diameter': '300', 'rpm': '300', 'power_b': '9.36'}, {'diameter': '300', 'rpm': '350', 'power_b': '10.6'}, {'diameter': '300', 'rpm': '400', 'power_b': '11.7'}, {'diameter': '300', 'rpm': '435', 'power_b': '12.5'}, {'diameter': '300', 'rpm': '450', 'power_b': '12.8'}, {'diameter': '300', 'rpm': '485', 'power_b': '13.5'}, {'diameter': '300', 'rpm': '500', 'power_b': '13.9'}, {'diameter': '300', 'rpm': '550', 'power_b': '14.8'}, {'diameter': '300', 'rpm': '575', 'power_b': '15.3'}, {'diameter': '300', 'rpm': '600', 'power_b': '15.8'}, {'diameter': '300', 'rpm': '650', 'power_b': '16.7'}, {'diameter': '300', 'rpm': '690', 'power_b': '17.4'}, {'diameter': '300', 'rpm': '700', 'power_b': '17.5'}, {'diameter': '300', 'rpm': '725', 'power_b': '17.9'}, {'diameter': '300', 'rpm': '750', 'power_b': '18.3'}, {'diameter': '300', 'rpm': '800', 'power_b': '19.1'}, {'diameter': '300', 'rpm': '850', 'power_b': '19.8'}, {'diameter': '300', 'rpm': '870', 'power_b': '20'}, {'diameter': '300', 'rpm': '900', 'power_b': '20.4'}, {'diameter': '300', 'rpm': '950', 'power_b': '21'}, {'diameter': '300', 'rpm': '950', 'power_b': '21'}, {'diameter': '300', 'rpm': '1000', 'power_b': '21.6'}, {'diameter': '300', 'rpm': '1050', 'power_b': '22'}, {'diameter': '300', 'rpm': '1100', 'power_b': '22.5'}, {'diameter': '300', 'rpm': '1150', 'power_b': '22.8'}, {'diameter': '300', 'rpm': '1160', 'power_b': '22.9'}, {'diameter': '300', 'rpm': '1200', 'power_b': '23.2'}, {'diameter': '300', 'rpm': '1250', 'power_b': '23.4'}, {'diameter': '300', 'rpm': '1300', 'power_b': '23.6'}, {'diameter': '300', 'rpm': '1350', 'power_b': '23.7'}, {'diameter': '300', 'rpm': '1400', 'power_b': '23.8'}, {'diameter': '300', 'rpm': '1450', 'power_b': '23.8'}, {'diameter': '300', 'rpm': '1500', 'power_b': '23.8'}, {'diameter': '300', 'rpm': '1550', 'power_b': '23.6'}, {'diameter': '300', 'rpm': '1600', 'power_b': '23.4'}, {'diameter': '300', 'rpm': '1650', 'power_b': '23.1'}, {'diameter': '300', 'rpm': '1700', 'power_b': '22.8'}, {'diameter': '300', 'rpm': '1750', 'power_b': '22.4'}, {'diameter': '300', 'rpm': '1800', 'power_b': '21.9'}, {'diameter': '300', 'rpm': '1850', 'power_b': '21.3'}, {'diameter': '300', 'rpm': '1900', 'power_b': '20.6'}, {'diameter': '300', 'rpm': '1950', 'power_b': '19.9'}, {'diameter': '320', 'rpm': '50', 'power_b': '2.37'}, {'diameter': '320', 'rpm': '100', 'power_b': '4.3'}, {'diameter': '320', 'rpm': '150', 'power_b': '6.05'}, {'diameter': '320', 'rpm': '200', 'power_b': '7.69'}, {'diameter': '320', 'rpm': '250', 'power_b': '9.23'}, {'diameter': '320', 'rpm': '300', 'power_b': '10.7'}, {'diameter': '320', 'rpm': '350', 'power_b': '12.1'}, {'diameter': '320', 'rpm': '400', 'power_b': '13.4'}, {'diameter': '320', 'rpm': '435', 'power_b': '14.3'}, {'diameter': '320', 'rpm': '450', 'power_b': '14.7'}, {'diameter': '320', 'rpm': '485', 'power_b': '15.6'}, {'diameter': '320', 'rpm': '500', 'power_b': '15.9'}, {'diameter': '320', 'rpm': '550', 'power_b': '17.1'}, {'diameter': '320', 'rpm': '575', 'power_b': '17.7'}, {'diameter': '320', 'rpm': '600', 'power_b': '18.2'}, {'diameter': '320', 'rpm': '650', 'power_b': '19.3'}, {'diameter': '320', 'rpm': '690', 'power_b': '20.1'}, {'diameter': '320', 'rpm': '700', 'power_b': '20.3'}, {'diameter': '320', 'rpm': '725', 'power_b': '20.7'}, {'diameter': '320', 'rpm': '750', 'power_b': '21.2'}, {'diameter': '320', 'rpm': '800', 'power_b': '22.1'}, {'diameter': '320', 'rpm': '850', 'power_b': '22.9'}, {'diameter': '320', 'rpm': '870', 'power_b': '23.2'}, {'diameter': '320', 'rpm': '900', 'power_b': '23.7'}, {'diameter': '320', 'rpm': '950', 'power_b': '24.4'}, {'diameter': '320', 'rpm': '950', 'power_b': '24.4'}, {'diameter': '320', 'rpm': '1000', 'power_b': '25.5'}, {'diameter': '320', 'rpm': '1050', 'power_b': '25.6'}, {'diameter': '320', 'rpm': '1100', 'power_b': '26.1'}, {'diameter': '320', 'rpm': '1150', 'power_b': '26.6'}, {'diameter': '320', 'rpm': '1160', 'power_b': '26.6'}, {'diameter': '320', 'rpm': '1200', 'power_b': '26.9'}, {'diameter': '320', 'rpm': '1250', 'power_b': '27.2'}, {'diameter': '320', 'rpm': '1300', 'power_b': '27.5'}, {'diameter': '320', 'rpm': '1350', 'power_b': '27.6'}, {'diameter': '320', 'rpm': '1400', 'power_b': '27.7'}, {'diameter': '320', 'rpm': '1450', 'power_b': '27.7'}, {'diameter': '320', 'rpm': '1500', 'power_b': '27.6'}, {'diameter': '320', 'rpm': '1550', 'power_b': '27.5'}, {'diameter': '320', 'rpm': '1600', 'power_b': '27.3'}, {'diameter': '320', 'rpm': '1650', 'power_b': '26.9'}, {'diameter': '320', 'rpm': '1700', 'power_b': '26.5'}, {'diameter': '320', 'rpm': '1750', 'power_b': '26'}, {'diameter': '320', 'rpm': '1800', 'power_b': '25.4'}, {'diameter': '320', 'rpm': '1850', 'power_b': '24.7'}, {'diameter': '340', 'rpm': '50', 'power_b': '2.63'}, {'diameter': '340', 'rpm': '100', 'power_b': '4.79'}, {'diameter': '340', 'rpm': '150', 'power_b': '6.76'}, {'diameter': '340', 'rpm': '200', 'power_b': '8.61'}, {'diameter': '340', 'rpm': '250', 'power_b': '10.4'}, {'diameter': '340', 'rpm': '300', 'power_b': '12'}, {'diameter': '340', 'rpm': '350', 'power_b': '1.36'}, {'diameter': '340', 'rpm': '400', 'power_b': '15.1'}, {'diameter': '340', 'rpm': '435', 'power_b': '16.2'}, {'diameter': '340', 'rpm': '450', 'power_b': '16.6'}, {'diameter': '340', 'rpm': '485', 'power_b': '17.6'}, {'diameter': '340', 'rpm': '500', 'power_b': '18'}, {'diameter': '340', 'rpm': '550', 'power_b': '19.3'}, {'diameter': '340', 'rpm': '575', 'power_b': '20'}, {'diameter': '340', 'rpm': '600', 'power_b': '20.6'}, {'diameter': '340', 'rpm': '650', 'power_b': '21.8'}, {'diameter': '340', 'rpm': '690', 'power_b': '22.7'}, {'diameter': '340', 'rpm': '700', 'power_b': '22.9'}, {'diameter': '340', 'rpm': '725', 'power_b': '23.5'}, {'diameter': '340', 'rpm': '750', 'power_b': '24'}, {'diameter': '340', 'rpm': '800', 'power_b': '25'}, {'diameter': '340', 'rpm': '850', 'power_b': '26'}, {'diameter': '340', 'rpm': '870', 'power_b': '26.3'}, {'diameter': '340', 'rpm': '900', 'power_b': '26.8'}, {'diameter': '340', 'rpm': '950', 'power_b': '27.6'}, {'diameter': '340', 'rpm': '950', 'power_b': '27.6'}, {'diameter': '340', 'rpm': '1000', 'power_b': '28.4'}, {'diameter': '340', 'rpm': '1050', 'power_b': '29'}, {'diameter': '340', 'rpm': '1100', 'power_b': '29.6'}, {'diameter': '340', 'rpm': '1150', 'power_b': '30.1'}, {'diameter': '340', 'rpm': '1160', 'power_b': '30.2'}, {'diameter': '340', 'rpm': '1200', 'power_b': '30.5'}, {'diameter': '340', 'rpm': '1250', 'power_b': '30.9'}, {'diameter': '340', 'rpm': '1300', 'power_b': '31.1'}, {'diameter': '340', 'rpm': '1350', 'power_b': '31.3'}, {'diameter': '340', 'rpm': '1400', 'power_b': '31.4'}, {'diameter': '340', 'rpm': '1450', 'power_b': '31.4'}, {'diameter': '340', 'rpm': '1500', 'power_b': '31.3'}, {'diameter': '340', 'rpm': '1550', 'power_b': '31'}, {'diameter': '340', 'rpm': '1600', 'power_b': '31.7'}, {'diameter': '340', 'rpm': '1650', 'power_b': '30.3'}, {'diameter': '340', 'rpm': '1700', 'power_b': '29.8'}, {'diameter': '340', 'rpm': '1750', 'power_b': '29.2'}, {'diameter': '350', 'rpm': '50', 'power_b': '2.76'}, {'diameter': '350', 'rpm': '100', 'power_b': '5.04'}, {'diameter': '350', 'rpm': '150', 'power_b': '7.12'}, {'diameter': '350', 'rpm': '200', 'power_b': '9.07'}, {'diameter': '350', 'rpm': '250', 'power_b': '10.9'}, {'diameter': '350', 'rpm': '300', 'power_b': '12.7'}, {'diameter': '350', 'rpm': '350', 'power_b': '14.4'}, {'diameter': '350', 'rpm': '400', 'power_b': '16'}, {'diameter': '350', 'rpm': '435', 'power_b': '17.1'}, {'diameter': '350', 'rpm': '450', 'power_b': '17.5'}, {'diameter': '350', 'rpm': '485', 'power_b': '18.6'}, {'diameter': '350', 'rpm': '500', 'power_b': '19'}, {'diameter': '350', 'rpm': '550', 'power_b': '20.4'}, {'diameter': '350', 'rpm': '575', 'power_b': '21.1'}, {'diameter': '350', 'rpm': '600', 'power_b': '21.8'}, {'diameter': '350', 'rpm': '650', 'power_b': '23'}, {'diameter': '350', 'rpm': '690', 'power_b': '24'}, {'diameter': '350', 'rpm': '700', 'power_b': '24.3'}, {'diameter': '350', 'rpm': '725', 'power_b': '24.8'}, {'diameter': '350', 'rpm': '750', 'power_b': '25.4'}, {'diameter': '350', 'rpm': '800', 'power_b': '26.5'}, {'diameter': '350', 'rpm': '850', 'power_b': '27.5'}, {'diameter': '350', 'rpm': '870', 'power_b': '27.8'}, {'diameter': '350', 'rpm': '900', 'power_b': '28.4'}, {'diameter': '350', 'rpm': '950', 'power_b': '29.2'}, {'diameter': '350', 'rpm': '950', 'power_b': '29.2'}, {'diameter': '350', 'rpm': '1000', 'power_b': '30'}, {'diameter': '350', 'rpm': '1050', 'power_b': '30.7'}, {'diameter': '350', 'rpm': '1100', 'power_b': '31.3'}, {'diameter': '350', 'rpm': '1150', 'power_b': '31.8'}, {'diameter': '350', 'rpm': '1160', 'power_b': '31.9'}, {'diameter': '350', 'rpm': '1200', 'power_b': '32.3'}, {'diameter': '350', 'rpm': '1250', 'power_b': '32.6'}, {'diameter': '350', 'rpm': '1300', 'power_b': '32.9'}, {'diameter': '350', 'rpm': '1350', 'power_b': '33.1'}, {'diameter': '350', 'rpm': '1400', 'power_b': '33.1'}, {'diameter': '350', 'rpm': '1450', 'power_b': '33.1'}, {'diameter': '350', 'rpm': '1500', 'power_b': '32.9'}, {'diameter': '350', 'rpm': '1550', 'power_b': '32.7'}, {'diameter': '350', 'rpm': '1600', 'power_b': '32.4'}, {'diameter': '350', 'rpm': '1650', 'power_b': '31.9'}, {'diameter': '350', 'rpm': '1700', 'power_b': '31.3'}, {'diameter': '360', 'rpm': '50', 'power_b': '2.89'}, {'diameter': '360', 'rpm': '100', 'power_b': '5.28'}, {'diameter': '360', 'rpm': '150', 'power_b': '7.47'}, {'diameter': '360', 'rpm': '200', 'power_b': '9.53'}, {'diameter': '360', 'rpm': '250', 'power_b': '11.5'}, {'diameter': '360', 'rpm': '300', 'power_b': '13.3'}, {'diameter': '360', 'rpm': '350', 'power_b': '15.1'}, {'diameter': '360', 'rpm': '400', 'power_b': '16.8'}, {'diameter': '360', 'rpm': '435', 'power_b': '18'}, {'diameter': '360', 'rpm': '450', 'power_b': '18.5'}, {'diameter': '360', 'rpm': '485', 'power_b': '19.6'}, {'diameter': '360', 'rpm': '500', 'power_b': '20'}, {'diameter': '360', 'rpm': '550', 'power_b': '21.5'}, {'diameter': '360', 'rpm': '575', 'power_b': '22.2'}, {'diameter': '360', 'rpm': '600', 'power_b': '22.9'}, {'diameter': '360', 'rpm': '650', 'power_b': '24.3'}, {'diameter': '360', 'rpm': '690', 'power_b': '25.3'}, {'diameter': '360', 'rpm': '700', 'power_b': '25.6'}, {'diameter': '360', 'rpm': '725', 'power_b': '26.2'}, {'diameter': '360', 'rpm': '750', 'power_b': '26.8'}, {'diameter': '360', 'rpm': '800', 'power_b': '27.9'}, {'diameter': '360', 'rpm': '850', 'power_b': '29'}, {'diameter': '360', 'rpm': '870', 'power_b': '29.4'}, {'diameter': '360', 'rpm': '900', 'power_b': '29.9'}, {'diameter': '360', 'rpm': '950', 'power_b': '30.8'}, {'diameter': '360', 'rpm': '950', 'power_b': '30.8'}, {'diameter': '360', 'rpm': '1000', 'power_b': '31.6'}, {'diameter': '360', 'rpm': '1050', 'power_b': '32.4'}, {'diameter': '360', 'rpm': '1100', 'power_b': '33'}, {'diameter': '360', 'rpm': '1150', 'power_b': '33.5'}, {'diameter': '360', 'rpm': '1160', 'power_b': '33.6'}, {'diameter': '360', 'rpm': '1200', 'power_b': '34'}, {'diameter': '360', 'rpm': '1250', 'power_b': '34.3'}, {'diameter': '360', 'rpm': '1300', 'power_b': '34.6'}, {'diameter': '360', 'rpm': '1350', 'power_b': '34.7'}, {'diameter': '360', 'rpm': '1400', 'power_b': '34.8'}, {'diameter': '360', 'rpm': '1450', 'power_b': '34.7'}, {'diameter': '360', 'rpm': '1500', 'power_b': '34.6'}, {'diameter': '360', 'rpm': '1550', 'power_b': '34.3'}, {'diameter': '360', 'rpm': '1600', 'power_b': '33.9'}, {'diameter': '360', 'rpm': '1650', 'power_b': '33.3'}, {'diameter': '380', 'rpm': '50', 'power_b': '3.15'}, {'diameter': '380', 'rpm': '100', 'power_b': '5.77'}, {'diameter': '380', 'rpm': '150', 'power_b': '8.17'}, {'diameter': '380', 'rpm': '200', 'power_b': '10.4'}, {'diameter': '380', 'rpm': '250', 'power_b': '12.6'}, {'diameter': '380', 'rpm': '300', 'power_b': '14.7'}, {'diameter': '380', 'rpm': '350', 'power_b': '16.6'}, {'diameter': '380', 'rpm': '400', 'power_b': '18.5'}, {'diameter': '380', 'rpm': '435', 'power_b': '19.8'}, {'diameter': '380', 'rpm': '450', 'power_b': '20.3'}, {'diameter': '380', 'rpm': '485', 'power_b': '21.5'}, {'diameter': '380', 'rpm': '500', 'power_b': '22'}, {'diameter': '380', 'rpm': '550', 'power_b': '23.7'}, {'diameter': '380', 'rpm': '575', 'power_b': '24.5'}, {'diameter': '380', 'rpm': '600', 'power_b': '25.3'}, {'diameter': '380', 'rpm': '650', 'power_b': '26.7'}, {'diameter': '380', 'rpm': '690', 'power_b': '27.9'}, {'diameter': '380', 'rpm': '700', 'power_b': '28.2'}, {'diameter': '380', 'rpm': '725', 'power_b': '28.8'}, {'diameter': '380', 'rpm': '750', 'power_b': '29.5'}, {'diameter': '380', 'rpm': '800', 'power_b': '30.7'}, {'diameter': '380', 'rpm': '850', 'power_b': '31.9'}, {'diameter': '380', 'rpm': '870', 'power_b': '32.3'}, {'diameter': '380', 'rpm': '900', 'power_b': '32.9'}, {'diameter': '380', 'rpm': '950', 'power_b': '33.9'}, {'diameter': '380', 'rpm': '950', 'power_b': '33.9'}, {'diameter': '380', 'rpm': '1000', 'power_b': '34.8'}, {'diameter': '380', 'rpm': '1050', 'power_b': '35.6'}, {'diameter': '380', 'rpm': '1100', 'power_b': '36.2'}, {'diameter': '380', 'rpm': '1150', 'power_b': '36.8'}, {'diameter': '380', 'rpm': '1160', 'power_b': '36.9'}, {'diameter': '380', 'rpm': '1200', 'power_b': '37.3'}, {'diameter': '380', 'rpm': '1250', 'power_b': '37.6'}, {'diameter': '380', 'rpm': '1300', 'power_b': '37.8'}, {'diameter': '380', 'rpm': '1350', 'power_b': '38'}, {'diameter': '380', 'rpm': '1400', 'power_b': '37.9'}, {'diameter': '380', 'rpm': '1450', 'power_b': '37.8'}, {'diameter': '380', 'rpm': '1500', 'power_b': '37.5'}, {'diameter': '380', 'rpm': '1550', 'power_b': '37.1'}, {'diameter': '400', 'rpm': '50', 'power_b': '3.41'}, {'diameter': '400', 'rpm': '100', 'power_b': '6.25'}, {'diameter': '400', 'rpm': '150', 'power_b': '8.88'}, {'diameter': '400', 'rpm': '200', 'power_b': '11.3'}, {'diameter': '400', 'rpm': '250', 'power_b': '13.7'}, {'diameter': '400', 'rpm': '300', 'power_b': '16'}, {'diameter': '400', 'rpm': '350', 'power_b': '18.1'}, {'diameter': '400', 'rpm': '400', 'power_b': '20.2'}, {'diameter': '400', 'rpm': '435', 'power_b': '21.6'}, {'diameter': '400', 'rpm': '450', 'power_b': '22.1'}, {'diameter': '400', 'rpm': '485', 'power_b': '23.5'}, {'diameter': '400', 'rpm': '500', 'power_b': '24'}, {'diameter': '400', 'rpm': '550', 'power_b': '25.8'}, {'diameter': '400', 'rpm': '575', 'power_b': '26.7'}, {'diameter': '400', 'rpm': '600', 'power_b': '27.5'}, {'diameter': '400', 'rpm': '650', 'power_b': '29.2'}, {'diameter': '400', 'rpm': '690', 'power_b': '30.4'}, {'diameter': '400', 'rpm': '700', 'power_b': '30.7'}, {'diameter': '400', 'rpm': '725', 'power_b': '31.4'}, {'diameter': '400', 'rpm': '750', 'power_b': '32.1'}, {'diameter': '400', 'rpm': '800', 'power_b': '33.5'}, {'diameter': '400', 'rpm': '850', 'power_b': '34.7'}, {'diameter': '400', 'rpm': '870', 'power_b': '35.2'}, {'diameter': '400', 'rpm': '900', 'power_b': '35.9'}, {'diameter': '400', 'rpm': '950', 'power_b': '36.9'}, {'diameter': '400', 'rpm': '950', 'power_b': '36.9'}, {'diameter': '400', 'rpm': '1000', 'power_b': '37.8'}, {'diameter': '400', 'rpm': '1050', 'power_b': '38.6'}, {'diameter': '400', 'rpm': '1100', 'power_b': '39.3'}, {'diameter': '400', 'rpm': '1150', 'power_b': '39.9'}, {'diameter': '400', 'rpm': '1160', 'power_b': '40'}, {'diameter': '400', 'rpm': '1200', 'power_b': '40.4'}, {'diameter': '400', 'rpm': '1250', 'power_b': '40.7'}, {'diameter': '400', 'rpm': '1300', 'power_b': '40.9'}, {'diameter': '400', 'rpm': '1350', 'power_b': '40.9'}, {'diameter': '400', 'rpm': '1400', 'power_b': '40.8'}, {'diameter': '400', 'rpm': '1450', 'power_b': '40.6'}, {'diameter': '400', 'rpm': '1500', 'power_b': '40.2'}, {'diameter': '420', 'rpm': '50', 'power_b': '3.66'}, {'diameter': '420', 'rpm': '100', 'power_b': '6.73'}, {'diameter': '420', 'rpm': '150', 'power_b': '9.57'}, {'diameter': '420', 'rpm': '200', 'power_b': '12.3'}, {'diameter': '420', 'rpm': '250', 'power_b': '14.8'}, {'diameter': '420', 'rpm': '300', 'power_b': '17.2'}, {'diameter': '420', 'rpm': '350', 'power_b': '19.6'}, {'diameter': '420', 'rpm': '400', 'power_b': '21.8'}, {'diameter': '420', 'rpm': '435', 'power_b': '23.3'}, {'diameter': '420', 'rpm': '450', 'power_b': '24'}, {'diameter': '420', 'rpm': '485', 'power_b': '25.4'}, {'diameter': '420', 'rpm': '500', 'power_b': '26'}, {'diameter': '420', 'rpm': '550', 'power_b': '28'}, {'diameter': '420', 'rpm': '575', 'power_b': '28.9'}, {'diameter': '420', 'rpm': '600', 'power_b': '29.8'}, {'diameter': '420', 'rpm': '650', 'power_b': '31.6'}, {'diameter': '420', 'rpm': '690', 'power_b': '32.9'}, {'diameter': '420', 'rpm': '700', 'power_b': '33.2'}, {'diameter': '420', 'rpm': '725', 'power_b': '34'}, {'diameter': '420', 'rpm': '750', 'power_b': '34.7'}, {'diameter': '420', 'rpm': '800', 'power_b': '36.2'}, {'diameter': '420', 'rpm': '850', 'power_b': '37.5'}, {'diameter': '420', 'rpm': '870', 'power_b': '38'}, {'diameter': '420', 'rpm': '900', 'power_b': '38.7'}, {'diameter': '420', 'rpm': '950', 'power_b': '39.8'}, {'diameter': '420', 'rpm': '950', 'power_b': '39.8'}, {'diameter': '420', 'rpm': '1000', 'power_b': '40.8'}, {'diameter': '420', 'rpm': '1050', 'power_b': '41.6'}, {'diameter': '420', 'rpm': '1100', 'power_b': '42.3'}, {'diameter': '420', 'rpm': '1150', 'power_b': '42.8'}, {'diameter': '420', 'rpm': '1160', 'power_b': '42.9'}, {'diameter': '420', 'rpm': '1200', 'power_b': '43.3'}, {'diameter': '420', 'rpm': '1250', 'power_b': '43.5'}, {'diameter': '420', 'rpm': '1300', 'power_b': '43.6'}, {'diameter': '420', 'rpm': '1350', 'power_b': '43.6'}, {'diameter': '420', 'rpm': '1400', 'power_b': '43.4'}, {'diameter': '440', 'rpm': '50', 'power_b': '3.92'}, {'diameter': '440', 'rpm': '100', 'power_b': '7.21'}, {'diameter': '440', 'rpm': '150', 'power_b': '10.3'}, {'diameter': '440', 'rpm': '200', 'power_b': '12.2'}, {'diameter': '440', 'rpm': '250', 'power_b': '15.9'}, {'diameter': '440', 'rpm': '300', 'power_b': '18.5'}, {'diameter': '440', 'rpm': '350', 'power_b': '21'}, {'diameter': '440', 'rpm': '400', 'power_b': '23.4'}, {'diameter': '440', 'rpm': '435', 'power_b': '25.1'}, {'diameter': '440', 'rpm': '450', 'power_b': '25.8'}, {'diameter': '440', 'rpm': '485', 'power_b': '27.3'}, {'diameter': '440', 'rpm': '500', 'power_b': '28'}, {'diameter': '440', 'rpm': '550', 'power_b': '30'}, {'diameter': '440', 'rpm': '575', 'power_b': '31'}, {'diameter': '440', 'rpm': '600', 'power_b': '32'}, {'diameter': '440', 'rpm': '650', 'power_b': '33.9'}, {'diameter': '440', 'rpm': '690', 'power_b': '35.3'}, {'diameter': '440', 'rpm': '700', 'power_b': '35.7'}, {'diameter': '440', 'rpm': '725', 'power_b': '36.5'}, {'diameter': '440', 'rpm': '750', 'power_b': '37.3'}, {'diameter': '440', 'rpm': '800', 'power_b': '38.8'}, {'diameter': '440', 'rpm': '850', 'power_b': '40.2'}, {'diameter': '440', 'rpm': '870', 'power_b': '40.7'}, {'diameter': '440', 'rpm': '900', 'power_b': '41.5'}, {'diameter': '440', 'rpm': '950', 'power_b': '42.6'}, {'diameter': '440', 'rpm': '950', 'power_b': '42.6'}, {'diameter': '440', 'rpm': '1000', 'power_b': '43.6'}, {'diameter': '440', 'rpm': '1050', 'power_b': '44.4'}, {'diameter': '440', 'rpm': '1100', 'power_b': '45.1'}, {'diameter': '440', 'rpm': '1150', 'power_b': '45.6'}, {'diameter': '440', 'rpm': '1160', 'power_b': '45.7'}, {'diameter': '440', 'rpm': '1200', 'power_b': '46'}, {'diameter': '440', 'rpm': '1250', 'power_b': '46.2'}, {'diameter': '440', 'rpm': '1300', 'power_b': '46.2'}, {'diameter': '440', 'rpm': '1350', 'power_b': '46'}, {'diameter': '450', 'rpm': '50', 'power_b': '4.04'}, {'diameter': '450', 'rpm': '100', 'power_b': '7.45'}, {'diameter': '450', 'rpm': '150', 'power_b': '10.6'}, {'diameter': '450', 'rpm': '200', 'power_b': '13.6'}, {'diameter': '450', 'rpm': '250', 'power_b': '16.4'}, {'diameter': '450', 'rpm': '300', 'power_b': '19.2'}, {'diameter': '450', 'rpm': '350', 'power_b': '21.8'}, {'diameter': '450', 'rpm': '400', 'power_b': '24.3'}, {'diameter': '450', 'rpm': '435', 'power_b': '25.9'}, {'diameter': '450', 'rpm': '450', 'power_b': '26.6'}, {'diameter': '450', 'rpm': '485', 'power_b': '28.2'}, {'diameter': '450', 'rpm': '500', 'power_b': '28.9'}, {'diameter': '450', 'rpm': '550', 'power_b': '31.1'}, {'diameter': '450', 'rpm': '575', 'power_b': '32.1'}, {'diameter': '450', 'rpm': '600', 'power_b': '33.1'}, {'diameter': '450', 'rpm': '650', 'power_b': '35.1'}, {'diameter': '450', 'rpm': '690', 'power_b': '36.5'}, {'diameter': '450', 'rpm': '700', 'power_b': '36.9'}, {'diameter': '450', 'rpm': '725', 'power_b': '37.7'}, {'diameter': '450', 'rpm': '750', 'power_b': '38.5'}, {'diameter': '450', 'rpm': '800', 'power_b': '40.1'}, {'diameter': '450', 'rpm': '850', 'power_b': '41.5'}, {'diameter': '450', 'rpm': '870', 'power_b': '42.1'}, {'diameter': '450', 'rpm': '900', 'power_b': '42.8'}, {'diameter': '450', 'rpm': '950', 'power_b': '43.9'}, {'diameter': '450', 'rpm': '950', 'power_b': '43.9'}, {'diameter': '450', 'rpm': '1000', 'power_b': '44.9'}, {'diameter': '450', 'rpm': '1050', 'power_b': '45.8'}, {'diameter': '450', 'rpm': '1100', 'power_b': '46.4'}, {'diameter': '450', 'rpm': '1150', 'power_b': '46.9'}, {'diameter': '450', 'rpm': '1160', 'power_b': '47'}, {'diameter': '450', 'rpm': '1200', 'power_b': '47.3'}, {'diameter': '450', 'rpm': '1250', 'power_b': '47.4'}, {'diameter': '450', 'rpm': '1300', 'power_b': '47.4'}, {'diameter': '450', 'rpm': '1350', 'power_b': '47.2'}, {'diameter': '460', 'rpm': '50', 'power_b': '4.17'}, {'diameter': '460', 'rpm': '100', 'power_b': '7.69'}, {'diameter': '460', 'rpm': '150', 'power_b': '11'}, {'diameter': '460', 'rpm': '200', 'power_b': '14'}, {'diameter': '460', 'rpm': '250', 'power_b': '17'}, {'diameter': '460', 'rpm': '300', 'power_b': '19.8'}, {'diameter': '460', 'rpm': '350', 'power_b': '22.5'}, {'diameter': '460', 'rpm': '400', 'power_b': '25.1'}, {'diameter': '460', 'rpm': '435', 'power_b': '26.8'}, {'diameter': '460', 'rpm': '450', 'power_b': '27.5'}, {'diameter': '460', 'rpm': '485', 'power_b': '29.2'}, {'diameter': '460', 'rpm': '500', 'power_b': '29.9'}, {'diameter': '460', 'rpm': '550', 'power_b': '32.1'}, {'diameter': '460', 'rpm': '575', 'power_b': '33.2'}, {'diameter': '460', 'rpm': '600', 'power_b': '34.2'}, {'diameter': '460', 'rpm': '650', 'power_b': '36.2'}, {'diameter': '460', 'rpm': '690', 'power_b': '37.7'}, {'diameter': '460', 'rpm': '700', 'power_b': '38.1'}, {'diameter': '460', 'rpm': '725', 'power_b': '38.9'}, {'diameter': '460', 'rpm': '750', 'power_b': '39.8'}, {'diameter': '460', 'rpm': '800', 'power_b': '41.4'}, {'diameter': '460', 'rpm': '850', 'power_b': '42.8'}, {'diameter': '460', 'rpm': '870', 'power_b': '43.4'}, {'diameter': '460', 'rpm': '900', 'power_b': '44.1'}, {'diameter': '460', 'rpm': '950', 'power_b': '45.3'}, {'diameter': '460', 'rpm': '950', 'power_b': '45.3'}, {'diameter': '460', 'rpm': '1000', 'power_b': '46.3'}, {'diameter': '460', 'rpm': '1050', 'power_b': '47.1'}, {'diameter': '460', 'rpm': '1100', 'power_b': '47.7'}, {'diameter': '460', 'rpm': '1150', 'power_b': '48.2'}, {'diameter': '460', 'rpm': '1160', 'power_b': '48.3'}, {'diameter': '460', 'rpm': '1200', 'power_b': '48.5'}, {'diameter': '460', 'rpm': '1250', 'power_b': '48.6'}, {'diameter': '460', 'rpm': '1300', 'power_b': '48.5'}, {'diameter': '480', 'rpm': '50', 'power_b': '4.42'}, {'diameter': '480', 'rpm': '100', 'power_b': '8.17'}, {'diameter': '480', 'rpm': '150', 'power_b': '11.6'}, {'diameter': '480', 'rpm': '200', 'power_b': '14.9'}, {'diameter': '480', 'rpm': '250', 'power_b': '18.1'}, {'diameter': '480', 'rpm': '300', 'power_b': '21.1'}, {'diameter': '480', 'rpm': '350', 'power_b': '23.9'}, {'diameter': '480', 'rpm': '400', 'power_b': '26.7'}, {'diameter': '480', 'rpm': '435', 'power_b': '28.5'}, {'diameter': '480', 'rpm': '450', 'power_b': '29.3'}, {'diameter': '480', 'rpm': '485', 'power_b': '31'}, {'diameter': '480', 'rpm': '500', 'power_b': '31.8'}, {'diameter': '480', 'rpm': '550', 'power_b': '34.1'}, {'diameter': '480', 'rpm': '575', 'power_b': '35.3'}, {'diameter': '480', 'rpm': '600', 'power_b': '36.4'}, {'diameter': '480', 'rpm': '650', 'power_b': '38.5'}, {'diameter': '480', 'rpm': '690', 'power_b': '40'}, {'diameter': '480', 'rpm': '700', 'power_b': '40.4'}, {'diameter': '480', 'rpm': '725', 'power_b': '41.3'}, {'diameter': '480', 'rpm': '750', 'power_b': '42.2'}, {'diameter': '480', 'rpm': '800', 'power_b': '43.9'}, {'diameter': '480', 'rpm': '850', 'power_b': '45.4'}, {'diameter': '480', 'rpm': '870', 'power_b': '45.9'}, {'diameter': '480', 'rpm': '900', 'power_b': '46.7'}, {'diameter': '480', 'rpm': '950', 'power_b': '47.8'}, {'diameter': '480', 'rpm': '950', 'power_b': '47.8'}, {'diameter': '480', 'rpm': '1000', 'power_b': '48.8'}, {'diameter': '480', 'rpm': '1050', 'power_b': '49.6'}, {'diameter': '480', 'rpm': '1100', 'power_b': '50.2'}, {'diameter': '480', 'rpm': '1150', 'power_b': '50.6'}, {'diameter': '480', 'rpm': '1160', 'power_b': '50.7'}, {'diameter': '480', 'rpm': '1200', 'power_b': '50.8'}, {'diameter': '480', 'rpm': '1250', 'power_b': '50.8'}, {'diameter': '500', 'rpm': '50', 'power_b': '4.68'}, {'diameter': '500', 'rpm': '100', 'power_b': '8.64'}, {'diameter': '500', 'rpm': '150', 'power_b': '12.3'}, {'diameter': '500', 'rpm': '200', 'power_b': '15.8'}, {'diameter': '500', 'rpm': '250', 'power_b': '19.1'}, {'diameter': '500', 'rpm': '300', 'power_b': '22.3'}, {'diameter': '500', 'rpm': '350', 'power_b': '25.4'}, {'diameter': '500', 'rpm': '400', 'power_b': '28.3'}, {'diameter': '500', 'rpm': '435', 'power_b': '30.2'}, {'diameter': '500', 'rpm': '450', 'power_b': '31'}, {'diameter': '500', 'rpm': '485', 'power_b': '32.9'}, {'diameter': '500', 'rpm': '500', 'power_b': '33.7'}, {'diameter': '500', 'rpm': '550', 'power_b': '36.2'}, {'diameter': '500', 'rpm': '575', 'power_b': '37.3'}, {'diameter': '500', 'rpm': '600', 'power_b': '38.5'}, {'diameter': '500', 'rpm': '650', 'power_b': '40.7'}, {'diameter': '500', 'rpm': '690', 'power_b': '42.3'}, {'diameter': '500', 'rpm': '700', 'power_b': '42.7'}, {'diameter': '500', 'rpm': '725', 'power_b': '43.7'}, {'diameter': '500', 'rpm': '750', 'power_b': '44.6'}, {'diameter': '500', 'rpm': '800', 'power_b': '46.3'}, {'diameter': '500', 'rpm': '850', 'power_b': '47.8'}, {'diameter': '500', 'rpm': '870', 'power_b': '48.4'}, {'diameter': '500', 'rpm': '900', 'power_b': '49.2'}, {'diameter': '500', 'rpm': '950', 'power_b': '50.3'}, {'diameter': '500', 'rpm': '950', 'power_b': '50.3'}, {'diameter': '500', 'rpm': '1000', 'power_b': '51.3'}, {'diameter': '500', 'rpm': '1050', 'power_b': '52'}, {'diameter': '500', 'rpm': '1100', 'power_b': '52.5'}, {'diameter': '500', 'rpm': '1150', 'power_b': '52.8'}, {'diameter': '500', 'rpm': '1160', 'power_b': '52.9'}, {'diameter': '500', 'rpm': '1200', 'power_b': '52.9'}, {'diameter': '520', 'rpm': '50', 'power_b': '4.93'}, {'diameter': '520', 'rpm': '100', 'power_b': '9.12'}, {'diameter': '520', 'rpm': '150', 'power_b': '13'}, {'diameter': '520', 'rpm': '200', 'power_b': '16.7'}, {'diameter': '520', 'rpm': '250', 'power_b': '20.2'}, {'diameter': '520', 'rpm': '300', 'power_b': '23.6'}, {'diameter': '520', 'rpm': '350', 'power_b': '26.8'}, {'diameter': '520', 'rpm': '400', 'power_b': '29.8'}, {'diameter': '520', 'rpm': '435', 'power_b': '31.9'}, {'diameter': '520', 'rpm': '450', 'power_b': '32.8'}, {'diameter': '520', 'rpm': '485', 'power_b': '34.7'}, {'diameter': '520', 'rpm': '500', 'power_b': '35.5'}, {'diameter': '520', 'rpm': '550', 'power_b': '38.1'}, {'diameter': '520', 'rpm': '575', 'power_b': '39.4'}, {'diameter': '520', 'rpm': '600', 'power_b': '40.6'}, {'diameter': '520', 'rpm': '650', 'power_b': '42.9'}, {'diameter': '520', 'rpm': '690', 'power_b': '44.6'}, {'diameter': '520', 'rpm': '700', 'power_b': '45'}, {'diameter': '520', 'rpm': '725', 'power_b': '46'}, {'diameter': '520', 'rpm': '750', 'power_b': '46.9'}, {'diameter': '520', 'rpm': '800', 'power_b': '48.6'}, {'diameter': '520', 'rpm': '850', 'power_b': '50.2'}, {'diameter': '520', 'rpm': '870', 'power_b': '50.8'}, {'diameter': '520', 'rpm': '900', 'power_b': '51.5'}, {'diameter': '520', 'rpm': '950', 'power_b': '52.7'}, {'diameter': '520', 'rpm': '950', 'power_b': '52.7'}, {'diameter': '520', 'rpm': '1000', 'power_b': '53.6'}, {'diameter': '520', 'rpm': '1050', 'power_b': '54.2'}, {'diameter': '520', 'rpm': '1100', 'power_b': '54.7'}, {'diameter': '520', 'rpm': '1150', 'power_b': '54.9'}, {'diameter': '520', 'rpm': '1160', 'power_b': '54.9'}, {'diameter': '540', 'rpm': '50', 'power_b': '5.18'}, {'diameter': '540', 'rpm': '100', 'power_b': '9.59'}, {'diameter': '540', 'rpm': '150', 'power_b': '13.7'}, {'diameter': '540', 'rpm': '200', 'power_b': '17.6'}, {'diameter': '540', 'rpm': '250', 'power_b': '21.3'}, {'diameter': '540', 'rpm': '300', 'power_b': '24.8'}, {'diameter': '540', 'rpm': '350', 'power_b': '28.2'}, {'diameter': '540', 'rpm': '400', 'power_b': '31.4'}, {'diameter': '540', 'rpm': '435', 'power_b': '33.6'}, {'diameter': '540', 'rpm': '450', 'power_b': '34.5'}, {'diameter': '540', 'rpm': '485', 'power_b': '36.5'}, {'diameter': '540', 'rpm': '500', 'power_b': '37.4'}, {'diameter': '540', 'rpm': '550', 'power_b': '40.1'}, {'diameter': '540', 'rpm': '575', 'power_b': '41.4'}, {'diameter': '540', 'rpm': '600', 'power_b': '42.6'}, {'diameter': '540', 'rpm': '650', 'power_b': '45'}, {'diameter': '540', 'rpm': '690', 'power_b': '46.8'}, {'diameter': '540', 'rpm': '700', 'power_b': '47.2'}, {'diameter': '540', 'rpm': '725', 'power_b': '48.2'}, {'diameter': '540', 'rpm': '750', 'power_b': '49.2'}, {'diameter': '540', 'rpm': '800', 'power_b': '50.9'}, {'diameter': '540', 'rpm': '850', 'power_b': '52.5'}, {'diameter': '540', 'rpm': '870', 'power_b': '53'}, {'diameter': '540', 'rpm': '900', 'power_b': '53.8'}, {'diameter': '540', 'rpm': '950', 'power_b': '54.9'}, {'diameter': '540', 'rpm': '950', 'power_b': '54.9'}, {'diameter': '540', 'rpm': '1000', 'power_b': '55.7'}, {'diameter': '540', 'rpm': '1050', 'power_b': '56.3'}, {'diameter': '540', 'rpm': '1100', 'power_b': '56.6'}, {'diameter': '560', 'rpm': '50', 'power_b': '5.43'}, {'diameter': '560', 'rpm': '100', 'power_b': '10.1'}, {'diameter': '560', 'rpm': '150', 'power_b': '14.4'}, {'diameter': '560', 'rpm': '200', 'power_b': '18.5'}, {'diameter': '560', 'rpm': '250', 'power_b': '22.3'}, {'diameter': '560', 'rpm': '300', 'power_b': '26'}, {'diameter': '560', 'rpm': '350', 'power_b': '29.6'}, {'diameter': '560', 'rpm': '400', 'power_b': '33'}, {'diameter': '560', 'rpm': '435', 'power_b': '35.2'}, {'diameter': '560', 'rpm': '450', 'power_b': '36.2'}, {'diameter': '560', 'rpm': '485', 'power_b': '38.8'}, {'diameter': '560', 'rpm': '500', 'power_b': '39.2'}, {'diameter': '560', 'rpm': '550', 'power_b': '42'}, {'diameter': '560', 'rpm': '575', 'power_b': '43.4'}, {'diameter': '560', 'rpm': '600', 'power_b': '44.6'}, {'diameter': '560', 'rpm': '650', 'power_b': '47.1'}, {'diameter': '560', 'rpm': '690', 'power_b': '48.9'}, {'diameter': '560', 'rpm': '700', 'power_b': '49.3'}, {'diameter': '560', 'rpm': '725', 'power_b': '50.4'}, {'diameter': '560', 'rpm': '750', 'power_b': '51.3'}, {'diameter': '560', 'rpm': '800', 'power_b': '53.1'}, {'diameter': '560', 'rpm': '850', 'power_b': '54.7'}, {'diameter': '560', 'rpm': '870', 'power_b': '55.2'}, {'diameter': '560', 'rpm': '900', 'power_b': '56'}, {'diameter': '560', 'rpm': '950', 'power_b': '57'}, {'diameter': '560', 'rpm': '950', 'power_b': '57'}, {'diameter': '560', 'rpm': '1000', 'power_b': '57.8'}, {'diameter': '560', 'rpm': '1050', 'power_b': '58.2'}, {'diameter': '580', 'rpm': '50', 'power_b': '5.67'}, {'diameter': '580', 'rpm': '100', 'power_b': '10.5'}, {'diameter': '580', 'rpm': '150', 'power_b': '15'}, {'diameter': '580', 'rpm': '200', 'power_b': '19.3'}, {'diameter': '580', 'rpm': '250', 'power_b': '23.4'}, {'diameter': '580', 'rpm': '300', 'power_b': '27.3'}, {'diameter': '580', 'rpm': '350', 'power_b': '31'}, {'diameter': '580', 'rpm': '400', 'power_b': '34.5'}, {'diameter': '580', 'rpm': '435', 'power_b': '36.8'}, {'diameter': '580', 'rpm': '450', 'power_b': '37.8'}, {'diameter': '580', 'rpm': '485', 'power_b': '40'}, {'diameter': '580', 'rpm': '500', 'power_b': '41'}, {'diameter': '580', 'rpm': '550', 'power_b': '43.9'}, {'diameter': '580', 'rpm': '575', 'power_b': '45.3'}, {'diameter': '580', 'rpm': '600', 'power_b': '46.6'}, {'diameter': '580', 'rpm': '650', 'power_b': '49.1'}, {'diameter': '580', 'rpm': '690', 'power_b': '51'}, {'diameter': '580', 'rpm': '700', 'power_b': '51.4'}, {'diameter': '580', 'rpm': '725', 'power_b': '52.5'}, {'diameter': '580', 'rpm': '750', 'power_b': '53.5'}, {'diameter': '580', 'rpm': '800', 'power_b': '55.2'}, {'diameter': '580', 'rpm': '850', 'power_b': '56.8'}, {'diameter': '580', 'rpm': '870', 'power_b': '57.3'}, {'diameter': '580', 'rpm': '900', 'power_b': '58'}, {'diameter': '580', 'rpm': '950', 'power_b': '59'}, {'diameter': '580', 'rpm': '950', 'power_b': '59'}, {'diameter': '580', 'rpm': '1000', 'power_b': '59.6'}, {'diameter': '580', 'rpm': '1050', 'power_b': '60'}, {'diameter': '600', 'rpm': '50', 'power_b': '5.92'}, {'diameter': '600', 'rpm': '100', 'power_b': '11'}, {'diameter': '600', 'rpm': '150', 'power_b': '15.7'}, {'diameter': '600', 'rpm': '200', 'power_b': '20.2'}, {'diameter': '600', 'rpm': '250', 'power_b': '24.4'}, {'diameter': '600', 'rpm': '300', 'power_b': '28.5'}, {'diameter': '600', 'rpm': '350', 'power_b': '32.4'}, {'diameter': '600', 'rpm': '400', 'power_b': '36'}, {'diameter': '600', 'rpm': '435', 'power_b': '38.5'}, {'diameter': '600', 'rpm': '450', 'power_b': '29.5'}, {'diameter': '600', 'rpm': '485', 'power_b': '41.8'}, {'diameter': '600', 'rpm': '500', 'power_b': '42.7'}, {'diameter': '600', 'rpm': '550', 'power_b': '45.8'}, {'diameter': '600', 'rpm': '575', 'power_b': '47.2'}, {'diameter': '600', 'rpm': '600', 'power_b': '48.6'}, {'diameter': '600', 'rpm': '650', 'power_b': '51.1'}, {'diameter': '600', 'rpm': '690', 'power_b': '53'}, {'diameter': '600', 'rpm': '700', 'power_b': '53.5'}, {'diameter': '600', 'rpm': '725', 'power_b': '56.5'}, {'diameter': '600', 'rpm': '750', 'power_b': '55.5'}, {'diameter': '600', 'rpm': '800', 'power_b': '57.3'}, {'diameter': '600', 'rpm': '850', 'power_b': '58.8'}, {'diameter': '600', 'rpm': '870', 'power_b': '59.3'}, {'diameter': '600', 'rpm': '900', 'power_b': '60'}, {'diameter': '600', 'rpm': '950', 'power_b': '60.8'}, {'diameter': '600', 'rpm': '950', 'power_b': '60.8'}, {'diameter': '600', 'rpm': '1000', 'power_b': '61.4'})

SuperHC_3v_pa = ({'gr_low': '1', 'gr_high': '1.02', 'rpm': '100', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '200', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '300', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '400', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '500', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '575', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '600', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '690', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '700', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '725', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '800', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '870', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '900', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '950', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1000', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1100', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1160', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1200', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1300', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1400', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1425', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1500', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1600', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1700', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1750', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1800', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1900', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '2000', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '2100', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '2200', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '2300', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '2400', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '2500', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '2600', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '2700', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '2800', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '2850', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '2900', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '3000', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '3100', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '3200', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '3300', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '3400', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '3450', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '3500', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '3600', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '3700', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '3800', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '3900', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '4000', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '4100', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '4200', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '4300', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '4400', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '4500', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '4600', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '4700', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '4800', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '4900', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '5000', 'power_a': '0'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '100', 'power_a': '0'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '200', 'power_a': '0'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '300', 'power_a': '0.01'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '400', 'power_a': '0.01'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '500', 'power_a': '0.01'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '575', 'power_a': '0.01'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '600', 'power_a': '0.01'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '690', 'power_a': '0.01'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '700', 'power_a': '0.01'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '725', 'power_a': '0.01'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '800', 'power_a': '0.01'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '870', 'power_a': '0.02'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '900', 'power_a': '0.02'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '950', 'power_a': '0.02'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '1000', 'power_a': '0.02'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '1100', 'power_a': '0.02'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '1160', 'power_a': '0.02'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '1200', 'power_a': '0.02'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '1300', 'power_a': '0.02'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '1400', 'power_a': '0.03'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '1425', 'power_a': '0.03'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '1500', 'power_a': '0.03'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '1600', 'power_a': '0.03'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '1700', 'power_a': '0.03'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '1750', 'power_a': '0.03'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '1800', 'power_a': '0.03'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '1900', 'power_a': '0.03'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '2000', 'power_a': '0.04'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '2100', 'power_a': '0.04'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '2200', 'power_a': '0.04'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '2300', 'power_a': '0.04'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '2400', 'power_a': '0.04'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '2500', 'power_a': '0.05'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '2600', 'power_a': '0.05'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '2700', 'power_a': '0.05'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '2800', 'power_a': '0.05'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '2850', 'power_a': '0.05'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '2900', 'power_a': '0.05'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '3000', 'power_a': '0.06'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '3100', 'power_a': '0.06'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '3200', 'power_a': '0.06'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '3300', 'power_a': '0.06'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '3400', 'power_a': '0.06'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '3450', 'power_a': '0.06'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '3500', 'power_a': '0.06'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '3600', 'power_a': '0.07'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '3700', 'power_a': '0.07'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '3800', 'power_a': '0.07'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '3900', 'power_a': '0.07'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '4000', 'power_a': '0.07'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '4100', 'power_a': '0.08'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '4200', 'power_a': '0.08'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '4300', 'power_a': '0.08'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '4400', 'power_a': '0.08'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '4500', 'power_a': '0.08'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '4600', 'power_a': '0.08'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '4700', 'power_a': '0.09'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '4800', 'power_a': '0.09'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '4900', 'power_a': '0.09'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '5000', 'power_a': '0.09'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '100', 'power_a': '0.01'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '200', 'power_a': '0.01'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '300', 'power_a': '0.02'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '400', 'power_a': '0.02'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '500', 'power_a': '0.03'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '575', 'power_a': '0.03'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '600', 'power_a': '0.03'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '690', 'power_a': '0.03'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '700', 'power_a': '0.04'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '725', 'power_a': '0.04'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '800', 'power_a': '0.04'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '870', 'power_a': '0.04'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '900', 'power_a': '0.05'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '950', 'power_a': '0.05'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '1000', 'power_a': '0.05'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '1100', 'power_a': '0.06'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '1160', 'power_a': '0.06'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '1200', 'power_a': '0.06'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '1300', 'power_a': '0.07'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '1400', 'power_a': '0.07'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '1425', 'power_a': '0.07'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '1500', 'power_a': '0.08'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '1600', 'power_a': '0.08'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '1700', 'power_a': '0.09'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '1750', 'power_a': '0.09'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '1800', 'power_a': '0.09'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '1900', 'power_a': '0.1'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '2000', 'power_a': '0.1'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '2100', 'power_a': '0.11'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '2200', 'power_a': '0.11'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '2300', 'power_a': '0.12'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '2400', 'power_a': '0.12'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '2500', 'power_a': '0.13'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '2600', 'power_a': '0.13'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '2700', 'power_a': '0.14'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '2800', 'power_a': '0.14'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '2850', 'power_a': '0.14'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '2900', 'power_a': '0.15'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '3000', 'power_a': '0.15'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '3100', 'power_a': '0.16'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '3200', 'power_a': '0.16'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '3300', 'power_a': '0.17'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '3400', 'power_a': '0.17'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '3450', 'power_a': '0.17'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '3500', 'power_a': '0.18'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '3600', 'power_a': '0.18'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '3700', 'power_a': '0.19'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '3800', 'power_a': '0.19'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '3900', 'power_a': '0.2'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '4000', 'power_a': '0.2'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '4100', 'power_a': '0.21'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '4200', 'power_a': '0.21'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '4300', 'power_a': '0.22'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '4400', 'power_a': '0.22'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '4500', 'power_a': '0.23'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '4600', 'power_a': '0.23'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '4700', 'power_a': '0.24'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '4800', 'power_a': '0.24'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '4900', 'power_a': '0.25'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '5000', 'power_a': '0.25'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '100', 'power_a': '0.01'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '200', 'power_a': '0.02'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '300', 'power_a': '0.03'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '400', 'power_a': '0.03'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '500', 'power_a': '0.04'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '575', 'power_a': '0.05'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '600', 'power_a': '0.05'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '690', 'power_a': '0.06'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '700', 'power_a': '0.06'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '725', 'power_a': '0.06'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '800', 'power_a': '0.07'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '870', 'power_a': '0.08'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '900', 'power_a': '0.08'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '950', 'power_a': '0.08'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '1000', 'power_a': '0.09'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '1100', 'power_a': '0.1'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '1160', 'power_a': '0.1'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '1200', 'power_a': '0.1'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '1300', 'power_a': '0.11'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '1400', 'power_a': '0.12'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '1425', 'power_a': '0.12'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '1500', 'power_a': '0.13'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '1600', 'power_a': '0.14'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '1700', 'power_a': '0.15'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '1750', 'power_a': '0.15'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '1800', 'power_a': '0.16'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '1900', 'power_a': '0.17'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '2000', 'power_a': '0.17'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '2100', 'power_a': '0.18'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '2200', 'power_a': '0.19'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '2300', 'power_a': '0.2'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '2400', 'power_a': '0.21'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '2500', 'power_a': '0.22'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '2600', 'power_a': '0.23'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '2700', 'power_a': '0.24'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '2800', 'power_a': '0.24'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '2850', 'power_a': '0.25'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '2900', 'power_a': '0.25'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '3000', 'power_a': '0.26'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '3100', 'power_a': '0.27'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '3200', 'power_a': '0.28'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '3300', 'power_a': '0.29'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '3400', 'power_a': '0.3'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '3450', 'power_a': '0.3'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '3500', 'power_a': '0.31'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '3600', 'power_a': '0.31'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '3700', 'power_a': '0.32'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '3800', 'power_a': '0.33'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '3900', 'power_a': '0.34'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '4000', 'power_a': '0.35'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '4100', 'power_a': '0.36'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '4200', 'power_a': '0.37'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '4300', 'power_a': '0.37'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '4400', 'power_a': '0.38'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '4500', 'power_a': '0.39'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '4600', 'power_a': '0.4'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '4700', 'power_a': '0.41'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '4800', 'power_a': '0.42'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '4900', 'power_a': '0.43'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '5000', 'power_a': '0.44'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '100', 'power_a': '0.01'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '200', 'power_a': '0.02'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '300', 'power_a': '0.04'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '400', 'power_a': '0.05'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '500', 'power_a': '0.06'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '575', 'power_a': '0.07'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '600', 'power_a': '0.07'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '690', 'power_a': '0.08'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '700', 'power_a': '0.08'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '725', 'power_a': '0.09'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '800', 'power_a': '0.09'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '870', 'power_a': '0.1'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '900', 'power_a': '0.11'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '950', 'power_a': '0.11'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '1000', 'power_a': '0.12'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '1100', 'power_a': '0.13'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '1160', 'power_a': '0.14'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '1200', 'power_a': '0.14'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '1300', 'power_a': '0.15'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '1400', 'power_a': '0.17'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '1425', 'power_a': '0.17'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '1500', 'power_a': '0.18'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '1600', 'power_a': '0.19'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '1700', 'power_a': '0.2'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '1750', 'power_a': '0.21'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '1800', 'power_a': '0.21'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '1900', 'power_a': '0.23'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '2000', 'power_a': '0.24'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '2100', 'power_a': '0.25'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '2200', 'power_a': '0.26'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '2300', 'power_a': '0.27'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '2400', 'power_a': '0.28'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '2500', 'power_a': '0.3'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '2600', 'power_a': '0.31'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '2700', 'power_a': '0.32'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '2800', 'power_a': '0.33'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '2850', 'power_a': '0.34'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '2900', 'power_a': '0.34'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '3000', 'power_a': '0.36'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '3100', 'power_a': '0.37'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '3200', 'power_a': '0.38'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '3300', 'power_a': '0.39'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '3400', 'power_a': '0.4'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '3450', 'power_a': '0.41'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '3500', 'power_a': '0.42'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '3600', 'power_a': '0.43'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '3700', 'power_a': '0.44'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '3800', 'power_a': '0.45'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '3900', 'power_a': '0.46'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '4000', 'power_a': '0.47'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '4100', 'power_a': '0.49'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '4200', 'power_a': '0.5'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '4300', 'power_a': '0.51'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '4400', 'power_a': '0.52'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '4500', 'power_a': '0.53'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '4600', 'power_a': '0.55'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '4700', 'power_a': '0.56'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '4800', 'power_a': '0.57'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '4900', 'power_a': '0.58'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '5000', 'power_a': '0.59'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '100', 'power_a': '0.01'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '200', 'power_a': '0.03'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '300', 'power_a': '0.04'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '400', 'power_a': '0.06'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '500', 'power_a': '0.07'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '575', 'power_a': '0.08'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '600', 'power_a': '0.09'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '690', 'power_a': '0.1'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '700', 'power_a': '0.1'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '725', 'power_a': '0.1'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '800', 'power_a': '0.12'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '870', 'power_a': '0.13'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '900', 'power_a': '0.13'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '950', 'power_a': '0.14'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '1000', 'power_a': '0.14'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '1100', 'power_a': '0.16'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '1160', 'power_a': '0.17'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '1200', 'power_a': '0.17'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '1300', 'power_a': '0.19'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '1400', 'power_a': '0.2'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '1425', 'power_a': '0.2'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '1500', 'power_a': '0.22'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '1600', 'power_a': '0.23'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '1700', 'power_a': '0.24'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '1750', 'power_a': '0.25'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '1800', 'power_a': '0.26'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '1900', 'power_a': '0.27'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '2000', 'power_a': '0.29'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '2100', 'power_a': '0.3'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '2200', 'power_a': '0.32'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '2300', 'power_a': '0.33'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '2400', 'power_a': '0.35'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '2500', 'power_a': '0.36'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '2600', 'power_a': '0.37'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '2700', 'power_a': '0.39'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '2800', 'power_a': '0.4'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '2850', 'power_a': '0.41'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '2900', 'power_a': '0.42'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '3000', 'power_a': '0.43'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '3100', 'power_a': '0.45'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '3200', 'power_a': '0.46'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '3300', 'power_a': '0.47'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '3400', 'power_a': '0.49'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '3450', 'power_a': '0.5'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '3500', 'power_a': '0.5'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '3600', 'power_a': '0.52'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '3700', 'power_a': '0.53'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '3800', 'power_a': '0.55'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '3900', 'power_a': '0.56'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '4000', 'power_a': '0.58'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '4100', 'power_a': '0.59'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '4200', 'power_a': '0.6'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '4300', 'power_a': '0.62'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '4400', 'power_a': '0.63'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '4500', 'power_a': '0.65'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '4600', 'power_a': '0.66'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '4700', 'power_a': '0.68'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '4800', 'power_a': '0.69'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '4900', 'power_a': '0.7'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '5000', 'power_a': '0.72'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '100', 'power_a': '0.02'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '200', 'power_a': '0.03'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '300', 'power_a': '0.05'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '400', 'power_a': '0.07'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '500', 'power_a': '0.08'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '575', 'power_a': '0.1'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '600', 'power_a': '0.1'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '690', 'power_a': '0.12'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '700', 'power_a': '0.12'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '725', 'power_a': '0.12'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '800', 'power_a': '0.13'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '870', 'power_a': '0.15'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '900', 'power_a': '0.15'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '950', 'power_a': '0.16'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '1000', 'power_a': '0.17'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '1100', 'power_a': '0.19'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '1160', 'power_a': '0.2'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '1200', 'power_a': '0.2'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '1300', 'power_a': '0.22'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '1400', 'power_a': '0.24'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '1425', 'power_a': '0.24'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '1500', 'power_a': '0.25'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '1600', 'power_a': '0.27'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '1700', 'power_a': '0.29'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '1750', 'power_a': '0.29'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '1800', 'power_a': '0.3'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '1900', 'power_a': '0.32'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '2000', 'power_a': '0.34'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '2100', 'power_a': '0.35'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '2200', 'power_a': '0.37'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '2300', 'power_a': '0.39'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '2400', 'power_a': '0.4'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '2500', 'power_a': '0.42'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '2600', 'power_a': '0.44'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '2700', 'power_a': '0.45'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '2800', 'power_a': '0.47'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '2850', 'power_a': '0.48'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '2900', 'power_a': '0.49'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '3000', 'power_a': '0.51'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '3100', 'power_a': '0.52'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '3200', 'power_a': '0.54'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '3300', 'power_a': '0.56'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '3400', 'power_a': '0.57'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '3450', 'power_a': '0.58'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '3500', 'power_a': '0.59'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '3600', 'power_a': '0.61'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '3700', 'power_a': '0.62'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '3800', 'power_a': '0.64'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '3900', 'power_a': '0.66'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '4000', 'power_a': '0.67'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '4100', 'power_a': '0.69'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '4200', 'power_a': '0.71'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '4300', 'power_a': '0.72'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '4400', 'power_a': '0.74'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '4500', 'power_a': '0.76'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '4600', 'power_a': '0.77'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '4700', 'power_a': '0.79'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '4800', 'power_a': '0.81'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '4900', 'power_a': '0.83'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '5000', 'power_a': '0.84'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '100', 'power_a': '0.02'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '200', 'power_a': '0.04'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '300', 'power_a': '0.06'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '400', 'power_a': '0.08'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '500', 'power_a': '0.09'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '575', 'power_a': '0.11'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '600', 'power_a': '0.11'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '690', 'power_a': '0.13'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '700', 'power_a': '0.13'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '725', 'power_a': '0.14'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '800', 'power_a': '0.17'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '870', 'power_a': '0.16'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '900', 'power_a': '0.19'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '950', 'power_a': '0.18'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '1000', 'power_a': '0.21'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '1100', 'power_a': '0.23'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '1160', 'power_a': '0.22'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '1200', 'power_a': '0.25'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '1300', 'power_a': '0.27'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '1400', 'power_a': '0.29'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '1425', 'power_a': '0.27'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '1500', 'power_a': '0.31'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '1600', 'power_a': '0.33'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '1700', 'power_a': '0.35'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '1750', 'power_a': '0.33'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '1800', 'power_a': '0.37'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '1900', 'power_a': '0.39'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '2000', 'power_a': '0.41'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '2100', 'power_a': '0.43'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '2200', 'power_a': '0.45'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '2300', 'power_a': '0.47'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '2400', 'power_a': '0.5'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '2500', 'power_a': '0.52'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '2600', 'power_a': '0.54'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '2700', 'power_a': '0.56'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '2800', 'power_a': '0.58'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '2850', 'power_a': '0.54'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '2900', 'power_a': '0.6'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '3000', 'power_a': '0.62'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '3100', 'power_a': '0.64'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '3200', 'power_a': '0.66'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '3300', 'power_a': '0.68'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '3400', 'power_a': '0.7'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '3450', 'power_a': '0.65'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '3500', 'power_a': '0.72'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '3600', 'power_a': '0.74'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '3700', 'power_a': '0.76'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '3800', 'power_a': '0.78'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '3900', 'power_a': '0.81'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '4000', 'power_a': '0.83'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '4100', 'power_a': '0.85'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '4200', 'power_a': '0.87'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '4300', 'power_a': '0.89'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '4400', 'power_a': '0.91'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '4500', 'power_a': '0.93'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '4600', 'power_a': '0.95'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '4700', 'power_a': '0.97'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '4800', 'power_a': '0.99'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '4900', 'power_a': '1.01'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '5000', 'power_a': '1.03'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '100', 'power_a': '0.02'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '200', 'power_a': '0.04'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '300', 'power_a': '0.06'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '400', 'power_a': '0.08'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '500', 'power_a': '0.1'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '575', 'power_a': '0.12'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '600', 'power_a': '0.12'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '690', 'power_a': '0.14'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '700', 'power_a': '0.14'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '725', 'power_a': '0.15'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '800', 'power_a': '0.17'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '870', 'power_a': '0.18'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '900', 'power_a': '0.19'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '950', 'power_a': '0.2'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '1000', 'power_a': '0.21'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '1100', 'power_a': '0.23'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '1160', 'power_a': '0.24'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '1200', 'power_a': '0.25'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '1300', 'power_a': '0.27'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '1400', 'power_a': '0.29'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '1425', 'power_a': '0.29'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '1500', 'power_a': '0.31'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '1600', 'power_a': '0.33'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '1700', 'power_a': '0.35'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '1750', 'power_a': '0.36'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '1800', 'power_a': '0.37'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '1900', 'power_a': '0.39'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '2000', 'power_a': '0.41'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '2100', 'power_a': '0.43'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '2200', 'power_a': '0.45'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '2300', 'power_a': '0.47'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '2400', 'power_a': '0.5'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '2500', 'power_a': '0.52'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '2600', 'power_a': '0.54'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '2700', 'power_a': '0.56'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '2800', 'power_a': '0.58'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '2850', 'power_a': '0.59'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '2900', 'power_a': '0.6'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '3000', 'power_a': '0.62'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '3100', 'power_a': '0.64'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '3200', 'power_a': '0.66'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '3300', 'power_a': '0.68'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '3400', 'power_a': '0.7'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '3450', 'power_a': '0.71'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '3500', 'power_a': '0.72'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '3600', 'power_a': '0.74'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '3700', 'power_a': '0.76'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '3800', 'power_a': '0.78'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '3900', 'power_a': '0.81'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '4000', 'power_a': '0.83'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '4100', 'power_a': '0.85'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '4200', 'power_a': '0.87'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '4300', 'power_a': '0.89'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '4400', 'power_a': '0.91'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '4500', 'power_a': '0.93'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '4600', 'power_a': '0.95'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '4700', 'power_a': '0.97'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '4800', 'power_a': '0.99'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '4900', 'power_a': '1.01'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '5000', 'power_a': '1.03'}, {'gr_low': '3.38', 'gr_high': '10', 'rpm': '100', 'power_a': '0.02'}, {'gr_low': '3.38', 'gr_high': '10', 'rpm': '200', 'power_a': '0.04'}, {'gr_low': '3.38', 'gr_high': '10', 'rpm': '300', 'power_a': '0.07'}, {'gr_low': '3.38', 'gr_high': '10', 'rpm': '400', 'power_a': '0.09'}, {'gr_low': '3.38', 'gr_high': '10', 'rpm': '500', 'power_a': '0.11'}, {'gr_low': '3.38', 'gr_high': '10', 'rpm': '575', 'power_a': '0.13'}, {'gr_low': '3.38', 'gr_high': '10', 'rpm': '600', 'power_a': '0.13'}, {'gr_low': '3.38', 'gr_high': '10', 'rpm': '690', 'power_a': '0.15'}, {'gr_low': '3.38', 'gr_high': '10', 'rpm': '700', 'power_a': '0.15'}, {'gr_low': '3.38', 'gr_high': '10', 'rpm': '725', 'power_a': '0.16'}, {'gr_low': '3.38', 'gr_high': '10', 'rpm': '800', 'power_a': '0.17'}, {'gr_low': '3.38', 'gr_high': '10', 'rpm': '870', 'power_a': '0.19'}, {'gr_low': '3.38', 'gr_high': '10', 'rpm': '900', 'power_a': '0.2'}, {'gr_low': '3.38', 'gr_high': '10', 'rpm': '950', 'power_a': '0.21'}, {'gr_low': '3.38', 'gr_high': '10', 'rpm': '1000', 'power_a': '0.22'}, {'gr_low': '3.38', 'gr_high': '10', 'rpm': '1100', 'power_a': '0.24'}, {'gr_low': '3.38', 'gr_high': '10', 'rpm': '1160', 'power_a': '0.25'}, {'gr_low': '3.38', 'gr_high': '10', 'rpm': '1200', 'power_a': '0.26'}, {'gr_low': '3.38', 'gr_high': '10', 'rpm': '1300', 'power_a': '0.28'}, {'gr_low': '3.38', 'gr_high': '10', 'rpm': '1400', 'power_a': '0.31'}, {'gr_low': '3.38', 'gr_high': '10', 'rpm': '1425', 'power_a': '0.31'}, {'gr_low': '3.38', 'gr_high': '10', 'rpm': '1500', 'power_a': '0.33'}, {'gr_low': '3.38', 'gr_high': '10', 'rpm': '1600', 'power_a': '0.35'}, {'gr_low': '3.38', 'gr_high': '10', 'rpm': '1700', 'power_a': '0.37'}, {'gr_low': '3.38', 'gr_high': '10', 'rpm': '1750', 'power_a': '0.38'}, {'gr_low': '3.38', 'gr_high': '10', 'rpm': '1800', 'power_a': '0.39'}, {'gr_low': '3.38', 'gr_high': '10', 'rpm': '1900', 'power_a': '0.42'}, {'gr_low': '3.38', 'gr_high': '10', 'rpm': '2000', 'power_a': '0.44'}, {'gr_low': '3.38', 'gr_high': '10', 'rpm': '2100', 'power_a': '0.46'}, {'gr_low': '3.38', 'gr_high': '10', 'rpm': '2200', 'power_a': '0.48'}, {'gr_low': '3.38', 'gr_high': '10', 'rpm': '2300', 'power_a': '0.5'}, {'gr_low': '3.38', 'gr_high': '10', 'rpm': '2400', 'power_a': '0.52'}, {'gr_low': '3.38', 'gr_high': '10', 'rpm': '2500', 'power_a': '0.55'}, {'gr_low': '3.38', 'gr_high': '10', 'rpm': '2600', 'power_a': '0.57'}, {'gr_low': '3.38', 'gr_high': '10', 'rpm': '2700', 'power_a': '0.59'}, {'gr_low': '3.38', 'gr_high': '10', 'rpm': '2800', 'power_a': '0.61'}, {'gr_low': '3.38', 'gr_high': '10', 'rpm': '2850', 'power_a': '0.62'}, {'gr_low': '3.38', 'gr_high': '10', 'rpm': '2900', 'power_a': '0.63'}, {'gr_low': '3.38', 'gr_high': '10', 'rpm': '3000', 'power_a': '0.66'}, {'gr_low': '3.38', 'gr_high': '10', 'rpm': '3100', 'power_a': '0.68'}, {'gr_low': '3.38', 'gr_high': '10', 'rpm': '3200', 'power_a': '0.7'}, {'gr_low': '3.38', 'gr_high': '10', 'rpm': '3300', 'power_a': '0.72'}, {'gr_low': '3.38', 'gr_high': '10', 'rpm': '3400', 'power_a': '0.74'}, {'gr_low': '3.38', 'gr_high': '10', 'rpm': '3450', 'power_a': '0.75'}, {'gr_low': '3.38', 'gr_high': '10', 'rpm': '3500', 'power_a': '0.77'}, {'gr_low': '3.38', 'gr_high': '10', 'rpm': '3600', 'power_a': '0.79'}, {'gr_low': '3.38', 'gr_high': '10', 'rpm': '3700', 'power_a': '0.81'}, {'gr_low': '3.38', 'gr_high': '10', 'rpm': '3800', 'power_a': '0.83'}, {'gr_low': '3.38', 'gr_high': '10', 'rpm': '3900', 'power_a': '0.85'}, {'gr_low': '3.38', 'gr_high': '10', 'rpm': '4000', 'power_a': '0.87'}, {'gr_low': '3.38', 'gr_high': '10', 'rpm': '4100', 'power_a': '0.9'}, {'gr_low': '3.38', 'gr_high': '10', 'rpm': '4200', 'power_a': '0.92'}, {'gr_low': '3.38', 'gr_high': '10', 'rpm': '4300', 'power_a': '0.94'}, {'gr_low': '3.38', 'gr_high': '10', 'rpm': '4400', 'power_a': '0.96'}, {'gr_low': '3.38', 'gr_high': '10', 'rpm': '4500', 'power_a': '0.98'}, {'gr_low': '3.38', 'gr_high': '10', 'rpm': '4600', 'power_a': '1.01'}, {'gr_low': '3.38', 'gr_high': '10', 'rpm': '4700', 'power_a': '1.03'}, {'gr_low': '3.38', 'gr_high': '10', 'rpm': '4800', 'power_a': '1.05'}, {'gr_low': '3.38', 'gr_high': '10', 'rpm': '4900', 'power_a': '1.07'}, {'gr_low': '3.38', 'gr_high': '10', 'rpm': '5000', 'power_a': '1.09'})

SuperHC_3v_pb = ({'diameter': '70', 'rpm': '100', 'power_b': '0.16'}, {'diameter': '70', 'rpm': '200', 'power_b': '0.3'}, {'diameter': '70', 'rpm': '300', 'power_b': '0.42'}, {'diameter': '70', 'rpm': '400', 'power_b': '0.54'}, {'diameter': '70', 'rpm': '500', 'power_b': '0.65'}, {'diameter': '70', 'rpm': '575', 'power_b': '0.73'}, {'diameter': '70', 'rpm': '600', 'power_b': '0.76'}, {'diameter': '70', 'rpm': '690', 'power_b': '0.85'}, {'diameter': '70', 'rpm': '700', 'power_b': '0.86'}, {'diameter': '70', 'rpm': '725', 'power_b': '0.59'}, {'diameter': '70', 'rpm': '800', 'power_b': '0.96'}, {'diameter': '70', 'rpm': '870', 'power_b': '1.03'}, {'diameter': '70', 'rpm': '900', 'power_b': '1.06'}, {'diameter': '70', 'rpm': '950', 'power_b': '1.11'}, {'diameter': '70', 'rpm': '1000', 'power_b': '1.15'}, {'diameter': '70', 'rpm': '1100', 'power_b': '1.25'}, {'diameter': '70', 'rpm': '1160', 'power_b': '1.3'}, {'diameter': '70', 'rpm': '1200', 'power_b': '1.34'}, {'diameter': '70', 'rpm': '1300', 'power_b': '1.43'}, {'diameter': '70', 'rpm': '1400', 'power_b': '1.51'}, {'diameter': '70', 'rpm': '1425', 'power_b': '1.53'}, {'diameter': '70', 'rpm': '1500', 'power_b': '1.6'}, {'diameter': '70', 'rpm': '1600', 'power_b': '1.66'}, {'diameter': '70', 'rpm': '1700', 'power_b': '1.76'}, {'diameter': '70', 'rpm': '1750', 'power_b': '1.8'}, {'diameter': '70', 'rpm': '1800', 'power_b': '1.84'}, {'diameter': '70', 'rpm': '1900', 'power_b': '1.92'}, {'diameter': '70', 'rpm': '2000', 'power_b': '1.99'}, {'diameter': '70', 'rpm': '2100', 'power_b': '2.07'}, {'diameter': '70', 'rpm': '2200', 'power_b': '2.14'}, {'diameter': '70', 'rpm': '2300', 'power_b': '2.21'}, {'diameter': '70', 'rpm': '2400', 'power_b': '2.28'}, {'diameter': '70', 'rpm': '2500', 'power_b': '2.35'}, {'diameter': '70', 'rpm': '2600', 'power_b': '2.42'}, {'diameter': '70', 'rpm': '2700', 'power_b': '2.48'}, {'diameter': '70', 'rpm': '2800', 'power_b': '2.55'}, {'diameter': '70', 'rpm': '2850', 'power_b': '2.58'}, {'diameter': '70', 'rpm': '2900', 'power_b': '2.61'}, {'diameter': '70', 'rpm': '3000', 'power_b': '2.67'}, {'diameter': '70', 'rpm': '3100', 'power_b': '2.73'}, {'diameter': '70', 'rpm': '3200', 'power_b': '2.79'}, {'diameter': '70', 'rpm': '3300', 'power_b': '2.85'}, {'diameter': '70', 'rpm': '3400', 'power_b': '2.9'}, {'diameter': '70', 'rpm': '3450', 'power_b': '2.93'}, {'diameter': '70', 'rpm': '3500', 'power_b': '2.96'}, {'diameter': '70', 'rpm': '3600', 'power_b': '3.01'}, {'diameter': '70', 'rpm': '3700', 'power_b': '3.06'}, {'diameter': '70', 'rpm': '3800', 'power_b': '3.11'}, {'diameter': '70', 'rpm': '3900', 'power_b': '3.16'}, {'diameter': '70', 'rpm': '4000', 'power_b': '3.2'}, {'diameter': '70', 'rpm': '4100', 'power_b': '3.25'}, {'diameter': '70', 'rpm': '4200', 'power_b': '3.29'}, {'diameter': '70', 'rpm': '4300', 'power_b': '3.34'}, {'diameter': '70', 'rpm': '4400', 'power_b': '3.38'}, {'diameter': '70', 'rpm': '4500', 'power_b': '3.41'}, {'diameter': '70', 'rpm': '4600', 'power_b': '3.45'}, {'diameter': '70', 'rpm': '4700', 'power_b': '3.49'}, {'diameter': '70', 'rpm': '4800', 'power_b': '3.52'}, {'diameter': '70', 'rpm': '4900', 'power_b': '3.55'}, {'diameter': '70', 'rpm': '5000', 'power_b': '3.58'}, {'diameter': '80', 'rpm': '100', 'power_b': '0.21'}, {'diameter': '80', 'rpm': '200', 'power_b': '0.39'}, {'diameter': '80', 'rpm': '300', 'power_b': '0.56'}, {'diameter': '80', 'rpm': '400', 'power_b': '0.72'}, {'diameter': '80', 'rpm': '500', 'power_b': '0.87'}, {'diameter': '80', 'rpm': '575', 'power_b': '0.98'}, {'diameter': '80', 'rpm': '600', 'power_b': '1.02'}, {'diameter': '80', 'rpm': '690', 'power_b': '1.15'}, {'diameter': '80', 'rpm': '700', 'power_b': '1.16'}, {'diameter': '80', 'rpm': '725', 'power_b': '1.2'}, {'diameter': '80', 'rpm': '800', 'power_b': '1.3'}, {'diameter': '80', 'rpm': '870', 'power_b': '1.4'}, {'diameter': '80', 'rpm': '900', 'power_b': '1.44'}, {'diameter': '80', 'rpm': '950', 'power_b': '1.5'}, {'diameter': '80', 'rpm': '1000', 'power_b': '1.57'}, {'diameter': '80', 'rpm': '1100', 'power_b': '1.7'}, {'diameter': '80', 'rpm': '1160', 'power_b': '1.78'}, {'diameter': '80', 'rpm': '1200', 'power_b': '1.83'}, {'diameter': '80', 'rpm': '1300', 'power_b': '1.95'}, {'diameter': '80', 'rpm': '1400', 'power_b': '2.08'}, {'diameter': '80', 'rpm': '1425', 'power_b': '2.11'}, {'diameter': '80', 'rpm': '1500', 'power_b': '2.2'}, {'diameter': '80', 'rpm': '1600', 'power_b': '2.31'}, {'diameter': '80', 'rpm': '1700', 'power_b': '2.43'}, {'diameter': '80', 'rpm': '1750', 'power_b': '2.49'}, {'diameter': '80', 'rpm': '1800', 'power_b': '2.54'}, {'diameter': '80', 'rpm': '1900', 'power_b': '2.66'}, {'diameter': '80', 'rpm': '2000', 'power_b': '2.77'}, {'diameter': '80', 'rpm': '2100', 'power_b': '2.88'}, {'diameter': '80', 'rpm': '2200', 'power_b': '2.98'}, {'diameter': '80', 'rpm': '2300', 'power_b': '3.09'}, {'diameter': '80', 'rpm': '2400', 'power_b': '3.19'}, {'diameter': '80', 'rpm': '2500', 'power_b': '3.29'}, {'diameter': '80', 'rpm': '2600', 'power_b': '3.39'}, {'diameter': '80', 'rpm': '2700', 'power_b': '3.49'}, {'diameter': '80', 'rpm': '2800', 'power_b': '3.58'}, {'diameter': '80', 'rpm': '2850', 'power_b': '3.63'}, {'diameter': '80', 'rpm': '2900', 'power_b': '3.67'}, {'diameter': '80', 'rpm': '3000', 'power_b': '3.76'}, {'diameter': '80', 'rpm': '3100', 'power_b': '3.85'}, {'diameter': '80', 'rpm': '3200', 'power_b': '3.94'}, {'diameter': '80', 'rpm': '3300', 'power_b': '4.03'}, {'diameter': '80', 'rpm': '3400', 'power_b': '4.11'}, {'diameter': '80', 'rpm': '3450', 'power_b': '4.15'}, {'diameter': '80', 'rpm': '3500', 'power_b': '4.19'}, {'diameter': '80', 'rpm': '3600', 'power_b': '4.27'}, {'diameter': '80', 'rpm': '3700', 'power_b': '4.35'}, {'diameter': '80', 'rpm': '3800', 'power_b': '4.42'}, {'diameter': '80', 'rpm': '3900', 'power_b': '4.5'}, {'diameter': '80', 'rpm': '4000', 'power_b': '4.57'}, {'diameter': '80', 'rpm': '4100', 'power_b': '4.64'}, {'diameter': '80', 'rpm': '4200', 'power_b': '4.7'}, {'diameter': '80', 'rpm': '4300', 'power_b': '4.77'}, {'diameter': '80', 'rpm': '4400', 'power_b': '4.83'}, {'diameter': '80', 'rpm': '4500', 'power_b': '4.89'}, {'diameter': '80', 'rpm': '4600', 'power_b': '4.95'}, {'diameter': '80', 'rpm': '4700', 'power_b': '5.01'}, {'diameter': '80', 'rpm': '4800', 'power_b': '5.06'}, {'diameter': '80', 'rpm': '4900', 'power_b': '5.11'}, {'diameter': '80', 'rpm': '5000', 'power_b': '5.16'}, {'diameter': '90', 'rpm': '100', 'power_b': '0.26'}, {'diameter': '90', 'rpm': '200', 'power_b': '0.48'}, {'diameter': '90', 'rpm': '300', 'power_b': '0.69'}, {'diameter': '90', 'rpm': '400', 'power_b': '0.89'}, {'diameter': '90', 'rpm': '500', 'power_b': '1.09'}, {'diameter': '90', 'rpm': '575', 'power_b': '1.23'}, {'diameter': '90', 'rpm': '600', 'power_b': '1.27'}, {'diameter': '90', 'rpm': '690', 'power_b': '1.44'}, {'diameter': '90', 'rpm': '700', 'power_b': '1.46'}, {'diameter': '90', 'rpm': '725', 'power_b': '1.5'}, {'diameter': '90', 'rpm': '800', 'power_b': '1.63'}, {'diameter': '90', 'rpm': '870', 'power_b': '1.76'}, {'diameter': '90', 'rpm': '900', 'power_b': '1.81'}, {'diameter': '90', 'rpm': '950', 'power_b': '1.89'}, {'diameter': '90', 'rpm': '1000', 'power_b': '1.98'}, {'diameter': '90', 'rpm': '1100', 'power_b': '2.15'}, {'diameter': '90', 'rpm': '1160', 'power_b': '2.25'}, {'diameter': '90', 'rpm': '1200', 'power_b': '2.31'}, {'diameter': '90', 'rpm': '1300', 'power_b': '2.47'}, {'diameter': '90', 'rpm': '1400', 'power_b': '2.63'}, {'diameter': '90', 'rpm': '1425', 'power_b': '2.67'}, {'diameter': '90', 'rpm': '1500', 'power_b': '2.79'}, {'diameter': '90', 'rpm': '1600', 'power_b': '2.94'}, {'diameter': '90', 'rpm': '1700', 'power_b': '3.09'}, {'diameter': '90', 'rpm': '1750', 'power_b': '3.17'}, {'diameter': '90', 'rpm': '1800', 'power_b': '3.24'}, {'diameter': '90', 'rpm': '1900', 'power_b': '3.39'}, {'diameter': '90', 'rpm': '2000', 'power_b': '3.53'}, {'diameter': '90', 'rpm': '2100', 'power_b': '3.67'}, {'diameter': '90', 'rpm': '2200', 'power_b': '3.81'}, {'diameter': '90', 'rpm': '2300', 'power_b': '3.95'}, {'diameter': '90', 'rpm': '2400', 'power_b': '4.08'}, {'diameter': '90', 'rpm': '2500', 'power_b': '4.21'}, {'diameter': '90', 'rpm': '2600', 'power_b': '4.34'}, {'diameter': '90', 'rpm': '2700', 'power_b': '4.47'}, {'diameter': '90', 'rpm': '2800', 'power_b': '4.59'}, {'diameter': '90', 'rpm': '2850', 'power_b': '4.65'}, {'diameter': '90', 'rpm': '2900', 'power_b': '4.71'}, {'diameter': '90', 'rpm': '3000', 'power_b': '4.83'}, {'diameter': '90', 'rpm': '3100', 'power_b': '4.95'}, {'diameter': '90', 'rpm': '3200', 'power_b': '5.06'}, {'diameter': '90', 'rpm': '3300', 'power_b': '5.17'}, {'diameter': '90', 'rpm': '3400', 'power_b': '5.28'}, {'diameter': '90', 'rpm': '3450', 'power_b': '5.33'}, {'diameter': '90', 'rpm': '3500', 'power_b': '5.39'}, {'diameter': '90', 'rpm': '3600', 'power_b': '5.49'}, {'diameter': '90', 'rpm': '3700', 'power_b': '5.59'}, {'diameter': '90', 'rpm': '3800', 'power_b': '5.69'}, {'diameter': '90', 'rpm': '3900', 'power_b': '5.79'}, {'diameter': '90', 'rpm': '4000', 'power_b': '5.88'}, {'diameter': '90', 'rpm': '4100', 'power_b': '5.97'}, {'diameter': '90', 'rpm': '4200', 'power_b': '6.05'}, {'diameter': '90', 'rpm': '4300', 'power_b': '6.14'}, {'diameter': '90', 'rpm': '4400', 'power_b': '6.22'}, {'diameter': '90', 'rpm': '4500', 'power_b': '6.3'}, {'diameter': '90', 'rpm': '4600', 'power_b': '6.37'}, {'diameter': '90', 'rpm': '4700', 'power_b': '6.44'}, {'diameter': '90', 'rpm': '4800', 'power_b': '6.51'}, {'diameter': '90', 'rpm': '4900', 'power_b': '6.58'}, {'diameter': '90', 'rpm': '5000', 'power_b': '6.64'}, {'diameter': '100', 'rpm': '100', 'power_b': '0.31'}, {'diameter': '100', 'rpm': '200', 'power_b': '0.58'}, {'diameter': '100', 'rpm': '300', 'power_b': '0.83'}, {'diameter': '100', 'rpm': '400', 'power_b': '1.07'}, {'diameter': '100', 'rpm': '500', 'power_b': '1.3'}, {'diameter': '100', 'rpm': '575', 'power_b': '1.47'}, {'diameter': '100', 'rpm': '600', 'power_b': '1.53'}, {'diameter': '100', 'rpm': '690', 'power_b': '1.73'}, {'diameter': '100', 'rpm': '700', 'power_b': '1.75'}, {'diameter': '100', 'rpm': '725', 'power_b': '1.8'}, {'diameter': '100', 'rpm': '800', 'power_b': '1.97'}, {'diameter': '100', 'rpm': '870', 'power_b': '2.11'}, {'diameter': '100', 'rpm': '900', 'power_b': '2.18'}, {'diameter': '100', 'rpm': '950', 'power_b': '2.28'}, {'diameter': '100', 'rpm': '1000', 'power_b': '2.39'}, {'diameter': '100', 'rpm': '1100', 'power_b': '2.59'}, {'diameter': '100', 'rpm': '1160', 'power_b': '2.71'}, {'diameter': '100', 'rpm': '1200', 'power_b': '2.79'}, {'diameter': '100', 'rpm': '1300', 'power_b': '2.99'}, {'diameter': '100', 'rpm': '1400', 'power_b': '3.18'}, {'diameter': '100', 'rpm': '1425', 'power_b': '3.23'}, {'diameter': '100', 'rpm': '1500', 'power_b': '3.37'}, {'diameter': '100', 'rpm': '1600', 'power_b': '3.56'}, {'diameter': '100', 'rpm': '1700', 'power_b': '3.74'}, {'diameter': '100', 'rpm': '1750', 'power_b': '3.83'}, {'diameter': '100', 'rpm': '1800', 'power_b': '3.92'}, {'diameter': '100', 'rpm': '1900', 'power_b': '4.1'}, {'diameter': '100', 'rpm': '2000', 'power_b': '4.28'}, {'diameter': '100', 'rpm': '2100', 'power_b': '4.45'}, {'diameter': '100', 'rpm': '2200', 'power_b': '4.62'}, {'diameter': '100', 'rpm': '2300', 'power_b': '4.79'}, {'diameter': '100', 'rpm': '2400', 'power_b': '4.95'}, {'diameter': '100', 'rpm': '2500', 'power_b': '5.11'}, {'diameter': '100', 'rpm': '2600', 'power_b': '5.27'}, {'diameter': '100', 'rpm': '2700', 'power_b': '5.42'}, {'diameter': '100', 'rpm': '2800', 'power_b': '5.57'}, {'diameter': '100', 'rpm': '2850', 'power_b': '5.65'}, {'diameter': '100', 'rpm': '2900', 'power_b': '5.72'}, {'diameter': '100', 'rpm': '3000', 'power_b': '5.87'}, {'diameter': '100', 'rpm': '3100', 'power_b': '6.01'}, {'diameter': '100', 'rpm': '3200', 'power_b': '6.15'}, {'diameter': '100', 'rpm': '3300', 'power_b': '6.28'}, {'diameter': '100', 'rpm': '3400', 'power_b': '6.41'}, {'diameter': '100', 'rpm': '3450', 'power_b': '6.48'}, {'diameter': '100', 'rpm': '3500', 'power_b': '6.54'}, {'diameter': '100', 'rpm': '3600', 'power_b': '6.67'}, {'diameter': '100', 'rpm': '3700', 'power_b': '6.79'}, {'diameter': '100', 'rpm': '3800', 'power_b': '6.91'}, {'diameter': '100', 'rpm': '3900', 'power_b': '7.02'}, {'diameter': '100', 'rpm': '4000', 'power_b': '7.13'}, {'diameter': '100', 'rpm': '4100', 'power_b': '7.24'}, {'diameter': '100', 'rpm': '4200', 'power_b': '7.34'}, {'diameter': '100', 'rpm': '4300', 'power_b': '7.44'}, {'diameter': '100', 'rpm': '4400', 'power_b': '7.53'}, {'diameter': '100', 'rpm': '4500', 'power_b': '7.63'}, {'diameter': '100', 'rpm': '4600', 'power_b': '7.71'}, {'diameter': '100', 'rpm': '4700', 'power_b': '7.8'}, {'diameter': '100', 'rpm': '4800', 'power_b': '7.88'}, {'diameter': '100', 'rpm': '4900', 'power_b': '7.95'}, {'diameter': '100', 'rpm': '5000', 'power_b': '8.02'}, {'diameter': '110', 'rpm': '100', 'power_b': '0.36'}, {'diameter': '110', 'rpm': '200', 'power_b': '0.67'}, {'diameter': '110', 'rpm': '300', 'power_b': '0.96'}, {'diameter': '110', 'rpm': '400', 'power_b': '1.24'}, {'diameter': '110', 'rpm': '500', 'power_b': '1.52'}, {'diameter': '110', 'rpm': '575', 'power_b': '1.71'}, {'diameter': '110', 'rpm': '600', 'power_b': '1.78'}, {'diameter': '110', 'rpm': '690', 'power_b': '2.01'}, {'diameter': '110', 'rpm': '700', 'power_b': '2.04'}, {'diameter': '110', 'rpm': '725', 'power_b': '2.1'}, {'diameter': '110', 'rpm': '800', 'power_b': '2.29'}, {'diameter': '110', 'rpm': '870', 'power_b': '2.47'}, {'diameter': '110', 'rpm': '900', 'power_b': '2.54'}, {'diameter': '110', 'rpm': '950', 'power_b': '2.67'}, {'diameter': '110', 'rpm': '1000', 'power_b': '2.79'}, {'diameter': '110', 'rpm': '1100', 'power_b': '3.03'}, {'diameter': '110', 'rpm': '1160', 'power_b': '3.17'}, {'diameter': '110', 'rpm': '1200', 'power_b': '3.26'}, {'diameter': '110', 'rpm': '1300', 'power_b': '3.5'}, {'diameter': '110', 'rpm': '1400', 'power_b': '3.72'}, {'diameter': '110', 'rpm': '1425', 'power_b': '3.78'}, {'diameter': '110', 'rpm': '1500', 'power_b': '3.95'}, {'diameter': '110', 'rpm': '1600', 'power_b': '4.17'}, {'diameter': '110', 'rpm': '1700', 'power_b': '4.39'}, {'diameter': '110', 'rpm': '1750', 'power_b': '4.49'}, {'diameter': '110', 'rpm': '1800', 'power_b': '4.6'}, {'diameter': '110', 'rpm': '1900', 'power_b': '4.81'}, {'diameter': '110', 'rpm': '2000', 'power_b': '5.02'}, {'diameter': '110', 'rpm': '2100', 'power_b': '5.22'}, {'diameter': '110', 'rpm': '2200', 'power_b': '5.42'}, {'diameter': '110', 'rpm': '2300', 'power_b': '5.61'}, {'diameter': '110', 'rpm': '2400', 'power_b': '5.8'}, {'diameter': '110', 'rpm': '2500', 'power_b': '5.99'}, {'diameter': '110', 'rpm': '2600', 'power_b': '6.18'}, {'diameter': '110', 'rpm': '2700', 'power_b': '6.36'}, {'diameter': '110', 'rpm': '2800', 'power_b': '6.53'}, {'diameter': '110', 'rpm': '2850', 'power_b': '6.62'}, {'diameter': '110', 'rpm': '2900', 'power_b': '6.7'}, {'diameter': '110', 'rpm': '3000', 'power_b': '6.87'}, {'diameter': '110', 'rpm': '3100', 'power_b': '7.04'}, {'diameter': '110', 'rpm': '3200', 'power_b': '7.2'}, {'diameter': '110', 'rpm': '3300', 'power_b': '7.35'}, {'diameter': '110', 'rpm': '3400', 'power_b': '7.5'}, {'diameter': '110', 'rpm': '3450', 'power_b': '7.58'}, {'diameter': '110', 'rpm': '3500', 'power_b': '7.65'}, {'diameter': '110', 'rpm': '3600', 'power_b': '7.79'}, {'diameter': '110', 'rpm': '3700', 'power_b': '7.93'}, {'diameter': '110', 'rpm': '3800', 'power_b': '8.07'}, {'diameter': '110', 'rpm': '3900', 'power_b': '8.2'}, {'diameter': '110', 'rpm': '4000', 'power_b': '8.32'}, {'diameter': '110', 'rpm': '4100', 'power_b': '8.44'}, {'diameter': '110', 'rpm': '4200', 'power_b': '8.56'}, {'diameter': '110', 'rpm': '4300', 'power_b': '8.67'}, {'diameter': '110', 'rpm': '4400', 'power_b': '8.77'}, {'diameter': '110', 'rpm': '4500', 'power_b': '8.87'}, {'diameter': '110', 'rpm': '4600', 'power_b': '8.96'}, {'diameter': '110', 'rpm': '4700', 'power_b': '9.05'}, {'diameter': '110', 'rpm': '4800', 'power_b': '9.14'}, {'diameter': '110', 'rpm': '4900', 'power_b': '9.22'}, {'diameter': '110', 'rpm': '5000', 'power_b': '9.29'}, {'diameter': '120', 'rpm': '100', 'power_b': '0.4'}, {'diameter': '120', 'rpm': '200', 'power_b': '0.76'}, {'diameter': '120', 'rpm': '300', 'power_b': '1.09'}, {'diameter': '120', 'rpm': '400', 'power_b': '1.41'}, {'diameter': '120', 'rpm': '500', 'power_b': '1.73'}, {'diameter': '120', 'rpm': '575', 'power_b': '1.96'}, {'diameter': '120', 'rpm': '600', 'power_b': '2.03'}, {'diameter': '120', 'rpm': '690', 'power_b': '2.3'}, {'diameter': '120', 'rpm': '700', 'power_b': '2.33'}, {'diameter': '120', 'rpm': '725', 'power_b': '2.4'}, {'diameter': '120', 'rpm': '800', 'power_b': '2.62'}, {'diameter': '120', 'rpm': '870', 'power_b': '2.82'}, {'diameter': '120', 'rpm': '900', 'power_b': '2.91'}, {'diameter': '120', 'rpm': '950', 'power_b': '3.05'}, {'diameter': '120', 'rpm': '1000', 'power_b': '3.19'}, {'diameter': '120', 'rpm': '1100', 'power_b': '3.46'}, {'diameter': '120', 'rpm': '1160', 'power_b': '3.62'}, {'diameter': '120', 'rpm': '1200', 'power_b': '3.73'}, {'diameter': '120', 'rpm': '1300', 'power_b': '4'}, {'diameter': '120', 'rpm': '1400', 'power_b': '4.26'}, {'diameter': '120', 'rpm': '1425', 'power_b': '4.33'}, {'diameter': '120', 'rpm': '1500', 'power_b': '4.52'}, {'diameter': '120', 'rpm': '1600', 'power_b': '4.77'}, {'diameter': '120', 'rpm': '1700', 'power_b': '5.02'}, {'diameter': '120', 'rpm': '1750', 'power_b': '5.14'}, {'diameter': '120', 'rpm': '1800', 'power_b': '5.26'}, {'diameter': '120', 'rpm': '1900', 'power_b': '5.5'}, {'diameter': '120', 'rpm': '2000', 'power_b': '5.74'}, {'diameter': '120', 'rpm': '2100', 'power_b': '5.97'}, {'diameter': '120', 'rpm': '2200', 'power_b': '6.2'}, {'diameter': '120', 'rpm': '2300', 'power_b': '6.42'}, {'diameter': '120', 'rpm': '2400', 'power_b': '6.64'}, {'diameter': '120', 'rpm': '2500', 'power_b': '6.85'}, {'diameter': '120', 'rpm': '2600', 'power_b': '7.06'}, {'diameter': '120', 'rpm': '2700', 'power_b': '7.27'}, {'diameter': '120', 'rpm': '2800', 'power_b': '7.46'}, {'diameter': '120', 'rpm': '2850', 'power_b': '7.56'}, {'diameter': '120', 'rpm': '2900', 'power_b': '7.66'}, {'diameter': '120', 'rpm': '3000', 'power_b': '7.85'}, {'diameter': '120', 'rpm': '3100', 'power_b': '8.03'}, {'diameter': '120', 'rpm': '3200', 'power_b': '8.21'}, {'diameter': '120', 'rpm': '3300', 'power_b': '8.39'}, {'diameter': '120', 'rpm': '3400', 'power_b': '8.55'}, {'diameter': '120', 'rpm': '3450', 'power_b': '8.64'}, {'diameter': '120', 'rpm': '3500', 'power_b': '8.72'}, {'diameter': '120', 'rpm': '3600', 'power_b': '8.87'}, {'diameter': '120', 'rpm': '3700', 'power_b': '9.03'}, {'diameter': '120', 'rpm': '3800', 'power_b': '9.17'}, {'diameter': '120', 'rpm': '3900', 'power_b': '9.31'}, {'diameter': '120', 'rpm': '4000', 'power_b': '9.45'}, {'diameter': '120', 'rpm': '4100', 'power_b': '9.58'}, {'diameter': '120', 'rpm': '4200', 'power_b': '9.7'}, {'diameter': '120', 'rpm': '4300', 'power_b': '9.81'}, {'diameter': '120', 'rpm': '4400', 'power_b': '9.92'}, {'diameter': '120', 'rpm': '4500', 'power_b': '10'}, {'diameter': '120', 'rpm': '4600', 'power_b': '10.1'}, {'diameter': '120', 'rpm': '4700', 'power_b': '10.2'}, {'diameter': '120', 'rpm': '4800', 'power_b': '10.3'}, {'diameter': '120', 'rpm': '4900', 'power_b': '10.4'}, {'diameter': '120', 'rpm': '5000', 'power_b': '10.4'}, {'diameter': '130', 'rpm': '100', 'power_b': '0.45'}, {'diameter': '130', 'rpm': '200', 'power_b': '0.85'}, {'diameter': '130', 'rpm': '300', 'power_b': '1.22'}, {'diameter': '130', 'rpm': '400', 'power_b': '1.59'}, {'diameter': '130', 'rpm': '500', 'power_b': '1.94'}, {'diameter': '130', 'rpm': '575', 'power_b': '2.19'}, {'diameter': '130', 'rpm': '600', 'power_b': '2.28'}, {'diameter': '130', 'rpm': '690', 'power_b': '2.58'}, {'diameter': '130', 'rpm': '700', 'power_b': '2.61'}, {'diameter': '130', 'rpm': '725', 'power_b': '2.7'}, {'diameter': '130', 'rpm': '800', 'power_b': '2.94'}, {'diameter': '130', 'rpm': '870', 'power_b': '3.17'}, {'diameter': '130', 'rpm': '900', 'power_b': '3.26'}, {'diameter': '130', 'rpm': '950', 'power_b': '3.42'}, {'diameter': '130', 'rpm': '1000', 'power_b': '3.58'}, {'diameter': '130', 'rpm': '1100', 'power_b': '3.89'}, {'diameter': '130', 'rpm': '1160', 'power_b': '4.08'}, {'diameter': '130', 'rpm': '1200', 'power_b': '4.2'}, {'diameter': '130', 'rpm': '1300', 'power_b': '4.5'}, {'diameter': '130', 'rpm': '1400', 'power_b': '4.79'}, {'diameter': '130', 'rpm': '1425', 'power_b': '4.86'}, {'diameter': '130', 'rpm': '1500', 'power_b': '5.08'}, {'diameter': '130', 'rpm': '1600', 'power_b': '5.37'}, {'diameter': '130', 'rpm': '1700', 'power_b': '5.56'}, {'diameter': '130', 'rpm': '1750', 'power_b': '5.78'}, {'diameter': '130', 'rpm': '1800', 'power_b': '5.92'}, {'diameter': '130', 'rpm': '1900', 'power_b': '6.19'}, {'diameter': '130', 'rpm': '2000', 'power_b': '6.45'}, {'diameter': '130', 'rpm': '2100', 'power_b': '6.71'}, {'diameter': '130', 'rpm': '2200', 'power_b': '6.97'}, {'diameter': '130', 'rpm': '2300', 'power_b': '7.21'}, {'diameter': '130', 'rpm': '2400', 'power_b': '7.46'}, {'diameter': '130', 'rpm': '2500', 'power_b': '7.69'}, {'diameter': '130', 'rpm': '2600', 'power_b': '7.92'}, {'diameter': '130', 'rpm': '2700', 'power_b': '8.15'}, {'diameter': '130', 'rpm': '2800', 'power_b': '8.37'}, {'diameter': '130', 'rpm': '2850', 'power_b': '8.48'}, {'diameter': '130', 'rpm': '2900', 'power_b': '8.58'}, {'diameter': '130', 'rpm': '3000', 'power_b': '8.79'}, {'diameter': '130', 'rpm': '3100', 'power_b': '8.99'}, {'diameter': '130', 'rpm': '3200', 'power_b': '9.19'}, {'diameter': '130', 'rpm': '3300', 'power_b': '9.38'}, {'diameter': '130', 'rpm': '3400', 'power_b': '9.56'}, {'diameter': '130', 'rpm': '3450', 'power_b': '9.65'}, {'diameter': '130', 'rpm': '3500', 'power_b': '9.73'}, {'diameter': '130', 'rpm': '3600', 'power_b': '9.9'}, {'diameter': '130', 'rpm': '3700', 'power_b': '10.1'}, {'diameter': '130', 'rpm': '3800', 'power_b': '10.2'}, {'diameter': '130', 'rpm': '3900', 'power_b': '10.4'}, {'diameter': '130', 'rpm': '4000', 'power_b': '10.5'}, {'diameter': '130', 'rpm': '4100', 'power_b': '10.6'}, {'diameter': '130', 'rpm': '4200', 'power_b': '10.8'}, {'diameter': '130', 'rpm': '4300', 'power_b': '10.9'}, {'diameter': '130', 'rpm': '4400', 'power_b': '11'}, {'diameter': '130', 'rpm': '4500', 'power_b': '11.1'}, {'diameter': '130', 'rpm': '4600', 'power_b': '11.2'}, {'diameter': '130', 'rpm': '4700', 'power_b': '11.3'}, {'diameter': '130', 'rpm': '4800', 'power_b': '11.3'}, {'diameter': '130', 'rpm': '4900', 'power_b': '11.4'}, {'diameter': '130', 'rpm': '5000', 'power_b': '11.5'}, {'diameter': '140', 'rpm': '100', 'power_b': '0.5'}, {'diameter': '140', 'rpm': '200', 'power_b': '0.94'}, {'diameter': '140', 'rpm': '300', 'power_b': '1.35'}, {'diameter': '140', 'rpm': '400', 'power_b': '1.76'}, {'diameter': '140', 'rpm': '500', 'power_b': '2.15'}, {'diameter': '140', 'rpm': '575', 'power_b': '2.43'}, {'diameter': '140', 'rpm': '600', 'power_b': '2.53'}, {'diameter': '140', 'rpm': '690', 'power_b': '2.86'}, {'diameter': '140', 'rpm': '700', 'power_b': '2.9'}, {'diameter': '140', 'rpm': '725', 'power_b': '2.99'}, {'diameter': '140', 'rpm': '800', 'power_b': '3.26'}, {'diameter': '140', 'rpm': '870', 'power_b': '3.51'}, {'diameter': '140', 'rpm': '900', 'power_b': '3.62'}, {'diameter': '140', 'rpm': '950', 'power_b': '3.8'}, {'diameter': '140', 'rpm': '1000', 'power_b': '3.97'}, {'diameter': '140', 'rpm': '1100', 'power_b': '4.32'}, {'diameter': '140', 'rpm': '1160', 'power_b': '4.52'}, {'diameter': '140', 'rpm': '1200', 'power_b': '4.66'}, {'diameter': '140', 'rpm': '1300', 'power_b': '4.99'}, {'diameter': '140', 'rpm': '1400', 'power_b': '5.32'}, {'diameter': '140', 'rpm': '1425', 'power_b': '5.4'}, {'diameter': '140', 'rpm': '1500', 'power_b': '5.64'}, {'diameter': '140', 'rpm': '1600', 'power_b': '5.95'}, {'diameter': '140', 'rpm': '1700', 'power_b': '6.26'}, {'diameter': '140', 'rpm': '1750', 'power_b': '6.41'}, {'diameter': '140', 'rpm': '1800', 'power_b': '6.56'}, {'diameter': '140', 'rpm': '1900', 'power_b': '6.86'}, {'diameter': '140', 'rpm': '2000', 'power_b': '7.15'}, {'diameter': '140', 'rpm': '2100', 'power_b': '7.44'}, {'diameter': '140', 'rpm': '2200', 'power_b': '7.72'}, {'diameter': '140', 'rpm': '2300', 'power_b': '7.99'}, {'diameter': '140', 'rpm': '2400', 'power_b': '8.25'}, {'diameter': '140', 'rpm': '2500', 'power_b': '8.51'}, {'diameter': '140', 'rpm': '2600', 'power_b': '8.76'}, {'diameter': '140', 'rpm': '2700', 'power_b': '9.01'}, {'diameter': '140', 'rpm': '2800', 'power_b': '9.25'}, {'diameter': '140', 'rpm': '2850', 'power_b': '9.36'}, {'diameter': '140', 'rpm': '2900', 'power_b': '9.48'}, {'diameter': '140', 'rpm': '3000', 'power_b': '9.7'}, {'diameter': '140', 'rpm': '3100', 'power_b': '9.92'}, {'diameter': '140', 'rpm': '3200', 'power_b': '10.1'}, {'diameter': '140', 'rpm': '3300', 'power_b': '10.3'}, {'diameter': '140', 'rpm': '3400', 'power_b': '10.5'}, {'diameter': '140', 'rpm': '3450', 'power_b': '10.6'}, {'diameter': '140', 'rpm': '3500', 'power_b': '10.7'}, {'diameter': '140', 'rpm': '3600', 'power_b': '10.9'}, {'diameter': '140', 'rpm': '3700', 'power_b': '11'}, {'diameter': '140', 'rpm': '3800', 'power_b': '11.2'}, {'diameter': '140', 'rpm': '3900', 'power_b': '11.3'}, {'diameter': '140', 'rpm': '4000', 'power_b': '11.5'}, {'diameter': '140', 'rpm': '4100', 'power_b': '11.6'}, {'diameter': '140', 'rpm': '4200', 'power_b': '11.7'}, {'diameter': '140', 'rpm': '4300', 'power_b': '11.9'}, {'diameter': '140', 'rpm': '4400', 'power_b': '12'}, {'diameter': '140', 'rpm': '4500', 'power_b': '12'}, {'diameter': '140', 'rpm': '4600', 'power_b': '12.1'}, {'diameter': '140', 'rpm': '4700', 'power_b': '12.2'}, {'diameter': '150', 'rpm': '100', 'power_b': '0.54'}, {'diameter': '150', 'rpm': '200', 'power_b': '1.03'}, {'diameter': '150', 'rpm': '300', 'power_b': '1.48'}, {'diameter': '150', 'rpm': '400', 'power_b': '1.93'}, {'diameter': '150', 'rpm': '500', 'power_b': '2.35'}, {'diameter': '150', 'rpm': '575', 'power_b': '2.67'}, {'diameter': '150', 'rpm': '600', 'power_b': '2.77'}, {'diameter': '150', 'rpm': '690', 'power_b': '3.14'}, {'diameter': '150', 'rpm': '700', 'power_b': '3.18'}, {'diameter': '150', 'rpm': '725', 'power_b': '3.28'}, {'diameter': '150', 'rpm': '800', 'power_b': '3.58'}, {'diameter': '150', 'rpm': '870', 'power_b': '3.86'}, {'diameter': '150', 'rpm': '900', 'power_b': '3.98'}, {'diameter': '150', 'rpm': '950', 'power_b': '4.17'}, {'diameter': '150', 'rpm': '1000', 'power_b': '4.36'}, {'diameter': '150', 'rpm': '1100', 'power_b': '4.74'}, {'diameter': '150', 'rpm': '1160', 'power_b': '4.96'}, {'diameter': '150', 'rpm': '1200', 'power_b': '5.11'}, {'diameter': '150', 'rpm': '1300', 'power_b': '5.48'}, {'diameter': '150', 'rpm': '1400', 'power_b': '5.83'}, {'diameter': '150', 'rpm': '1425', 'power_b': '5.92'}, {'diameter': '150', 'rpm': '1500', 'power_b': '6.19'}, {'diameter': '150', 'rpm': '1600', 'power_b': '6.53'}, {'diameter': '150', 'rpm': '1700', 'power_b': '6.87'}, {'diameter': '150', 'rpm': '1750', 'power_b': '7.03'}, {'diameter': '150', 'rpm': '1800', 'power_b': '7.2'}, {'diameter': '150', 'rpm': '1900', 'power_b': '7.52'}, {'diameter': '150', 'rpm': '2000', 'power_b': '7.84'}, {'diameter': '150', 'rpm': '2100', 'power_b': '8.15'}, {'diameter': '150', 'rpm': '2200', 'power_b': '8.45'}, {'diameter': '150', 'rpm': '2300', 'power_b': '8.74'}, {'diameter': '150', 'rpm': '2400', 'power_b': '9.03'}, {'diameter': '150', 'rpm': '2500', 'power_b': '9.31'}, {'diameter': '150', 'rpm': '2600', 'power_b': '9.58'}, {'diameter': '150', 'rpm': '2700', 'power_b': '9.84'}, {'diameter': '150', 'rpm': '2800', 'power_b': '10.1'}, {'diameter': '150', 'rpm': '2850', 'power_b': '10.2'}, {'diameter': '150', 'rpm': '2900', 'power_b': '10.3'}, {'diameter': '150', 'rpm': '3000', 'power_b': '10.6'}, {'diameter': '150', 'rpm': '3100', 'power_b': '10.8'}, {'diameter': '150', 'rpm': '3200', 'power_b': '11'}, {'diameter': '150', 'rpm': '3300', 'power_b': '11.2'}, {'diameter': '150', 'rpm': '3400', 'power_b': '11.4'}, {'diameter': '150', 'rpm': '3450', 'power_b': '11.5'}, {'diameter': '150', 'rpm': '3500', 'power_b': '11.6'}, {'diameter': '150', 'rpm': '3600', 'power_b': '11.8'}, {'diameter': '150', 'rpm': '3700', 'power_b': '12'}, {'diameter': '150', 'rpm': '3800', 'power_b': '12.1'}, {'diameter': '150', 'rpm': '3900', 'power_b': '12.3'}, {'diameter': '150', 'rpm': '4000', 'power_b': '12.4'}, {'diameter': '150', 'rpm': '4100', 'power_b': '12.5'}, {'diameter': '150', 'rpm': '4200', 'power_b': '12.6'}, {'diameter': '150', 'rpm': '4300', 'power_b': '12.7'}, {'diameter': '150', 'rpm': '4400', 'power_b': '12.8'}, {'diameter': '160', 'rpm': '100', 'power_b': '0.59'}, {'diameter': '160', 'rpm': '200', 'power_b': '1.12'}, {'diameter': '160', 'rpm': '300', 'power_b': '1.61'}, {'diameter': '160', 'rpm': '400', 'power_b': '2.09'}, {'diameter': '160', 'rpm': '500', 'power_b': '2.56'}, {'diameter': '160', 'rpm': '575', 'power_b': '2.9'}, {'diameter': '160', 'rpm': '600', 'power_b': '3.02'}, {'diameter': '160', 'rpm': '690', 'power_b': '3.42'}, {'diameter': '160', 'rpm': '700', 'power_b': '3.46'}, {'diameter': '160', 'rpm': '725', 'power_b': '3.57'}, {'diameter': '160', 'rpm': '800', 'power_b': '3.9'}, {'diameter': '160', 'rpm': '870', 'power_b': '4.2'}, {'diameter': '160', 'rpm': '900', 'power_b': '4.33'}, {'diameter': '160', 'rpm': '950', 'power_b': '4.54'}, {'diameter': '160', 'rpm': '1000', 'power_b': '4.75'}, {'diameter': '160', 'rpm': '1100', 'power_b': '5.16'}, {'diameter': '160', 'rpm': '1160', 'power_b': '5.4'}, {'diameter': '160', 'rpm': '1200', 'power_b': '5.56'}, {'diameter': '160', 'rpm': '1300', 'power_b': '5.96'}, {'diameter': '160', 'rpm': '1400', 'power_b': '6.35'}, {'diameter': '160', 'rpm': '1425', 'power_b': '6.44'}, {'diameter': '160', 'rpm': '1500', 'power_b': '6.73'}, {'diameter': '160', 'rpm': '1600', 'power_b': '7.1'}, {'diameter': '160', 'rpm': '1700', 'power_b': '4.47'}, {'diameter': '160', 'rpm': '1750', 'power_b': '7.65'}, {'diameter': '160', 'rpm': '1800', 'power_b': '7.82'}, {'diameter': '160', 'rpm': '1900', 'power_b': '8.17'}, {'diameter': '160', 'rpm': '2000', 'power_b': '8.51'}, {'diameter': '160', 'rpm': '2100', 'power_b': '8.84'}, {'diameter': '160', 'rpm': '2200', 'power_b': '9.17'}, {'diameter': '160', 'rpm': '2300', 'power_b': '9.48'}, {'diameter': '160', 'rpm': '2400', 'power_b': '9.79'}, {'diameter': '160', 'rpm': '2500', 'power_b': '10.1'}, {'diameter': '160', 'rpm': '2600', 'power_b': '10.4'}, {'diameter': '160', 'rpm': '2700', 'power_b': '10.6'}, {'diameter': '160', 'rpm': '2800', 'power_b': '10.9'}, {'diameter': '160', 'rpm': '2850', 'power_b': '11'}, {'diameter': '160', 'rpm': '2900', 'power_b': '11.2'}, {'diameter': '160', 'rpm': '3000', 'power_b': '11.4'}, {'diameter': '160', 'rpm': '3100', 'power_b': '11.6'}, {'diameter': '160', 'rpm': '3200', 'power_b': '11.9'}, {'diameter': '160', 'rpm': '3300', 'power_b': '12.1'}, {'diameter': '160', 'rpm': '3400', 'power_b': '12.3'}, {'diameter': '160', 'rpm': '3450', 'power_b': '12.4'}, {'diameter': '160', 'rpm': '3500', 'power_b': '12.5'}, {'diameter': '160', 'rpm': '3600', 'power_b': '12.6'}, {'diameter': '160', 'rpm': '3700', 'power_b': '12.8'}, {'diameter': '160', 'rpm': '3800', 'power_b': '13'}, {'diameter': '160', 'rpm': '3900', 'power_b': '13.1'}, {'diameter': '160', 'rpm': '4000', 'power_b': '13.2'}, {'diameter': '160', 'rpm': '4100', 'power_b': '13.3'}, {'diameter': '170', 'rpm': '100', 'power_b': '0.64'}, {'diameter': '170', 'rpm': '200', 'power_b': '1.2'}, {'diameter': '170', 'rpm': '300', 'power_b': '1.74'}, {'diameter': '170', 'rpm': '400', 'power_b': '2.26'}, {'diameter': '170', 'rpm': '500', 'power_b': '2.77'}, {'diameter': '170', 'rpm': '575', 'power_b': '3.14'}, {'diameter': '170', 'rpm': '600', 'power_b': '3.26'}, {'diameter': '170', 'rpm': '690', 'power_b': '3.69'}, {'diameter': '170', 'rpm': '700', 'power_b': '3.74'}, {'diameter': '170', 'rpm': '725', 'power_b': '3.86'}, {'diameter': '170', 'rpm': '800', 'power_b': '4.21'}, {'diameter': '170', 'rpm': '870', 'power_b': '4.54'}, {'diameter': '170', 'rpm': '900', 'power_b': '4.67'}, {'diameter': '170', 'rpm': '950', 'power_b': '4.9'}, {'diameter': '170', 'rpm': '1000', 'power_b': '5.13'}, {'diameter': '170', 'rpm': '1100', 'power_b': '5.57'}, {'diameter': '170', 'rpm': '1160', 'power_b': '5.84'}, {'diameter': '170', 'rpm': '1200', 'power_b': '6.01'}, {'diameter': '170', 'rpm': '1300', 'power_b': '6.44'}, {'diameter': '170', 'rpm': '1400', 'power_b': '6.85'}, {'diameter': '170', 'rpm': '1425', 'power_b': '6.96'}, {'diameter': '170', 'rpm': '1500', 'power_b': '7.26'}, {'diameter': '170', 'rpm': '1600', 'power_b': '7.66'}, {'diameter': '170', 'rpm': '1700', 'power_b': '8.06'}, {'diameter': '170', 'rpm': '1750', 'power_b': '8.25'}, {'diameter': '170', 'rpm': '1800', 'power_b': '8.44'}, {'diameter': '170', 'rpm': '1900', 'power_b': '8.81'}, {'diameter': '170', 'rpm': '2000', 'power_b': '9.17'}, {'diameter': '170', 'rpm': '2100', 'power_b': '9.53'}, {'diameter': '170', 'rpm': '2200', 'power_b': '9.87'}, {'diameter': '170', 'rpm': '2300', 'power_b': '10.2'}, {'diameter': '170', 'rpm': '2400', 'power_b': '10.5'}, {'diameter': '170', 'rpm': '2500', 'power_b': '10.8'}, {'diameter': '170', 'rpm': '2600', 'power_b': '11.1'}, {'diameter': '170', 'rpm': '2700', 'power_b': '11.4'}, {'diameter': '170', 'rpm': '2800', 'power_b': '11.7'}, {'diameter': '170', 'rpm': '2850', 'power_b': '11.8'}, {'diameter': '170', 'rpm': '2900', 'power_b': '12'}, {'diameter': '170', 'rpm': '3000', 'power_b': '12.2'}, {'diameter': '170', 'rpm': '3100', 'power_b': '12.4'}, {'diameter': '170', 'rpm': '3200', 'power_b': '12.7'}, {'diameter': '170', 'rpm': '3300', 'power_b': '12.9'}, {'diameter': '170', 'rpm': '3400', 'power_b': '13.1'}, {'diameter': '170', 'rpm': '3450', 'power_b': '13.2'}, {'diameter': '170', 'rpm': '3500', 'power_b': '13.3'}, {'diameter': '170', 'rpm': '3600', 'power_b': '13.4'}, {'diameter': '170', 'rpm': '3700', 'power_b': '13.6'}, {'diameter': '170', 'rpm': '3800', 'power_b': '13.7'}, {'diameter': '170', 'rpm': '3900', 'power_b': '13.9'}, {'diameter': '180', 'rpm': '100', 'power_b': '0.68'}, {'diameter': '180', 'rpm': '200', 'power_b': '1.29'}, {'diameter': '180', 'rpm': '300', 'power_b': '1.87'}, {'diameter': '180', 'rpm': '400', 'power_b': '2.43'}, {'diameter': '180', 'rpm': '500', 'power_b': '2.97'}, {'diameter': '180', 'rpm': '575', 'power_b': '3.37'}, {'diameter': '180', 'rpm': '600', 'power_b': '3.5'}, {'diameter': '180', 'rpm': '690', 'power_b': '3.97'}, {'diameter': '180', 'rpm': '700', 'power_b': '4.02'}, {'diameter': '180', 'rpm': '725', 'power_b': '4.15'}, {'diameter': '180', 'rpm': '800', 'power_b': '4.52'}, {'diameter': '180', 'rpm': '870', 'power_b': '4.87'}, {'diameter': '180', 'rpm': '900', 'power_b': '5.02'}, {'diameter': '180', 'rpm': '950', 'power_b': '5.27'}, {'diameter': '180', 'rpm': '1000', 'power_b': '5.51'}, {'diameter': '180', 'rpm': '1100', 'power_b': '5.98'}, {'diameter': '180', 'rpm': '1160', 'power_b': '6.27'}, {'diameter': '180', 'rpm': '1200', 'power_b': '6.45'}, {'diameter': '180', 'rpm': '1300', 'power_b': '6.91'}, {'diameter': '180', 'rpm': '1400', 'power_b': '7.35'}, {'diameter': '180', 'rpm': '1425', 'power_b': '7.46'}, {'diameter': '180', 'rpm': '1500', 'power_b': '7.79'}, {'diameter': '180', 'rpm': '1600', 'power_b': '8.22'}, {'diameter': '180', 'rpm': '1700', 'power_b': '8.63'}, {'diameter': '180', 'rpm': '1750', 'power_b': '8.84'}, {'diameter': '180', 'rpm': '1800', 'power_b': '9.04'}, {'diameter': '180', 'rpm': '1900', 'power_b': '9.44'}, {'diameter': '180', 'rpm': '2000', 'power_b': '9.82'}, {'diameter': '180', 'rpm': '2100', 'power_b': '10.2'}, {'diameter': '180', 'rpm': '2200', 'power_b': '10.6'}, {'diameter': '180', 'rpm': '2300', 'power_b': '10.9'}, {'diameter': '180', 'rpm': '2400', 'power_b': '11.2'}, {'diameter': '180', 'rpm': '2500', 'power_b': '11.6'}, {'diameter': '180', 'rpm': '2600', 'power_b': '11.9'}, {'diameter': '180', 'rpm': '2700', 'power_b': '12.2'}, {'diameter': '180', 'rpm': '2800', 'power_b': '12.4'}, {'diameter': '180', 'rpm': '2850', 'power_b': '12.6'}, {'diameter': '180', 'rpm': '2900', 'power_b': '12.7'}, {'diameter': '180', 'rpm': '3000', 'power_b': '13'}, {'diameter': '180', 'rpm': '3100', 'power_b': '13.2'}, {'diameter': '180', 'rpm': '3200', 'power_b': '13.4'}, {'diameter': '180', 'rpm': '3300', 'power_b': '13.6'}, {'diameter': '180', 'rpm': '3400', 'power_b': '13.8'}, {'diameter': '180', 'rpm': '3450', 'power_b': '13.9'}, {'diameter': '180', 'rpm': '3500', 'power_b': '14'}, {'diameter': '180', 'rpm': '3600', 'power_b': '14.2'}, {'diameter': '180', 'rpm': '3700', 'power_b': '14.3'}, {'diameter': '190', 'rpm': '100', 'power_b': '0.73'}, {'diameter': '190', 'rpm': '200', 'power_b': '1.38'}, {'diameter': '190', 'rpm': '300', 'power_b': '2'}, {'diameter': '190', 'rpm': '400', 'power_b': '2.59'}, {'diameter': '190', 'rpm': '500', 'power_b': '3.17'}, {'diameter': '190', 'rpm': '575', 'power_b': '3.6'}, {'diameter': '190', 'rpm': '600', 'power_b': '3.74'}, {'diameter': '190', 'rpm': '690', 'power_b': '4.24'}, {'diameter': '190', 'rpm': '700', 'power_b': '4.29'}, {'diameter': '190', 'rpm': '725', 'power_b': '4.43'}, {'diameter': '190', 'rpm': '800', 'power_b': '4.83'}, {'diameter': '190', 'rpm': '870', 'power_b': '5.21'}, {'diameter': '190', 'rpm': '900', 'power_b': '5.36'}, {'diameter': '190', 'rpm': '950', 'power_b': '5.63'}, {'diameter': '190', 'rpm': '1000', 'power_b': '5.88'}, {'diameter': '190', 'rpm': '1100', 'power_b': '6.39'}, {'diameter': '190', 'rpm': '1160', 'power_b': '6.69'}, {'diameter': '190', 'rpm': '1200', 'power_b': '6.89'}, {'diameter': '190', 'rpm': '1300', 'power_b': '7.37'}, {'diameter': '190', 'rpm': '1400', 'power_b': '7.85'}, {'diameter': '190', 'rpm': '1425', 'power_b': '7.97'}, {'diameter': '190', 'rpm': '1500', 'power_b': '8.31'}, {'diameter': '190', 'rpm': '1600', 'power_b': '8.76'}, {'diameter': '190', 'rpm': '1700', 'power_b': '9.2'}, {'diameter': '190', 'rpm': '1750', 'power_b': '9.42'}, {'diameter': '190', 'rpm': '1800', 'power_b': '9.63'}, {'diameter': '190', 'rpm': '1900', 'power_b': '10'}, {'diameter': '190', 'rpm': '2000', 'power_b': '10.5'}, {'diameter': '190', 'rpm': '2100', 'power_b': '10.8'}, {'diameter': '190', 'rpm': '2200', 'power_b': '11.2'}, {'diameter': '190', 'rpm': '2300', 'power_b': '11.6'}, {'diameter': '190', 'rpm': '2400', 'power_b': '11.9'}, {'diameter': '190', 'rpm': '2500', 'power_b': '12.3'}, {'diameter': '190', 'rpm': '2600', 'power_b': '12.6'}, {'diameter': '190', 'rpm': '2700', 'power_b': '12.9'}, {'diameter': '190', 'rpm': '2800', 'power_b': '13.2'}, {'diameter': '190', 'rpm': '2850', 'power_b': '13.3'}, {'diameter': '190', 'rpm': '2900', 'power_b': '13.4'}, {'diameter': '190', 'rpm': '3000', 'power_b': '13.7'}, {'diameter': '190', 'rpm': '3100', 'power_b': '13.9'}, {'diameter': '190', 'rpm': '3200', 'power_b': '14.1'}, {'diameter': '190', 'rpm': '3300', 'power_b': '14.3'}, {'diameter': '190', 'rpm': '3400', 'power_b': '14.5'}, {'diameter': '190', 'rpm': '3450', 'power_b': '14.6'}, {'diameter': '190', 'rpm': '3500', 'power_b': '14.7'}, {'diameter': '200', 'rpm': '100', 'power_b': '0.78'}, {'diameter': '200', 'rpm': '200', 'power_b': '1.47'}, {'diameter': '200', 'rpm': '300', 'power_b': '2.12'}, {'diameter': '200', 'rpm': '400', 'power_b': '2.76'}, {'diameter': '200', 'rpm': '500', 'power_b': '3.38'}, {'diameter': '200', 'rpm': '575', 'power_b': '3.83'}, {'diameter': '200', 'rpm': '600', 'power_b': '3.98'}, {'diameter': '200', 'rpm': '690', 'power_b': '4.51'}, {'diameter': '200', 'rpm': '700', 'power_b': '4.57'}, {'diameter': '200', 'rpm': '725', 'power_b': '4.71'}, {'diameter': '200', 'rpm': '800', 'power_b': '5.14'}, {'diameter': '200', 'rpm': '870', 'power_b': '5.54'}, {'diameter': '200', 'rpm': '900', 'power_b': '5.71'}, {'diameter': '200', 'rpm': '950', 'power_b': '598'}, {'diameter': '200', 'rpm': '1000', 'power_b': '6.26'}, {'diameter': '200', 'rpm': '1100', 'power_b': '6.79'}, {'diameter': '200', 'rpm': '1160', 'power_b': '7.11'}, {'diameter': '200', 'rpm': '1200', 'power_b': '7.32'}, {'diameter': '200', 'rpm': '1300', 'power_b': '7.84'}, {'diameter': '200', 'rpm': '1400', 'power_b': '8.34'}, {'diameter': '200', 'rpm': '1425', 'power_b': '8.46'}, {'diameter': '200', 'rpm': '1500', 'power_b': '8.83'}, {'diameter': '200', 'rpm': '1600', 'power_b': '9.3'}, {'diameter': '200', 'rpm': '1700', 'power_b': '9.76'}, {'diameter': '200', 'rpm': '1750', 'power_b': '9.99'}, {'diameter': '200', 'rpm': '1800', 'power_b': '10.2'}, {'diameter': '200', 'rpm': '1900', 'power_b': '10.6'}, {'diameter': '200', 'rpm': '2000', 'power_b': '11.1'}, {'diameter': '200', 'rpm': '2100', 'power_b': '11.5'}, {'diameter': '200', 'rpm': '2200', 'power_b': '11.9'}, {'diameter': '200', 'rpm': '2300', 'power_b': '12.2'}, {'diameter': '200', 'rpm': '2400', 'power_b': '12.6'}, {'diameter': '200', 'rpm': '2500', 'power_b': '12.9'}, {'diameter': '200', 'rpm': '2600', 'power_b': '13.3'}, {'diameter': '200', 'rpm': '2700', 'power_b': '13.6'}, {'diameter': '200', 'rpm': '2800', 'power_b': '13.8'}, {'diameter': '200', 'rpm': '2850', 'power_b': '14'}, {'diameter': '200', 'rpm': '2900', 'power_b': '14.1'}, {'diameter': '200', 'rpm': '3000', 'power_b': '14.4'}, {'diameter': '200', 'rpm': '3100', 'power_b': '14.6'}, {'diameter': '200', 'rpm': '3200', 'power_b': '14.8'}, {'diameter': '200', 'rpm': '3300', 'power_b': '15'}, {'diameter': '210', 'rpm': '100', 'power_b': '0.82'}, {'diameter': '210', 'rpm': '200', 'power_b': '1.55'}, {'diameter': '210', 'rpm': '300', 'power_b': '2.25'}, {'diameter': '210', 'rpm': '400', 'power_b': '2.92'}, {'diameter': '210', 'rpm': '500', 'power_b': '3.58'}, {'diameter': '210', 'rpm': '575', 'power_b': '4.06'}, {'diameter': '210', 'rpm': '600', 'power_b': '4.22'}, {'diameter': '210', 'rpm': '690', 'power_b': '4.78'}, {'diameter': '210', 'rpm': '700', 'power_b': '4.84'}, {'diameter': '210', 'rpm': '725', 'power_b': '4.99'}, {'diameter': '210', 'rpm': '800', 'power_b': '5.45'}, {'diameter': '210', 'rpm': '870', 'power_b': '5.87'}, {'diameter': '210', 'rpm': '900', 'power_b': '6.04'}, {'diameter': '210', 'rpm': '950', 'power_b': '6.34'}, {'diameter': '210', 'rpm': '1000', 'power_b': '6.63'}, {'diameter': '210', 'rpm': '1100', 'power_b': '7.19'}, {'diameter': '210', 'rpm': '1160', 'power_b': '7.53'}, {'diameter': '210', 'rpm': '1200', 'power_b': '7.75'}, {'diameter': '210', 'rpm': '1300', 'power_b': '8.29'}, {'diameter': '210', 'rpm': '1400', 'power_b': '8.82'}, {'diameter': '210', 'rpm': '1425', 'power_b': '8.95'}, {'diameter': '210', 'rpm': '1500', 'power_b': '9.33'}, {'diameter': '210', 'rpm': '1600', 'power_b': '9.83'}, {'diameter': '210', 'rpm': '1700', 'power_b': '10.3'}, {'diameter': '210', 'rpm': '1750', 'power_b': '10.6'}, {'diameter': '210', 'rpm': '1800', 'power_b': '10.8'}, {'diameter': '210', 'rpm': '1900', 'power_b': '11.2'}, {'diameter': '210', 'rpm': '2000', 'power_b': '11.7'}, {'diameter': '210', 'rpm': '2100', 'power_b': '12.1'}, {'diameter': '210', 'rpm': '2200', 'power_b': '12.5'}, {'diameter': '210', 'rpm': '2300', 'power_b': '12.9'}, {'diameter': '210', 'rpm': '2400', 'power_b': '13.2'}, {'diameter': '210', 'rpm': '2500', 'power_b': '13.6'}, {'diameter': '210', 'rpm': '2600', 'power_b': '13.9'}, {'diameter': '210', 'rpm': '2700', 'power_b': '14.2'}, {'diameter': '210', 'rpm': '2800', 'power_b': '14.5'}, {'diameter': '210', 'rpm': '2850', 'power_b': '14.6'}, {'diameter': '210', 'rpm': '2900', 'power_b': '14.7'}, {'diameter': '210', 'rpm': '3000', 'power_b': '15'}, {'diameter': '210', 'rpm': '3100', 'power_b': '15.2'}, {'diameter': '220', 'rpm': '100', 'power_b': '0.87'}, {'diameter': '220', 'rpm': '200', 'power_b': '1.64'}, {'diameter': '220', 'rpm': '300', 'power_b': '2.38'}, {'diameter': '220', 'rpm': '400', 'power_b': '3.09'}, {'diameter': '220', 'rpm': '500', 'power_b': '3.78'}, {'diameter': '220', 'rpm': '575', 'power_b': '4.28'}, {'diameter': '220', 'rpm': '600', 'power_b': '4.45'}, {'diameter': '220', 'rpm': '690', 'power_b': '5.04'}, {'diameter': '220', 'rpm': '700', 'power_b': '5.11'}, {'diameter': '220', 'rpm': '725', 'power_b': '5.27'}, {'diameter': '220', 'rpm': '800', 'power_b': '5.75'}, {'diameter': '220', 'rpm': '870', 'power_b': '6.19'}, {'diameter': '220', 'rpm': '900', 'power_b': '6.38'}, {'diameter': '220', 'rpm': '950', 'power_b': '6.69'}, {'diameter': '220', 'rpm': '1000', 'power_b': '6.99'}, {'diameter': '220', 'rpm': '1100', 'power_b': '7.59'}, {'diameter': '220', 'rpm': '1160', 'power_b': '7.94'}, {'diameter': '220', 'rpm': '1200', 'power_b': '8.17'}, {'diameter': '220', 'rpm': '1300', 'power_b': '8.74'}, {'diameter': '220', 'rpm': '1400', 'power_b': '9.29'}, {'diameter': '220', 'rpm': '1425', 'power_b': '9.43'}, {'diameter': '220', 'rpm': '1500', 'power_b': '9.83'}, {'diameter': '220', 'rpm': '1600', 'power_b': '10.4'}, {'diameter': '220', 'rpm': '1700', 'power_b': '10.9'}, {'diameter': '220', 'rpm': '1750', 'power_b': '11.1'}, {'diameter': '220', 'rpm': '1800', 'power_b': '11.3'}, {'diameter': '220', 'rpm': '1900', 'power_b': '11.8'}, {'diameter': '220', 'rpm': '2000', 'power_b': '12.3'}, {'diameter': '220', 'rpm': '2100', 'power_b': '12.7'}, {'diameter': '220', 'rpm': '2200', 'power_b': '13.1'}, {'diameter': '220', 'rpm': '2300', 'power_b': '13.5'}, {'diameter': '220', 'rpm': '2400', 'power_b': '13.8'}, {'diameter': '220', 'rpm': '2500', 'power_b': '14.2'}, {'diameter': '220', 'rpm': '2600', 'power_b': '14.5'}, {'diameter': '220', 'rpm': '2700', 'power_b': '14.8'}, {'diameter': '220', 'rpm': '2800', 'power_b': '15.1'}, {'diameter': '220', 'rpm': '2850', 'power_b': '15.2'}, {'diameter': '220', 'rpm': '2900', 'power_b': '15.3'}, {'diameter': '220', 'rpm': '3000', 'power_b': '15.6'}, {'diameter': '220', 'rpm': '3100', 'power_b': '14.6'}, {'diameter': '220', 'rpm': '3200', 'power_b': '14.8'}, {'diameter': '220', 'rpm': '3300', 'power_b': '15'}, {'diameter': '230', 'rpm': '100', 'power_b': '0.91'}, {'diameter': '230', 'rpm': '200', 'power_b': '1.73'}, {'diameter': '230', 'rpm': '300', 'power_b': '2.5'}, {'diameter': '230', 'rpm': '400', 'power_b': '3.25'}, {'diameter': '230', 'rpm': '500', 'power_b': '3.98'}, {'diameter': '230', 'rpm': '575', 'power_b': '4.51'}, {'diameter': '230', 'rpm': '600', 'power_b': '4.69'}, {'diameter': '230', 'rpm': '690', 'power_b': '5.31'}, {'diameter': '230', 'rpm': '700', 'power_b': '5.38'}, {'diameter': '230', 'rpm': '725', 'power_b': '5.55'}, {'diameter': '230', 'rpm': '800', 'power_b': '6.05'}, {'diameter': '230', 'rpm': '870', 'power_b': '6.52'}, {'diameter': '230', 'rpm': '900', 'power_b': '6.71'}, {'diameter': '230', 'rpm': '950', 'power_b': '7.04'}, {'diameter': '230', 'rpm': '1000', 'power_b': '7.36'}, {'diameter': '230', 'rpm': '1100', 'power_b': '7.98'}, {'diameter': '230', 'rpm': '1160', 'power_b': '8.35'}, {'diameter': '230', 'rpm': '1200', 'power_b': '8.59'}, {'diameter': '230', 'rpm': '1300', 'power_b': '9.19'}, {'diameter': '230', 'rpm': '1400', 'power_b': '9.76'}, {'diameter': '230', 'rpm': '1425', 'power_b': '9.9'}, {'diameter': '230', 'rpm': '1500', 'power_b': '10.3'}, {'diameter': '230', 'rpm': '1600', 'power_b': '10.9'}, {'diameter': '230', 'rpm': '1700', 'power_b': '11.4'}, {'diameter': '230', 'rpm': '1750', 'power_b': '11.6'}, {'diameter': '230', 'rpm': '1800', 'power_b': '11.9'}, {'diameter': '230', 'rpm': '1900', 'power_b': '12.4'}, {'diameter': '230', 'rpm': '2000', 'power_b': '12.8'}, {'diameter': '230', 'rpm': '2100', 'power_b': '13.3'}, {'diameter': '230', 'rpm': '2200', 'power_b': '13.7'}, {'diameter': '230', 'rpm': '2300', 'power_b': '14.1'}, {'diameter': '230', 'rpm': '2400', 'power_b': '14.4'}, {'diameter': '230', 'rpm': '2500', 'power_b': '14.8'}, {'diameter': '230', 'rpm': '2600', 'power_b': '15.1'}, {'diameter': '230', 'rpm': '2700', 'power_b': '15.4'}, {'diameter': '230', 'rpm': '2800', 'power_b': '15.6'}, {'diameter': '230', 'rpm': '2850', 'power_b': '15.8'}, {'diameter': '230', 'rpm': '2900', 'power_b': '15.9'}, {'diameter': '240', 'rpm': '100', 'power_b': '0.96'}, {'diameter': '240', 'rpm': '200', 'power_b': '1.81'}, {'diameter': '240', 'rpm': '300', 'power_b': '2.63'}, {'diameter': '240', 'rpm': '400', 'power_b': '3.41'}, {'diameter': '240', 'rpm': '500', 'power_b': '4.18'}, {'diameter': '240', 'rpm': '575', 'power_b': '4.74'}, {'diameter': '240', 'rpm': '600', 'power_b': '4.92'}, {'diameter': '240', 'rpm': '690', 'power_b': '5.57'}, {'diameter': '240', 'rpm': '700', 'power_b': '5.65'}, {'diameter': '240', 'rpm': '725', 'power_b': '5.82'}, {'diameter': '240', 'rpm': '800', 'power_b': '6.35'}, {'diameter': '240', 'rpm': '870', 'power_b': '6.84'}, {'diameter': '240', 'rpm': '900', 'power_b': '7.04'}, {'diameter': '240', 'rpm': '950', 'power_b': '7.38'}, {'diameter': '240', 'rpm': '1000', 'power_b': '7.72'}, {'diameter': '240', 'rpm': '1100', 'power_b': '8.37'}, {'diameter': '240', 'rpm': '1160', 'power_b': '8.76'}, {'diameter': '240', 'rpm': '1200', 'power_b': '9.01'}, {'diameter': '240', 'rpm': '1300', 'power_b': '9.63'}, {'diameter': '240', 'rpm': '1400', 'power_b': '10.2'}, {'diameter': '240', 'rpm': '1425', 'power_b': '10.4'}, {'diameter': '240', 'rpm': '1500', 'power_b': '10.8'}, {'diameter': '240', 'rpm': '1600', 'power_b': '11.4'}, {'diameter': '240', 'rpm': '1700', 'power_b': '11.95'}, {'diameter': '240', 'rpm': '1750', 'power_b': '12.2'}, {'diameter': '240', 'rpm': '1800', 'power_b': '12.4'}, {'diameter': '240', 'rpm': '1900', 'power_b': '12.9'}, {'diameter': '240', 'rpm': '2000', 'power_b': '13.4'}, {'diameter': '240', 'rpm': '2100', 'power_b': '13.8'}, {'diameter': '240', 'rpm': '2200', 'power_b': '14.2'}, {'diameter': '240', 'rpm': '2300', 'power_b': '14.6'}, {'diameter': '240', 'rpm': '2400', 'power_b': '15'}, {'diameter': '240', 'rpm': '2500', 'power_b': '15.3'}, {'diameter': '240', 'rpm': '2600', 'power_b': '15.6'}, {'diameter': '240', 'rpm': '2700', 'power_b': '15.9'})

SuperHC_5v_pa = ({'gr_low': '1', 'gr_high': '1.02', 'rpm': '100', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '200', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '300', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '400', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '435', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '485', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '500', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '575', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '600', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '690', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '700', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '725', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '800', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '870', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '900', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '950', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1000', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1100', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1160', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1200', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1300', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1400', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1425', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1500', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1600', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1700', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1750', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1800', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1900', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '2000', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '2100', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '2200', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '2300', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '2400', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '2500', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '2580', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '2600', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '2700', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '2800', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '2900', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '3000', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '3100', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '3200', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '3300', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '3400', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '3450', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '3500', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '3600', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '3700', 'power_a': '0'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '100', 'power_a': '0.01'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '200', 'power_a': '0.02'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '300', 'power_a': '0.03'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '400', 'power_a': '0.04'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '435', 'power_a': '0.04'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '485', 'power_a': '0.05'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '500', 'power_a': '0.05'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '575', 'power_a': '0.06'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '600', 'power_a': '0.06'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '690', 'power_a': '0.07'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '700', 'power_a': '0.07'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '725', 'power_a': '0.07'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '800', 'power_a': '0.08'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '870', 'power_a': '0.08'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '900', 'power_a': '0.09'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '950', 'power_a': '0.09'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '1000', 'power_a': '0.1'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '1100', 'power_a': '0.11'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '1160', 'power_a': '0.11'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '1200', 'power_a': '0.12'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '1300', 'power_a': '0.13'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '1400', 'power_a': '0.14'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '1425', 'power_a': '0.14'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '1500', 'power_a': '0.15'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '1600', 'power_a': '0.16'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '1700', 'power_a': '0.17'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '1750', 'power_a': '0.17'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '1800', 'power_a': '0.18'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '1900', 'power_a': '0.19'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '2000', 'power_a': '0.2'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '2100', 'power_a': '0.2'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '2200', 'power_a': '0.21'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '2300', 'power_a': '0.22'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '2400', 'power_a': '0.23'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '2500', 'power_a': '0.24'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '2580', 'power_a': '0.28'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '2600', 'power_a': '0.25'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '2700', 'power_a': '0.26'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '2800', 'power_a': '0.27'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '2900', 'power_a': '0.28'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '3000', 'power_a': '0.29'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '3100', 'power_a': '0.3'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '3200', 'power_a': '0.31'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '3300', 'power_a': '0.32'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '3400', 'power_a': '0.33'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '3450', 'power_a': '0.34'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '3500', 'power_a': '0.34'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '3600', 'power_a': '0.35'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '3700', 'power_a': '0.36'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '100', 'power_a': '0.03'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '200', 'power_a': '0.05'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '300', 'power_a': '0.08'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '400', 'power_a': '0.11'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '435', 'power_a': '0.12'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '485', 'power_a': '0.13'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '500', 'power_a': '0.13'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '575', 'power_a': '0.15'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '600', 'power_a': '0.16'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '690', 'power_a': '0.18'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '700', 'power_a': '0.19'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '725', 'power_a': '0.19'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '800', 'power_a': '0.21'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '870', 'power_a': '0.23'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '900', 'power_a': '0.24'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '950', 'power_a': '0.25'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '1000', 'power_a': '0.27'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '1100', 'power_a': '0.29'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '1160', 'power_a': '0.31'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '1200', 'power_a': '0.32'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '1300', 'power_a': '0.35'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '1400', 'power_a': '0.37'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '1425', 'power_a': '0.38'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '1500', 'power_a': '0.4'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '1600', 'power_a': '0.43'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '1700', 'power_a': '0.45'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '1750', 'power_a': '0.47'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '1800', 'power_a': '0.48'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '1900', 'power_a': '0.51'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '2000', 'power_a': '53'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '2100', 'power_a': '0.56'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '2200', 'power_a': '0.58'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '2300', 'power_a': '0.61'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '2400', 'power_a': '0.64'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '2500', 'power_a': '0.66'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '2580', 'power_a': '0.76'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '2600', 'power_a': '0.69'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '2700', 'power_a': '0.72'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '2800', 'power_a': '0.74'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '2900', 'power_a': '0.77'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '3000', 'power_a': '0.8'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '3100', 'power_a': '0.82'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '3200', 'power_a': '0.85'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '3300', 'power_a': '0.88'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '3400', 'power_a': '0.9'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '3450', 'power_a': '0.92'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '3500', 'power_a': '0.93'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '3600', 'power_a': '0.96'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '3700', 'power_a': '0.98'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '100', 'power_a': '0.05'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '200', 'power_a': '0.09'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '300', 'power_a': '0.14'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '400', 'power_a': '0.19'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '435', 'power_a': '0.2'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '485', 'power_a': '0.22'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '500', 'power_a': '0.23'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '575', 'power_a': '0.27'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '600', 'power_a': '0.28'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '690', 'power_a': '0.32'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '700', 'power_a': '0.32'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '725', 'power_a': '0.34'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '800', 'power_a': '0.37'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '870', 'power_a': '0.4'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '900', 'power_a': '0.42'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '950', 'power_a': '0.44'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '1000', 'power_a': '0.46'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '1100', 'power_a': '0.51'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '1160', 'power_a': '0.54'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '1200', 'power_a': '0.56'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '1300', 'power_a': '0.6'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '1400', 'power_a': '0.65'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '1425', 'power_a': '0.66'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '1500', 'power_a': '0.7'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '1600', 'power_a': '0.74'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '1700', 'power_a': '0.79'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '1750', 'power_a': '0.81'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '1800', 'power_a': '0.83'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '1900', 'power_a': '0.88'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '2000', 'power_a': '0.93'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '2100', 'power_a': '0.97'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '2200', 'power_a': '1.02'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '2300', 'power_a': '1.07'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '2400', 'power_a': '1.11'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '2500', 'power_a': '1.16'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '2580', 'power_a': '1.32'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '2600', 'power_a': '1.2'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '2700', 'power_a': '1.25'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '2800', 'power_a': '1.3'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '2900', 'power_a': '1.34'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '3000', 'power_a': '1.39'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '3100', 'power_a': '1.44'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '3200', 'power_a': '1.48'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '3300', 'power_a': '1.53'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '3400', 'power_a': '1.58'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '3450', 'power_a': '1.6'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '3500', 'power_a': '1.62'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '3600', 'power_a': '1.67'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '3700', 'power_a': '1.71'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '100', 'power_a': '0.06'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '200', 'power_a': '0.13'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '300', 'power_a': '0.19'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '400', 'power_a': '0.25'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '435', 'power_a': '0.27'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '485', 'power_a': '0.31'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '500', 'power_a': '0.32'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '575', 'power_a': '0.36'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '600', 'power_a': '0.38'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '690', 'power_a': '0.44'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '700', 'power_a': '0.44'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '725', 'power_a': '0.46'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '800', 'power_a': '0.5'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '870', 'power_a': '0.55'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '900', 'power_a': '0.57'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '950', 'power_a': '0.6'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '1000', 'power_a': '0.63'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '1100', 'power_a': '0.69'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '1160', 'power_a': '0.73'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '1200', 'power_a': '0.76'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '1300', 'power_a': '0.82'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '1400', 'power_a': '0.88'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '1425', 'power_a': '0.9'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '1500', 'power_a': '0.95'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '1600', 'power_a': '1.01'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '1700', 'power_a': '1.07'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '1750', 'power_a': '1.1'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '1800', 'power_a': '1.14'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '1900', 'power_a': '1.2'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '2000', 'power_a': '1.26'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '2100', 'power_a': '1.32'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '2200', 'power_a': '1.39'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '2300', 'power_a': '1.45'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '2400', 'power_a': '1.51'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '2500', 'power_a': '1.58'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '2580', 'power_a': '1.8'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '2600', 'power_a': '1.64'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '2700', 'power_a': '1.7'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '2800', 'power_a': '1.77'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '2900', 'power_a': '1.83'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '3000', 'power_a': '1.89'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '3100', 'power_a': '196'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '3200', 'power_a': '2.02'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '3300', 'power_a': '2.08'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '3400', 'power_a': '2.14'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '3450', 'power_a': '2.18'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '3500', 'power_a': '2.21'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '3600', 'power_a': '2.27'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '3700', 'power_a': '2.33'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '100', 'power_a': '0.08'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '200', 'power_a': '0.15'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '300', 'power_a': '0.23'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '400', 'power_a': '0.31'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '435', 'power_a': '0.33'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '485', 'power_a': '0.37'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '500', 'power_a': '0.38'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '575', 'power_a': '0.44'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '600', 'power_a': '0.46'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '690', 'power_a': '0.53'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '700', 'power_a': '0.54'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '725', 'power_a': '0.55'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '800', 'power_a': '0.61'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '870', 'power_a': '0.67'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '900', 'power_a': '0.69'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '950', 'power_a': '0.73'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '1000', 'power_a': '0.76'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '1100', 'power_a': '0.84'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '1160', 'power_a': '0.89'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '1200', 'power_a': '0.92'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '1300', 'power_a': '0.99'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '1400', 'power_a': '1.07'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '1425', 'power_a': '1.09'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '1500', 'power_a': '1.15'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '1600', 'power_a': '1.22'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '1700', 'power_a': '1.3'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '1750', 'power_a': '1.34'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '1800', 'power_a': '1.38'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '1900', 'power_a': '1.45'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '2000', 'power_a': '1.53'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '2100', 'power_a': '1.61'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '2200', 'power_a': '1.68'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '2300', 'power_a': '1.76'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '2400', 'power_a': '1.83'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '2500', 'power_a': '1.91'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '2580', 'power_a': '2.18'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '2600', 'power_a': '1.99'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '2700', 'power_a': '2.06'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '2800', 'power_a': '2.14'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '2900', 'power_a': '2.22'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '3000', 'power_a': '2.29'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '3100', 'power_a': '2.37'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '3200', 'power_a': '2.45'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '3300', 'power_a': '2.52'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '3400', 'power_a': '2.6'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '3450', 'power_a': '2.64'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '3500', 'power_a': '2.68'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '3600', 'power_a': '2.75'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '3700', 'power_a': '2.83'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '100', 'power_a': '0.09'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '200', 'power_a': '0.18'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '300', 'power_a': '0.27'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '400', 'power_a': '0.36'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '435', 'power_a': '0.39'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '485', 'power_a': '0.43'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '500', 'power_a': '0.45'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '575', 'power_a': '0.51'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '600', 'power_a': '0.54'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '690', 'power_a': '0.62'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '700', 'power_a': '0.63'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '725', 'power_a': '0.65'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '800', 'power_a': '0.72'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '870', 'power_a': '0.78'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '900', 'power_a': '0.81'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '950', 'power_a': '0.85'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '1000', 'power_a': '0.9'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '1100', 'power_a': '0.98'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '1160', 'power_a': '1.04'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '1200', 'power_a': '1.07'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '1300', 'power_a': '1.1'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '1400', 'power_a': '1.25'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '1425', 'power_a': '1.28'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '1500', 'power_a': '1.34'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '1600', 'power_a': '1.43'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '1700', 'power_a': '1.52'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '1750', 'power_a': '1.57'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '1800', 'power_a': '1.61'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '1900', 'power_a': '1.7'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '2000', 'power_a': '1.79'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '2100', 'power_a': '1.88'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '2200', 'power_a': '1.97'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '2300', 'power_a': '2.06'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '2400', 'power_a': '2.15'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '2500', 'power_a': '2.24'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '2580', 'power_a': '2.55'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '2600', 'power_a': '2.33'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '2700', 'power_a': '2.42'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '2800', 'power_a': '2.51'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '2900', 'power_a': '2.6'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '3000', 'power_a': '2.69'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '3100', 'power_a': '2.78'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '3200', 'power_a': '2.87'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '3300', 'power_a': '2.95'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '3400', 'power_a': '3.04'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '3450', 'power_a': '3.09'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '3500', 'power_a': '3.13'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '3600', 'power_a': '3.22'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '3700', 'power_a': '3.31'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '100', 'power_a': '0.1'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '200', 'power_a': '0.2'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '300', 'power_a': '0.3'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '400', 'power_a': '0.4'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '435', 'power_a': '0.44'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '485', 'power_a': '0.49'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '500', 'power_a': '0.5'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '575', 'power_a': '0.58'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '600', 'power_a': '0.6'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '690', 'power_a': '0.7'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '700', 'power_a': '0.71'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '725', 'power_a': '0.73'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '800', 'power_a': '0.81'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '870', 'power_a': '0.88'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '900', 'power_a': '0.91'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '950', 'power_a': '0.96'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '1000', 'power_a': '1.01'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '1100', 'power_a': '1.11'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '1160', 'power_a': '1.17'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '1200', 'power_a': '1.21'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '1300', 'power_a': '1.31'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '1400', 'power_a': '1.41'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '1425', 'power_a': '1.44'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '1500', 'power_a': '1.51'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '1600', 'power_a': '1.61'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '1700', 'power_a': '1.71'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '1750', 'power_a': '1.76'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '1800', 'power_a': '1.81'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '1900', 'power_a': '1.91'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '2000', 'power_a': '2.02'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '2100', 'power_a': '2.12'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '2200', 'power_a': '2.22'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '2300', 'power_a': '2.32'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '2400', 'power_a': '2.42'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '2500', 'power_a': '2.52'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '2580', 'power_a': '2.87'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '2600', 'power_a': '2.62'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '2700', 'power_a': '2.72'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '2800', 'power_a': '2.82'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '2900', 'power_a': '2.92'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '3000', 'power_a': '3.02'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '3100', 'power_a': '3.12'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '3200', 'power_a': '3.22'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '3300', 'power_a': '3.32'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '3400', 'power_a': '3.42'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '3450', 'power_a': '3.48'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '3500', 'power_a': '3.52'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '3600', 'power_a': '3.62'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '3700', 'power_a': '3.72'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '100', 'power_a': '0.11'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '200', 'power_a': '0.22'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '300', 'power_a': '0.33'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '400', 'power_a': '0.44'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '435', 'power_a': '0.48'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '485', 'power_a': '0.53'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '500', 'power_a': '0.55'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '575', 'power_a': '0.63'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '600', 'power_a': '0.66'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '690', 'power_a': '0.76'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '700', 'power_a': '0.77'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '725', 'power_a': '0.8'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '800', 'power_a': '0.88'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '870', 'power_a': '0.96'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '900', 'power_a': '0.99'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '950', 'power_a': '1.04'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '1000', 'power_a': '1.1'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '1100', 'power_a': '1.21'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '1160', 'power_a': '1.27'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '1200', 'power_a': '1.32'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '1300', 'power_a': '1.43'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '1400', 'power_a': '1.54'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '1425', 'power_a': '1.56'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '1500', 'power_a': '1.65'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '1600', 'power_a': '1.76'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '1700', 'power_a': '1.87'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '1750', 'power_a': '1.92'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '1800', 'power_a': '1.98'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '1900', 'power_a': '2.09'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '2000', 'power_a': '2.2'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '2100', 'power_a': '2.31'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '2200', 'power_a': '2.42'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '2300', 'power_a': '2.52'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '2400', 'power_a': '2.63'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '2500', 'power_a': '2.74'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '2580', 'power_a': '3.13'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '2600', 'power_a': '2.85'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '2700', 'power_a': '2.96'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '2800', 'power_a': '3.07'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '2900', 'power_a': '3.18'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '3000', 'power_a': '3.29'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '3100', 'power_a': '3.4'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '3200', 'power_a': '3.51'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '3300', 'power_a': '3.62'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '3400', 'power_a': '3.73'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '3450', 'power_a': '3.79'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '3500', 'power_a': '3.84'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '3600', 'power_a': '3.95'}, {'gr_low': '1.95', 'gr_high': '3.38', 'rpm': '3700', 'power_a': '4.06'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '100', 'power_a': '0.12'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '200', 'power_a': '0.23'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '300', 'power_a': '0.35'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '400', 'power_a': '0.47'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '435', 'power_a': '0.51'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '485', 'power_a': '0.56'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '500', 'power_a': '0.58'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '575', 'power_a': '0.67'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '600', 'power_a': '0.7'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '690', 'power_a': '0.8'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '700', 'power_a': '0.81'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '725', 'power_a': '0.84'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '800', 'power_a': '0.93'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '870', 'power_a': '1.01'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '900', 'power_a': '1.05'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '950', 'power_a': '1.1'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '1000', 'power_a': '1.16'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '1100', 'power_a': '1.28'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '1160', 'power_a': '1.36'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '1200', 'power_a': '1.4'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '1300', 'power_a': '1.51'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '1400', 'power_a': '1.63'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '1425', 'power_a': '1.66'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '1500', 'power_a': '1.74'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '1600', 'power_a': '1.86'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '1700', 'power_a': '1.98'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '1750', 'power_a': '2.03'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '1800', 'power_a': '2.09'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '1900', 'power_a': '2.21'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '2000', 'power_a': '2.33'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '2100', 'power_a': '2.44'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '2200', 'power_a': '2.56'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '2300', 'power_a': '2.67'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '2400', 'power_a': '2.79'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '2500', 'power_a': '2.91'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '2580', 'power_a': '3.31'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '2600', 'power_a': '3.02'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '2700', 'power_a': '3.14'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '2800', 'power_a': '3.26'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '2900', 'power_a': '3.37'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '3000', 'power_a': '3.49'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '3100', 'power_a': '3.6'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '3200', 'power_a': '3.72'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '3300', 'power_a': '3.84'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '3400', 'power_a': '3.95'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '3450', 'power_a': '4.01'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '3500', 'power_a': '4.07'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '3600', 'power_a': '4.19'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '3700', 'power_a': '4.3'})

SuperHC_5v_pb = ({'diameter': '180', 'rpm': '100', 'power_b': '1.37'}, {'diameter': '180', 'rpm': '200', 'power_b': '2.54'}, {'diameter': '180', 'rpm': '300', 'power_b': '3.63'}, {'diameter': '180', 'rpm': '400', 'power_b': '4.67'}, {'diameter': '180', 'rpm': '435', 'power_b': '5.03'}, {'diameter': '180', 'rpm': '485', 'power_b': '5.52'}, {'diameter': '180', 'rpm': '500', 'power_b': '5.67'}, {'diameter': '180', 'rpm': '575', 'power_b': '6.4'}, {'diameter': '180', 'rpm': '600', 'power_b': '6.64'}, {'diameter': '180', 'rpm': '690', 'power_b': '7.48'}, {'diameter': '180', 'rpm': '700', 'power_b': '7.57'}, {'diameter': '180', 'rpm': '725', 'power_b': '7.8'}, {'diameter': '180', 'rpm': '800', 'power_b': '8.47'}, {'diameter': '180', 'rpm': '870', 'power_b': '9.09'}, {'diameter': '180', 'rpm': '900', 'power_b': '9.35'}, {'diameter': '180', 'rpm': '950', 'power_b': '9.78'}, {'diameter': '180', 'rpm': '1000', 'power_b': '10.2'}, {'diameter': '180', 'rpm': '1100', 'power_b': '11'}, {'diameter': '180', 'rpm': '1160', 'power_b': '11.5'}, {'diameter': '180', 'rpm': '1200', 'power_b': '11.8'}, {'diameter': '180', 'rpm': '1300', 'power_b': '12.6'}, {'diameter': '180', 'rpm': '1400', 'power_b': '13.3'}, {'diameter': '180', 'rpm': '1425', 'power_b': '13.5'}, {'diameter': '180', 'rpm': '1500', 'power_b': '14.1'}, {'diameter': '180', 'rpm': '1600', 'power_b': '14.7'}, {'diameter': '180', 'rpm': '1700', 'power_b': '15.4'}, {'diameter': '180', 'rpm': '1750', 'power_b': '15.7'}, {'diameter': '180', 'rpm': '1800', 'power_b': '16'}, {'diameter': '180', 'rpm': '1900', 'power_b': '16.6'}, {'diameter': '180', 'rpm': '2000', 'power_b': '17.2'}, {'diameter': '180', 'rpm': '2100', 'power_b': '17.7'}, {'diameter': '180', 'rpm': '2200', 'power_b': '18.2'}, {'diameter': '180', 'rpm': '2300', 'power_b': '18.7'}, {'diameter': '180', 'rpm': '2400', 'power_b': '19.2'}, {'diameter': '180', 'rpm': '2500', 'power_b': '19.6'}, {'diameter': '180', 'rpm': '2580', 'power_b': '20.7'}, {'diameter': '180', 'rpm': '2600', 'power_b': '19.9'}, {'diameter': '180', 'rpm': '2700', 'power_b': '20.3'}, {'diameter': '180', 'rpm': '2800', 'power_b': '20.5'}, {'diameter': '180', 'rpm': '2900', 'power_b': '20.8'}, {'diameter': '180', 'rpm': '3000', 'power_b': '21'}, {'diameter': '180', 'rpm': '3100', 'power_b': '21.2'}, {'diameter': '180', 'rpm': '3200', 'power_b': '21.3'}, {'diameter': '180', 'rpm': '3300', 'power_b': '21.4'}, {'diameter': '180', 'rpm': '3400', 'power_b': '21.4'}, {'diameter': '180', 'rpm': '3450', 'power_b': '21.4'}, {'diameter': '180', 'rpm': '3500', 'power_b': '21.4'}, {'diameter': '180', 'rpm': '3600', 'power_b': '21.4'}, {'diameter': '180', 'rpm': '3700', 'power_b': '21.3'}, {'diameter': '190', 'rpm': '100', 'power_b': '1.5'}, {'diameter': '190', 'rpm': '200', 'power_b': '2.78'}, {'diameter': '190', 'rpm': '300', 'power_b': '3.99'}, {'diameter': '190', 'rpm': '400', 'power_b': '5.13'}, {'diameter': '190', 'rpm': '435', 'power_b': '5.52'}, {'diameter': '190', 'rpm': '485', 'power_b': '6.07'}, {'diameter': '190', 'rpm': '500', 'power_b': '6.24'}, {'diameter': '190', 'rpm': '575', 'power_b': '7.04'}, {'diameter': '190', 'rpm': '600', 'power_b': '7.3'}, {'diameter': '190', 'rpm': '690', 'power_b': '8.23'}, {'diameter': '190', 'rpm': '700', 'power_b': '8.34'}, {'diameter': '190', 'rpm': '725', 'power_b': '8.59'}, {'diameter': '190', 'rpm': '800', 'power_b': '9.34'}, {'diameter': '190', 'rpm': '870', 'power_b': '10'}, {'diameter': '190', 'rpm': '900', 'power_b': '10.3'}, {'diameter': '190', 'rpm': '950', 'power_b': '10.8'}, {'diameter': '190', 'rpm': '1000', 'power_b': '11.2'}, {'diameter': '190', 'rpm': '1100', 'power_b': '12.2'}, {'diameter': '190', 'rpm': '1160', 'power_b': '12.7'}, {'diameter': '190', 'rpm': '1200', 'power_b': '13'}, {'diameter': '190', 'rpm': '1300', 'power_b': '13.9'}, {'diameter': '190', 'rpm': '1400', 'power_b': '14.7'}, {'diameter': '190', 'rpm': '1425', 'power_b': '14.9'}, {'diameter': '190', 'rpm': '1500', 'power_b': '15.5'}, {'diameter': '190', 'rpm': '1600', 'power_b': '16.3'}, {'diameter': '190', 'rpm': '1700', 'power_b': '17'}, {'diameter': '190', 'rpm': '1750', 'power_b': '17.3'}, {'diameter': '190', 'rpm': '1800', 'power_b': '17.7'}, {'diameter': '190', 'rpm': '1900', 'power_b': '18.3'}, {'diameter': '190', 'rpm': '2000', 'power_b': '19'}, {'diameter': '190', 'rpm': '2100', 'power_b': '19.5'}, {'diameter': '190', 'rpm': '2200', 'power_b': '20.1'}, {'diameter': '190', 'rpm': '2300', 'power_b': '20.6'}, {'diameter': '190', 'rpm': '2400', 'power_b': '21.1'}, {'diameter': '190', 'rpm': '2500', 'power_b': '21.5'}, {'diameter': '190', 'rpm': '2580', 'power_b': '22.7'}, {'diameter': '190', 'rpm': '2600', 'power_b': '21.9'}, {'diameter': '190', 'rpm': '2700', 'power_b': '22.2'}, {'diameter': '190', 'rpm': '2800', 'power_b': '22.5'}, {'diameter': '190', 'rpm': '2900', 'power_b': '22.8'}, {'diameter': '190', 'rpm': '3000', 'power_b': '23'}, {'diameter': '190', 'rpm': '3100', 'power_b': '23.2'}, {'diameter': '190', 'rpm': '3200', 'power_b': '23.3'}, {'diameter': '190', 'rpm': '3300', 'power_b': '23.3'}, {'diameter': '190', 'rpm': '3400', 'power_b': '23.4'}, {'diameter': '190', 'rpm': '3450', 'power_b': '23.3'}, {'diameter': '190', 'rpm': '3500', 'power_b': '23.3'}, {'diameter': '200', 'rpm': '100', 'power_b': '1.62'}, {'diameter': '200', 'rpm': '200', 'power_b': '3.02'}, {'diameter': '200', 'rpm': '300', 'power_b': '4.34'}, {'diameter': '200', 'rpm': '400', 'power_b': '5.59'}, {'diameter': '200', 'rpm': '435', 'power_b': '6.02'}, {'diameter': '200', 'rpm': '485', 'power_b': '6.62'}, {'diameter': '200', 'rpm': '500', 'power_b': '6.8'}, {'diameter': '200', 'rpm': '575', 'power_b': '7.68'}, {'diameter': '200', 'rpm': '600', 'power_b': '7.97'}, {'diameter': '200', 'rpm': '690', 'power_b': '8.98'}, {'diameter': '200', 'rpm': '700', 'power_b': '9.1'}, {'diameter': '200', 'rpm': '725', 'power_b': '9.37'}, {'diameter': '200', 'rpm': '800', 'power_b': '10.2'}, {'diameter': '200', 'rpm': '870', 'power_b': '10.9'}, {'diameter': '200', 'rpm': '900', 'power_b': '11.3'}, {'diameter': '200', 'rpm': '950', 'power_b': '11.8'}, {'diameter': '200', 'rpm': '1000', 'power_b': '12.3'}, {'diameter': '200', 'rpm': '1100', 'power_b': '13.3'}, {'diameter': '200', 'rpm': '1160', 'power_b': '13.9'}, {'diameter': '200', 'rpm': '1200', 'power_b': '14.2'}, {'diameter': '200', 'rpm': '1300', 'power_b': '15.2'}, {'diameter': '200', 'rpm': '1400', 'power_b': '16.1'}, {'diameter': '200', 'rpm': '1425', 'power_b': '16.3'}, {'diameter': '200', 'rpm': '1500', 'power_b': '16.9'}, {'diameter': '200', 'rpm': '1600', 'power_b': '17.8'}, {'diameter': '200', 'rpm': '1700', 'power_b': '18.5'}, {'diameter': '200', 'rpm': '1750', 'power_b': '18.9'}, {'diameter': '200', 'rpm': '1800', 'power_b': '19.3'}, {'diameter': '200', 'rpm': '1900', 'power_b': '20'}, {'diameter': '200', 'rpm': '2000', 'power_b': '20.7'}, {'diameter': '200', 'rpm': '2100', 'power_b': '21.3'}, {'diameter': '200', 'rpm': '2200', 'power_b': '21.9'}, {'diameter': '200', 'rpm': '2300', 'power_b': '22.4'}, {'diameter': '200', 'rpm': '2400', 'power_b': '22.9'}, {'diameter': '200', 'rpm': '2500', 'power_b': '23.4'}, {'diameter': '200', 'rpm': '2580', 'power_b': '24.6'}, {'diameter': '200', 'rpm': '2600', 'power_b': '23.8'}, {'diameter': '200', 'rpm': '2700', 'power_b': '24.1'}, {'diameter': '200', 'rpm': '2800', 'power_b': '24.4'}, {'diameter': '200', 'rpm': '2900', 'power_b': '24.7'}, {'diameter': '200', 'rpm': '3000', 'power_b': '24.9'}, {'diameter': '200', 'rpm': '3100', 'power_b': '25'}, {'diameter': '200', 'rpm': '3200', 'power_b': '25.1'}, {'diameter': '200', 'rpm': '3300', 'power_b': '25.1'}, {'diameter': '210', 'rpm': '100', 'power_b': '1.75'}, {'diameter': '210', 'rpm': '200', 'power_b': '3.26'}, {'diameter': '210', 'rpm': '300', 'power_b': '4.69'}, {'diameter': '210', 'rpm': '400', 'power_b': '6.05'}, {'diameter': '210', 'rpm': '435', 'power_b': '6.51'}, {'diameter': '210', 'rpm': '485', 'power_b': '7.16'}, {'diameter': '210', 'rpm': '500', 'power_b': '7.36'}, {'diameter': '210', 'rpm': '575', 'power_b': '8.31'}, {'diameter': '210', 'rpm': '600', 'power_b': '8.62'}, {'diameter': '210', 'rpm': '690', 'power_b': '9.73'}, {'diameter': '210', 'rpm': '700', 'power_b': '9.85'}, {'diameter': '210', 'rpm': '725', 'power_b': '10.2'}, {'diameter': '210', 'rpm': '800', 'power_b': '11'}, {'diameter': '210', 'rpm': '870', 'power_b': '11.9'}, {'diameter': '210', 'rpm': '900', 'power_b': '12.2'}, {'diameter': '210', 'rpm': '950', 'power_b': '12.8'}, {'diameter': '210', 'rpm': '1000', 'power_b': '13.3'}, {'diameter': '210', 'rpm': '1100', 'power_b': '14.4'}, {'diameter': '210', 'rpm': '1160', 'power_b': '15'}, {'diameter': '210', 'rpm': '1200', 'power_b': '15.4'}, {'diameter': '210', 'rpm': '1300', 'power_b': '16.4'}, {'diameter': '210', 'rpm': '1400', 'power_b': '17.4'}, {'diameter': '210', 'rpm': '1425', 'power_b': '17.6'}, {'diameter': '210', 'rpm': '1500', 'power_b': '18.3'}, {'diameter': '210', 'rpm': '1600', 'power_b': '19.2'}, {'diameter': '210', 'rpm': '1700', 'power_b': '20.1'}, {'diameter': '210', 'rpm': '1750', 'power_b': '20.5'}, {'diameter': '210', 'rpm': '1800', 'power_b': '20.9'}, {'diameter': '210', 'rpm': '1900', 'power_b': '21.6'}, {'diameter': '210', 'rpm': '2000', 'power_b': '22.4'}, {'diameter': '210', 'rpm': '2100', 'power_b': '23'}, {'diameter': '210', 'rpm': '2200', 'power_b': '23.6'}, {'diameter': '210', 'rpm': '2300', 'power_b': '24.2'}, {'diameter': '210', 'rpm': '2400', 'power_b': '24.7'}, {'diameter': '210', 'rpm': '2500', 'power_b': '25.2'}, {'diameter': '210', 'rpm': '2580', 'power_b': '26.4'}, {'diameter': '210', 'rpm': '2600', 'power_b': '25.6'}, {'diameter': '210', 'rpm': '2700', 'power_b': '25.9'}, {'diameter': '210', 'rpm': '2800', 'power_b': '26.2'}, {'diameter': '210', 'rpm': '2900', 'power_b': '26.5'}, {'diameter': '210', 'rpm': '3000', 'power_b': '26.6'}, {'diameter': '210', 'rpm': '3100', 'power_b': '26.7'}, {'diameter': '220', 'rpm': '100', 'power_b': '1.87'}, {'diameter': '220', 'rpm': '200', 'power_b': '3.5'}, {'diameter': '220', 'rpm': '300', 'power_b': '5.03'}, {'diameter': '220', 'rpm': '400', 'power_b': '6.5'}, {'diameter': '220', 'rpm': '435', 'power_b': '7'}, {'diameter': '220', 'rpm': '485', 'power_b': '7.7'}, {'diameter': '220', 'rpm': '500', 'power_b': '7.91'}, {'diameter': '220', 'rpm': '575', 'power_b': '8.94'}, {'diameter': '220', 'rpm': '600', 'power_b': '9.28'}, {'diameter': '220', 'rpm': '690', 'power_b': '10.5'}, {'diameter': '220', 'rpm': '700', 'power_b': '10.6'}, {'diameter': '220', 'rpm': '725', 'power_b': '10.9'}, {'diameter': '220', 'rpm': '800', 'power_b': '11.9'}, {'diameter': '220', 'rpm': '870', 'power_b': '12.8'}, {'diameter': '220', 'rpm': '900', 'power_b': '13.1'}, {'diameter': '220', 'rpm': '950', 'power_b': '13.7'}, {'diameter': '220', 'rpm': '1000', 'power_b': '14.3'}, {'diameter': '220', 'rpm': '1100', 'power_b': '15.5'}, {'diameter': '220', 'rpm': '1160', 'power_b': '16.2'}, {'diameter': '220', 'rpm': '1200', 'power_b': '16.6'}, {'diameter': '220', 'rpm': '1300', 'power_b': '17.7'}, {'diameter': '220', 'rpm': '1400', 'power_b': '18.7'}, {'diameter': '220', 'rpm': '1425', 'power_b': '19'}, {'diameter': '220', 'rpm': '1500', 'power_b': '19.7'}, {'diameter': '220', 'rpm': '1600', 'power_b': '20.7'}, {'diameter': '220', 'rpm': '1700', 'power_b': '21.6'}, {'diameter': '220', 'rpm': '1750', 'power_b': '22'}, {'diameter': '220', 'rpm': '1800', 'power_b': '22.4'}, {'diameter': '220', 'rpm': '1900', 'power_b': '23.2'}, {'diameter': '220', 'rpm': '2000', 'power_b': '24'}, {'diameter': '220', 'rpm': '2100', 'power_b': '24.7'}, {'diameter': '220', 'rpm': '2200', 'power_b': '25.3'}, {'diameter': '220', 'rpm': '2300', 'power_b': '25.9'}, {'diameter': '220', 'rpm': '2400', 'power_b': '26.4'}, {'diameter': '220', 'rpm': '2500', 'power_b': '26.9'}, {'diameter': '220', 'rpm': '2580', 'power_b': '28'}, {'diameter': '220', 'rpm': '2600', 'power_b': '27.3'}, {'diameter': '220', 'rpm': '2700', 'power_b': '27.6'}, {'diameter': '220', 'rpm': '2800', 'power_b': '27.9'}, {'diameter': '220', 'rpm': '2900', 'power_b': '28.1'}, {'diameter': '220', 'rpm': '3000', 'power_b': '28.2'}, {'diameter': '230', 'rpm': '100', 'power_b': '2'}, {'diameter': '230', 'rpm': '200', 'power_b': '3.74'}, {'diameter': '230', 'rpm': '300', 'power_b': '5.38'}, {'diameter': '230', 'rpm': '400', 'power_b': '6.95'}, {'diameter': '230', 'rpm': '435', 'power_b': '7.49'}, {'diameter': '230', 'rpm': '485', 'power_b': '8.24'}, {'diameter': '230', 'rpm': '500', 'power_b': '8.47'}, {'diameter': '230', 'rpm': '575', 'power_b': '9.57'}, {'diameter': '230', 'rpm': '600', 'power_b': '9.93'}, {'diameter': '230', 'rpm': '690', 'power_b': '11.2'}, {'diameter': '230', 'rpm': '700', 'power_b': '11.4'}, {'diameter': '230', 'rpm': '725', 'power_b': '11.7'}, {'diameter': '230', 'rpm': '800', 'power_b': '12.7'}, {'diameter': '230', 'rpm': '870', 'power_b': '13.7'}, {'diameter': '230', 'rpm': '900', 'power_b': '14.1'}, {'diameter': '230', 'rpm': '950', 'power_b': '14.7'}, {'diameter': '230', 'rpm': '1000', 'power_b': '15.3'}, {'diameter': '230', 'rpm': '1100', 'power_b': '16.6'}, {'diameter': '230', 'rpm': '1160', 'power_b': '17.3'}, {'diameter': '230', 'rpm': '1200', 'power_b': '17.8'}, {'diameter': '230', 'rpm': '1300', 'power_b': '18.9'}, {'diameter': '230', 'rpm': '1400', 'power_b': '20'}, {'diameter': '230', 'rpm': '1425', 'power_b': '20.3'}, {'diameter': '230', 'rpm': '1500', 'power_b': '21.1'}, {'diameter': '230', 'rpm': '1600', 'power_b': '22.1'}, {'diameter': '230', 'rpm': '1700', 'power_b': '23.1'}, {'diameter': '230', 'rpm': '1750', 'power_b': '23.5'}, {'diameter': '230', 'rpm': '1800', 'power_b': '24'}, {'diameter': '230', 'rpm': '1900', 'power_b': '24.8'}, {'diameter': '230', 'rpm': '2000', 'power_b': '25.6'}, {'diameter': '230', 'rpm': '2100', 'power_b': '26.3'}, {'diameter': '230', 'rpm': '2200', 'power_b': '27'}, {'diameter': '230', 'rpm': '2300', 'power_b': '27.6'}, {'diameter': '230', 'rpm': '2400', 'power_b': '28.1'}, {'diameter': '230', 'rpm': '2500', 'power_b': '28.5'}, {'diameter': '230', 'rpm': '2580', 'power_b': '29.6'}, {'diameter': '230', 'rpm': '2600', 'power_b': '28.9'}, {'diameter': '230', 'rpm': '2700', 'power_b': '29.2'}, {'diameter': '230', 'rpm': '2800', 'power_b': '29.5'}, {'diameter': '230', 'rpm': '2900', 'power_b': '29.6'}, {'diameter': '240', 'rpm': '100', 'power_b': '2.12'}, {'diameter': '240', 'rpm': '200', 'power_b': '3.98'}, {'diameter': '240', 'rpm': '300', 'power_b': '5.73'}, {'diameter': '240', 'rpm': '400', 'power_b': '7.4'}, {'diameter': '240', 'rpm': '435', 'power_b': '7.98'}, {'diameter': '240', 'rpm': '485', 'power_b': '8.78'}, {'diameter': '240', 'rpm': '500', 'power_b': '9.02'}, {'diameter': '240', 'rpm': '575', 'power_b': '10.2'}, {'diameter': '240', 'rpm': '600', 'power_b': '10.6'}, {'diameter': '240', 'rpm': '690', 'power_b': '11.9'}, {'diameter': '240', 'rpm': '700', 'power_b': '12.1'}, {'diameter': '240', 'rpm': '725', 'power_b': '12.5'}, {'diameter': '240', 'rpm': '800', 'power_b': '13.6'}, {'diameter': '240', 'rpm': '870', 'power_b': '14.6'}, {'diameter': '240', 'rpm': '900', 'power_b': '15'}, {'diameter': '240', 'rpm': '950', 'power_b': '15.7'}, {'diameter': '240', 'rpm': '1000', 'power_b': '16.3'}, {'diameter': '240', 'rpm': '1100', 'power_b': '17.7'}, {'diameter': '240', 'rpm': '1160', 'power_b': '18.4'}, {'diameter': '240', 'rpm': '1200', 'power_b': '18.9'}, {'diameter': '240', 'rpm': '1300', 'power_b': '20.2'}, {'diameter': '240', 'rpm': '1400', 'power_b': '21.3'}, {'diameter': '240', 'rpm': '1425', 'power_b': '21.6'}, {'diameter': '240', 'rpm': '1500', 'power_b': '22.4'}, {'diameter': '240', 'rpm': '1600', 'power_b': '23.5'}, {'diameter': '240', 'rpm': '1700', 'power_b': '24.5'}, {'diameter': '240', 'rpm': '1750', 'power_b': '25'}, {'diameter': '240', 'rpm': '1800', 'power_b': '25.4'}, {'diameter': '240', 'rpm': '1900', 'power_b': '26.3'}, {'diameter': '240', 'rpm': '2000', 'power_b': '27.1'}, {'diameter': '240', 'rpm': '2100', 'power_b': '27.9'}, {'diameter': '240', 'rpm': '2200', 'power_b': '28.5'}, {'diameter': '240', 'rpm': '2300', 'power_b': '29.1'}, {'diameter': '240', 'rpm': '2400', 'power_b': '29.6'}, {'diameter': '240', 'rpm': '2500', 'power_b': '30.1'}, {'diameter': '240', 'rpm': '2600', 'power_b': '30.5'}, {'diameter': '240', 'rpm': '2700', 'power_b': '30.7'}, {'diameter': '250', 'rpm': '100', 'power_b': '2.25'}, {'diameter': '250', 'rpm': '200', 'power_b': '4.22'}, {'diameter': '250', 'rpm': '300', 'power_b': '6.07'}, {'diameter': '250', 'rpm': '400', 'power_b': '7.85'}, {'diameter': '250', 'rpm': '435', 'power_b': '8.46'}, {'diameter': '250', 'rpm': '485', 'power_b': '9.32'}, {'diameter': '250', 'rpm': '500', 'power_b': '9.57'}, {'diameter': '250', 'rpm': '575', 'power_b': '10.8'}, {'diameter': '250', 'rpm': '600', 'power_b': '11.2'}, {'diameter': '250', 'rpm': '690', 'power_b': '12.7'}, {'diameter': '250', 'rpm': '700', 'power_b': '12.8'}, {'diameter': '250', 'rpm': '725', 'power_b': '13.2'}, {'diameter': '250', 'rpm': '800', 'power_b': '14.4'}, {'diameter': '250', 'rpm': '870', 'power_b': '15.4'}, {'diameter': '250', 'rpm': '900', 'power_b': '15.9'}, {'diameter': '250', 'rpm': '950', 'power_b': '16.6'}, {'diameter': '250', 'rpm': '1000', 'power_b': '17.3'}, {'diameter': '250', 'rpm': '1100', 'power_b': '18.7'}, {'diameter': '250', 'rpm': '1160', 'power_b': '19.6'}, {'diameter': '250', 'rpm': '1200', 'power_b': '20.1'}, {'diameter': '250', 'rpm': '1300', 'power_b': '21.4'}, {'diameter': '250', 'rpm': '1400', 'power_b': '22.6'}, {'diameter': '250', 'rpm': '1425', 'power_b': '22.9'}, {'diameter': '250', 'rpm': '1500', 'power_b': '23.8'}, {'diameter': '250', 'rpm': '1600', 'power_b': '24.9'}, {'diameter': '250', 'rpm': '1700', 'power_b': '25.9'}, {'diameter': '250', 'rpm': '1750', 'power_b': '26.4'}, {'diameter': '250', 'rpm': '1800', 'power_b': '26.9'}, {'diameter': '250', 'rpm': '1900', 'power_b': '27.8'}, {'diameter': '250', 'rpm': '2000', 'power_b': '28.6'}, {'diameter': '250', 'rpm': '2100', 'power_b': '29.4'}, {'diameter': '250', 'rpm': '2200', 'power_b': '30'}, {'diameter': '250', 'rpm': '2300', 'power_b': '30.6'}, {'diameter': '250', 'rpm': '2400', 'power_b': '31.1'}, {'diameter': '250', 'rpm': '2500', 'power_b': '31.6'}, {'diameter': '250', 'rpm': '2600', 'power_b': '31.9'}, {'diameter': '265', 'rpm': '100', 'power_b': '2.43'}, {'diameter': '265', 'rpm': '200', 'power_b': '4.57'}, {'diameter': '265', 'rpm': '300', 'power_b': '6.59'}, {'diameter': '265', 'rpm': '400', 'power_b': '8.52'}, {'diameter': '265', 'rpm': '435', 'power_b': '9.18'}, {'diameter': '265', 'rpm': '485', 'power_b': '10.1'}, {'diameter': '265', 'rpm': '500', 'power_b': '10.4'}, {'diameter': '265', 'rpm': '575', 'power_b': '11.7'}, {'diameter': '265', 'rpm': '600', 'power_b': '12.2'}, {'diameter': '265', 'rpm': '690', 'power_b': '13.8'}, {'diameter': '265', 'rpm': '700', 'power_b': '13.9'}, {'diameter': '265', 'rpm': '725', 'power_b': '14.4'}, {'diameter': '265', 'rpm': '800', 'power_b': '15.6'}, {'diameter': '265', 'rpm': '870', 'power_b': '16.8'}, {'diameter': '265', 'rpm': '900', 'power_b': '17.2'}, {'diameter': '265', 'rpm': '950', 'power_b': '18'}, {'diameter': '265', 'rpm': '1000', 'power_b': '18.8'}, {'diameter': '265', 'rpm': '1100', 'power_b': '20.3'}, {'diameter': '265', 'rpm': '1160', 'power_b': '21.2'}, {'diameter': '265', 'rpm': '1200', 'power_b': '21.8'}, {'diameter': '265', 'rpm': '1300', 'power_b': '23.2'}, {'diameter': '265', 'rpm': '1400', 'power_b': '24.5'}, {'diameter': '265', 'rpm': '1425', 'power_b': '24.8'}, {'diameter': '265', 'rpm': '1500', 'power_b': '25.7'}, {'diameter': '265', 'rpm': '1600', 'power_b': '26.9'}, {'diameter': '265', 'rpm': '1700', 'power_b': '28'}, {'diameter': '265', 'rpm': '1750', 'power_b': '28.5'}, {'diameter': '265', 'rpm': '1800', 'power_b': '29'}, {'diameter': '265', 'rpm': '1900', 'power_b': '29.9'}, {'diameter': '265', 'rpm': '2000', 'power_b': '30.8'}, {'diameter': '265', 'rpm': '2100', 'power_b': '31.5'}, {'diameter': '265', 'rpm': '2200', 'power_b': '32.2'}, {'diameter': '265', 'rpm': '2300', 'power_b': '32.7'}, {'diameter': '265', 'rpm': '2400', 'power_b': '33.2'}, {'diameter': '265', 'rpm': '2500', 'power_b': '33.6'}, {'diameter': '280', 'rpm': '100', 'power_b': '2.62'}, {'diameter': '280', 'rpm': '200', 'power_b': '4.92'}, {'diameter': '280', 'rpm': '300', 'power_b': '7.1'}, {'diameter': '280', 'rpm': '400', 'power_b': '9.19'}, {'diameter': '280', 'rpm': '435', 'power_b': '9.9'}, {'diameter': '280', 'rpm': '485', 'power_b': '10.9'}, {'diameter': '280', 'rpm': '500', 'power_b': '11.2'}, {'diameter': '280', 'rpm': '575', 'power_b': '12.7'}, {'diameter': '280', 'rpm': '600', 'power_b': '13.1'}, {'diameter': '280', 'rpm': '690', 'power_b': '14.8'}, {'diameter': '280', 'rpm': '700', 'power_b': '15'}, {'diameter': '280', 'rpm': '725', 'power_b': '15.5'}, {'diameter': '280', 'rpm': '800', 'power_b': '16.8'}, {'diameter': '280', 'rpm': '870', 'power_b': '18.1'}, {'diameter': '280', 'rpm': '900', 'power_b': '18.6'}, {'diameter': '280', 'rpm': '950', 'power_b': '19.4'}, {'diameter': '280', 'rpm': '1000', 'power_b': '20.3'}, {'diameter': '280', 'rpm': '1100', 'power_b': '21.9'}, {'diameter': '280', 'rpm': '1160', 'power_b': '22.8'}, {'diameter': '280', 'rpm': '1200', 'power_b': '23.4'}, {'diameter': '280', 'rpm': '1300', 'power_b': '24.9'}, {'diameter': '280', 'rpm': '1400', 'power_b': '26.3'}, {'diameter': '280', 'rpm': '1425', 'power_b': '26.6'}, {'diameter': '280', 'rpm': '1500', 'power_b': '27.6'}, {'diameter': '280', 'rpm': '1600', 'power_b': '28.8'}, {'diameter': '280', 'rpm': '1700', 'power_b': '30'}, {'diameter': '280', 'rpm': '1750', 'power_b': '30.5'}, {'diameter': '280', 'rpm': '1800', 'power_b': '31'}, {'diameter': '280', 'rpm': '1900', 'power_b': '31.9'}, {'diameter': '280', 'rpm': '2000', 'power_b': '32.8'}, {'diameter': '280', 'rpm': '2100', 'power_b': '33.5'}, {'diameter': '280', 'rpm': '2200', 'power_b': '34.2'}, {'diameter': '280', 'rpm': '2300', 'power_b': '34.7'}, {'diameter': '295', 'rpm': '100', 'power_b': '2.8'}, {'diameter': '295', 'rpm': '200', 'power_b': '5.28'}, {'diameter': '295', 'rpm': '300', 'power_b': '7.61'}, {'diameter': '295', 'rpm': '400', 'power_b': '9.85'}, {'diameter': '295', 'rpm': '435', 'power_b': '10.6'}, {'diameter': '295', 'rpm': '485', 'power_b': '11.7'}, {'diameter': '295', 'rpm': '500', 'power_b': '12'}, {'diameter': '295', 'rpm': '575', 'power_b': '13.6'}, {'diameter': '295', 'rpm': '600', 'power_b': '14.1'}, {'diameter': '295', 'rpm': '690', 'power_b': '15.9'}, {'diameter': '295', 'rpm': '700', 'power_b': '16.1'}, {'diameter': '295', 'rpm': '725', 'power_b': '16.6'}, {'diameter': '295', 'rpm': '800', 'power_b': '18'}, {'diameter': '295', 'rpm': '870', 'power_b': '19.4'}, {'diameter': '295', 'rpm': '900', 'power_b': '19.9'}, {'diameter': '295', 'rpm': '950', 'power_b': '20.8'}, {'diameter': '295', 'rpm': '1000', 'power_b': '21.7'}, {'diameter': '295', 'rpm': '1100', 'power_b': '23.4'}, {'diameter': '295', 'rpm': '1160', 'power_b': '24.4'}, {'diameter': '295', 'rpm': '1200', 'power_b': '25.1'}, {'diameter': '295', 'rpm': '1300', 'power_b': '26.6'}, {'diameter': '295', 'rpm': '1400', 'power_b': '28.1'}, {'diameter': '295', 'rpm': '1425', 'power_b': '28.4'}, {'diameter': '295', 'rpm': '1500', 'power_b': '29.4'}, {'diameter': '295', 'rpm': '1600', 'power_b': '30.7'}, {'diameter': '295', 'rpm': '1700', 'power_b': '31.9'}, {'diameter': '295', 'rpm': '1750', 'power_b': '32.4'}, {'diameter': '295', 'rpm': '1800', 'power_b': '32.9'}, {'diameter': '295', 'rpm': '1900', 'power_b': '33.9'}, {'diameter': '295', 'rpm': '2000', 'power_b': '34.7'}, {'diameter': '295', 'rpm': '2100', 'power_b': '35.4'}, {'diameter': '295', 'rpm': '2200', 'power_b': '36'}, {'diameter': '310', 'rpm': '100', 'power_b': '2.99'}, {'diameter': '310', 'rpm': '200', 'power_b': '5.63'}, {'diameter': '310', 'rpm': '300', 'power_b': '8.12'}, {'diameter': '310', 'rpm': '400', 'power_b': '10.5'}, {'diameter': '310', 'rpm': '435', 'power_b': '11.3'}, {'diameter': '310', 'rpm': '485', 'power_b': '12.5'}, {'diameter': '310', 'rpm': '500', 'power_b': '12.8'}, {'diameter': '310', 'rpm': '575', 'power_b': '14.5'}, {'diameter': '310', 'rpm': '600', 'power_b': '15'}, {'diameter': '310', 'rpm': '690', 'power_b': '17'}, {'diameter': '310', 'rpm': '700', 'power_b': '17.2'}, {'diameter': '310', 'rpm': '725', 'power_b': '17.7'}, {'diameter': '310', 'rpm': '800', 'power_b': '19.2'}, {'diameter': '310', 'rpm': '870', 'power_b': '20.6'}, {'diameter': '310', 'rpm': '900', 'power_b': '21.2'}, {'diameter': '310', 'rpm': '950', 'power_b': '22.2'}, {'diameter': '310', 'rpm': '1000', 'power_b': '23.1'}, {'diameter': '310', 'rpm': '1100', 'power_b': '24.9'}, {'diameter': '310', 'rpm': '1160', 'power_b': '26'}, {'diameter': '310', 'rpm': '1200', 'power_b': '26.6'}, {'diameter': '310', 'rpm': '1300', 'power_b': '28.3'}, {'diameter': '310', 'rpm': '1400', 'power_b': '29.8'}, {'diameter': '310', 'rpm': '1425', 'power_b': '30.1'}, {'diameter': '310', 'rpm': '1500', 'power_b': '31.2'}, {'diameter': '310', 'rpm': '1600', 'power_b': '32.5'}, {'diameter': '310', 'rpm': '1700', 'power_b': '33.7'}, {'diameter': '310', 'rpm': '1750', 'power_b': '34.2'}, {'diameter': '310', 'rpm': '1800', 'power_b': '34.7'}, {'diameter': '310', 'rpm': '1900', 'power_b': '35.7'}, {'diameter': '310', 'rpm': '2000', 'power_b': '36.5'}, {'diameter': '310', 'rpm': '2100', 'power_b': '37.1'}, {'diameter': '325', 'rpm': '100', 'power_b': '3.17'}, {'diameter': '325', 'rpm': '200', 'power_b': '5.97'}, {'diameter': '325', 'rpm': '300', 'power_b': '8.63'}, {'diameter': '325', 'rpm': '400', 'power_b': '11.2'}, {'diameter': '325', 'rpm': '435', 'power_b': '12'}, {'diameter': '325', 'rpm': '485', 'power_b': '13.3'}, {'diameter': '325', 'rpm': '500', 'power_b': '13.6'}, {'diameter': '325', 'rpm': '575', 'power_b': '15.4'}, {'diameter': '325', 'rpm': '600', 'power_b': '16'}, {'diameter': '325', 'rpm': '690', 'power_b': '18'}, {'diameter': '325', 'rpm': '700', 'power_b': '18.2'}, {'diameter': '325', 'rpm': '725', 'power_b': '18.8'}, {'diameter': '325', 'rpm': '800', 'power_b': '20.4'}, {'diameter': '325', 'rpm': '870', 'power_b': '21.9'}, {'diameter': '325', 'rpm': '900', 'power_b': '22.5'}, {'diameter': '325', 'rpm': '950', 'power_b': '23.5'}, {'diameter': '325', 'rpm': '1000', 'power_b': '24.5'}, {'diameter': '325', 'rpm': '1100', 'power_b': '26.4'}, {'diameter': '325', 'rpm': '1160', 'power_b': '27.5'}, {'diameter': '325', 'rpm': '1200', 'power_b': '28.2'}, {'diameter': '325', 'rpm': '1300', 'power_b': '29.9'}, {'diameter': '325', 'rpm': '1400', 'power_b': '31.5'}, {'diameter': '325', 'rpm': '1425', 'power_b': '31.8'}, {'diameter': '325', 'rpm': '1500', 'power_b': '32.9'}, {'diameter': '325', 'rpm': '1600', 'power_b': '34.2'}, {'diameter': '325', 'rpm': '1700', 'power_b': '35.4'}, {'diameter': '325', 'rpm': '1750', 'power_b': '36'}, {'diameter': '325', 'rpm': '1800', 'power_b': '36.5'}, {'diameter': '325', 'rpm': '1900', 'power_b': '37.4'}, {'diameter': '325', 'rpm': '2000', 'power_b': '38.1'}, {'diameter': '340', 'rpm': '100', 'power_b': '3.35'}, {'diameter': '340', 'rpm': '200', 'power_b': '6.32'}, {'diameter': '340', 'rpm': '300', 'power_b': '9.13'}, {'diameter': '340', 'rpm': '400', 'power_b': '11.8'}, {'diameter': '340', 'rpm': '435', 'power_b': '12.7'}, {'diameter': '340', 'rpm': '485', 'power_b': '14'}, {'diameter': '340', 'rpm': '500', 'power_b': '14.4'}, {'diameter': '340', 'rpm': '575', 'power_b': '16.3'}, {'diameter': '340', 'rpm': '600', 'power_b': '16.9'}, {'diameter': '340', 'rpm': '690', 'power_b': '19.1'}, {'diameter': '340', 'rpm': '700', 'power_b': '19.3'}, {'diameter': '340', 'rpm': '725', 'power_b': '19.9'}, {'diameter': '340', 'rpm': '800', 'power_b': '21.6'}, {'diameter': '340', 'rpm': '870', 'power_b': '23.1'}, {'diameter': '340', 'rpm': '900', 'power_b': '23.8'}, {'diameter': '340', 'rpm': '950', 'power_b': '24.9'}, {'diameter': '340', 'rpm': '1000', 'power_b': '25.9'}, {'diameter': '340', 'rpm': '1100', 'power_b': '27.9'}, {'diameter': '340', 'rpm': '1160', 'power_b': '29'}, {'diameter': '340', 'rpm': '1200', 'power_b': '29.7'}, {'diameter': '340', 'rpm': '1300', 'power_b': '31.5'}, {'diameter': '340', 'rpm': '1400', 'power_b': '33.1'}, {'diameter': '340', 'rpm': '1425', 'power_b': '33.5'}, {'diameter': '340', 'rpm': '1500', 'power_b': '34.6'}, {'diameter': '340', 'rpm': '1600', 'power_b': '35.9'}, {'diameter': '340', 'rpm': '1700', 'power_b': '37.1'}, {'diameter': '340', 'rpm': '1750', 'power_b': '37.6'}, {'diameter': '340', 'rpm': '1800', 'power_b': '38.1'}, {'diameter': '340', 'rpm': '1900', 'power_b': '38.9'}, {'diameter': '355', 'rpm': '100', 'power_b': '3.54'}, {'diameter': '355', 'rpm': '200', 'power_b': '6.67'}, {'diameter': '355', 'rpm': '300', 'power_b': '9.63'}, {'diameter': '355', 'rpm': '400', 'power_b': '12.5'}, {'diameter': '355', 'rpm': '435', 'power_b': '13.4'}, {'diameter': '355', 'rpm': '485', 'power_b': '14.8'}, {'diameter': '355', 'rpm': '500', 'power_b': '15.2'}, {'diameter': '355', 'rpm': '575', 'power_b': '17.2'}, {'diameter': '355', 'rpm': '600', 'power_b': '17.8'}, {'diameter': '355', 'rpm': '690', 'power_b': '20.1'}, {'diameter': '355', 'rpm': '700', 'power_b': '20.3'}, {'diameter': '355', 'rpm': '725', 'power_b': '21'}, {'diameter': '355', 'rpm': '800', 'power_b': '22.8'}, {'diameter': '355', 'rpm': '870', 'power_b': '24.4'}, {'diameter': '355', 'rpm': '900', 'power_b': '25.1'}, {'diameter': '355', 'rpm': '950', 'power_b': '26.2'}, {'diameter': '355', 'rpm': '1000', 'power_b': '27.2'}, {'diameter': '355', 'rpm': '1100', 'power_b': '19.3'}, {'diameter': '355', 'rpm': '1160', 'power_b': '30.5'}, {'diameter': '355', 'rpm': '1200', 'power_b': '31.2'}, {'diameter': '355', 'rpm': '1300', 'power_b': '33'}, {'diameter': '355', 'rpm': '1400', 'power_b': '34.7'}, {'diameter': '355', 'rpm': '1425', 'power_b': '35'}, {'diameter': '355', 'rpm': '1500', 'power_b': '36.1'}, {'diameter': '355', 'rpm': '1600', 'power_b': '37.5'}, {'diameter': '355', 'rpm': '1700', 'power_b': '38.6'}, {'diameter': '355', 'rpm': '1750', 'power_b': '39.1'}, {'diameter': '355', 'rpm': '1800', 'power_b': '39.6'}, {'diameter': '370', 'rpm': '100', 'power_b': '3.72'}, {'diameter': '370', 'rpm': '200', 'power_b': '7.01'}, {'diameter': '370', 'rpm': '300', 'power_b': '10.1'}, {'diameter': '370', 'rpm': '400', 'power_b': '13.1'}, {'diameter': '370', 'rpm': '435', 'power_b': '14.1'}, {'diameter': '370', 'rpm': '485', 'power_b': '15.6'}, {'diameter': '370', 'rpm': '500', 'power_b': '16'}, {'diameter': '370', 'rpm': '575', 'power_b': '18.1'}, {'diameter': '370', 'rpm': '600', 'power_b': '18.7'}, {'diameter': '370', 'rpm': '690', 'power_b': '21.1'}, {'diameter': '370', 'rpm': '700', 'power_b': '21.4'}, {'diameter': '370', 'rpm': '725', 'power_b': '22'}, {'diameter': '370', 'rpm': '800', 'power_b': '13.9'}, {'diameter': '370', 'rpm': '870', 'power_b': '25.6'}, {'diameter': '370', 'rpm': '900', 'power_b': '16.3'}, {'diameter': '370', 'rpm': '950', 'power_b': '27.5'}, {'diameter': '370', 'rpm': '1000', 'power_b': '18.6'}, {'diameter': '370', 'rpm': '1100', 'power_b': '30.7'}, {'diameter': '370', 'rpm': '1160', 'power_b': '31.9'}, {'diameter': '370', 'rpm': '1200', 'power_b': '32.7'}, {'diameter': '370', 'rpm': '1300', 'power_b': '34.5'}, {'diameter': '370', 'rpm': '1400', 'power_b': '36.2'}, {'diameter': '370', 'rpm': '1425', 'power_b': '26.6'}, {'diameter': '370', 'rpm': '1500', 'power_b': '37.7'}, {'diameter': '370', 'rpm': '1600', 'power_b': '39'}, {'diameter': '370', 'rpm': '1700', 'power_b': '40.1'}, {'diameter': '370', 'rpm': '1750', 'power_b': '40.6'}, {'diameter': '370', 'rpm': '1800', 'power_b': '41'}, {'diameter': '385', 'rpm': '100', 'power_b': '3.9'}, {'diameter': '385', 'rpm': '200', 'power_b': '7.36'}, {'diameter': '385', 'rpm': '300', 'power_b': '10.6'}, {'diameter': '385', 'rpm': '400', 'power_b': '13.8'}, {'diameter': '385', 'rpm': '435', 'power_b': '14.8'}, {'diameter': '385', 'rpm': '485', 'power_b': '16.3'}, {'diameter': '385', 'rpm': '500', 'power_b': '16.8'}, {'diameter': '385', 'rpm': '575', 'power_b': '18.9'}, {'diameter': '385', 'rpm': '600', 'power_b': '19.7'}, {'diameter': '385', 'rpm': '690', 'power_b': '22.1'}, {'diameter': '385', 'rpm': '700', 'power_b': '22.4'}, {'diameter': '385', 'rpm': '725', 'power_b': '23.1'}, {'diameter': '385', 'rpm': '800', 'power_b': '25'}, {'diameter': '385', 'rpm': '870', 'power_b': '26.8'}, {'diameter': '385', 'rpm': '900', 'power_b': '27.5'}, {'diameter': '385', 'rpm': '950', 'power_b': '28.7'}, {'diameter': '385', 'rpm': '1000', 'power_b': '29.9'}, {'diameter': '385', 'rpm': '1100', 'power_b': '32.1'}, {'diameter': '385', 'rpm': '1160', 'power_b': '33.3'}, {'diameter': '385', 'rpm': '1200', 'power_b': '34.1'}, {'diameter': '385', 'rpm': '1300', 'power_b': '36'}, {'diameter': '385', 'rpm': '1400', 'power_b': '37.6'}, {'diameter': '385', 'rpm': '1425', 'power_b': '38'}, {'diameter': '385', 'rpm': '1500', 'power_b': '39.1'}, {'diameter': '385', 'rpm': '1600', 'power_b': '40.4'}, {'diameter': '385', 'rpm': '1700', 'power_b': '41.5'}, {'diameter': '400', 'rpm': '100', 'power_b': '4.08'}, {'diameter': '400', 'rpm': '200', 'power_b': '7.7'}, {'diameter': '400', 'rpm': '300', 'power_b': '11.1'}, {'diameter': '400', 'rpm': '400', 'power_b': '14.4'}, {'diameter': '400', 'rpm': '435', 'power_b': '15.5'}, {'diameter': '400', 'rpm': '485', 'power_b': '17.1'}, {'diameter': '400', 'rpm': '500', 'power_b': '17.5'}, {'diameter': '400', 'rpm': '575', 'power_b': '19.8'}, {'diameter': '400', 'rpm': '600', 'power_b': '20.6'}, {'diameter': '400', 'rpm': '690', 'power_b': '23.1'}, {'diameter': '400', 'rpm': '700', 'power_b': '23.4'}, {'diameter': '400', 'rpm': '725', 'power_b': '24.1'}, {'diameter': '400', 'rpm': '800', 'power_b': '26.2'}, {'diameter': '400', 'rpm': '870', 'power_b': '28'}, {'diameter': '400', 'rpm': '900', 'power_b': '28.7'}, {'diameter': '400', 'rpm': '950', 'power_b': '30'}, {'diameter': '400', 'rpm': '1000', 'power_b': '32.2'}, {'diameter': '400', 'rpm': '1100', 'power_b': '33.4'}, {'diameter': '400', 'rpm': '1160', 'power_b': '34.7'}, {'diameter': '400', 'rpm': '1200', 'power_b': '35.5'}, {'diameter': '400', 'rpm': '1300', 'power_b': '37.4'}, {'diameter': '400', 'rpm': '1400', 'power_b': '39'}, {'diameter': '400', 'rpm': '1425', 'power_b': '39.4'}, {'diameter': '400', 'rpm': '1500', 'power_b': '40.5'}, {'diameter': '400', 'rpm': '1600', 'power_b': '41.7'})

SuperHC_8v_pa = ({'gr_low': '1', 'gr_high': '1.02', 'rpm': '50', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '100', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '150', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '200', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '250', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '300', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '350', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '400', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '435', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '450', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '485', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '500', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '550', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '575', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '600', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '650', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '690', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '700', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '725', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '750', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '800', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '850', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '870', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '900', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '950', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '950', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1000', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1050', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1100', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1150', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1160', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1200', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1250', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1300', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1350', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1400', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1425', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1450', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1500', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1550', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1600', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1650', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1700', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1750', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1750', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1800', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1850', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1900', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '1950', 'power_a': '0'}, {'gr_low': '1', 'gr_high': '1.02', 'rpm': '2000', 'power_a': '0'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '50', 'power_a': '0.02'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '100', 'power_a': '0.05'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '150', 'power_a': '0.07'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '200', 'power_a': '0.1'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '250', 'power_a': '0.12'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '300', 'power_a': '0.14'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '350', 'power_a': '0.17'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '400', 'power_a': '0.19'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '435', 'power_a': '0.21'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '450', 'power_a': '0.21'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '485', 'power_a': '0.23'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '500', 'power_a': '0.24'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '550', 'power_a': '0.26'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '575', 'power_a': '0.27'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '600', 'power_a': '0.29'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '650', 'power_a': '0.31'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '690', 'power_a': '0.33'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '700', 'power_a': '0.33'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '725', 'power_a': '0.34'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '750', 'power_a': '0.36'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '800', 'power_a': '0.38'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '850', 'power_a': '0.4'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '870', 'power_a': '0.41'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '900', 'power_a': '0.43'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '950', 'power_a': '0.45'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '950', 'power_a': '0.45'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '1000', 'power_a': '0.48'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '1050', 'power_a': '0.5'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '1100', 'power_a': '0.52'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '1150', 'power_a': '0.55'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '1160', 'power_a': '0.55'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '1200', 'power_a': '0.57'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '1250', 'power_a': '0.59'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '1300', 'power_a': '0.62'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '1350', 'power_a': '0.64'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '1400', 'power_a': '0.67'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '1425', 'power_a': '0.68'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '1450', 'power_a': '0.69'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '1500', 'power_a': '0.71'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '1550', 'power_a': '0.74'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '1600', 'power_a': '0.76'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '1650', 'power_a': '0.78'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '1700', 'power_a': '0.81'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '1750', 'power_a': '0.83'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '1750', 'power_a': '0.83'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '1800', 'power_a': '0.86'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '1850', 'power_a': '0.88'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '1900', 'power_a': '0.9'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '1950', 'power_a': '0.93'}, {'gr_low': '1.02', 'gr_high': '1.06', 'rpm': '2000', 'power_a': '0.95'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '50', 'power_a': '0.06'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '100', 'power_a': '0.13'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '150', 'power_a': '0.19'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '200', 'power_a': '0.26'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '250', 'power_a': '0.32'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '300', 'power_a': '0.39'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '350', 'power_a': '0.45'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '400', 'power_a': '0.52'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '435', 'power_a': '0.56'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '450', 'power_a': '0.58'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '485', 'power_a': '0.63'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '500', 'power_a': '0.65'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '550', 'power_a': '0.71'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '575', 'power_a': '0.74'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '600', 'power_a': '0.78'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '650', 'power_a': '0.84'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '690', 'power_a': '0.89'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '700', 'power_a': '0.91'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '725', 'power_a': '0.94'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '750', 'power_a': '0.97'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '800', 'power_a': '1.04'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '850', 'power_a': '1.1'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '870', 'power_a': '1.13'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '900', 'power_a': '1.17'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '950', 'power_a': '1.23'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '950', 'power_a': '1.23'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '1000', 'power_a': '1.3'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '1050', 'power_a': '1.36'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '1100', 'power_a': '1.43'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '1150', 'power_a': '1.49'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '1160', 'power_a': '1.5'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '1200', 'power_a': '1.55'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '1250', 'power_a': '1.62'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '1300', 'power_a': '1.68'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '1350', 'power_a': '1.75'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '1400', 'power_a': '1.81'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '1425', 'power_a': '1.85'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '1450', 'power_a': '1.88'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '1500', 'power_a': '1.94'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '1550', 'power_a': '2.01'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '1600', 'power_a': '2.07'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '1650', 'power_a': '2.14'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '1700', 'power_a': '2.2'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '1750', 'power_a': '2.27'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '1750', 'power_a': '2.27'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '1800', 'power_a': '2.33'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '1850', 'power_a': '2.4'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '1900', 'power_a': '2.46'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '1950', 'power_a': '2.53'}, {'gr_low': '1.06', 'gr_high': '1.12', 'rpm': '2000', 'power_a': '2.59'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '50', 'power_a': '0.11'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '100', 'power_a': '0.23'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '150', 'power_a': '0.34'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '200', 'power_a': '0.45'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '250', 'power_a': '0.56'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '300', 'power_a': '0.68'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '350', 'power_a': '0.79'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '400', 'power_a': '0.9'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '435', 'power_a': '0.98'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '450', 'power_a': '1.02'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '485', 'power_a': '1.1'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '500', 'power_a': '1.13'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '550', 'power_a': '1.24'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '575', 'power_a': '1.3'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '600', 'power_a': '1.35'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '650', 'power_a': '1.47'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '690', 'power_a': '1.56'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '700', 'power_a': '1.58'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '725', 'power_a': '1.64'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '750', 'power_a': '1.69'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '800', 'power_a': '1.81'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '850', 'power_a': '1.92'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '870', 'power_a': '1.96'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '900', 'power_a': '2.03'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '950', 'power_a': '2.15'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '950', 'power_a': '2.15'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '1000', 'power_a': '2.26'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '1050', 'power_a': '2.37'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '1100', 'power_a': '2.48'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '1150', 'power_a': '2.6'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '1160', 'power_a': '2.62'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '1200', 'power_a': '2.71'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '1250', 'power_a': '2.82'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '1300', 'power_a': '2.94'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '1350', 'power_a': '3.05'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '1400', 'power_a': '3.16'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '1425', 'power_a': '3.22'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '1450', 'power_a': '3.27'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '1500', 'power_a': '3.39'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '1550', 'power_a': '3.5'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '1600', 'power_a': '3.61'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '1650', 'power_a': '3.79'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '1700', 'power_a': '3.84'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '1750', 'power_a': '3.95'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '1750', 'power_a': '3.95'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '1800', 'power_a': '4.06'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '1850', 'power_a': '4.18'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '1900', 'power_a': '4.29'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '1950', 'power_a': '4.4'}, {'gr_low': '1.12', 'gr_high': '1.19', 'rpm': '2000', 'power_a': '4.52'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '50', 'power_a': '0.15'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '100', 'power_a': '0.31'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '150', 'power_a': '0.46'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '200', 'power_a': '0.61'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '250', 'power_a': '0.77'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '300', 'power_a': '0.92'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '350', 'power_a': '1.08'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '400', 'power_a': '1.23'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '435', 'power_a': '1.34'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '450', 'power_a': '1.38'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '485', 'power_a': '1.49'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '500', 'power_a': '1.54'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '550', 'power_a': '1.69'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '575', 'power_a': '1.77'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '600', 'power_a': '1.84'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '650', 'power_a': '2'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '690', 'power_a': '2.12'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '700', 'power_a': '2.15'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '725', 'power_a': '2.23'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '750', 'power_a': '2.31'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '800', 'power_a': '2.46'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '850', 'power_a': '2.61'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '870', 'power_a': '2.67'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '900', 'power_a': '2.77'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '950', 'power_a': '2.92'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '950', 'power_a': '2.92'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '1000', 'power_a': '3.07'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '1050', 'power_a': '3.23'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '1100', 'power_a': '3.38'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '1150', 'power_a': '3.53'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '1160', 'power_a': '3.57'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '1200', 'power_a': '3.69'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '1250', 'power_a': '3.84'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '1300', 'power_a': '4'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '1350', 'power_a': '4.15'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '1400', 'power_a': '4.3'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '1425', 'power_a': '4.38'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '1450', 'power_a': '4.46'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '1500', 'power_a': '4.61'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '1550', 'power_a': '4.76'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '1600', 'power_a': '4.92'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '1650', 'power_a': '5.07'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '1700', 'power_a': '5.23'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '1750', 'power_a': '5.38'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '1750', 'power_a': '5.38'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '1800', 'power_a': '5.53'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '1850', 'power_a': '5.69'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '1900', 'power_a': '5.84'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '1950', 'power_a': '5.99'}, {'gr_low': '1.19', 'gr_high': '1.27', 'rpm': '2000', 'power_a': '6.15'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '50', 'power_a': '0.19'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '100', 'power_a': '0.37'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '150', 'power_a': '0.56'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '200', 'power_a': '0.75'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '250', 'power_a': '0.93'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '300', 'power_a': '1.12'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '350', 'power_a': '1.3'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '400', 'power_a': '1.49'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '435', 'power_a': '1.62'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '450', 'power_a': '1.68'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '485', 'power_a': '1.81'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '500', 'power_a': '1.86'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '550', 'power_a': '2.05'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '575', 'power_a': '2.14'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '600', 'power_a': '2.24'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '650', 'power_a': '2.42'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '690', 'power_a': '2.57'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '700', 'power_a': '2.61'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '725', 'power_a': '2.7'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '750', 'power_a': '2.79'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '800', 'power_a': '2.98'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '850', 'power_a': '3.17'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '870', 'power_a': '3.24'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '900', 'power_a': '3.35'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '950', 'power_a': '3.54'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '950', 'power_a': '3.54'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '1000', 'power_a': '3.73'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '1050', 'power_a': '3.91'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '1100', 'power_a': '4.1'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '1150', 'power_a': '4.28'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '1160', 'power_a': '4.32'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '1200', 'power_a': '4.47'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '1250', 'power_a': '4.66'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '1300', 'power_a': '4.84'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '1350', 'power_a': '5.03'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '1400', 'power_a': '5.22'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '1425', 'power_a': '5.31'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '1450', 'power_a': '5.4'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '1500', 'power_a': '5.59'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '1550', 'power_a': '5.77'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '1600', 'power_a': '5.96'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '1650', 'power_a': '6.15'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '1700', 'power_a': '6.33'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '1750', 'power_a': '6.52'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '1750', 'power_a': '6.52'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '1800', 'power_a': '6.71'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '1850', 'power_a': '6.89'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '1900', 'power_a': '7.08'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '1950', 'power_a': '7.26'}, {'gr_low': '1.27', 'gr_high': '1.39', 'rpm': '2000', 'power_a': '7.45'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '50', 'power_a': '0.22'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '100', 'power_a': '0.44'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '150', 'power_a': '0.65'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '200', 'power_a': '0.87'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '250', 'power_a': '1.09'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '300', 'power_a': '1.31'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '350', 'power_a': '1.53'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '400', 'power_a': '1.75'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '435', 'power_a': '1.9'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '450', 'power_a': '1.96'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '485', 'power_a': '2.12'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '500', 'power_a': '2.18'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '550', 'power_a': '2.4'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '575', 'power_a': '2.51'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '600', 'power_a': '2.62'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '650', 'power_a': '2.84'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '690', 'power_a': '3.01'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '700', 'power_a': '3.05'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '725', 'power_a': '3.16'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '750', 'power_a': '3.27'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '800', 'power_a': '3.49'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '850', 'power_a': '3.71'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '870', 'power_a': '3.8'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '900', 'power_a': '3.93'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '950', 'power_a': '4.14'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '950', 'power_a': '4.14'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '1000', 'power_a': '4.36'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '1050', 'power_a': '4.58'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '1100', 'power_a': '4.8'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '1150', 'power_a': '5.02'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '1160', 'power_a': '5.06'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '1200', 'power_a': '5.24'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '1250', 'power_a': '5.45'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '1300', 'power_a': '5.67'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '1350', 'power_a': '5.89'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '1400', 'power_a': '6.11'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '1425', 'power_a': '6.22'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '1450', 'power_a': '6.33'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '1500', 'power_a': '6.54'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '1550', 'power_a': '6.76'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '1600', 'power_a': '6.98'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '1650', 'power_a': '7.2'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '1700', 'power_a': '7.42'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '1750', 'power_a': '7.63'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '1750', 'power_a': '7.63'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '1800', 'power_a': '7.85'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '1850', 'power_a': '8.07'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '1900', 'power_a': '8.29'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '1950', 'power_a': '8.51'}, {'gr_low': '1.39', 'gr_high': '1.58', 'rpm': '2000', 'power_a': '8.73'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '50', 'power_a': '0.25'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '100', 'power_a': '0.49'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '150', 'power_a': '0.74'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '200', 'power_a': '0.98'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '250', 'power_a': '1.23'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '300', 'power_a': '1.47'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '350', 'power_a': '1.72'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '400', 'power_a': '1.96'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '435', 'power_a': '2.14'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '450', 'power_a': '2.21'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '485', 'power_a': '2.38'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '500', 'power_a': '2.46'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '550', 'power_a': '2.7'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '575', 'power_a': '2.82'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '600', 'power_a': '2.95'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '650', 'power_a': '3.19'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '690', 'power_a': '3.39'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '700', 'power_a': '3.44'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '725', 'power_a': '3.56'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '750', 'power_a': '3.68'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '800', 'power_a': '3.93'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '850', 'power_a': '4.17'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '870', 'power_a': '4.27'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '900', 'power_a': '4.42'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '950', 'power_a': '4.66'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '950', 'power_a': '4.66'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '1000', 'power_a': '4.91'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '1050', 'power_a': '5.16'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '1100', 'power_a': '5.4'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '1150', 'power_a': '5.65'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '1160', 'power_a': '5.7'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '1200', 'power_a': '5.89'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '1250', 'power_a': '6.14'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '1300', 'power_a': '6.38'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '1350', 'power_a': '6.63'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '1400', 'power_a': '6.87'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '1425', 'power_a': '7'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '1450', 'power_a': '7.12'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '1500', 'power_a': '7.37'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '1550', 'power_a': '7.61'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '1600', 'power_a': '7.86'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '1650', 'power_a': '8.1'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '1700', 'power_a': '8.35'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '1750', 'power_a': '8.59'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '1750', 'power_a': '8.59'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '1800', 'power_a': '8.84'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '1850', 'power_a': '9.08'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '1900', 'power_a': '9.33'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '1950', 'power_a': '9.57'}, {'gr_low': '1.58', 'gr_high': '1.95', 'rpm': '2000', 'power_a': '9.82'}, {'gr_low': '1.95', 'gr_high': '3.39', 'rpm': '50', 'power_a': '0.27'}, {'gr_low': '1.95', 'gr_high': '3.39', 'rpm': '100', 'power_a': '0.53'}, {'gr_low': '1.95', 'gr_high': '3.39', 'rpm': '150', 'power_a': '0.8'}, {'gr_low': '1.95', 'gr_high': '3.39', 'rpm': '200', 'power_a': '1.07'}, {'gr_low': '1.95', 'gr_high': '3.39', 'rpm': '250', 'power_a': '1.34'}, {'gr_low': '1.95', 'gr_high': '3.39', 'rpm': '300', 'power_a': '1.6'}, {'gr_low': '1.95', 'gr_high': '3.39', 'rpm': '350', 'power_a': '1.87'}, {'gr_low': '1.95', 'gr_high': '3.39', 'rpm': '400', 'power_a': '2.14'}, {'gr_low': '1.95', 'gr_high': '3.39', 'rpm': '435', 'power_a': '2.33'}, {'gr_low': '1.95', 'gr_high': '3.39', 'rpm': '450', 'power_a': '2.41'}, {'gr_low': '1.95', 'gr_high': '3.39', 'rpm': '485', 'power_a': '2.59'}, {'gr_low': '1.95', 'gr_high': '3.39', 'rpm': '500', 'power_a': '2.67'}, {'gr_low': '1.95', 'gr_high': '3.39', 'rpm': '550', 'power_a': '2.94'}, {'gr_low': '1.95', 'gr_high': '3.39', 'rpm': '575', 'power_a': '3.08'}, {'gr_low': '1.95', 'gr_high': '3.39', 'rpm': '600', 'power_a': '3.21'}, {'gr_low': '1.95', 'gr_high': '3.39', 'rpm': '650', 'power_a': '3.48'}, {'gr_low': '1.95', 'gr_high': '3.39', 'rpm': '690', 'power_a': '3.69'}, {'gr_low': '1.95', 'gr_high': '3.39', 'rpm': '700', 'power_a': '3.74'}, {'gr_low': '1.95', 'gr_high': '3.39', 'rpm': '725', 'power_a': '3.88'}, {'gr_low': '1.95', 'gr_high': '3.39', 'rpm': '750', 'power_a': '4.01'}, {'gr_low': '1.95', 'gr_high': '3.39', 'rpm': '800', 'power_a': '4.28'}, {'gr_low': '1.95', 'gr_high': '3.39', 'rpm': '850', 'power_a': '4.55'}, {'gr_low': '1.95', 'gr_high': '3.39', 'rpm': '870', 'power_a': '4.65'}, {'gr_low': '1.95', 'gr_high': '3.39', 'rpm': '900', 'power_a': '4.81'}, {'gr_low': '1.95', 'gr_high': '3.39', 'rpm': '950', 'power_a': '5.08'}, {'gr_low': '1.95', 'gr_high': '3.39', 'rpm': '950', 'power_a': '5.08'}, {'gr_low': '1.95', 'gr_high': '3.39', 'rpm': '1000', 'power_a': '5.35'}, {'gr_low': '1.95', 'gr_high': '3.39', 'rpm': '1050', 'power_a': '5.62'}, {'gr_low': '1.95', 'gr_high': '3.39', 'rpm': '1100', 'power_a': '5.88'}, {'gr_low': '1.95', 'gr_high': '3.39', 'rpm': '1150', 'power_a': '6.15'}, {'gr_low': '1.95', 'gr_high': '3.39', 'rpm': '1160', 'power_a': '6.2'}, {'gr_low': '1.95', 'gr_high': '3.39', 'rpm': '1200', 'power_a': '6.42'}, {'gr_low': '1.95', 'gr_high': '3.39', 'rpm': '1250', 'power_a': '6.69'}, {'gr_low': '1.95', 'gr_high': '3.39', 'rpm': '1300', 'power_a': '6.95'}, {'gr_low': '1.95', 'gr_high': '3.39', 'rpm': '1350', 'power_a': '7.22'}, {'gr_low': '1.95', 'gr_high': '3.39', 'rpm': '1400', 'power_a': '7.49'}, {'gr_low': '1.95', 'gr_high': '3.39', 'rpm': '1425', 'power_a': '7.62'}, {'gr_low': '1.95', 'gr_high': '3.39', 'rpm': '1450', 'power_a': '7.76'}, {'gr_low': '1.95', 'gr_high': '3.39', 'rpm': '1500', 'power_a': '8.02'}, {'gr_low': '1.95', 'gr_high': '3.39', 'rpm': '1550', 'power_a': '8.29'}, {'gr_low': '1.95', 'gr_high': '3.39', 'rpm': '1600', 'power_a': '8.56'}, {'gr_low': '1.95', 'gr_high': '3.39', 'rpm': '1650', 'power_a': '8.83'}, {'gr_low': '1.95', 'gr_high': '3.39', 'rpm': '1700', 'power_a': '9.09'}, {'gr_low': '1.95', 'gr_high': '3.39', 'rpm': '1750', 'power_a': '9.36'}, {'gr_low': '1.95', 'gr_high': '3.39', 'rpm': '1750', 'power_a': '9.36'}, {'gr_low': '1.95', 'gr_high': '3.39', 'rpm': '1800', 'power_a': '9.63'}, {'gr_low': '1.95', 'gr_high': '3.39', 'rpm': '1850', 'power_a': '9.9'}, {'gr_low': '1.95', 'gr_high': '3.39', 'rpm': '1900', 'power_a': '10.16'}, {'gr_low': '1.95', 'gr_high': '3.39', 'rpm': '1950', 'power_a': '10.43'}, {'gr_low': '1.95', 'gr_high': '3.39', 'rpm': '2000', 'power_a': '10.7'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '50', 'power_a': '0.28'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '100', 'power_a': '0.57'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '150', 'power_a': '0.85'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '200', 'power_a': '1.13'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '250', 'power_a': '1.42'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '300', 'power_a': '1.7'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '350', 'power_a': '1.98'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '400', 'power_a': '2.27'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '435', 'power_a': '2.46'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '450', 'power_a': '2.55'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '485', 'power_a': '2.75'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '500', 'power_a': '2.83'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '550', 'power_a': '3.12'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '575', 'power_a': '3.26'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '600', 'power_a': '3.4'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '650', 'power_a': '3.68'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '690', 'power_a': '3.91'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '700', 'power_a': '3.97'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '725', 'power_a': '4.11'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '750', 'power_a': '4.25'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '800', 'power_a': '4.53'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '850', 'power_a': '4.82'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '870', 'power_a': '4.93'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '900', 'power_a': '5.1'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '950', 'power_a': '5.38'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '950', 'power_a': '5.38'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '1000', 'power_a': '5.67'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '1050', 'power_a': '5.95'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '1100', 'power_a': '6.23'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '1150', 'power_a': '6.52'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '1160', 'power_a': '6.57'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '1200', 'power_a': '6.8'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '1250', 'power_a': '7.08'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '1300', 'power_a': '7.37'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '1350', 'power_a': '7.65'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '1400', 'power_a': '7.93'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '1425', 'power_a': '8.07'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '1450', 'power_a': '8.22'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '1500', 'power_a': '8.5'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '1550', 'power_a': '8.78'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '1600', 'power_a': '9.07'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '1650', 'power_a': '9.35'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '1700', 'power_a': '9.63'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '1750', 'power_a': '9.92'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '1750', 'power_a': '9.92'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '1800', 'power_a': '10.2'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '1850', 'power_a': '10.48'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '1900', 'power_a': '10.76'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '1950', 'power_a': '11.05'}, {'gr_low': '3.39', 'gr_high': '10', 'rpm': '2000', 'power_a': '11.33'})

SuperHC_8v_pb = ({'diameter': '320', 'rpm': '50', 'power_b': '3.09'}, {'diameter': '320', 'rpm': '100', 'power_b': '5.74'}, {'diameter': '320', 'rpm': '150', 'power_b': '8.21'}, {'diameter': '320', 'rpm': '200', 'power_b': '10.6'}, {'diameter': '320', 'rpm': '250', 'power_b': '12.8'}, {'diameter': '320', 'rpm': '300', 'power_b': '15'}, {'diameter': '320', 'rpm': '350', 'power_b': '17.2'}, {'diameter': '320', 'rpm': '400', 'power_b': '19.2'}, {'diameter': '320', 'rpm': '435', 'power_b': '20.6'}, {'diameter': '320', 'rpm': '450', 'power_b': '21.2'}, {'diameter': '320', 'rpm': '485', 'power_b': '22.6'}, {'diameter': '320', 'rpm': '500', 'power_b': '23.2'}, {'diameter': '320', 'rpm': '550', 'power_b': '25.1'}, {'diameter': '320', 'rpm': '575', 'power_b': '26'}, {'diameter': '320', 'rpm': '600', 'power_b': '26.9'}, {'diameter': '320', 'rpm': '650', 'power_b': '28.7'}, {'diameter': '320', 'rpm': '690', 'power_b': '30.1'}, {'diameter': '320', 'rpm': '700', 'power_b': '30.5'}, {'diameter': '320', 'rpm': '725', 'power_b': '31.3'}, {'diameter': '320', 'rpm': '750', 'power_b': '32.1'}, {'diameter': '320', 'rpm': '800', 'power_b': '33.8'}, {'diameter': '320', 'rpm': '850', 'power_b': '35.3'}, {'diameter': '320', 'rpm': '870', 'power_b': '35.9'}, {'diameter': '320', 'rpm': '900', 'power_b': '36.8'}, {'diameter': '320', 'rpm': '950', 'power_b': '38.3'}, {'diameter': '320', 'rpm': '950', 'power_b': '38.3'}, {'diameter': '320', 'rpm': '1000', 'power_b': '39.7'}, {'diameter': '320', 'rpm': '1050', 'power_b': '41'}, {'diameter': '320', 'rpm': '1100', 'power_b': '42.3'}, {'diameter': '320', 'rpm': '1150', 'power_b': '43.5'}, {'diameter': '320', 'rpm': '1160', 'power_b': '43.7'}, {'diameter': '320', 'rpm': '1200', 'power_b': '44.6'}, {'diameter': '320', 'rpm': '1250', 'power_b': '45.7'}, {'diameter': '320', 'rpm': '1300', 'power_b': '46.7'}, {'diameter': '320', 'rpm': '1350', 'power_b': '47.6'}, {'diameter': '320', 'rpm': '1400', 'power_b': '48.5'}, {'diameter': '320', 'rpm': '1425', 'power_b': '48.9'}, {'diameter': '320', 'rpm': '1450', 'power_b': '49.2'}, {'diameter': '320', 'rpm': '1500', 'power_b': '49.9'}, {'diameter': '320', 'rpm': '1550', 'power_b': '50.6'}, {'diameter': '320', 'rpm': '1600', 'power_b': '51.1'}, {'diameter': '320', 'rpm': '1650', 'power_b': '51.5'}, {'diameter': '320', 'rpm': '1700', 'power_b': '51.9'}, {'diameter': '320', 'rpm': '1750', 'power_b': '52.2'}, {'diameter': '320', 'rpm': '1750', 'power_b': '52.2'}, {'diameter': '320', 'rpm': '1800', 'power_b': '52.4'}, {'diameter': '320', 'rpm': '1850', 'power_b': '52.5'}, {'diameter': '320', 'rpm': '1900', 'power_b': '52.5'}, {'diameter': '320', 'rpm': '1950', 'power_b': '52.4'}, {'diameter': '320', 'rpm': '2000', 'power_b': '52.2'}, {'diameter': '340', 'rpm': '50', 'power_b': '3.42'}, {'diameter': '340', 'rpm': '100', 'power_b': '6.38'}, {'diameter': '340', 'rpm': '150', 'power_b': '9.15'}, {'diameter': '340', 'rpm': '200', 'power_b': '11.8'}, {'diameter': '340', 'rpm': '250', 'power_b': '14.3'}, {'diameter': '340', 'rpm': '300', 'power_b': '16.8'}, {'diameter': '340', 'rpm': '350', 'power_b': '19.2'}, {'diameter': '340', 'rpm': '400', 'power_b': '21.5'}, {'diameter': '340', 'rpm': '435', 'power_b': '23.1'}, {'diameter': '340', 'rpm': '450', 'power_b': '23.8'}, {'diameter': '340', 'rpm': '485', 'power_b': '25.3'}, {'diameter': '340', 'rpm': '500', 'power_b': '26'}, {'diameter': '340', 'rpm': '550', 'power_b': '28.1'}, {'diameter': '340', 'rpm': '575', 'power_b': '29.2'}, {'diameter': '340', 'rpm': '600', 'power_b': '30.2'}, {'diameter': '340', 'rpm': '650', 'power_b': '32.2'}, {'diameter': '340', 'rpm': '690', 'power_b': '33.8'}, {'diameter': '340', 'rpm': '700', 'power_b': '34.2'}, {'diameter': '340', 'rpm': '725', 'power_b': '35.1'}, {'diameter': '340', 'rpm': '750', 'power_b': '36.1'}, {'diameter': '340', 'rpm': '800', 'power_b': '37.9'}, {'diameter': '340', 'rpm': '850', 'power_b': '39.7'}, {'diameter': '340', 'rpm': '870', 'power_b': '40.3'}, {'diameter': '340', 'rpm': '900', 'power_b': '41.4'}, {'diameter': '340', 'rpm': '950', 'power_b': '43'}, {'diameter': '340', 'rpm': '950', 'power_b': '43'}, {'diameter': '340', 'rpm': '1000', 'power_b': '44.5'}, {'diameter': '340', 'rpm': '1050', 'power_b': '46'}, {'diameter': '340', 'rpm': '1100', 'power_b': '47.4'}, {'diameter': '340', 'rpm': '1150', 'power_b': '48.8'}, {'diameter': '340', 'rpm': '1160', 'power_b': '49'}, {'diameter': '340', 'rpm': '1200', 'power_b': '50'}, {'diameter': '340', 'rpm': '1250', 'power_b': '51.2'}, {'diameter': '340', 'rpm': '1300', 'power_b': '52.3'}, {'diameter': '340', 'rpm': '1350', 'power_b': '53.3'}, {'diameter': '340', 'rpm': '1400', 'power_b': '54.2'}, {'diameter': '340', 'rpm': '1425', 'power_b': '54.7'}, {'diameter': '340', 'rpm': '1450', 'power_b': '55.1'}, {'diameter': '340', 'rpm': '1500', 'power_b': '55.8'}, {'diameter': '340', 'rpm': '1550', 'power_b': '56.5'}, {'diameter': '340', 'rpm': '1600', 'power_b': '57'}, {'diameter': '340', 'rpm': '1650', 'power_b': '57.5'}, {'diameter': '340', 'rpm': '1700', 'power_b': '57.8'}, {'diameter': '340', 'rpm': '1750', 'power_b': '58.1'}, {'diameter': '340', 'rpm': '1750', 'power_b': '58.1'}, {'diameter': '340', 'rpm': '1800', 'power_b': '58.2'}, {'diameter': '340', 'rpm': '1850', 'power_b': '58.2'}, {'diameter': '340', 'rpm': '1900', 'power_b': '58.2'}, {'diameter': '340', 'rpm': '1950', 'power_b': '58'}, {'diameter': '360', 'rpm': '50', 'power_b': '3.76'}, {'diameter': '360', 'rpm': '100', 'power_b': '7.01'}, {'diameter': '360', 'rpm': '150', 'power_b': '10.1'}, {'diameter': '360', 'rpm': '200', 'power_b': '13'}, {'diameter': '360', 'rpm': '250', 'power_b': '15.8'}, {'diameter': '360', 'rpm': '300', 'power_b': '18.6'}, {'diameter': '360', 'rpm': '350', 'power_b': '21.2'}, {'diameter': '360', 'rpm': '400', 'power_b': '23.8'}, {'diameter': '360', 'rpm': '435', 'power_b': '25.6'}, {'diameter': '360', 'rpm': '450', 'power_b': '26.3'}, {'diameter': '360', 'rpm': '485', 'power_b': '28'}, {'diameter': '360', 'rpm': '500', 'power_b': '28.8'}, {'diameter': '360', 'rpm': '550', 'power_b': '31.1'}, {'diameter': '360', 'rpm': '575', 'power_b': '32.3'}, {'diameter': '360', 'rpm': '600', 'power_b': '33.5'}, {'diameter': '360', 'rpm': '650', 'power_b': '35.7'}, {'diameter': '360', 'rpm': '690', 'power_b': '37.4'}, {'diameter': '360', 'rpm': '700', 'power_b': '37.9'}, {'diameter': '360', 'rpm': '725', 'power_b': '38.9'}, {'diameter': '360', 'rpm': '750', 'power_b': '40'}, {'diameter': '360', 'rpm': '800', 'power_b': '42'}, {'diameter': '360', 'rpm': '850', 'power_b': '43.9'}, {'diameter': '360', 'rpm': '870', 'power_b': '44.7'}, {'diameter': '360', 'rpm': '900', 'power_b': '45.8'}, {'diameter': '360', 'rpm': '950', 'power_b': '47.6'}, {'diameter': '360', 'rpm': '950', 'power_b': '47.6'}, {'diameter': '360', 'rpm': '1000', 'power_b': '49.3'}, {'diameter': '360', 'rpm': '1050', 'power_b': '50.9'}, {'diameter': '360', 'rpm': '1100', 'power_b': '52.5'}, {'diameter': '360', 'rpm': '1150', 'power_b': '53.9'}, {'diameter': '360', 'rpm': '1160', 'power_b': '54.2'}, {'diameter': '360', 'rpm': '1200', 'power_b': '55.3'}, {'diameter': '360', 'rpm': '1250', 'power_b': '56.5'}, {'diameter': '360', 'rpm': '1300', 'power_b': '57.7'}, {'diameter': '360', 'rpm': '1350', 'power_b': '58.8'}, {'diameter': '360', 'rpm': '1400', 'power_b': '59.8'}, {'diameter': '360', 'rpm': '1425', 'power_b': '60.2'}, {'diameter': '360', 'rpm': '1450', 'power_b': '60.6'}, {'diameter': '360', 'rpm': '1500', 'power_b': '61.4'}, {'diameter': '360', 'rpm': '1550', 'power_b': '62'}, {'diameter': '360', 'rpm': '1600', 'power_b': '62.6'}, {'diameter': '360', 'rpm': '1650', 'power_b': '63'}, {'diameter': '360', 'rpm': '1700', 'power_b': '63.3'}, {'diameter': '360', 'rpm': '1750', 'power_b': '63.5'}, {'diameter': '360', 'rpm': '1750', 'power_b': '63.5'}, {'diameter': '360', 'rpm': '1800', 'power_b': '63.5'}, {'diameter': '360', 'rpm': '1850', 'power_b': '63.4'}, {'diameter': '380', 'rpm': '50', 'power_b': '4.09'}, {'diameter': '380', 'rpm': '100', 'power_b': '7.65'}, {'diameter': '380', 'rpm': '150', 'power_b': '11'}, {'diameter': '380', 'rpm': '200', 'power_b': '14.2'}, {'diameter': '380', 'rpm': '250', 'power_b': '17.3'}, {'diameter': '380', 'rpm': '300', 'power_b': '20.3'}, {'diameter': '380', 'rpm': '350', 'power_b': '23.2'}, {'diameter': '380', 'rpm': '400', 'power_b': '26.1'}, {'diameter': '380', 'rpm': '435', 'power_b': '28'}, {'diameter': '380', 'rpm': '450', 'power_b': '28.8'}, {'diameter': '380', 'rpm': '485', 'power_b': '30.7'}, {'diameter': '380', 'rpm': '500', 'power_b': '31.5'}, {'diameter': '380', 'rpm': '550', 'power_b': '34.1'}, {'diameter': '380', 'rpm': '575', 'power_b': '35.4'}, {'diameter': '380', 'rpm': '600', 'power_b': '36.7'}, {'diameter': '380', 'rpm': '650', 'power_b': '39.1'}, {'diameter': '380', 'rpm': '690', 'power_b': '41'}, {'diameter': '380', 'rpm': '700', 'power_b': '41.5'}, {'diameter': '380', 'rpm': '725', 'power_b': '42.6'}, {'diameter': '380', 'rpm': '750', 'power_b': '43.8'}, {'diameter': '380', 'rpm': '800', 'power_b': '46'}, {'diameter': '380', 'rpm': '850', 'power_b': '48.1'}, {'diameter': '380', 'rpm': '870', 'power_b': '48.9'}, {'diameter': '380', 'rpm': '900', 'power_b': '50.1'}, {'diameter': '380', 'rpm': '950', 'power_b': '52.1'}, {'diameter': '380', 'rpm': '950', 'power_b': '52.1'}, {'diameter': '380', 'rpm': '1000', 'power_b': '53.9'}, {'diameter': '380', 'rpm': '1050', 'power_b': '55.7'}, {'diameter': '380', 'rpm': '1100', 'power_b': '57.3'}, {'diameter': '380', 'rpm': '1150', 'power_b': '58.9'}, {'diameter': '380', 'rpm': '1160', 'power_b': '59.2'}, {'diameter': '380', 'rpm': '1200', 'power_b': '60.3'}, {'diameter': '380', 'rpm': '1250', 'power_b': '61.7'}, {'diameter': '380', 'rpm': '1300', 'power_b': '62.9'}, {'diameter': '380', 'rpm': '1350', 'power_b': '64'}, {'diameter': '380', 'rpm': '1400', 'power_b': '65'}, {'diameter': '380', 'rpm': '1425', 'power_b': '65.5'}, {'diameter': '380', 'rpm': '1450', 'power_b': '65.9'}, {'diameter': '380', 'rpm': '1500', 'power_b': '66.6'}, {'diameter': '380', 'rpm': '1550', 'power_b': '67.2'}, {'diameter': '380', 'rpm': '1600', 'power_b': '67.7'}, {'diameter': '380', 'rpm': '1650', 'power_b': '68.1'}, {'diameter': '380', 'rpm': '1700', 'power_b': '68.3'}, {'diameter': '380', 'rpm': '1750', 'power_b': '68.4'}, {'diameter': '380', 'rpm': '1750', 'power_b': '68.4'}, {'diameter': '400', 'rpm': '50', 'power_b': '4.42'}, {'diameter': '400', 'rpm': '100', 'power_b': '8.28'}, {'diameter': '400', 'rpm': '150', 'power_b': '11.9'}, {'diameter': '400', 'rpm': '200', 'power_b': '15.4'}, {'diameter': '400', 'rpm': '250', 'power_b': '18.8'}, {'diameter': '400', 'rpm': '300', 'power_b': '22.1'}, {'diameter': '400', 'rpm': '350', 'power_b': '25.2'}, {'diameter': '400', 'rpm': '400', 'power_b': '28.3'}, {'diameter': '400', 'rpm': '435', 'power_b': '30.5'}, {'diameter': '400', 'rpm': '450', 'power_b': '31.3'}, {'diameter': '400', 'rpm': '485', 'power_b': '33.4'}, {'diameter': '400', 'rpm': '500', 'power_b': '34.3'}, {'diameter': '400', 'rpm': '550', 'power_b': '37.1'}, {'diameter': '400', 'rpm': '575', 'power_b': '38.5'}, {'diameter': '400', 'rpm': '600', 'power_b': '39.8'}, {'diameter': '400', 'rpm': '650', 'power_b': '42.5'}, {'diameter': '400', 'rpm': '690', 'power_b': '44.6'}, {'diameter': '400', 'rpm': '700', 'power_b': '45.1'}, {'diameter': '400', 'rpm': '725', 'power_b': '46.3'}, {'diameter': '400', 'rpm': '750', 'power_b': '47.6'}, {'diameter': '400', 'rpm': '800', 'power_b': '49.9'}, {'diameter': '400', 'rpm': '850', 'power_b': '52.2'}, {'diameter': '400', 'rpm': '870', 'power_b': '53.1'}, {'diameter': '400', 'rpm': '900', 'power_b': '54.4'}, {'diameter': '400', 'rpm': '950', 'power_b': '56.5'}, {'diameter': '400', 'rpm': '950', 'power_b': '56.5'}, {'diameter': '400', 'rpm': '1000', 'power_b': '58.5'}, {'diameter': '400', 'rpm': '1050', 'power_b': '60.3'}, {'diameter': '400', 'rpm': '1100', 'power_b': '62.1'}, {'diameter': '400', 'rpm': '1150', 'power_b': '63.7'}, {'diameter': '400', 'rpm': '1160', 'power_b': '64'}, {'diameter': '400', 'rpm': '1200', 'power_b': '65.2'}, {'diameter': '400', 'rpm': '1250', 'power_b': '66.6'}, {'diameter': '400', 'rpm': '1300', 'power_b': '67.9'}, {'diameter': '400', 'rpm': '1350', 'power_b': '69'}, {'diameter': '400', 'rpm': '1400', 'power_b': '70'}, {'diameter': '400', 'rpm': '1425', 'power_b': '70.4'}, {'diameter': '400', 'rpm': '1450', 'power_b': '70.9'}, {'diameter': '400', 'rpm': '1500', 'power_b': '71.6'}, {'diameter': '400', 'rpm': '1550', 'power_b': '72.1'}, {'diameter': '400', 'rpm': '1600', 'power_b': '72.5'}, {'diameter': '400', 'rpm': '1650', 'power_b': '72.8'}, {'diameter': '420', 'rpm': '50', 'power_b': '4.75'}, {'diameter': '420', 'rpm': '100', 'power_b': '8.91'}, {'diameter': '420', 'rpm': '150', 'power_b': '12.8'}, {'diameter': '420', 'rpm': '200', 'power_b': '16.6'}, {'diameter': '420', 'rpm': '250', 'power_b': '20.3'}, {'diameter': '420', 'rpm': '300', 'power_b': '23.8'}, {'diameter': '420', 'rpm': '350', 'power_b': '27.2'}, {'diameter': '420', 'rpm': '400', 'power_b': '30.6'}, {'diameter': '420', 'rpm': '435', 'power_b': '32.9'}, {'diameter': '420', 'rpm': '450', 'power_b': '33.8'}, {'diameter': '420', 'rpm': '485', 'power_b': '36'}, {'diameter': '420', 'rpm': '500', 'power_b': '37'}, {'diameter': '420', 'rpm': '550', 'power_b': '40'}, {'diameter': '420', 'rpm': '575', 'power_b': '41.5'}, {'diameter': '420', 'rpm': '600', 'power_b': '43'}, {'diameter': '420', 'rpm': '650', 'power_b': '45.9'}, {'diameter': '420', 'rpm': '690', 'power_b': '48.1'}, {'diameter': '420', 'rpm': '700', 'power_b': '48.6'}, {'diameter': '420', 'rpm': '725', 'power_b': '50'}, {'diameter': '420', 'rpm': '750', 'power_b': '51.3'}, {'diameter': '420', 'rpm': '800', 'power_b': '53.8'}, {'diameter': '420', 'rpm': '850', 'power_b': '56.3'}, {'diameter': '420', 'rpm': '870', 'power_b': '57.2'}, {'diameter': '420', 'rpm': '900', 'power_b': '58.6'}, {'diameter': '420', 'rpm': '950', 'power_b': '60.8'}, {'diameter': '420', 'rpm': '950', 'power_b': '50.8'}, {'diameter': '420', 'rpm': '1000', 'power_b': '62.9'}, {'diameter': '420', 'rpm': '1050', 'power_b': '64.9'}, {'diameter': '420', 'rpm': '1100', 'power_b': '66.7'}, {'diameter': '420', 'rpm': '1150', 'power_b': '68.4'}, {'diameter': '420', 'rpm': '1160', 'power_b': '68.7'}, {'diameter': '420', 'rpm': '1200', 'power_b': '69.9'}, {'diameter': '420', 'rpm': '1250', 'power_b': '71.4'}, {'diameter': '420', 'rpm': '1300', 'power_b': '72.6'}, {'diameter': '420', 'rpm': '1350', 'power_b': '73.8'}, {'diameter': '420', 'rpm': '1400', 'power_b': '74.7'}, {'diameter': '420', 'rpm': '1425', 'power_b': '75.1'}, {'diameter': '420', 'rpm': '1450', 'power_b': '75.5'}, {'diameter': '420', 'rpm': '1500', 'power_b': '76.1'}, {'diameter': '420', 'rpm': '1550', 'power_b': '76.6'}, {'diameter': '440', 'rpm': '50', 'power_b': '5.08'}, {'diameter': '440', 'rpm': '100', 'power_b': '9.54'}, {'diameter': '440', 'rpm': '150', 'power_b': '13.8'}, {'diameter': '440', 'rpm': '200', 'power_b': '17.8'}, {'diameter': '440', 'rpm': '250', 'power_b': '21.7'}, {'diameter': '440', 'rpm': '300', 'power_b': '25.5'}, {'diameter': '440', 'rpm': '350', 'power_b': '29.2'}, {'diameter': '440', 'rpm': '400', 'power_b': '32.8'}, {'diameter': '440', 'rpm': '435', 'power_b': '35.3'}, {'diameter': '440', 'rpm': '450', 'power_b': '36.3'}, {'diameter': '440', 'rpm': '485', 'power_b': '38.7'}, {'diameter': '440', 'rpm': '500', 'power_b': '39.7'}, {'diameter': '440', 'rpm': '550', 'power_b': '42.9'}, {'diameter': '440', 'rpm': '575', 'power_b': '44.5'}, {'diameter': '440', 'rpm': '600', 'power_b': '46.1'}, {'diameter': '440', 'rpm': '650', 'power_b': '49.2'}, {'diameter': '440', 'rpm': '690', 'power_b': '51.5'}, {'diameter': '440', 'rpm': '700', 'power_b': '52.1'}, {'diameter': '440', 'rpm': '725', 'power_b': '53.5'}, {'diameter': '440', 'rpm': '750', 'power_b': '54.9'}, {'diameter': '440', 'rpm': '800', 'power_b': '57.6'}, {'diameter': '440', 'rpm': '850', 'power_b': '60.2'}, {'diameter': '440', 'rpm': '870', 'power_b': '61.2'}, {'diameter': '440', 'rpm': '900', 'power_b': '62.7'}, {'diameter': '440', 'rpm': '950', 'power_b': '65'}, {'diameter': '440', 'rpm': '950', 'power_b': '65'}, {'diameter': '440', 'rpm': '1000', 'power_b': '67.2'}, {'diameter': '440', 'rpm': '1050', 'power_b': '69.2'}, {'diameter': '440', 'rpm': '1100', 'power_b': '71.1'}, {'diameter': '440', 'rpm': '1150', 'power_b': '72.9'}, {'diameter': '440', 'rpm': '1160', 'power_b': '73.2'}, {'diameter': '440', 'rpm': '1200', 'power_b': '74.5'}, {'diameter': '440', 'rpm': '1250', 'power_b': '75.9'}, {'diameter': '440', 'rpm': '1300', 'power_b': '77.1'}, {'diameter': '440', 'rpm': '1350', 'power_b': '78.2'}, {'diameter': '440', 'rpm': '1400', 'power_b': '79.1'}, {'diameter': '440', 'rpm': '1425', 'power_b': '79.5'}, {'diameter': '440', 'rpm': '1450', 'power_b': '79.8'}, {'diameter': '440', 'rpm': '1500', 'power_b': '80.4'}, {'diameter': '460', 'rpm': '50', 'power_b': '5.41'}, {'diameter': '460', 'rpm': '100', 'power_b': '10.2'}, {'diameter': '460', 'rpm': '150', 'power_b': '14.7'}, {'diameter': '460', 'rpm': '200', 'power_b': '19'}, {'diameter': '460', 'rpm': '250', 'power_b': '23.2'}, {'diameter': '460', 'rpm': '300', 'power_b': '27.3'}, {'diameter': '460', 'rpm': '350', 'power_b': '31.2'}, {'diameter': '460', 'rpm': '400', 'power_b': '35'}, {'diameter': '460', 'rpm': '435', 'power_b': '37.6'}, {'diameter': '460', 'rpm': '450', 'power_b': '38.7'}, {'diameter': '460', 'rpm': '485', 'power_b': '41.3'}, {'diameter': '460', 'rpm': '500', 'power_b': '42.3'}, {'diameter': '460', 'rpm': '550', 'power_b': '45.8'}, {'diameter': '460', 'rpm': '575', 'power_b': '47.5'}, {'diameter': '460', 'rpm': '600', 'power_b': '49.2'}, {'diameter': '460', 'rpm': '650', 'power_b': '52.4'}, {'diameter': '460', 'rpm': '690', 'power_b': '54.9'}, {'diameter': '460', 'rpm': '700', 'power_b': '55.6'}, {'diameter': '460', 'rpm': '725', 'power_b': '57.1'}, {'diameter': '460', 'rpm': '750', 'power_b': '58.5'}, {'diameter': '460', 'rpm': '800', 'power_b': '61.4'}, {'diameter': '460', 'rpm': '850', 'power_b': '64.1'}, {'diameter': '460', 'rpm': '870', 'power_b': '65.2'}, {'diameter': '460', 'rpm': '900', 'power_b': '66.7'}, {'diameter': '460', 'rpm': '950', 'power_b': '69.1'}, {'diameter': '460', 'rpm': '950', 'power_b': '69.1'}, {'diameter': '460', 'rpm': '1000', 'power_b': '71.4'}, {'diameter': '460', 'rpm': '1050', 'power_b': '73.5'}, {'diameter': '460', 'rpm': '1100', 'power_b': '75.4'}, {'diameter': '460', 'rpm': '1150', 'power_b': '77.2'}, {'diameter': '460', 'rpm': '1160', 'power_b': '77.5'}, {'diameter': '460', 'rpm': '1200', 'power_b': '78.8'}, {'diameter': '460', 'rpm': '1250', 'power_b': '80.2'}, {'diameter': '460', 'rpm': '1300', 'power_b': '81.4'}, {'diameter': '460', 'rpm': '1350', 'power_b': '82.4'}, {'diameter': '460', 'rpm': '1400', 'power_b': '83.2'}, {'diameter': '460', 'rpm': '1425', 'power_b': '83.6'}, {'diameter': '460', 'rpm': '1450', 'power_b': '83.8'}, {'diameter': '480', 'rpm': '50', 'power_b': '5.73'}, {'diameter': '480', 'rpm': '100', 'power_b': '10.8'}, {'diameter': '480', 'rpm': '150', 'power_b': '15.6'}, {'diameter': '480', 'rpm': '200', 'power_b': '20.2'}, {'diameter': '480', 'rpm': '250', 'power_b': '24.6'}, {'diameter': '480', 'rpm': '300', 'power_b': '29'}, {'diameter': '480', 'rpm': '350', 'power_b': '33.2'}, {'diameter': '480', 'rpm': '400', 'power_b': '37.2'}, {'diameter': '480', 'rpm': '435', 'power_b': '40'}, {'diameter': '480', 'rpm': '450', 'power_b': '41.2'}, {'diameter': '480', 'rpm': '485', 'power_b': '43.8'}, {'diameter': '480', 'rpm': '500', 'power_b': '45'}, {'diameter': '480', 'rpm': '550', 'power_b': '48.7'}, {'diameter': '480', 'rpm': '575', 'power_b': '50.5'}, {'diameter': '480', 'rpm': '600', 'power_b': '52.2'}, {'diameter': '480', 'rpm': '650', 'power_b': '55.7'}, {'diameter': '480', 'rpm': '690', 'power_b': '58.3'}, {'diameter': '480', 'rpm': '700', 'power_b': '58.9'}, {'diameter': '480', 'rpm': '725', 'power_b': '60.5'}, {'diameter': '480', 'rpm': '750', 'power_b': '62.1'}, {'diameter': '480', 'rpm': '800', 'power_b': '65.1'}, {'diameter': '480', 'rpm': '850', 'power_b': '67.9'}, {'diameter': '480', 'rpm': '870', 'power_b': '69'}, {'diameter': '480', 'rpm': '900', 'power_b': '70.6'}, {'diameter': '480', 'rpm': '950', 'power_b': '73.1'}, {'diameter': '480', 'rpm': '950', 'power_b': '73.1'}, {'diameter': '480', 'rpm': '1000', 'power_b': '75.4'}, {'diameter': '480', 'rpm': '1050', 'power_b': '77.6'}, {'diameter': '480', 'rpm': '1100', 'power_b': '79.6'}, {'diameter': '480', 'rpm': '1150', 'power_b': '81.3'}, {'diameter': '480', 'rpm': '1160', 'power_b': '81.7'}, {'diameter': '480', 'rpm': '1200', 'power_b': '82.9'}, {'diameter': '480', 'rpm': '1250', 'power_b': '84.3'}, {'diameter': '480', 'rpm': '1300', 'power_b': '85.4'}, {'diameter': '480', 'rpm': '1350', 'power_b': '86.3'}, {'diameter': '500', 'rpm': '50', 'power_b': '6.06'}, {'diameter': '500', 'rpm': '100', 'power_b': '11.4'}, {'diameter': '500', 'rpm': '150', 'power_b': '16.5'}, {'diameter': '500', 'rpm': '200', 'power_b': '21.4'}, {'diameter': '500', 'rpm': '250', 'power_b': '26.1'}, {'diameter': '500', 'rpm': '300', 'power_b': '30.7'}, {'diameter': '500', 'rpm': '350', 'power_b': '35.1'}, {'diameter': '500', 'rpm': '400', 'power_b': '39.4'}, {'diameter': '500', 'rpm': '435', 'power_b': '42.3'}, {'diameter': '500', 'rpm': '450', 'power_b': '43.6'}, {'diameter': '500', 'rpm': '485', 'power_b': '46.4'}, {'diameter': '500', 'rpm': '500', 'power_b': '47.6'}, {'diameter': '500', 'rpm': '550', 'power_b': '51.5'}, {'diameter': '500', 'rpm': '575', 'power_b': '53.4'}, {'diameter': '500', 'rpm': '600', 'power_b': '55.2'}, {'diameter': '500', 'rpm': '650', 'power_b': '58.8'}, {'diameter': '500', 'rpm': '690', 'power_b': '61.6'}, {'diameter': '500', 'rpm': '700', 'power_b': '62.3'}, {'diameter': '500', 'rpm': '725', 'power_b': '64'}, {'diameter': '500', 'rpm': '750', 'power_b': '65.6'}, {'diameter': '500', 'rpm': '800', 'power_b': '68.7'}, {'diameter': '500', 'rpm': '850', 'power_b': '71.6'}, {'diameter': '500', 'rpm': '870', 'power_b': '72.8'}, {'diameter': '500', 'rpm': '900', 'power_b': '74.4'}, {'diameter': '500', 'rpm': '950', 'power_b': '77'}, {'diameter': '500', 'rpm': '950', 'power_b': '77'}, {'diameter': '500', 'rpm': '1000', 'power_b': '79.4'}, {'diameter': '500', 'rpm': '1050', 'power_b': '81.6'}, {'diameter': '500', 'rpm': '1100', 'power_b': '83.5'}, {'diameter': '500', 'rpm': '1150', 'power_b': '85.3'}, {'diameter': '500', 'rpm': '1160', 'power_b': '85.6'}, {'diameter': '500', 'rpm': '1200', 'power_b': '86.8'}, {'diameter': '500', 'rpm': '1250', 'power_b': '88.1'}, {'diameter': '500', 'rpm': '1300', 'power_b': '89.1'}, {'diameter': '520', 'rpm': '50', 'power_b': '6.38'}, {'diameter': '520', 'rpm': '100', 'power_b': '12'}, {'diameter': '520', 'rpm': '150', 'power_b': '17.4'}, {'diameter': '520', 'rpm': '200', 'power_b': '22.5'}, {'diameter': '520', 'rpm': '250', 'power_b': '27.5'}, {'diameter': '520', 'rpm': '300', 'power_b': '32.4'}, {'diameter': '520', 'rpm': '350', 'power_b': '37'}, {'diameter': '520', 'rpm': '400', 'power_b': '41.6'}, {'diameter': '520', 'rpm': '435', 'power_b': '44.7'}, {'diameter': '520', 'rpm': '450', 'power_b': '46'}, {'diameter': '520', 'rpm': '485', 'power_b': '48.9'}, {'diameter': '520', 'rpm': '500', 'power_b': '50.2'}, {'diameter': '520', 'rpm': '550', 'power_b': '54.3'}, {'diameter': '520', 'rpm': '575', 'power_b': '56.3'}, {'diameter': '520', 'rpm': '600', 'power_b': '58.2'}, {'diameter': '520', 'rpm': '650', 'power_b': '62'}, {'diameter': '520', 'rpm': '690', 'power_b': '64.9'}, {'diameter': '520', 'rpm': '700', 'power_b': '65.6'}, {'diameter': '520', 'rpm': '725', 'power_b': '67.3'}, {'diameter': '520', 'rpm': '750', 'power_b': '69'}, {'diameter': '520', 'rpm': '800', 'power_b': '72.2'}, {'diameter': '520', 'rpm': '850', 'power_b': '75.3'}, {'diameter': '520', 'rpm': '870', 'power_b': '76.4'}, {'diameter': '520', 'rpm': '900', 'power_b': '78.1'}, {'diameter': '520', 'rpm': '950', 'power_b': '80.8'}, {'diameter': '520', 'rpm': '950', 'power_b': '80.8'}, {'diameter': '520', 'rpm': '1000', 'power_b': '83.2'}, {'diameter': '520', 'rpm': '1050', 'power_b': '85.4'}, {'diameter': '520', 'rpm': '1100', 'power_b': '87.3'}, {'diameter': '520', 'rpm': '1150', 'power_b': '89'}, {'diameter': '520', 'rpm': '1160', 'power_b': '89.3'}, {'diameter': '520', 'rpm': '1200', 'power_b': '90.5'}, {'diameter': '520', 'rpm': '1250', 'power_b': '91.7'}, {'diameter': '540', 'rpm': '50', 'power_b': '6.71'}, {'diameter': '540', 'rpm': '100', 'power_b': '12.7'}, {'diameter': '540', 'rpm': '150', 'power_b': '18.3'}, {'diameter': '540', 'rpm': '200', 'power_b': '23.7'}, {'diameter': '540', 'rpm': '250', 'power_b': '29'}, {'diameter': '540', 'rpm': '300', 'power_b': '34'}, {'diameter': '540', 'rpm': '350', 'power_b': '39'}, {'diameter': '540', 'rpm': '400', 'power_b': '43.7'}, {'diameter': '540', 'rpm': '435', 'power_b': '47'}, {'diameter': '540', 'rpm': '450', 'power_b': '48.3'}, {'diameter': '540', 'rpm': '485', 'power_b': '51.5'}, {'diameter': '540', 'rpm': '500', 'power_b': '52.8'}, {'diameter': '540', 'rpm': '550', 'power_b': '57.1'}, {'diameter': '540', 'rpm': '575', 'power_b': '59.1'}, {'diameter': '540', 'rpm': '600', 'power_b': '61.2'}, {'diameter': '540', 'rpm': '650', 'power_b': '65.1'}, {'diameter': '540', 'rpm': '690', 'power_b': '68.1'}, {'diameter': '540', 'rpm': '700', 'power_b': '68.8'}, {'diameter': '540', 'rpm': '725', 'power_b': '70.6'}, {'diameter': '540', 'rpm': '750', 'power_b': '72.4'}, {'diameter': '540', 'rpm': '800', 'power_b': '75.7'}, {'diameter': '540', 'rpm': '850', 'power_b': '78.8'}, {'diameter': '540', 'rpm': '870', 'power_b': '80'}, {'diameter': '540', 'rpm': '900', 'power_b': '81.7'}, {'diameter': '540', 'rpm': '950', 'power_b': '84.4'}, {'diameter': '540', 'rpm': '950', 'power_b': '84.4'}, {'diameter': '540', 'rpm': '1000', 'power_b': '86.8'}, {'diameter': '540', 'rpm': '1050', 'power_b': '89'}, {'diameter': '540', 'rpm': '1100', 'power_b': '90.9'}, {'diameter': '540', 'rpm': '1150', 'power_b': '92.6'}, {'diameter': '540', 'rpm': '1160', 'power_b': '92.9'}, {'diameter': '540', 'rpm': '1200', 'power_b': '93.9'}, {'diameter': '560', 'rpm': '50', 'power_b': '7.03'}, {'diameter': '560', 'rpm': '100', 'power_b': '13.3'}, {'diameter': '560', 'rpm': '150', 'power_b': '19.2'}, {'diameter': '560', 'rpm': '200', 'power_b': '24.9'}, {'diameter': '560', 'rpm': '250', 'power_b': '30.4'}, {'diameter': '560', 'rpm': '300', 'power_b': '35.7'}, {'diameter': '560', 'rpm': '350', 'power_b': '40.9'}, {'diameter': '560', 'rpm': '400', 'power_b': '45.9'}, {'diameter': '560', 'rpm': '435', 'power_b': '49.3'}, {'diameter': '560', 'rpm': '450', 'power_b': '50.7'}, {'diameter': '560', 'rpm': '485', 'power_b': '54'}, {'diameter': '560', 'rpm': '500', 'power_b': '55.3'}, {'diameter': '560', 'rpm': '550', 'power_b': '59.8'}, {'diameter': '560', 'rpm': '575', 'power_b': '62'}, {'diameter': '560', 'rpm': '600', 'power_b': '64.1'}, {'diameter': '560', 'rpm': '650', 'power_b': '68.1'}, {'diameter': '560', 'rpm': '690', 'power_b': '71.3'}, {'diameter': '560', 'rpm': '700', 'power_b': '72'}, {'diameter': '560', 'rpm': '725', 'power_b': '73.9'}, {'diameter': '560', 'rpm': '750', 'power_b': '75.7'}, {'diameter': '560', 'rpm': '800', 'power_b': '79.1'}, {'diameter': '560', 'rpm': '850', 'power_b': '82.3'}, {'diameter': '560', 'rpm': '870', 'power_b': '83.5'}, {'diameter': '560', 'rpm': '900', 'power_b': '85.2'}, {'diameter': '560', 'rpm': '950', 'power_b': '78.9'}, {'diameter': '560', 'rpm': '950', 'power_b': '87.9'}, {'diameter': '560', 'rpm': '1000', 'power_b': '90.4'}, {'diameter': '560', 'rpm': '1050', 'power_b': '82.5'}, {'diameter': '560', 'rpm': '1100', 'power_b': '94.4'}, {'diameter': '560', 'rpm': '1150', 'power_b': '95.9'}, {'diameter': '560', 'rpm': '1160', 'power_b': '96.2'}, {'diameter': '580', 'rpm': '50', 'power_b': '7.35'}, {'diameter': '580', 'rpm': '100', 'power_b': '13.9'}, {'diameter': '580', 'rpm': '150', 'power_b': '20.1'}, {'diameter': '580', 'rpm': '200', 'power_b': '26.1'}, {'diameter': '580', 'rpm': '250', 'power_b': '31.8'}, {'diameter': '580', 'rpm': '300', 'power_b': '37.4'}, {'diameter': '580', 'rpm': '350', 'power_b': '42.8'}, {'diameter': '580', 'rpm': '400', 'power_b': '48'}, {'diameter': '580', 'rpm': '435', 'power_b': '51.5'}, {'diameter': '580', 'rpm': '450', 'power_b': '53'}, {'diameter': '580', 'rpm': '485', 'power_b': '56.4'}, {'diameter': '580', 'rpm': '500', 'power_b': '57.9'}, {'diameter': '580', 'rpm': '550', 'power_b': '62.5'}, {'diameter': '580', 'rpm': '575', 'power_b': '64.7'}, {'diameter': '580', 'rpm': '600', 'power_b': '66.9'}, {'diameter': '580', 'rpm': '650', 'power_b': '71.2'}, {'diameter': '580', 'rpm': '690', 'power_b': '74.4'}, {'diameter': '580', 'rpm': '700', 'power_b': '75.1'}, {'diameter': '580', 'rpm': '725', 'power_b': '77.1'}, {'diameter': '580', 'rpm': '750', 'power_b': '78.9'}, {'diameter': '580', 'rpm': '800', 'power_b': '82.4'}, {'diameter': '580', 'rpm': '850', 'power_b': '85.7'}, {'diameter': '580', 'rpm': '870', 'power_b': '86.9'}, {'diameter': '580', 'rpm': '900', 'power_b': '88.6'}, {'diameter': '580', 'rpm': '950', 'power_b': '91.3'}, {'diameter': '580', 'rpm': '950', 'power_b': '91.3'}, {'diameter': '580', 'rpm': '1000', 'power_b': '93.7'}, {'diameter': '580', 'rpm': '1050', 'power_b': '95.8'}, {'diameter': '580', 'rpm': '1100', 'power_b': '97.6'}, {'diameter': '580', 'rpm': '1150', 'power_b': '99'}, {'diameter': '600', 'rpm': '50', 'power_b': '7.68'}, {'diameter': '600', 'rpm': '100', 'power_b': '14.5'}, {'diameter': '600', 'rpm': '150', 'power_b': '21'}, {'diameter': '600', 'rpm': '200', 'power_b': '27.2'}, {'diameter': '600', 'rpm': '250', 'power_b': '33.2'}, {'diameter': '600', 'rpm': '300', 'power_b': '39.1'}, {'diameter': '600', 'rpm': '350', 'power_b': '44.7'}, {'diameter': '600', 'rpm': '400', 'power_b': '50.1'}, {'diameter': '600', 'rpm': '435', 'power_b': '53.8'}, {'diameter': '600', 'rpm': '450', 'power_b': '55.3'}, {'diameter': '600', 'rpm': '485', 'power_b': '58.9'}, {'diameter': '600', 'rpm': '500', 'power_b': '60.4'}, {'diameter': '600', 'rpm': '550', 'power_b': '65.2'}, {'diameter': '600', 'rpm': '575', 'power_b': '67.5'}, {'diameter': '600', 'rpm': '600', 'power_b': '69.8'}, {'diameter': '600', 'rpm': '650', 'power_b': '74.1'}, {'diameter': '600', 'rpm': '690', 'power_b': '77.4'}, {'diameter': '600', 'rpm': '700', 'power_b': '78.2'}, {'diameter': '600', 'rpm': '725', 'power_b': '80.2'}, {'diameter': '600', 'rpm': '750', 'power_b': '82.1'}, {'diameter': '600', 'rpm': '800', 'power_b': '85.6'}, {'diameter': '600', 'rpm': '850', 'power_b': '88.9'}, {'diameter': '600', 'rpm': '870', 'power_b': '90.2'}, {'diameter': '600', 'rpm': '900', 'power_b': '91.9'}, {'diameter': '600', 'rpm': '950', 'power_b': '94.6'}, {'diameter': '600', 'rpm': '950', 'power_b': '94.6'}, {'diameter': '600', 'rpm': '1000', 'power_b': '97'}, {'diameter': '600', 'rpm': '1050', 'power_b': '99'}, {'diameter': '600', 'rpm': '1100', 'power_b': '100.6'}, {'diameter': '620', 'rpm': '50', 'power_b': '8'}, {'diameter': '620', 'rpm': '100', 'power_b': '15.1'}, {'diameter': '620', 'rpm': '150', 'power_b': '21.9'}, {'diameter': '620', 'rpm': '200', 'power_b': '28.4'}, {'diameter': '620', 'rpm': '250', 'power_b': '34.6'}, {'diameter': '620', 'rpm': '300', 'power_b': '40.7'}, {'diameter': '620', 'rpm': '350', 'power_b': '46.6'}, {'diameter': '620', 'rpm': '400', 'power_b': '52.2'}, {'diameter': '620', 'rpm': '435', 'power_b': '56'}, {'diameter': '620', 'rpm': '450', 'power_b': '57.6'}, {'diameter': '620', 'rpm': '485', 'power_b': '61.3'}, {'diameter': '620', 'rpm': '500', 'power_b': '62.9'}, {'diameter': '620', 'rpm': '550', 'power_b': '67.8'}, {'diameter': '620', 'rpm': '575', 'power_b': '70.2'}, {'diameter': '620', 'rpm': '600', 'power_b': '72.6'}, {'diameter': '620', 'rpm': '650', 'power_b': '77'}, {'diameter': '620', 'rpm': '690', 'power_b': '80.4'}, {'diameter': '620', 'rpm': '700', 'power_b': '81.2'}, {'diameter': '620', 'rpm': '725', 'power_b': '83.2'}, {'diameter': '620', 'rpm': '750', 'power_b': '85.2'}, {'diameter': '620', 'rpm': '800', 'power_b': '88.8'}, {'diameter': '620', 'rpm': '850', 'power_b': '92.1'}, {'diameter': '620', 'rpm': '870', 'power_b': '93.3'}, {'diameter': '620', 'rpm': '900', 'power_b': '95.1'}, {'diameter': '620', 'rpm': '950', 'power_b': '97.7'}, {'diameter': '620', 'rpm': '950', 'power_b': '97.7'}, {'diameter': '620', 'rpm': '1000', 'power_b': '100'}, {'diameter': '620', 'rpm': '1050', 'power_b': '102'}, {'diameter': '640', 'rpm': '50', 'power_b': '8.32'}, {'diameter': '640', 'rpm': '100', 'power_b': '15.7'}, {'diameter': '640', 'rpm': '150', 'power_b': '22.8'}, {'diameter': '640', 'rpm': '200', 'power_b': '29.5'}, {'diameter': '640', 'rpm': '250', 'power_b': '36.1'}, {'diameter': '640', 'rpm': '300', 'power_b': '42.4'}, {'diameter': '640', 'rpm': '350', 'power_b': '48.4'}, {'diameter': '640', 'rpm': '400', 'power_b': '54.3'}, {'diameter': '640', 'rpm': '435', 'power_b': '58.3'}, {'diameter': '640', 'rpm': '450', 'power_b': '59.9'}, {'diameter': '640', 'rpm': '485', 'power_b': '63.7'}, {'diameter': '640', 'rpm': '500', 'power_b': '65.3'}, {'diameter': '640', 'rpm': '550', 'power_b': '71.4'}, {'diameter': '640', 'rpm': '575', 'power_b': '72.9'}, {'diameter': '640', 'rpm': '600', 'power_b': '75.3'}, {'diameter': '640', 'rpm': '650', 'power_b': '79.9'}, {'diameter': '640', 'rpm': '690', 'power_b': '93.4'}, {'diameter': '640', 'rpm': '700', 'power_b': '84.2'}, {'diameter': '640', 'rpm': '725', 'power_b': '96.2'}, {'diameter': '640', 'rpm': '750', 'power_b': '88.2'}, {'diameter': '640', 'rpm': '800', 'power_b': '91.9'}, {'diameter': '640', 'rpm': '850', 'power_b': '95.2'}, {'diameter': '640', 'rpm': '870', 'power_b': '96.4'}, {'diameter': '640', 'rpm': '900', 'power_b': '98.2'}, {'diameter': '640', 'rpm': '950', 'power_b': '100.7'}, {'diameter': '640', 'rpm': '950', 'power_b': '100.7'}, {'diameter': '640', 'rpm': '1000', 'power_b': '102.9'}, {'diameter': '660', 'rpm': '50', 'power_b': '8.64'}, {'diameter': '660', 'rpm': '100', 'power_b': '16.3'}, {'diameter': '660', 'rpm': '150', 'power_b': '23.7'}, {'diameter': '660', 'rpm': '200', 'power_b': '30.7'}, {'diameter': '660', 'rpm': '250', 'power_b': '37.5'}, {'diameter': '660', 'rpm': '300', 'power_b': '44'}, {'diameter': '660', 'rpm': '350', 'power_b': '50.3'}, {'diameter': '660', 'rpm': '400', 'power_b': '56.4'}, {'diameter': '660', 'rpm': '435', 'power_b': '60.5'}, {'diameter': '660', 'rpm': '450', 'power_b': '62.2'}, {'diameter': '660', 'rpm': '485', 'power_b': '66.1'}, {'diameter': '660', 'rpm': '500', 'power_b': '67.7'}, {'diameter': '660', 'rpm': '550', 'power_b': '73'}, {'diameter': '660', 'rpm': '575', 'power_b': '75.6'}, {'diameter': '660', 'rpm': '600', 'power_b': '78'}, {'diameter': '660', 'rpm': '650', 'power_b': '82.7'}, {'diameter': '660', 'rpm': '690', 'power_b': '86.3'}, {'diameter': '660', 'rpm': '700', 'power_b': '87.1'}, {'diameter': '660', 'rpm': '725', 'power_b': '89.2'}, {'diameter': '660', 'rpm': '750', 'power_b': '91.1'}, {'diameter': '660', 'rpm': '800', 'power_b': '94.8'}, {'diameter': '660', 'rpm': '850', 'power_b': '98.2'}, {'diameter': '660', 'rpm': '870', 'power_b': '99.4'}, {'diameter': '660', 'rpm': '900', 'power_b': '101.1'}, {'diameter': '660', 'rpm': '950', 'power_b': '103.6'}, {'diameter': '660', 'rpm': '950', 'power_b': '103.6'}, {'diameter': '660', 'rpm': '1000', 'power_b': '105.7'})

class EstPower():
    r"""EstPower class calculates the estimated power to run the pulley system.

    Parameters
    ----------
    engine_power : float
        Engine power, [hp]
    drive_group : int
        Engine group classifier, [-]
    machine_group : int
        Machine group classifier, [-]
    hours_service : float
        Amount of hours per day that the system is on, [h]
    
    Attributes
    ----------
    service_factor : float
        Service factor of the system
    
    Notes
    -----
    The service factor data [#]_ is available online.

    Examples
    --------
    >>> est_power = vbelts.power.EstPower(2, 1, 1, 4)
    >>> est_power.calc()
    2
    >>> est_power2 = vbelts.power.EstPower(2, 2, 4, 18)
    >>> est_power2.calc()
    3.6

    References
    ----------
    .. [#] Megadyne. 2016."V-BELTS: Rubber V-belts", **Vermeire webshop**. Accessed September 14, 2020, http://shop.vermeire.com/inc/Doc/courroies/megadyne/2016/v_belts_jan_2016.pdf
    """
    def __init__(self, engine_power:float, drive_group:int, machine_group:int, hours_service:float):
        self.engine_power = engine_power
        self.drive_group = drive_group
        self.machine_group = machine_group
        self.hours_service = hours_service
        self._sf()
    

    def _sf(self):
        r"""Method selects and calculates the service factor.
        """
        # calculate service_factor partial
        if self.machine_group == 1:
            if 0 < self.hours_service <= 5:
                sf_part = 1.0
            elif 5 < self.hours_service <= 10:
                sf_part = 1.1
            elif 10 < self.hours_service <= 24:
                sf_part = 1.2
        elif self.machine_group == 2:
            if 0 < self.hours_service <= 5:
                sf_part = 1.1
            elif 5 < self.hours_service <= 10:
                sf_part = 1.2
            elif 10 < self.hours_service <= 24:
                sf_part = 1.3
        elif self.machine_group == 3:
            if 0 < self.hours_service <= 5:
                sf_part = 1.2
            elif 5 < self.hours_service <= 10:
                sf_part = 1.3
            elif 10 < self.hours_service <= 24:
                sf_part = 1.4
        elif self.machine_group == 4:
            if 0 < self.hours_service <= 5:
                sf_part = 1.3
            elif 5 < self.hours_service <= 10:
                sf_part = 1.4
            elif 10 < self.hours_service <= 24:
                sf_part = 1.5
        # calculate service_factor additional and final
        if self.machine_group == 1 and self.drive_group == 2:
            result = sf_part + 0.1
        elif self.machine_group == 2 and self.drive_group == 2:
            result = sf_part + 0.1
        elif self.machine_group == 3 and self.drive_group == 2:
            if sf_part == 1.4:
                result = sf_part + 0.1
            else:
                result = sf_part + 0.2
        elif self.machine_group == 4 and self.drive_group == 2:
            if sf_part == 1.4:
                result = sf_part + 0.2
            else:
                result = sf_part + 0.3
        else:
            result = sf_part
        self._service_factor = round(result,1)

    
    def calc(self):
        r"""Estimated power to run the pulley system.

        Returns
        -------
        pp : float
            Estimated power, [hp]
        
        Notes
        -----
        The equation to calculate the estimated power, using the engine power `P_{engine}` and the service factor `F_s`:

        .. math::
            P_p = P_{engine} \cdot F_s
        """
        pp = self.engine_power * self._service_factor
        return pp


class TransPower():
    """TransPower class calculates the quantity of belts needed to ensure the power of the system.

    Parameters
    ----------
    vbelt_model : str
        Model of the v-belt, [-]
    vbelt_profile : str
        Profile of the v-belt, [-]
    vbelt_type : str
        Type of the v-belt, [-]
    est_power : float
        Estimated power, [hp]
    gear_ratio : float
        Pulley system gear ratio, [-]
    belt_length_corr : float
        Corrected belt length, [-]
    min_diam : float
        Smallest pulley, [mm]
    maj_diam : float
        Largest pulley, [mm]
    rpm : float
        Fastest axle rotation speed, [rpm]
    
    Notes
    -----
    All the information [#]_ is available online. The valid entries for `vbelt_model`, `vbelt_profile` and `vbelt_type` are in the :ref:`Model Profile <vbelt_model_profile>` and in the :ref:`Types <vbelt_types>` of the data section.

    Examples
    --------
    >>> trans_power = vbelts.power.TransPower('HiPower', 'a', 'A-32', 2, 130/240, 850, 130, 240, 1750)
    >>> trans_power.calc()
    0.5060451558976288

    References
    ----------
    .. [#] Claudino Alves, Claudemir. "Transmissão por Correias - Dimensionamento Atividade 2". **Fatec Itaquera**. Accessed September 16, 2020, http://claudemiralves.weebly.com/uploads/3/8/6/2/3862918/dimen._de_correias.pdf.
    """
    def __init__(self, vbelt_model:str, vbelt_profile:str, vbelt_type:str, est_power:float, gear_ratio:float, belt_length_corr:float, min_diam:float, maj_diam:float, rpm:float, iterator:_ReIterate=_ReIterate):
        self.b_model = vbelt_model
        self.b_profile = vbelt_profile
        self.b_type = vbelt_type
        self.est_power = est_power
        self.gear_ratio = gear_ratio
        self.l_corr = belt_length_corr
        self.min_diam = min_diam
        self.maj_diam = maj_diam
        self.rpm = rpm
        self.iterator = iterator
        self._fc_length()
        self._basic()
        self._additional()
        self._fc_arc()
    

    def _fc_length(self):
        """Selects the appropriate correction factor for belt length."""
        if self.b_model == 'HiPower':
            fcc_list = hipower_fcc
        elif self.b_model == 'SuperHC':
            fcc_list = superhc_fcc
        else:
            raise _NotValidError(f'The value {self.b_model} is not valid for fcc calculation.')
        for line in fcc_list:
            if line['type'] == self.b_type:
                self._fcc = float(line['fcc'])
    

    def _basic(self):
        """Select the basic power transmitted by belt unit."""
        listname_pb = f'{self.b_model}_{self.b_profile}_pb'
        temp_result, adjust = self.iterator().three_rows(globals()[listname_pb], self.min_diam, self.rpm)
        # result adjusting for interpolation
        if adjust:
            if 0.3 < temp_result <= 1:
                self._p_basic = temp_result - 0.25
            elif 1 < temp_result <= 10:
                self._p_basic = temp_result - 0.5
            elif 10 < temp_result <= 120:
                self._p_basic = temp_result - 2.5
        else:
            self._p_basic = temp_result
    

    def _additional(self):
        """Selects the additional power transmitted by belt unit."""
        filename_pa = f'{self.b_model}_{self.b_profile}_pa'
        # checking if gear_ratio is below one and adjust
        if self.gear_ratio < 1:
            gear_ratio_corr = 1/self.gear_ratio
        else:
            gear_ratio_corr = self.gear_ratio
        self._p_add = self.iterator().four_rows(globals()[filename_pa], gear_ratio_corr, self.rpm)


    def _fc_arc(self):
        """Selects the appropriate correction factor for contact arc."""
        dict_list = fcac_contact_arc
        factor = (self.maj_diam - self.min_diam) / self.l_corr
        self._fcac = self.iterator().three_rows_choose(dict_list, factor, 'fcac')


    def belt_qty(self):
        r"""Number of v-belts needed to transmit the estimated power.

        Returns
        -------
        b_qty : float
            Quantity of v-belts, [-]
        

        Notes
        -----
        Before calculate the belt quantity, the transmitted power `P_t` in horse-power has to be calculated [#]_ by:

        .. math::
            P_t = (P_b + P_a) \cdot f_{cc} \cdot f_{cac}

        Where `P_b` is the basic power transmitted, `P_a` is the additional power transmitted, `f_{cc}` is the length correction factor and `f_{cac}` is the contact arc correction factor.
        Then, the belt quantity is calculated by:

        .. math::
            N_{v-belt} = \frac{P_{estimated}}{P_t}

        References
        ----------
        .. [#] Claudino Alves, Claudemir. "Transmissão por Correias - Dimensionamento Atividade 2". **Fatec Itaquera**. Accessed September 16, 2020, http://claudemiralves.weebly.com/uploads/3/8/6/2/3862918/dimen._de_correias.pdf.
        """
        belt_transmission_capacity = (self._p_basic + self._p_add) * self._fcc * self._fcac
        return self.est_power / belt_transmission_capacity
